/*
cd ~/C/PSgraf3/examples
g++ -Wall -o _3d-slices 3d-slices.cpp -lPSgraf3 -lm
_3d-slices

*/

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <PSgraf3.h>

#define NX       80
#define NY       70
#define NZ       60
#define DX       50
#define NCTR     65
#define MAXHUE	  0.7

int main()
{
  int i,j,k;
  double ***f,bx,by,bz,
    ctr[NCTR],c0[NCTR+1],c1[NCTR+1],c2[NCTR+1],min,max;
  struct dvec X0,X1,X2,illum;

  X0.dim=X1.dim=X2.dim=3;

  f=(double***)malloc(NX*sizeof(double**));
  for (i=0;i<NX;i++) {
    f[i]=(double**)malloc(NY*sizeof(double*));
    for (j=0;j<NY;j++) f[i][j]=(double*)malloc(NZ*sizeof(double));
  }

  min=max=0;
  for (i=0;i<NX;i++) {
    bx=(double)(i-NX/2)/NX;
    for (j=0;j<NY;j++) {
      by=(double)(j-NY/2)/NX;
      for (k=0;k<NZ;k++) {
	bz=(double)(k-NZ/2)/NX;
	f[i][j][k]=cos(100*bx*by)*cos(40*by*bz)*cos(10*bz*bx);
	if (min>f[i][j][k]) min=f[i][j][k];
	if (max<f[i][j][k]) max=f[i][j][k];
      }
    }
  }

  gPaper("fig/3d-slices");
    sXWorldCoord(0,NX,0,DX); sYWorldCoord(0,NY,0,NY*DX/NX); sZWorldCoord(0,NZ,0,NZ*DX/NX);
    X1.x=-1;   X1.y=-1;   X1.z=-1;
    X2.x= 1;   X2.y= 0;   X2.z=-1;
    sView(X1,X2);

    sColorSpace("HSB");
    for (i=0;i<NCTR;i++) {
      ctr[i]=min+(i+1)*(max-min)/(NCTR+1);
      c0[i]=MAXHUE*i/(NCTR-1); c1[i]=1; c2[i]=1;
    }
    c0[NCTR]=MAXHUE; c1[NCTR]=1; c2[NCTR]=0.8;  	// "low-light" outlyers
    sContours(ctr,NCTR,c0,c1,c2);

    illum.dim=0;
    sCBlock(0,1,NX,0,NX-1,
	    0,1,NY,0,NY-1,
	    0,1,NZ,0,NZ-1,1,illum);
    dCBlock(f,1,0);

    sCBlock(0,1,NX,(int)(0.2*NX),NX-1,
	    0,1,NY,(int)(0.5*NY),NY-1,
	    0,1,NZ,(int)(0.3*NZ),NZ-1,0,illum);
    dCBlock(f,1,0);

    sCBlock(0,1,NX,(int)(0.5*NX),NX-1,
	    0,1,NY,0,(int)(0.5*NY),
	    0,1,NZ,(int)(0.5*NZ),NZ-1,0,illum);
    dCBlock(f,1,0);



    sXWorldCoord(0,NX,DX,2*DX); sYWorldCoord(0,NY,0,NY*DX/NX);
    sZWorldCoord(0,NZ,-NZ*DX/NX,0);

    illum.dim=3; illum.x=-0.3; illum.y=-1; illum.z=-0.6;
    sCBlock(0,1,NX,0,NX-1,
	    0,1,NY,0,NY-1,
	    0,1,NZ,0,NZ-1,1,illum);
    dCBlock(f,1,0);

    sCBlock(0,1,NX,(int)(0.2*NX),NX-1,
	    0,1,NY,(int)(0.5*NY),NY-1,
	    0,1,NZ,(int)(0.3*NZ),NZ-1,0,illum);
    dCBlock(f,1,0);

    sCBlock(0,1,NX,(int)(0.5*NX),NX-1,
	    0,1,NY,0,(int)(0.5*NY),
	    0,1,NZ,(int)(0.5*NZ),NZ-1,0,illum);
    dCBlock(f,1,0);
  endPS();
  
  return 0;
}
