/*
cd ~/C/PSgraf3/examples
g++ -o _contours contours.cpp -lPSgraf3 -lm
_contours

*/

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <PSgraf3.h>

#define Nx       80
#define Ny       80
#define DX       60
#define NCTR     65

int main()
{
  int i,j;
  double *x,*y,*z,ctr[NCTR],c0[NCTR+1],c1[NCTR+1],c2[NCTR+1],
         sphi,cphi,dphi=1.5707963/(Nx-1),r,dr=1;
  struct dvec orig;

  orig.dim=2; orig.x=0; orig.y=0;

  x=(double*)malloc(Nx*Ny*sizeof(double));      /* allocate memory */
  y=(double*)malloc(Nx*Ny*sizeof(double));
  z=(double*)malloc(Nx*Ny*sizeof(double));
  
  for (i=0;i<NCTR;i++) {
    ctr[i]=i*2./(NCTR-1)-1;
    c0[i]=0.8*i/(NCTR-1); c1[i]=c2[i]=1;
  }
  c0[NCTR]=0.8; c1[NCTR]=c2[NCTR]=1;
  for (i=0;i<Nx;i++) {
    sphi=sin(i*dphi); cphi=cos(i*dphi);
    for (j=0;j<Ny;j++) {
      r=0.0001+j*dr;
      x[i+Nx*j]=r*sphi+5; y[i+Nx*j]=r*cphi+5;
      z[i+Nx*j]=0.5*sin(0.2*r)*sin(5*i*dphi) +0.3*sin(0.3*r)*sin(7*i*dphi)
               +0.2*sin(0.5*r)*sin(11*i*dphi)+0.1*sin(0.7*r)*sin(13*i*dphi);
    }
  }

  gPaper("fig/contours");
    sNumber('f',2);
    sXWorldCoord(0,Nx+10,0,DX); sYWorldCoord(0,Ny+10,0,DX);
    dXAxis(orig,86,1);          dYAxis(orig,86,1);
    sColorSpace("HSB");
    sContours(ctr,NCTR,c0,c1,c2);
    gDRGrid(x,y,Nx,Ny);
    dContours(z,1,0);
    dLegend(DX+4,0,-2,DX-4,0,8);

    sColorSpace("G");
    for (i=0;i<5;i++) ctr[i]=i*0.2;
    sContours(ctr,5,c0); dContours(z,0,1);
    for (i=0;i<4;i++) ctr[i]=-0.8+i*0.2;
    sDash(1); sContours(ctr,4,c0); dContours(z,0,1); sDash(-1);
  endPS();
  
  return 0;
}
