/*
cd ~/C/PSgraf3/examples
g++ -o _contours3 contours3.cpp -lPSgraf3 -lm
_contours3

*/

#include <math.h>
#include <stdlib.h>
#include <PSgraf3.h>

#define NX       80
#define NY       80
#define DX       60
#define NCTR     65

int main()
{
  int i,j,k;
  double *x,*y,*z,ctr[NCTR],c0[NCTR+1],c1[NCTR+1],c2[NCTR+1],
         sphi,cphi,dphi=1.5707963/(NX-1),r,dr=1;
  struct dvec X0,X1,X2;

  X0.dim=X1.dim=X2.dim=3;

  x=(double*)malloc(NX*NY*sizeof(double));      /* allocate memory */
  y=(double*)malloc(NX*NY*sizeof(double));
  z=(double*)malloc(NX*NY*sizeof(double));
  
  for (i=0;i<NX;i++) {
    sphi=sin(i*dphi); cphi=cos(i*dphi);
    for (j=0;j<NY;j++) {
      r=0.0001+j*dr;
      z[i+NX*j]=0.5*sin(0.2*r)*sin(5*i*dphi) +0.3*sin(0.3*r)*sin(7*i*dphi)
               +0.2*sin(0.5*r)*sin(11*i*dphi)+0.1*sin(0.7*r)*sin(13*i*dphi);
    }
  }

  gPaper("fig/contours3");
    sXWorldCoord(0,NX+10,0,DX); sYWorldCoord(0,NY+10,0,DX); sZWorldCoord(0,NX+10,0,DX);
    X0.x=0;    X0.y=0;   X0.z=0;
    X1.x=1;    X1.y=1;   X1.z=1;
    X2.x=-1;   X2.y=2;   X2.z=-1;
    sView(X0,X1,X2);

    sText("TeXfonts",10,'C','C');

    dXAxis(X0,86,1);
    dYAxis(X0,86,1);
    dZAxis(X0,52,1);

    X1.x=1; X1.y=0; X1.z=0;
    X2.x=0; X2.y=1; X2.z=0;
    gRGrid(X0,X1,X2,NX,NY);
    for (i=0;i<5;i++) ctr[i]=i*0.2;
    sContours(ctr,5,c0); dContours(z,0,1);
    for (i=0;i<4;i++) ctr[i]=-0.8+i*0.2;
    sDash(1); sContours(ctr,4,c0); dContours(z,0,1); sDash(-1);
    dGridBoundary(0,0);
    deleteGrid();

    sColorSpace("HSB");
    for (i=0;i<NCTR;i++) {
      ctr[i]=i*2.0/(NCTR-1)-1.;
      c0[i]=0.8*i/(NCTR-1); c1[i]=c2[i]=1;
    }
    c0[NCTR]=0.8; c1[NCTR]=c2[NCTR]=1;
  
    sContours(ctr,NCTR,c0,c1,c2);
    X0.x=0; X0.y=0; X0.z=6;
    X1.x=1; X1.y=0; X1.z=0;
    X2.x=0; X2.y=1; X2.z=0.5;
    gRGrid(X0,X1,X2,NX,NY);
    dContours(z,1,0);

    sColorSpace("G");
    for (i=0;i<5;i++) ctr[i]=i*0.2;
    sContours(ctr,5,c0); dContours(z,0,1);
    for (i=0;i<4;i++) ctr[i]=-0.8+i*0.2;
    sDash(1); sContours(ctr,4,c0); dContours(z,0,1); sDash(-1);
    dGridBoundary(0,0);
  endPS();
  
  return 0;
}

