/*
cd ~/C/PSgraf3/examples
g++ -o _contours3 contours3o.cpp -lPSgraf3 -lm
_contours3

*/

#include <math.h>
#include <stdlib.h>
#include <PSgraf3.h>

#define NX       80
#define NY       80
#define DX       60
#define NCTR     64
#define COLOR     1  /* 0: b&w, 1: color */

int main()
{
  int Nctr,i,j;
  double *x,*y,*z,ctr[NCTR],ctrs[NCTR/8],c0[NCTR+1],c1[NCTR+1],c2[NCTR+1],
         sphi,cphi,dphi=1.5707963/(NX-1),r,dr=1;
  struct dvec xa0,x0,x1,x2;

  xa0.dim=x0.dim=x1.dim=x2.dim=3;

  x=(double*)malloc(NX*NY*sizeof(double));      /* allocate memory */
  y=(double*)malloc(NX*NY*sizeof(double));
  z=(double*)malloc(NX*NY*sizeof(double));
  
  if (COLOR) {
    Nctr=NCTR; c0[NCTR]=c1[NCTR]=c2[NCTR]=1;
  } else {
    Nctr=NCTR/8; c0[Nctr]=1;
  }
  
  for (i=0;i<Nctr;i++) {
    ctr[i]=(i+1)*2./(Nctr+1)-1.;
    c0[i]=(i+1)/(double)(Nctr+1); c1[i]=c2[i]=1;
  }
  for (i=0;i<NCTR/8;i++) ctrs[i]=(i+1)*2./(NCTR/8+1)-1.;
  for (i=0;i<NX;i++) {
    sphi=sin(i*dphi); cphi=cos(i*dphi);
    for (j=0;j<NY;j++) {
      r=0.0001+j*dr;
      z[i+NX*j]=0.5*sin(0.2*r)*sin(5*i*dphi) +0.3*sin(0.3*r)*sin(7*i*dphi)
               +0.2*sin(0.5*r)*sin(11*i*dphi)+0.1*sin(0.7*r)*sin(13*i*dphi);
    }
  }

  gPaper("fig/contours3");
    sXWorldCoord(0,NX+10,0,DX); sYWorldCoord(0,NY+10,0,DX); sZWorldCoord(0,NX+10,0,DX);
    x0.x=0;    x0.y=0;   x0.z=0;
    x1.x=1;    x1.y=1;   x1.z=1;
    x2.x=-1;   x2.y=2;   x2.z=-1;
    sView(x0,x1,x2);                /* set view */

    sContours(ctrs,NCTR/8,c0); 
    sText("TeXfonts",0,'C','C'); sNumber('f',2);
    xa0.x=0; xa0.y=0; xa0.z=0;
    dXAxis(xa0,86,1);
    dYAxis(xa0,86,1);
    dZAxis(xa0,52,1);
    x0.x=0; x0.y=0; x0.z=0;
    x1.x=1; x1.y=0; x1.z=0;
    x2.x=0; x2.y=1; x2.z=0;
    gRGrid(x0,x1,x2,NX,NX);         /* regular grid for xy-projection */
    dContours(z,0,1);
    dGridBoundary(0,0);
    deleteGrid();

    if (COLOR) {
      sColorSpace("HSB");
      sContours(ctr,Nctr,c0,c1,c2);
    } else {
      sColorSpace("G");
      sContours(ctr,Nctr,c0); 
    }
    x0.x=0; x0.y=0; x0.z=10;
    x1.x=1; x1.y=0; x1.z=0;
    x2.x=0; x2.y=1; x2.z=0.5;
    gRGrid(x0,x1,x2,NX,NX);         /* slanted regular grid */
    dContours(z,1,(COLOR)?0:1);
    dGridBoundary(0,0);
  endPS();
  
  return 0;
}

