/*
cd ~/C/PSgraf3/examples
g++ -o _data data.cpp -lPSgraf3 -lm
_data
*/

#include <PSgraf3.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{
  int N,i;
  double *x,*y,minx,maxx,miny,maxy;
  FILE *dat;

  dat=fopen("data/ran0.dat","r");
  if (dat==NULL) {
    fprintf(stderr,"cannot open file: abort\n");
    exit(EXIT_FAILURE);
  }

  fscanf(dat,"%i",&N);
    
  x=(double*)malloc(N*sizeof(double));
  if (x==NULL) {
    fprintf(stderr,"cannot allocate memory for array x with %i elements: abort\n",N);
    exit(EXIT_FAILURE);
  }
  y=(double*)malloc(N*sizeof(double));
  if (y==NULL) {
    fprintf(stderr,"cannot allocate memory for array y with %i elements: abort\n",N);
    exit(EXIT_FAILURE);
  }

  for (i=0;i<N;i++) fscanf(dat,"%lf %lf",x+i,y+i);

  fclose(dat);


  gPaper("fig/data");
    MinMax(x,N,&minx,&maxx); MinMax(y,N,&miny,&maxy);

    sXWorldCoord(minx,maxx,0,65); sYWorldCoord(miny,maxy,0,45);
    dXAxis(minx,miny,maxx,1);     dYAxis(minx,miny,maxy,1);

    for (i=0;i<N;i++) dSymbol('W',x[i],y[i],0.5,0);

    dPolygon('W',x,y,N);

  endPS();
  
  return 0;
}
