/*
cd ~/C/PSgraf3/examples
g++ -o _grids grids.cpp -lPSgraf3 -lm
_grids
*/
#include <math.h>
#include <PSgraf3.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{
  int Nx=25,Ny=20,Np,Nl,*b,*e,i,j;
  double x[Nx*Ny],y[Nx*Ny],sphi,cphi,dphi=1.5707963/(Nx-1),r,dr=2.5,min,max;
  struct dvec orig;
  FILE *f;
  
  orig.dim=2; orig.x=0; orig.y=0; 

  gPaper("fig/grids");
    sNumber('f',0);
    sXWorldCoord(0,60,0,40);   sYWorldCoord(0,60,50,90);
    sXIntervals(20,10,2,0);    sYIntervals(20,10,2,0);
    dXAxis(orig,60,1);         dYAxis(orig,60,1);
    gRGrid(5,10,6,5,7.1429,8);
    sDash(0); dGrid(1,0); sDash(-1);
    deleteGrid();
    
    sXWorldCoord(0,60,60,100); sYWorldCoord(0,60,50,90);
    dXAxis(orig,60,1);         dYAxis(orig,60,1);
    for (i=0;i<6;i++) x[i]=5+pow(2,i)*50/31.;
    for (j=0;j<8;j++) y[j]=5+pow(2,j)*50/127.;
    gSRGrid(x,6,y,8);
    dGrid(0,0);
    deleteGrid();    

    sXWorldCoord(0,60,0,40);   sYWorldCoord(0,60,0,40);
    dXAxis(orig,60,1);         dYAxis(orig,60,1);
    for (i=0;i<Nx;i++) {
      sphi=sin(i*dphi); cphi=cos(i*dphi);
      for (j=0;j<Ny;j++) {
        r=0.0001+j*dr;
        x[i+Nx*j]=r*sphi+5; y[i+Nx*j]=r*cphi+5;
      }
    }
    gDRGrid(x,y,Nx,Ny);
    dGrid(0,0);
    deleteGrid();

    sXWorldCoord(0,60,60,100); sYWorldCoord(0,60,0,40);
    dXAxis(orig,60,1);         dYAxis(orig,60,1);
    f=fopen("TGrid.dat","r");
      fscanf(f,"%i %i",&Np,&Nl);
      for (i=0;i<Np;i++) fscanf(f,"%i %lf %lf",&j,x+i,y+i);
      b=(int*)malloc(Nl*sizeof(int));
      e=(int*)malloc(Nl*sizeof(int));
      for (i=0;i<Nl;i++) fscanf(f,"%i %i %i",&j,b+i,e+i);
    fclose(f);

    gTGrid(x,y,Np,b,e,Nl);
    sText("Helvetica",9,'C','C'); dGrid(1,0);
    sText("Helvetica",4,'C','C'); dGrid(0,1);

  endPS();
  
  return 0;
}

