#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dBars: draw bar plot of {(x_i,f(x_i)), i=0,..,N-1} in coordinate system CS [P,W].
       The bars are represented by rectangles (with the current stroke and fill) that are
       centered at x (for equidistant {x}). The first and the last bar are always
       symmetric. {x} must be ordered in monotonically increasing order, but the values
       need not be equidistant. {f(x)} may be negative.

v3.0.2										041028kr
--------------------------------------------------------------------------------------*/
void dBars(char CS,double *x,double *f,int N)
{
  int i;
  double lx,ux;
  
//   hadjust=toupper(hadjust);
//   if (!(hadjust=='L' || hadjust=='C' || hadjust=='R')) {
//     PSwarning("dBars", "unknown horizontal adjustment requested; set to 'L'");
//     hadjust='L';
//   }

  for (i=1;i<N;i++)
    if (x[i]<=x[i-1]) {
      PSwarning("dBars", "{x} not monotonically increasing; operator ignored");
      for (i=0;i<N;i++)
	fprintf(stderr,"\t%5i\t%f\n",i,x[i]);
      return;
    }

  if (N<2) {
    PSwarning("dBars", "less than 2 bars specified; operator ignored");
    return;
  }

  fprintf(PSout,"%%--dBars (%c)-->",CS);
  lx=(3*x[0]-x[1])/2; ux=(x[0]+x[1])/2; dRectangle(CS,lx,0,ux,f[0],0);
  for (i=1;i<N-1;i++) {
    lx=ux; ux=(x[i]+x[i+1])/2; dRectangle(CS,lx,0,ux,f[i],0);    
  }
  lx=ux; ux=(3*x[N-1]-x[N-2])/2; dRectangle(CS,lx,0,ux,f[N-1],0);
  
  return;
}
