#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dDensity: Draw density map (bitmap) in coordinate system CS;
	center of ll pixel is at (x0,y0) and center of ur pixel is at(x0+dx,y0+dy) with
	Nx points in x- and Ny points in y-direction;
	ordering of data zd: 	zd[0]       -> (x0,y0)
				zd[Nx-1]    -> (x0+dx/(Nx-1),y0)
				zd[Nx]	    -> (x0,y0+dy/(Ny-1))
				zd[Nx*Ny-1] -> (x0+dx,y0+dy)
	a missing value at i is indicated by zd[i]>misval and mapped to C_.[N_Ctr]
	
created										971129kr
--------------------------------------------------------------------------------------*/
void dDensity(char CS,double x0,double y0,double dx,double dy,int Nx,int Ny,
	      double *zd,double misval)
{
  int i,j;
  double *c0,*c1,*c2,*c3,*dCtr,px,py,dpx,dpy;
  
  if ((dCtr=(double*)malloc(N_Ctr*sizeof(double)))==NULL)
    PSerror("dDensity","memory overflow");
  for (i=1;i<N_Ctr;i++) dCtr[i]=C_ctr[i]-C_ctr[i-1];


  switch (ColorSpace) {
    case 0:
      if ((c0=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");
      for (i=0;i<Nx*Ny;i++) {
        if (zd[i]>misval) {c0[i]=C_col[N_Ctr].c0;}
	else {
	  if (zd[i]>C_ctr[N_Ctr-1]) {c0[i]=C_col[N_Ctr-1].c0;}
	  else {
            if (zd[i]<C_ctr[0]) {c0[i]=C_col[0].c0;}
	    else {
	      for (j=1;j<N_Ctr;j++) if (zd[i]<C_ctr[j]) break;
	      c0[i]=C_col[j-1].c0+(C_col[j].c0-C_col[j-1].c0)*(zd[i]-C_ctr[j-1])/dCtr[j];
	    }
	  }
	}
      }
      free((void*)dCtr);
      if (CS=='P' || CS=='p') {
        px=x0; py=y0; dpx=dx; dpy=dy;
      } else {
        pWP(0,0,&px,&py); pWP(dx,dy,&dpx,&dpy); dpx-=px; dpy-=py;
	pWP(x0,y0,&px,&py); 
      }
      dBitMap(px-0.5*dpx/Nx,py-0.5*dpy/Ny,(Nx+1)*dpx/Nx,(Ny+1)*dpy/Ny,Nx,Ny,c0);
      free((void*)c0);
      break;
      
    case 2: case 4:
      if ((c0=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");
      if ((c1=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");
      if ((c2=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");

      for (i=0;i<Nx*Ny;i++) {
        if (zd[i]>misval) {
	  c0[i]=C_col[N_Ctr].c0; c1[i]=C_col[N_Ctr].c1; c2[i]=C_col[N_Ctr].c2;
	} else {
	  if (zd[i]>C_ctr[N_Ctr-1]) {
	    c0[i]=C_col[N_Ctr-1].c0; c1[i]=C_col[N_Ctr-1].c1; c2[i]=C_col[N_Ctr-1].c2;
	  } else {
            if (zd[i]<C_ctr[0]) {
	      c0[i]=C_col[0].c0; c1[i]=C_col[0].c1; c2[i]=C_col[0].c2;
	    } else {
	      for (j=1;j<N_Ctr;j++) if (zd[i]<C_ctr[j]) break;
	      c0[i]=C_col[j-1].c0+(C_col[j].c0-C_col[j-1].c0)*(zd[i]-C_ctr[j-1])/dCtr[j];
	      c1[i]=C_col[j-1].c1+(C_col[j].c1-C_col[j-1].c1)*(zd[i]-C_ctr[j-1])/dCtr[j];
	      c2[i]=C_col[j-1].c2+(C_col[j].c2-C_col[j-1].c2)*(zd[i]-C_ctr[j-1])/dCtr[j];
	    }
	  }
	}
      }
      free((void*)dCtr);
      if (CS=='P' || CS=='p') {
        px=x0; py=y0; dpx=dx; dpy=dy;
      } else {
        pWP(0,0,&px,&py); pWP(dx,dy,&dpx,&dpy); dpx-=px; dpy-=py;
	pWP(x0,y0,&px,&py); 
      }
      dBitMap(px-0.5*dpx/Nx,py-0.5*dpy/Ny,(Nx+1)*dpx/Nx,(Ny+1)*dpy/Ny,Nx,Ny,c0,c1,c2);
      free((void*)c0); free((void*)c1); free((void*)c2);
      break;
      
    case 8:
      if ((c0=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");
      if ((c1=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");
      if ((c2=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");
      if ((c3=(double*)malloc(Nx*Ny*sizeof(double)))==NULL)
	PSerror("dDensity","memory overflow");

      for (i=0;i<Nx*Ny;i++) {
        if (zd[i]>misval) {
	  c0[i]=C_col[N_Ctr].c0; c1[i]=C_col[N_Ctr].c1;
	  c2[i]=C_col[N_Ctr].c2; c3[i]=C_col[N_Ctr].c3;
	} else {
	  if (zd[i]>C_ctr[N_Ctr-1]) {
	    c0[i]=C_col[N_Ctr-1].c0; c1[i]=C_col[N_Ctr-1].c1;
	    c2[i]=C_col[N_Ctr-1].c2; c3[i]=C_col[N_Ctr-1].c3;
	  } else {
            if (zd[i]<C_ctr[0]) {
	      c0[i]=C_col[0].c0; c1[i]=C_col[0].c1; c2[i]=C_col[0].c2; c3[i]=C_col[0].c3;
	    } else {
	      for (j=1;j<N_Ctr;j++) if (zd[i]<C_ctr[j]) break;
	      c0[i]=C_col[j-1].c0+(C_col[j].c0-C_col[j-1].c0)*(zd[i]-C_ctr[j-1])/dCtr[j];
	      c1[i]=C_col[j-1].c1+(C_col[j].c1-C_col[j-1].c1)*(zd[i]-C_ctr[j-1])/dCtr[j];
	      c2[i]=C_col[j-1].c2+(C_col[j].c2-C_col[j-1].c2)*(zd[i]-C_ctr[j-1])/dCtr[j];
	      c3[i]=C_col[j-1].c3+(C_col[j].c3-C_col[j-1].c3)*(zd[i]-C_ctr[j-1])/dCtr[j];
	    }
	  }
	}
      }
      free((void*)dCtr);
      if (CS=='P' || CS=='p') {
        px=x0; py=y0; dpx=dx; dpy=dy;
      } else {
        pWP(0,0,&px,&py); pWP(dx,dy,&dpx,&dpy); dpx-=px; dpy-=py;
	pWP(x0,y0,&px,&py); 
      }
      dBitMap(px-0.5*dpx/Nx,py-0.5*dpy/Ny,(Nx+1)*dpx/Nx,(Ny+1)*dpy/Ny,Nx,Ny,c0,c1,c2);
      free((void*)c0); free((void*)c1); free((void*)c2); free((void*)c3);
      break;
      
    default:
      PSwarning("dDensity","ColorSpace undefined: operator ignored");
      break;
  } 
  
  return;
}
