#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dGrid: draw current grid

HISTORY:
  v3.0.0									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void dGrid(int Node_numbers,int Line_numbers)
{
  int *Ndone,N,i;
  char oldhadj,oldvadj,text[20];
  double x0,y0;
  struct line *thiss,*last;
  
  if (L_==NULL) {PSwarning("dGrid","no grid defined: operator ignored"); return;}
  
  oldhadj=hadj; oldvadj=vadj; hadj='C'; vadj='C';
  
  fprintf(PSout,"%%-----dGrid\nnewpath\n");	/*-----gridlines */
  x0=L_->bx; y0=L_->by;
  m2Pa(x0,y0); l2Pa(L_->ex,L_->ey);
  for (i=1,last=L_,thiss=L_+1;i<NL_;i++,last++,thiss++) {
    if (thiss->bx!=last->ex || thiss->by!=last->ey) {
      m2Pa(x0,y0);
      fprintf(PSout,"  closepath\nstroke\n");
      fprintf(PSout,"newpath\n");
      x0=thiss->bx; y0=thiss->by; m2Pa(x0,y0);
    }
    l2Pa(thiss->ex,thiss->ey);
  }
  m2Pa(x0,y0);
  fprintf(PSout,"  closepath\nstroke\n");
  
  if (Node_numbers) {				/*-----node numbers */
    Ndone=(int*) calloc(NL_,sizeof(int));	/* mem. for Ndone (nodes done) */
    if (Ndone==NULL) PSerror("dGrid","memory overflow");
    for (i=0,thiss=L_;i<NL_;i++,thiss++) {
      N=thiss->n[0];
      if (!*(Ndone+N)) {
	*(Ndone+N)=1;
	m2Pa(thiss->bx,thiss->by);
	sprintf(text,"%i",N); dText(text);
      }
      N=thiss->n[1];
      if (!*(Ndone+N)) {
	*(Ndone+N)=1;
	m2Pa(thiss->ex,thiss->ey);
	sprintf(text,"%i",N); dText(text);
      }
    }
    free((void*) Ndone);}			/* release memory */
	
  if (Line_numbers) {				/*-----line numbers */
    for (i=0,thiss=L_;i<NL_;i++,thiss++) {
      m2Pa(0.5*(thiss->bx+thiss->ex),0.5*(thiss->by+thiss->ey));
      sprintf(text,"%i",i); dText(text);
    }
  }
  hadj=oldhadj; vadj=oldvadj;
  
  return;
}
