#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dGridBoundary: draw boundary of current grid

HISTORY:
  v3.0.0									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void dGridBoundary(int Node_numbers,int Line_numbers)
{
  int N,i;
  char oldhadj,oldvadj,text[20];
  double x,y;
  struct line *l;
  struct bline *b;
  
  if (B_==NULL) {
    PSwarning("dGridBoundary","no grid boundary defined; operator ignored");
    return;
  }
  
  oldhadj=hadj; oldvadj=vadj;
  hadj='C'; vadj='C';
  fprintf(PSout,"%%-----dGridBoundary\nnewpath\n");		/* grid lines on bdr */
  b=B_; l=b->l; m2Pa(l->bx,l->by);
  x=l->ex; y=l->ey; l2Pa(x,y);
  for (i=1;i<NB_;i++) {
    b=b->path[0]; l=b->l;
    if (x==l->ex && y==l->ey) {x=l->bx; y=l->by;} else {x=l->ex; y=l->ey;}
    l2Pa(x,y);
  }
  fprintf(PSout,"  closepath\nstroke\n");
  if (Node_numbers) {						/* node numbers*/
    b=B_; l=b->l; x=l->ex; y=l->ey; N=l->n[1]; m2Pa(x,y);
    sprintf(text,"%i",N); dText(text);
    for (i=1;i<NB_;i++) {
      b=b->path[0]; l=b->l;
      if (x==l->ex && y==l->ey) {x=l->bx; y=l->by; N=l->n[0];}
      else {x=l->ex; y=l->ey; N=l->n[1];}
      m2Pa(x,y);
      sprintf(text,"%i",N); dText(text);
    }
  }
  if (Line_numbers) {						/* line numbers */
    b=B_;
    for (i=0;i<NB_;i++,b=b->path[0]) {
      N=(b->l)-L_;
      m2Pa(0.5*(b->l->bx + b->l->ex),0.5*(b->l->by + b->l->ey));
      sprintf(text,"%i",N); dText(text);
    }
  }
  hadj=oldhadj; vadj=oldvadj;
  
  return;
}
