#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dMissing: fill areas corresponding to missing data with default misscolor (10% gray)

HISTORY:
  v3.0.2									041128kr
  debugged									970525kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void dMissing(int *missing)
{
  struct color misscol;

  misscol.CS=0; misscol.c0=0.1;		/* set light gray for missing color */
  dMissing(missing,misscol);

  return;
}
/*--------------------------------------------------------------------------------------
dMissing: fill areas corresponding to missing data with misscolor

HISTORY:
  v3.0.2									041128kr
  debugged									970525kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void dMissing(int *missing,struct color misscol)
{
  int N_m,save_N_Ctr,save_ColorSpace,i;
  double *z,*save_C_ctr,this_C_ctr[1];
  struct color *save_C_col,this_C_col[2];

  N_m=0;				/* count missing values */
  for (i=0;i<N_gn;i++) if (missing[i]) N_m++;
  if (N_m==0) return;			/* no missing values: return */


  if (C_ctr!=NULL && N_Ctr>0) {		/* save current contour settings */
    save_ColorSpace=ColorSpace;
    save_N_Ctr=N_Ctr;
    save_C_ctr=C_ctr;
    save_C_col=C_col-1;			/* sContours increments C_col */
  } else {
    PSwarning("dMissing",
	      "sContours must have been invoked before: operator ignored");
    return;
  }

  this_C_ctr[0]=0;
  this_C_col[1]=misscol;
  this_C_col[0]=misscol; this_C_col[0].c0=NONE;
  ColorSpace=misscol.CS;

  z=(double*) malloc(N_gn*sizeof(double));
  if (z==NULL) PSerror("dMissing","memory overflow");
  
  for (i=0;i<N_gn;i++) z[i]=(missing[i])?1:-1;

  sContours(this_C_ctr,1,this_C_col);
  dContours(z,1,0);

  free((void*) z);			/* release memory */
  
  ColorSpace=save_ColorSpace;		/* reset saved values */
  sContours(save_C_ctr,save_N_Ctr,save_C_col);

  return;
}
