#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dParallel: draw parallelogram with corner x0 and edges s0 and s1
           in coordinate system CS [P,W]

v3.0.0										031115kr
--------------------------------------------------------------------------------------*/
void dParallel(char CS,struct dvec x0,struct dvec s0,struct dvec s1)
{
  int i;
  struct dvec p[5];
  
  if (x0.dim!=2 && x0.dim!=3)
    PSerror("dParallel","dimension different from 2 or 3");
  if (x0.dim!=s0.dim || s0.dim!=s1.dim) {
    PSerror("dParallel","dimensions of vectors different");
  }

  for (i=0;i<5;i++) p[i].dim=x0.dim;

  fprintf(PSout, "%%--dParallel (%c%i)-->",CS,x0.dim);
  p[0].x=p[4].x=x0.x; p[1].x=p[0].x+s0.x; p[2].x=p[1].x+s1.x; p[3].x=p[2].x-s0.x;
  p[0].y=p[4].y=x0.y; p[1].y=p[0].y+s0.y; p[2].y=p[1].y+s1.y; p[3].y=p[2].y-s0.y;
  if (x0.dim==3)
    p[0].z=p[4].z=x0.z; p[1].z=p[0].z+s0.z; p[2].z=p[1].z+s1.z; p[3].z=p[2].z-s0.z;

  dPolygon(CS,p,5);
  
  return;
}
/*--------------------------------------------------------------------------------------
dParallel: draw parallelogram with corner x0 and edges s0, s1, s2
           in coordinate system CS [P,W]

	   draw faces individually to eventually allow different shading
--------------------------------------------------------------------------------------*/
void dParallel(char CS,struct dvec x0,struct dvec s0,struct dvec s1,struct dvec s2)
{
  if (x0.dim!=2 && x0.dim!=3)
    PSerror("dParallel","dimension different from 2 or 3");
  if (x0.dim!=s0.dim || s0.dim!=s1.dim || s0.dim!=s2.dim) {
    PSerror("dParallel","dimensions of vectors different");
  }

  dParallel(CS,x0,s0,s1);
  dParallel(CS,x0,s0,s2);
  dParallel(CS,x0,s1,s2);
  x0=addvec(x0,addvec(s0,addvec(s1,s2))); s0=negvec(s0); s1=negvec(s1); s2=negvec(s2);
  dParallel(CS,x0,s0,s1);
  dParallel(CS,x0,s0,s2);
  dParallel(CS,x0,s1,s2);
  
  return;
}
