#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
dText: draw text

HISTORY:
  v3.0.0, layered TeX text							031227kr
  added TeXstyle								980908kr
  removed special treatment of "no rotation"					960220kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void dText(const char *text)
{
  double x,y,dx,dy,s1,s2,s3,s4,phi,ax=0,ay=0;
  char TeXcolor[127];
  
  phi=Deg_to_Rad*TextRotation;
  if (hadj=='C') ax=0.5; else if (hadj=='R') ax=1;
  if (vadj=='C') ay=0.5; else if (vadj=='T') ay=1;
  
  if (TeXfonts==1) {				/*-----TeX fonts-----*/
    if (lay_text>=0) lay_text=lay_fill+1;
    x=PT_to_MM*cpx+Px; y=PT_to_MM*cpy+Py;
    if (clip_on) {
      if (x<clip_xl || x>clip_xh || y<clip_yl || y>clip_yh) {
	PSwarning("dText","location outside clipping rectangle: operator ignored");
	return;
      }
    }
    switch (ColorSpace) {
    case 0:
      sprintf(TeXcolor,"{}");
      break;
    case 2:
      sprintf(TeXcolor,"\\color[rgb]{%f,%f,%f}",S_c0,S_c1,S_c2);
      break;
    case 4:
      sprintf(TeXcolor,"\\color[hsb]{%f,%f,%f}",S_c0,S_c1,S_c2);
      break;
    case 8:
      sprintf(TeXcolor,"\\color[cmyk]{%f,%f,%f,%f}",S_c0,S_c1,S_c2,S_c3);
      break;
    default:
      PSwarning("sText","ColorSpace undefined: operator ignored");
      sprintf(TeXcolor,"{}");
      break;
    }
    fprintf(TeXout,"%i{%f}{%f}{{%s%s{}%s}}{%i}{%f}{%f}{%f}{%f}\n",
	    lay_text,
	    x,y,
	    TeXstyle,TeXcolor,text,
	    (int) TextRotation,ax,ay,cos(phi),sin(phi));
  } else {					/*-----PostScript fonts-----*/
    fprintf(PSout,"gsave (%s) true charpath flattenpath pathbbox grestore\n",text);
    fprintf(PSout,"2 index sub %f mul exch 3 index sub %f mul exch\n",-ay,-ax);
    fprintf(PSout,"gsave\n");
    fprintf(PSout,"2 copy\n");
    fprintf(PSout,"%f sin mul exch %f cos mul add\n",
		    -TextRotation,TextRotation);
    fprintf(PSout,"1 index %f cos mul 3 index %f sin mul add\n",
		    TextRotation,TextRotation);
    fprintf(PSout,"rmoveto %f rotate (%s) show clear\n",TextRotation, text);
    fprintf(PSout,"grestore\n");
  
    dx=X_stretch*strlen(text)*curFSize;		/* update BoundingBox */
    dy=Y_stretch*curFSize;
    s1=cos(phi)*dx; s2=sin(phi)*dx;
    s3=cos(phi)*dy; s4=sin(phi)*dy;
    x=cpx-ax*s1+ay*s4; y=cpy-ax*s2-ay*s3; updateBB(x,y);
    x+=s1; y+=s2; updateBB(x,y);
    x-=s4; y+=s3; updateBB(x,y);
    x-=s1; y-=s2; updateBB(x,y);
  }
  
  return;
}
