#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
endPS: save last PostScript file

HISTORY:
  v3.0.3 debug: error messages; add version string				041223kr
  v3.0.1 debug: mark PSgraf as not initialized and reset drawing count 		040623kr
  v3.0.0									031115kr
  give bounding box as (rounded) integers; some previewers cannot handle reals	020519kr
  add bounding box of PostScript file to TeX file      				971221kr
  all coordinates positive							950330kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void endPS(void)
{
  int portrait,i;
  double dx,dy,tx,ty;
  char fn[255],c;
  FILE *inttex;

  if (PSout==NULL) {
    fprintf(stderr, "\n$ PSgraf error\n\tendPS: no file to close (endPS missing?)\n\n");
    return;
  }

  fprintf(PSout,"grestore\n");			/* close PSout */
  if (clip_on) sClipping();
  fprintf(PSout,"showpage\n");
  fprintf(PSout,"%%%%Trailer\n");
  fprintf(PSout,"%%%%EOF\n");
  dx=Bxur-Bxll; dy=Byur-Byll; portrait=(dy/dx>1.4142);
  tx=Px/PT_to_MM; ty=Py/PT_to_MM;
  if ((portrait && dy<296*PT_to_MM) || (!portrait && dx<296*PT_to_MM)) {
    dx=105*PT_to_MM-Bxll-dx/2; dy=148*PT_to_MM-Byll-dy/2;
  } else {
    dx=10*PT_to_MM-Bxll; dy=10*PT_to_MM-Byll;
  }
  Bxll+=dx; Bxur+=dx; Byll+=dy; Byur+=dy;
  fseek(PSout,BoundingBox,SEEK_SET);
  Bxll=floor(Bxll); Bxur=ceil(Bxur); Byll=floor(Byll); Byur=ceil(Byur);
  fprintf(PSout,"%%%%BoundingBox: %12.0f %12.0f %12.0f %12.0f\n",Bxll,Byll,Bxur,Byur);
  //  fprintf(PSout,"%%%%BoundingBox: %12.2f %12.2f %12.2f %12.2f\n",Bxll,Byll,Bxur,Byur);
  fseek(PSout, PaperShift,SEEK_SET);
  fprintf(PSout,"%12.5f %12.5f  translate\n",tx+dx,ty+dy);
  fclose(PSout);
  if (EPSencaps) gPreview();
  if (TeXfonts) {				// close intermediary TeXout if it exists
    fclose(TeXout);
                                                // process intermediary TeX output
    sprintf(fn,"%s.tex", paper_name);   TeXout=fopen(fn,"w");
    if (TeXout==NULL) PSerror("endPS","cannot open TeX file for writing");
    sprintf(fn,"%s.inttex",paper_name); inttex=fopen(fn,"r");
      fprintf(TeXout, "%%Document: %s\n",paper_name);
      fprintf(TeXout,"%%%%Creator: PSgraf %s, copyright Kurt Roth 1992-2004\n",
	      PSgraflibVersionString);
      dx=tx+dx-Bxll; dy=ty+dy-Byll;
      fprintf(TeXout,"\\xoff=%12.5fbp\\yoff=%12.5fbp\n",dx,dy);

      while (fscanf(inttex,"%i",&i)!=EOF) {  	// copy text
	fprintf(TeXout,"\\dlTeXText");
	while ((c=fgetc(inttex))!='\n') fprintf(TeXout,"%c",c);
	  if (i<0 || i>lay_fill)
	    fprintf(TeXout,"{2}%%\n");
	  else
	    fprintf(TeXout,"{1}%%\n");
      }

      fprintf(TeXout,"\\dlTeXText{%f}{%f}{{}}{0}{0.5}{0.5}{1}{0}{1}%%\n",
	      -dx,-dy);
      fprintf(TeXout,"\\dlTeXText{%f}{%f}{{}}{0}{0.5}{0.5}{1}{0}{1}%%\n",
	      Bxur-Bxll-dx,Byur-Byll-dy);
      fprintf(TeXout,"\\xoff=%12.5fbp\\yoff=%12.5fbp\n",-dx,-dy);
    fclose(inttex); remove(fn); fclose(TeXout);
  }

  if (L_!=NULL) free((void*)L_);		/* free memory (grid) */
  if (B_!=NULL) free((void*)B_);		/* free memory (boundary) */

  PSinitialized=0; PSdrwN=0;

  printf("---------- leaving PSgraf %s\n\n\n",PSgraflibVersionString);
  return;
}
