#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
gPreview: encapsulate preview by invoking system calls "ps2epsi" and "mv".

          This function is typically not invoked explicitly but implicitly by
	  gPaper and endPS when the preview flag has been set by sPreview(1).

	  see /usr/bin/ps2epsi

v2.4.1										011226kr
--------------------------------------------------------------------------------------*/
void gPreview(void)
{
  char c,cbuf[255],fn[255];
  FILE *eps_in,*eps_out;

  			/* system call for generating preview */
  sprintf(cbuf,"ps2epsi %s.eps %s.epsi",paper_name,paper_name);
  system(cbuf);

/* Bounding box calculated by ps2epsi does not capture TeXfonts and is thus inaccurate. */
/* The following clumsy remedy is to copy file explicitly but inserting the precise BB  */
/* information                                                                          */

                       /* open in & out files,... */
  sprintf(fn,"%s.epsi",paper_name);
  if ((eps_in=fopen(fn,"r"))==NULL) {
    sprintf(cbuf,"cannot read file %s",fn); PSerror("gPreview",cbuf);
  }
  sprintf(fn,"%s.eps",paper_name);
  if ((eps_out=fopen(fn,"w"))==NULL) {
    sprintf(cbuf,"cannot write file %s",fn); PSerror("gPreview",cbuf);
  }

                       /* ...copy material above BB,... */
  fscanf(eps_in,"%s",cbuf);
  while (strncmp(cbuf,"%%BoundingBox",13)!=0) {
    fprintf(eps_out,"%s",cbuf);
    while ((c=fgetc(eps_in))!=EOF && c!='\n') fputc(c,eps_out);
    fprintf(eps_out,"\n");
    fscanf(eps_in,"%s",cbuf);
  }
                       /* ...write original BB,... */
  fprintf(eps_out,"%%%%BoundingBox: %.2f %.2f %.2f %.2f\n",Bxll,Byll,Bxur,Byur);
  while ((c=fgetc(eps_in))!=EOF && c!='\n') ;

                       /* ...copy material below BB,... */
  while ((c=fgetc(eps_in))!=EOF) fputc(c,eps_out);

                       /* ...and close in & out files */  
  fclose(eps_in); fclose(eps_out);


  			/* system call for removing *.epsi */
  sprintf(cbuf,"rm -f %s.epsi",paper_name);
  system(cbuf);

  return;
}
