#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
gTCover: get coverage of triangular grid; grid must already be defined
         return # triangles created

created										001223kr
--------------------------------------------------------------------------------------*/
int gTCover()
{
  int iL,iT,**nodes,**lines,i;
  double *cgx,*cgy;

  if (L_==NULL) PSerror("gTCover","Grid not yet defined");
  if (GT_!=1)   PSerror("gTCover","Grid must be triangular");

  nodes=(int**) malloc(NL_*sizeof(int*));			/* allocate memory */
  if (nodes==NULL) PSerror("gTCover","memory overflow");
  for (i=0;i<NL_;i++) {
    nodes[i]=(int*) malloc(3*sizeof(int));
    if (nodes[i]==NULL) PSerror("gTCover","memory overflow");
  }
  lines=(int**) malloc(NL_*sizeof(int*));
  if (lines==NULL) PSerror("gTCover","memory overflow");
  for (i=0;i<NL_;i++) {
    lines[i]=(int*) malloc(3*sizeof(int));
    if (lines[i]==NULL) PSerror("gTCover","memory overflow");
  }
  cgx  =(double*) malloc(NL_*sizeof(double));
  if (cgx==NULL)   PSerror("gTCover","memory overflow");
  cgy  =(double*) malloc(NL_*sizeof(double));
  if (cgy==NULL)   PSerror("gTCover","memory overflow");

  iT=0;
  for (iL=0;iL<NL_;iL++) {
    if (L_[iL].id<L_[iL].l[0]->id && L_[iL].id<L_[iL].l[1]->id) {
      nodes[iT][0]=L_[iL].n[0]; nodes[iT][1]=L_[iL].n[1];
      lines[iT][0]=iL; lines[iT][1]=L_[iL].l[0]->id; lines[iT][2]=L_[iL].l[1]->id;
      cgx[iT]=L_[iL].bx+L_[iL].ex; cgy[iT]=L_[iL].by+L_[iL].ey;
      if (L_[iL].n[0]==L_[iL].l[0]->n[0] || L_[iL].n[1]==L_[iL].l[0]->n[0]) {
	nodes[iT][2]=L_[iL].l[0]->n[1];
	cgx[iT]+=L_[iL].l[0]->ex; cgy[iT]+=L_[iL].l[0]->ey;
      } else {
	nodes[iT][2]=L_[iL].l[0]->n[0];
	cgx[iT]+=L_[iL].l[0]->bx; cgy[iT]+=L_[iL].l[0]->by;
      }
      cgx[iT]/=3; cgy[iT]/=3;
      iT++;
    }
    if (L_[iL].l[2]!=NULL) {
      if (L_[iL].id<L_[iL].l[2]->id && L_[iL].id<L_[iL].l[3]->id) {
	nodes[iT][0]=L_[iL].n[0]; nodes[iT][1]=L_[iL].n[1];
	lines[iT][0]=iL; lines[iT][1]=L_[iL].l[2]->id; lines[iT][2]=L_[iL].l[3]->id;
	cgx[iT]=L_[iL].bx+L_[iL].ex; cgy[iT]=L_[iL].by+L_[iL].ey;
	if (L_[iL].n[0]==L_[iL].l[2]->n[0] || L_[iL].n[3]==L_[iL].l[0]->n[0]) {
	  nodes[iT][2]=L_[iL].l[2]->n[1];
	  cgx[iT]+=L_[iL].l[2]->ex; cgy[iT]+=L_[iL].l[2]->ey;
	} else {
	  nodes[iT][2]=L_[iL].l[2]->n[0];
	  cgx[iT]+=L_[iL].l[2]->bx; cgy[iT]+=L_[iL].l[2]->by;
	}
	cgx[iT]/=3; cgy[iT]/=3;
	iT++;
      }
    }
  }

  NT_=iT;
  T_=(struct Telement*) malloc(NL_*sizeof(struct Telement));
  if (T_==NULL) PSerror("gTCover","memory overflow");
  for (iT=0;iT<NT_;iT++) {
    T_[iT].id=iT;
    for (i=0;i<3;i++) T_[iT].n[i]=nodes[iT][i];
    T_[iT].cg[0]=cgx[iT]; T_[iT].cg[1]=cgy[iT];
    for (i=0;i<3;i++) T_[iT].l[i]=lines[iT][i];
  }
  
  for (i=0;i<NL_;i++) {free((void*)nodes[i]); free((void*)lines[i]);}
  free((void*)nodes); free((void*)lines);
  free((void*)cgx);   free((void*)cgy);

  return NT_;
}
#undef COM_SYM_DEF
