#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
interpolate: recursively interpolate missing values; replaces Z and returns number of 
	interpolated values;
	does not modify missing

v2.0										920524kr
--------------------------------------------------------------------------------------*/
int interpolate(double Z[],int missing[])
{
  int *miss,*weight,N_m,N_m0,n0,n1,i;
  
  N_m=0;				/* count missing values */
  for (i=0;i<N_gn;i++) if (missing[i]) N_m++;
  if (N_m==0) return 0;			/* no missing values */
  N_m0=N_m;
  
  if ((miss=(int*) malloc(N_gn*sizeof(int)))==NULL)
    PSerror("interpolate","memory overflow");
  if ((weight=(int*) malloc(N_gn*sizeof(int)))==NULL)
    PSerror("interpolate","memory overflow");
  
  for (i=0;i<N_gn;i++) {
    miss[i]=missing[i]; weight[i]=0; if (miss[i]) Z[i]=0;
  }
  
  while (N_m>0) {
    for (i=0;i<NL_;i++) {		/* sum contributions from neighbors */
      n0=L_[i].n[0]; n1=L_[i].n[1];
      if (miss[n0]) {if (!miss[n1]) {weight[n0]++; Z[n0] +=Z[n1];}}
      else if (miss[n1]) {if (!miss[n0]) {weight[n1]++; Z[n1] +=Z[n0];}}
    }
    for (i=0;i<N_gn;i++)		/* calculate weighted value */
      if (miss[i] && weight[i]>0) {
        Z[i]/=weight[i]; miss[i]=0; weight[i]=0;
      }
    N_m=0;				/* count remaining missing values */
    for (i=0;i<N_gn;i++) if (miss[i]) N_m++;
  }

  free((void*) miss);			/* release memory */
  free((void*) weight);
  
  return N_m0;
}
