#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
linea: line to absolute position X in coordinate system CS [P,W]

HISTORY:
  v3.0.0       									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void linea(char CS,struct dvec X)
{
  CS=toupper(CS);

  if (X.dim==2) {
    if (CS=='W') {l2Wa(X.x,X.y); return;}
    if (CS=='P') {l2Pa(X.x,X.y); return;}
    PSerror("linea","requested coordinate system not implemented");
  }

  if (X.dim==3) {
    CS=toupper(CS);
    if (CS=='W') {
      linea('P',pWI(X));
      return;
    }
    if (CS=='P') {
      linea('P',pPI(X));
      return;
    }
    PSerror("linea","requested coordinate system not implemented: operator ignored");
  }

  PSerror("linea","dimension different from 2 or 3: operator ignored");
}
/*--------------------------------------------------------------------------------------
linea: line to absolute position in 2D coordinate system CS [P,W]
--------------------------------------------------------------------------------------*/
void linea(char CS,double x,double y)
{
  CS=toupper(CS);

  if (CS=='W') {l2Wa(x,y); return;}

  if (CS=='P') {l2Pa(x,y); return;}

  PSerror("linea","requested coordinate system not implemented");
}
/*--------------------------------------------------------------------------------------
l2Pa: line to absolute position in 2d P without checks
--------------------------------------------------------------------------------------*/
void l2Pa(double x,double y)
{
  cpx=x; cpy=y;
  fprintf(PSout,"  %f %f  lineto\n",cpx,cpy);
  updateBB(cpx,cpy);
  
  return;
}
/*--------------------------------------------------------------------------------------
l2Wa: line to absolute position in 2d W without checks
--------------------------------------------------------------------------------------*/
void l2Wa(double x,double y)
{
  cpx=Plx+(x-Wlx)*PWx; cpy=Ply+(y-Wly)*PWy;
  fprintf(PSout,"  %f %f  lineto\n",cpx,cpy);
  updateBB(cpx,cpy);
  
  return;
}
