#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
liner: line from current position to X in coordinate system CS [P,W]

HISTORY:
  v3.0.0       									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void liner(char CS,struct dvec X)
{
  if (X.dim==2) {
    liner(CS,X.x,X.y);
    return;
  }

  if (X.dim==3) {
    CS=toupper(CS);
    if (CS=='W') {
      pWI(X,&X); liner('P',X.x,X.y);
      return;
    }
    if (CS=='P') {
      pPI(X,&X); liner('P',X.x,X.y);
      return;
    }
    PSwarning("liner","requested coordinate system not implemented: operator ignored");
    return;
  }

  PSwarning("liner","dimension different from 2 or 3: operator ignored");
  return;

  return;
}
/*--------------------------------------------------------------------------------------
liner: line relative to current position in 2d coordinate system CS [P,W]

HISTORY:
  v3.0.0       									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void liner(char CS,double x,double y)
{
  double dx,dy;
  
  CS=toupper(CS);
  if (CS!='W' && CS!='P')
    PSerror("liner","requested coordinate system not implemented");


  if (CS=='W') {
    dx=x*PWx; cpx+=dx;
    dy=y*PWy; cpy+=dy;
    fprintf(PSout, "  %f %f  rlineto\n",dx,dy);
  } else {
    cpx+=x; cpy+=y;
    fprintf(PSout, "  %f %f  rlineto\n",x,y);
  }

  updateBB(cpx, cpy);
  
  return;
}
