#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
movea: move to absolute position x in coordinate system CS [P,W]

HISTORY:
  v3.0.0       									031115kr
--------------------------------------------------------------------------------------*/
void movea(char CS,struct dvec X)
{
  CS=toupper(CS);

  if (CS=='P') {
    if (X.dim==2) {m2Pa(X.x,X.y);     return;}
    if (X.dim==3) {m3Pa(X.x,X.y,X.z); return;}
    PSerror("movea","dimension different from 2 or 3");
  }

  if (CS=='W') {
    if (X.dim==2) {m2Wa(X.x,X.y);     return;}
    if (X.dim==3) {m3Wa(X.x,X.y,X.z); return;}
    PSerror("movea","dimension different from 2 or 3");
  }

  PSerror("movea","requested coordinate system not implemented");
}
/*--------------------------------------------------------------------------------------
movea: move to absolute position in 3d coordinate system CS [P,W]

HISTORY:
  v3.0.0									031115kr
--------------------------------------------------------------------------------------*/
void movea(char CS,double x,double y,double z)
{
  CS=toupper(CS);

  if (CS=='P') {m3Pa(x,y,z); return;}

  if (CS=='W') {m3Wa(x,y,z); return;}

  PSerror("movea","requested coordinate system not implemented");
}
/*--------------------------------------------------------------------------------------
movea: move to absolute position in 2d coordinate system CS [P,W]

HISTORY:
  v3.0.0									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void movea(char CS,double x,double y)
{
  CS=toupper(CS);

  if (CS=='W') {m2Wa(x,y); return;}

  if (CS=='P') {m2Pa(x,y); return;}

  PSerror("movea","requested coordinate system not implemented");
}
/*--------------------------------------------------------------------------------------
m2Pa: move to absolute position in 2d P without checks

HISTORY:
  v3.0.0									031220kr
--------------------------------------------------------------------------------------*/
void m2Pa(double x,double y)
{
  cpx=x; cpy=y;
  fprintf(PSout, "  %f %f  moveto\n",cpx,cpy);
  updateBB(cpx,cpy);
  
  return;
}
/*--------------------------------------------------------------------------------------
m2Wa: move to absolute position in 2d W without checks

HISTORY:
  v3.0.0									031115kr
--------------------------------------------------------------------------------------*/
void m2Wa(double x,double y)
{
  cpx=Plx+(x-Wlx)*PWx; cpy=Ply+(y-Wly)*PWy;
  fprintf(PSout, "  %f %f  moveto\n",cpx,cpy);
  updateBB(cpx,cpy);
  
  return;
}
/*--------------------------------------------------------------------------------------
m3Pa: move to absolute position in 3d P without checks

HISTORY:
  v3.0.0									031220kr
--------------------------------------------------------------------------------------*/
void m3Pa(double x,double y,double z)
{
  pPI(x,y,z,&cpx,&cpy);
  fprintf(PSout, "  %f %f  moveto\n",cpx,cpy);
  updateBB(cpx,cpy);
  
  return;
}
/*--------------------------------------------------------------------------------------
m3Wa: move to absolute position in 3d W without checks

HISTORY:
  v3.0.0									031115kr
--------------------------------------------------------------------------------------*/
void m3Wa(double x,double y,double z)
{
  pWI(x,y,z,&cpx,&cpy);
  fprintf(PSout, "  %f %f  moveto\n",cpx,cpy);
  updateBB(cpx,cpy);
  
  return;
}
