#undef COM_SYM_DEF
#include "PSgraf_p.h"
// void mover(char CS,struct dvec x);
// void mover(char CS,double x,double y);
// void mover(char CS,double x,double y,double z);

/*--------------------------------------------------------------------------------------
mover: move relative to current position in coordinate system CS [P,W]

HISTORY:
  v3.0.0       									031115kr
--------------------------------------------------------------------------------------*/
void mover(char CS,struct dvec X)
{
  double dx,dy;
  struct dvec X0,X1;
  
  CS=toupper(CS);
  if (CS!='W' && CS!='P')
    PSerror("mover","requested coordinate system not implemented");
  if (X.dim!=2 && X.dim!=3)
    PSerror("mover","dimension different from 2 or 3");

  if (X.dim==2) {				/* dim = 2 */
    if (CS=='W') {
      dx=X.x*PWx; cpx+=dx;
      dy=X.y*PWy; cpy+=dy;
      fprintf(PSout, "  %f %f  rmoveto\n",dx,dy);
    } else {
      cpx+=X.x; cpy+=X.y;
      fprintf(PSout, "  %f %f  rmoveto\n",X.x,X.y);
    }
  } else {					/* dim = 3 */
    if (CS=='W') {
      pWI(X,&X1);
      X.x=X.y=X.z=0; pWI(X,&X0);
    } else {
      pPI(X,&X1);
      X.x=X.y=X.z=0; pPI(X,&X0);
    }
    dx=(X1.x-X0.x); cpx+=dx;
    dy=(X1.y-X0.y); cpy+=dy;
    fprintf(PSout, "  %f %f  rmoveto\n",dx,dy);
  }

  updateBB(cpx, cpy);
  
  return;
}
/*--------------------------------------------------------------------------------------
mover: move relative to current position in coordinate system CS [P,W]

HISTORY:
  v3.0.0       									031115kr
--------------------------------------------------------------------------------------*/
void mover(char CS,double x,double y,double z)
{
  double dx,dy;
  struct dvec X,X0,X1;
  
  CS=toupper(CS);
  if (CS!='W' && CS!='P')
    PSerror("mover","requested coordinate system not implemented");

  X.dim=3; X.x=x; X.y=y; X.z=z;
  
  if (CS=='W') {
    pWI(X,&X1);
    X.x=X.y=X.z=0; pWI(X,&X0);
  } else {
    pPI(X,&X1);
    X.x=X.y=X.z=0; pPI(X,&X0);
  }
  dx=(X1.x-X0.x); cpx+=dx;
  dy=(X1.y-X0.y); cpy+=dy;
  fprintf(PSout, "  %f %f  rmoveto\n",dx,dy);

  updateBB(cpx, cpy);
  
  return;
}
/*--------------------------------------------------------------------------------------
mover: move relative to current position in 2d coordinate system CS [P,W]

HISTORY:
  v3.0.0       									031115kr
  v2.0										920524kr
--------------------------------------------------------------------------------------*/
void mover(char CS,double x,double y)
{
  double dx,dy;

  CS=toupper(CS);
  if (CS!='W' && CS!='P')
    PSerror("mover","requested coordinate system not implemented");

  if (CS=='W') {
    dx=x*PWx; cpx+=dx;
    dy=y*PWy; cpy+=dy;
    fprintf(PSout, "  %f %f  rmoveto\n", dx, dy);
  } else {
    cpx+=x; cpy+=y;
    fprintf(PSout, "  %f %f  rmoveto\n", x, y);
  }

  updateBB(cpx, cpy);
  
  return;
}
