#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
put_label: 

HISTORY:
  v3.0.0									031206kr
--------------------------------------------------------------------------------------*/
void put_label(double T0x,double T0y,double T1x,double T1y,double thenumber)
{
  int exponent,positive,prec;
  double L,H,d,dTx,dTy,phi,num,buf;
  char thisformat,cbuf[64];
  struct dvec T0,T1;

  dTx=T1x-T0x; dTy=T1y-T0y;
  if (1000*fabs(dTx)<fabs(dTy)) {			// vertical tick
    hadj='C'; vadj=(dTy>0)?'B':'T';
    movea('P',T0x,T0y+1.5*dTy);
    dNumber(thenumber);
    return;
  }
  if (1000*fabs(dTy)<fabs(dTx)) {			// horizontal tick
    hadj=(dTx>0)?'L':'R'; vadj='C';
    movea('P',T0x+1.5*dTx,T0y);
    dNumber(thenumber);
    return;
  }

  prec=(precision>0)?precision:-precision;		// tilted tick
  if (!(positive=thenumber>=0)) thenumber=-thenumber;
  buf=log10(thenumber);
  if (nformat=='g')
    thisformat=(fabs(buf)>prec+1)?'e':'f';
  else
    thisformat=nformat;
  if (thisformat=='f') {
    if (positive) sprintf(cbuf,"%1.*f",prec,thenumber);
    else {
      if (TeXfonts==1)
        sprintf(cbuf,"$-%1.*f$",prec,thenumber);
      else
        sprintf(cbuf,"-%1.*f",prec,thenumber);
    }
  } else {
    exponent=(int)buf; if (buf<0) exponent--;
    num=((positive)?1:-1)*thenumber/pow(10,exponent);
    buf=num*pow(10,prec);
    if (pow(10,prec+1)-buf<0.5) {
      exponent++; num/=10;
    }
    if (TeXfonts==1) {
      sprintf(cbuf,"{$%1.*f\\cdot10^{%1i}$}",prec,num,exponent);
    } else {
      sprintf(cbuf,"%1.*fe%+1i",prec,num,exponent);
    }
  }

  hadj='C'; vadj='C';
  phi=atan2(dTy,dTx); phi+=M_PI;
  L=strlen(cbuf)*curFSize*X_stretch; H=curFSize*Y_stretch; d=zTiMaLe[0]/2;
  T0.dim=T1.dim=2; T0.x=T0x; T0.y=T0y; T1.x=T1x; T1.y=T1y;
  if (L*fabs(dTy)>H*fabs(dTx)) {		       	// region I
    d=1.5+H/(2*cos(phi)*zTiMaLe[0]);
    T1=addvec(T0,scalmult(d,subvec(T1,T0)));
    movea('P',T1);
  } else {		       				// region II
    d=1.5+L/(2*sin(phi)*zTiMaLe[0]);
    T1=addvec(T0,scalmult(d,subvec(T1,T0)));
    movea('P',T1);
  }
  dText(cbuf);

  
  return;
}
