#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sClipping: set clipping rectangle in coordinate system CS

HISTORY:
  v3.0.0									031115kr
--------------------------------------------------------------------------------------*/
void sClipping(char CS,double xmin,double xmax,double ymin,double ymax)
{
  double buf;

  CS=toupper(CS);
  if (CS!='W' && CS!='P') {
    PSwarning("sClipping",
	      "requested coordinate system not implemented: operator ignored");
    return;
  }

  if (xmin==xmax || ymin==ymax) {
    PSwarning("sClipping","clipping area zero: operator ignored");
    return;
  }

  if (clip_on) sClipping();		// close old clipping rectangle

  if (CS=='W') {
    pWP(xmin,ymin,&xmin,&ymin); pWP(xmax,ymax,&xmax,&ymax);
  }

  if (xmin>xmax) {buf=xmin; xmin=xmax; xmax=buf;}
  if (ymin>ymax) {buf=ymin; ymin=ymax; ymax=buf;}

  clip_xl=xmin; clip_xh=xmax; clip_yl=ymin; clip_yh=ymax;

  fprintf(PSout,"gsave\n");    
  fprintf(PSout,"%f %f %f %f rectclip\n",xmin,ymin,xmax-xmin,ymax-ymin);    

  clip_on=1;

  return;
}
/*--------------------------------------------------------------------------------------
sClipping: stop clipping

HISTORY:
  v3.0.0									031115kr
--------------------------------------------------------------------------------------*/
void sClipping()
{
  fprintf(PSout,"grestore\n");
  clip_on=0;
  return;
}
