#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*==================================== SET ===========================================*/
/*--------------------------------------------------------------------------------------
sColorSpace: set color space [G (gray), RGB, HSB, CMYK]
             returns 1 if CS is undefined (required by sStroke)

v3.0.0										031130kr
v2.0										920524kr
---------------------------------------------------------------------------------------*/
int sColorSpace(const char *cspace)
{
  if (strcmp(cspace,"G")==0    || strcmp(cspace,"g")==0)    return sColorSpace(0);
  if (strcmp(cspace,"RGB")==0  || strcmp(cspace,"rgb")==0)  return sColorSpace(2);
  if (strcmp(cspace,"HSB")==0  || strcmp(cspace,"hsb")==0)  return sColorSpace(4);
  if (strcmp(cspace,"CMYK")==0 || strcmp(cspace,"cmyk")==0) return sColorSpace(8);

  PSwarning("sColorSpace(const char)","color space undefined: operator ignored");  
  return 1;
}
/*--------------------------------------------------------------------------------------
sColorSpace: set color space
             returns 1 if CS is undefined (required by sStroke)

v3.0.0										031130kr
---------------------------------------------------------------------------------------*/
int sColorSpace(int cspace)
{
  if (cspace==0 || cspace==2 || cspace==4 || cspace==8) {
    ColorSpace=cspace;
    return 0;
  }

  PSwarning("sColorSpace(int)","color space undefined: operator ignored");  
  return 1;
}
/*==================================== GET ===========================================*/
/*--------------------------------------------------------------------------------------
gColorSpace: return current  color space

v3.0.1										040404kr
---------------------------------------------------------------------------------------*/
int gColorSpace()
{
  return ColorSpace;
}
