#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sDash: set predefined dash pattern for lines 

  v3.0.0									031213kr
  added standard dash patterns                                                  990110kr
  v2.0   		       			                  		920524kr
--------------------------------------------------------------------------------------*/
void sDash(int ip)
{
  int j;
  double l[7],d0;
  char rep[63];

  fprintf(PSout,"%%-- sDash (%i)\n",ip);

  if (ip<0) {fprintf(PSout,"[] 0 setdash\n"); return;}

  l[0]= 0.2*Pthick;
  l[1]= 1*Pthick;
  l[2]= 2*Pthick;
  l[3]= 4*Pthick;
  l[4]= 8*Pthick;
  l[5]=16*Pthick;
  l[6]=32*Pthick;
  d0  = 3*Pthick;

  switch (ip/10) {
    case  0: {
      sprintf(rep,"[%.2lf] 0 setdash\n",
	      d0);
      break;
    }
    case  1: {
      sprintf(rep,"[%.2lf %.2lf %.2lf] 0 setdash\n",
	      d0,l[0],d0);
      break;
    }
    case  2: {
      sprintf(rep,"[%.2lf %.2lf %.2lf %.2lf %.2lf] 0 setdash\n",
	      d0,l[0],d0,l[0],d0);
      break;
    }
    case  3: {
      sprintf(rep,"[%.2lf %.2lf %.2lf %.2lf %.2lf %.2lf %.2lf] 0 setdash\n",
	      d0,l[0],d0,l[0],d0,l[0],d0);
      break;
    }
    default: {
      PSwarning("sDash", "dash pattern undefined: operator ignored");
      return;
    }
  }
  
  if ((j=1+ip-10*(ip/10))<7)
    fprintf(PSout,"[%.2lf %s",l[j],rep);
  else
    PSwarning("sDash", "dash pattern undefined: operator ignored");

  return;
}
/*--------------------------------------------------------------------------------------
sDash: set dash pattern for lines (all lengths in [mm]) example: "[1 2 4] 2"
       (see PostScript reference manual for definition)

added standard dash patterns                                                    990110kr
v2.0   						                  		920524kr
--------------------------------------------------------------------------------------*/
void sDash(const char *dpat)
{
  fprintf(PSout,"%%-- sDash\n"); 
  fprintf(PSout,"%s setdash\n",dpat);

  return;
}
