#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sFill: set fill color

HISTORY:
  v3.0.0       									031129kr
---------------------------------------------------------------------------------------*/
void sFill(struct color c)
{
  if (ColorSpace!=c.CS)			// set color space implicitly
    if (sColorSpace(c.CS)) {
    PSwarning("sFill(struct color)","wrong color space; operator ignored");
    return;
  }

  switch (c.CS) {
    case 0:
      F_c0=c.c0; F_c1=F_c2=F_c3=0;
      fprintf(PSout, "%%-- sFill (G)\n");
      break;
    case 2:
      F_c0=c.c0; F_c1=c.c1; F_c2=c.c2; F_c3=0;
      fprintf(PSout, "%%-- sFill (RGB)\n");
      break;
    case 4:
      F_c0=c.c0; F_c1=c.c1; F_c2=c.c2; F_c3=0;
      fprintf(PSout, "%%-- sFill (HSB)\n");
      break;
    case 8:
      F_c0=c.c0; F_c1=c.c1; F_c2=c.c2; F_c3=c.c3;
      fprintf(PSout, "%%-- sFill (CMYK)\n");
      break;
  }

  if (F_c1==NONE||F_c2==NONE||F_c3==NONE) F_c0=NONE;

  return;
}
/*--------------------------------------------------------------------------------------
sFill: set fill color to NONE
---------------------------------------------------------------------------------------*/
void sFill()
{
  F_c0=NONE;

  return;
}
/*--------------------------------------------------------------------------------------
sFill: set gray level for fill

HISTORY:
  v3.0.0       									031122kr
  variable argument lists      							920819kr
  v2.0										920525kr
---------------------------------------------------------------------------------------*/
void sFill(double c0)
{
  struct color c;

  if (ColorSpace!=0) {
    PSwarning("sFill(double)","only useable for G color space; operator ignored");
    return;
  }

  c.CS=0; c.c0=c0;
  sFill(c);

  return;
}
/*--------------------------------------------------------------------------------------
sFill: set color components in RGB or HSB ColorSpace for fill
---------------------------------------------------------------------------------------*/
void sFill(double c0,double c1,double c2)
{
  struct color c;

  if (ColorSpace==2) {
    c.CS=2; c.c0=c0; c.c1=c1; c.c2=c2;
    sFill(c);
    return;
  }

  if (ColorSpace==4) {
    c.CS=4; c.c0=c0; c.c1=c1; c.c2=c2;
    sFill(c);
    return;
  }

  PSwarning("sFill(double,double,double)",
	    "only useable for RGB or HSB color space; operator ignored");
  return;
}
/*--------------------------------------------------------------------------------------
sFill: set color components in CMYK ColorSpace for fill
---------------------------------------------------------------------------------------*/
void sFill(double c0,double c1,double c2,double c3)
{
  struct color c;

  if (ColorSpace!=8) {
    PSwarning("sFill(double,double,double,double)",
	      "only useable for CMYK color space; operator ignored");
    return;
  }

  c.CS=8; c.c0=c0; c.c1=c1; c.c2=c2; c.c3=c3;
  sFill(c);

  return;
}

/*--------------------------------------------------------------------------------------
gFill: get actual fill color

HISTORY:
  v3.0.0       									031129kr
---------------------------------------------------------------------------------------*/
struct color gFill()
{
  struct color c;

  c.CS=ColorSpace;
  c.c0=F_c0; c.c1=F_c1; c.c2=F_c2; c.c3=F_c3;
  
  return c;
}
