#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sPPlane: set projection plane by defining
       1. projection plane by vectors x'=(x1,y1,z1) and y'=(x2,y2,z2) in normal space
       2. origin (x0,y0,z0) of plane

v3.0.0										031115kr
--------------------------------------------------------------------------------------*/
void sPPlane(struct dvec x0,struct dvec x1,struct dvec x2)
{
  double buf;

  if (norm(x1)<1e-6)
    PSerror("sPPlane","vector x1 too short for defining projection plane");
  else normalize(&x1);

  if (norm(x2)<1e-6)
    PSerror("sPPlane","vector x2 too short for defining projection plane");
  else normalize(&x2);

  buf=dotprod(x1,x2);
  if (buf>0.99999)
    PSerror("sPPlane","angle between x1 and x2 too small for defining projection plane");

  if (buf>1e-6)
    PSwarning("sPPlane","x1 and x2 not orthogonal; projection will be distorted");

  R32x0=x0.x; R32y0=x0.y; R32z0=x0.z;
  R32x1=x1.x; R32y1=x1.y; R32z1=x1.z;
  R32x2=x2.x; R32y2=x2.y; R32z2=x2.z;

  R32_view=normalize(vecprod(x2,x1));

  return;
}
/*--------------------------------------------------------------------------------------
sPPlane: set projection plane by defining
       1. projection plane by vectors x'=(x1,y1,z1) and y'=(x2,y2,z2) in normal space
       2. origin (0,0,0) of plane

v3.0.0										031115kr
--------------------------------------------------------------------------------------*/
void sPPlane(struct dvec x1,struct dvec x2)
{
  struct dvec x0;

  x0.dim=3; x0.x=x0.y=x0.z=0;
  sPPlane(x0,x1,x2);

  return;
}
