#undef COM_SYM_DEF
#include "PSgraf_p.h"
/*--------------------------------------------------------------------------------------
sText: set font and adjustment relative to current position;

all coordinates positive							950330kr
v2.0										920524kr
--------------------------------------------------------------------------------------*/
void sText(const char *font, double size, char hadjust, char vadjust)
{
  char fn[255];
  double FSize;

  hadj=toupper(hadjust); vadj=toupper(vadjust);
  if (!(hadj=='L' || hadj=='C' || hadj=='R')) {
    PSwarning("sText", "unknown horizontal adjustment requested; set to 'L'");
    hadj='L';
  }
  if (!(vadj=='T' || vadj=='C' || vadj=='B')) {
    printf("vadj=%c,  ", vadj);
    PSwarning("sText", "unknown vertical adjustment requested; set to 'B'");
    vadj='B';
  }
  
  if (!strcmp(font,"TeXfonts")) {		/* set TeX fonts */
    if (TeXfonts==0) {				/* open TeX file */
      sprintf(fn,"%s.inttex",paper_name);	/* name of new intermediary TeX file */
      TeXout=fopen(fn,"w");
      if (TeXout==NULL) PSerror("sText","cannot write intermediary TeX file");
    }
    TeXfonts=1; 
  }
  else {					/* set PostScript fonts */
    if (TeXfonts) TeXfonts=2;
    FSize=size/PT_to_MM;
    if (strcmp(font, curFont) || curFSize!=FSize) {
      strcpy(curFont, font); curFSize=FSize;
      fprintf(PSout, "%%--setText\n");
      fprintf(PSout, "/%s  findfont\n", curFont);
      fprintf(PSout, "%f  scalefont setfont\n", curFSize);
    }
  }
  
  return;
}
