/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

int NeighbourSet(image_cc *im, int x, int y, int z)
{
	int i,j,k;
	int lx,ux,ly,uy,lz,uz;
	lx = (x>0) ? -1 : 0;
	ux = ((x+2)<im->dim[0]) ? 1 : 0;
	ly = (y>0) ? -1 : 0;
	uy = ((y+2)<im->dim[1]) ? 1 : 0;
	lz = (z>0) ? -1 : 0;
	uz = ((z+2)<im->dim[2]) ? 1 : 0;

	for(i=lx;i<=ux;i++)
		for(j=ly;j<=uy;j++)
			for(k=lz;k<=uz;k++)
	      if((*(im->pix + (z+k)/8 + (x+i)*im->numbytes + (y+j)*im->dim[0]*im->numbytes) & 1<<(z+k)%8) && ((i||j||k)!=0))
		      return 1;
	return 0;
}


void BtdContinuity(image_cc *im,int mode)
{
 	int x,y,z,j,i;
	int iter=0;
  image_cc *outim;
	int changeCount;
        
  outim= InitImage(im->dim[0],im->dim[1],im->dim[2],0, "btd");
  for(i=0;i<3;i++) outim->res[i]=im->res[i];

  if(mode & 1)	
	  for(z=0;z<im->dim[2];z++)
	    for(y=0;y<im->dim[1];y++)
		  {
	  	  if(rPixel(0,y,z,im))
		  	  wPixel(0,y,z,outim,1);
	    }
  if(mode & 2)	
	  for(z=0;z<im->dim[2];z++)
	    for(y=0;y<im->dim[1];y++)
		  {
	  	  if(rPixel(im->dim[0]-1,y,z,im))
		  	  wPixel(im->dim[0]-1,y,z,outim,1);
	    }
  if(mode & 4)	
	  for(z=0;z<im->dim[2];z++)
	    for(x=0;x<im->dim[0];x++)
		  {
	  	  if(rPixel(x,0,z,im))
		  	  wPixel(x,0,z,outim,1);
	    }
  if(mode & 8)	
	  for(z=0;z<im->dim[2];z++)
	    for(x=0;x<im->dim[0];x++)
		  {
	  	  if(rPixel(x,im->dim[1]-1,z,im))
		  	  wPixel(x,im->dim[1]-1,z,outim,1);
	    }
  if(mode & 16)	
	  for(x=0;x<im->dim[0];x++)
	    for(y=0;y<im->dim[1];y++)
		  {
	  	  if(rPixel(x,y,0,im))
		  	  wPixel(x,y,0,outim,1);
	    }
  if(mode & 32)	
	  for(x=0;x<im->dim[0];x++)
	    for(y=0;y<im->dim[1];y++)
		  {
	  	  if(rPixel(x,y,im->dim[2]-1,im))
		  	  wPixel(x,y,im->dim[2]-1,outim,1);
	    }
	do
	{
		changeCount=0;
		iter++;
		for(z=0;z<im->dim[2];z++)
		{
			for(x=0;x<im->dim[0];x++)
		    for(y=0;y<im->dim[1];y++)
				{
			  	if((rPixel(x,y,z,im)) && (rPixel(x,y,z,outim)==0) && (NeighbourSet(outim,x,y,z)))
					{
				    wPixel(x,y,z,outim,1);
						changeCount++;
					}
			  }
		}
		for(z=im->dim[2];z>=0;z--)
		{
			for(x=0;x<im->dim[0];x++)
			  for(y=0;y<im->dim[1];y++)
				{
			  	if((rPixel(x,y,z,im)) && (rPixel(x,y,z,outim)==0) && (NeighbourSet(outim,x,y,z)))
					{
				    wPixel(x,y,z,outim,1);
						changeCount++;
					}
			  }
		}
		for(x=0;x<im->dim[0];x++)
		{
		  for(z=0;z<im->dim[2];z++)
			  for(y=0;y<im->dim[1];y++)
				{
			  	if((rPixel(x,y,z,im)) && (rPixel(x,y,z,outim)==0) && (NeighbourSet(outim,x,y,z)))
					{
				    wPixel(x,y,z,outim,1);
						changeCount++;
					}
			  }
		}
		for(x=im->dim[0]-1;x>=0;x--)
		{
		  for(z=0;z<im->dim[2];z++)
			  for(y=0;y<im->dim[1];y++)
				{
			  	if((rPixel(x,y,z,im)) && (rPixel(x,y,z,outim)==0) && (NeighbourSet(outim,x,y,z)))
					{
				    wPixel(x,y,z,outim,1);
						changeCount++;
					}
			  }
		}
		for(y=0;y<im->dim[1];y++)
		{
		  for(z=0;z<im->dim[2];z++)
		    for(x=0;x<im->dim[0];x++)
				{
			  	if((rPixel(x,y,z,im)) && (rPixel(x,y,z,outim)==0) && (NeighbourSet(outim,x,y,z)))
					{
				    wPixel(x,y,z,outim,1);
						changeCount++;
					}
			  }
		}
		for(y=im->dim[1]-1;y>=0;y--)
		{
		  for(z=0;z<im->dim[2];z++)
		    for(x=0;x<im->dim[0];x++)
				{
			  	if((rPixel(x,y,z,im)) && (rPixel(x,y,z,outim)==0) && (NeighbourSet(outim,x,y,z)))
					{
				    wPixel(x,y,z,outim,1);
						changeCount++;
					}
			  }
		}
	}while (changeCount>0);
	for(j=0;j<(im->dim[0]*im->dim[1]*im->numbytes);j++)
		*(im->pix+j)=*(outim->pix+j); /** just a copy **/
	DeleteImage(outim);
}
int NeighbourSet(image_cc *im, int x, int y)
{
        int i,j;
        int lx,ux,ly,uy;
        lx = (x>0) ? -1 : 0;
        ux = ((x+2)<im->dim[0]) ? 1 : 0;
        ly = (y>0) ? -1 : 0;
        uy = ((y+2)<im->dim[1]) ? 1 : 0;

        for(i=lx;i<=ux;i++)
                for(j=ly;j<=uy;j++)
              if((i||j)!=0)
		if((rPixel((x+i),(y+j),im)))
                      return 1;
        return 0;
}


void D2Continuity(image_cc *im,int mode)
{
        int x,y,j,i;
        int iter=0;
  image_cc *outim;
        int changeCount;

  outim= InitImage(im->dim[0],im->dim[1],0, im->itype);
  for(i=0;i<2;i++) outim->res[i]=im->res[i];

  if(mode & 1)
            for(y=0;y<im->dim[1];y++)
                  {
                  if(rPixel(0,y,im))
                          wPixel(0,y,outim,1);
            }
  if(mode & 2)
            for(y=0;y<im->dim[1];y++)
                  {
                  if(rPixel(im->dim[0]-1,y,im))
                          wPixel(im->dim[0]-1,y,outim,1);
            }
  if(mode & 4)
            for(x=0;x<im->dim[0];x++)
                  {
                  if(rPixel(x,0,im))
                          wPixel(x,0,outim,1);
            }
  if(mode & 8)
            for(x=0;x<im->dim[0];x++)
                  {
                  if(rPixel(x,im->dim[1]-1,im))
                          wPixel(x,im->dim[1]-1,outim,1);
            }
        do
        {
                changeCount=0;
                iter++;
                               
		for(x=im->dim[0]-1;x>=0;x--)
		{
		  for(y=0;y<im->dim[1];y++)
		  {
		    if(rPixel(x,y,im))
		      if(rPixel(x,y,outim)==0)
			if(NeighbourSet(outim,x,y)){
			  wPixel(x,y,outim,1);
			  changeCount++;
			}
		  }
		}
		for(x=0;x<im->dim[0];x++)
		{
		  for(y=0;y<im->dim[1];y++)
		  {
		    if(rPixel(x,y,im))
		      if(rPixel(x,y,outim)==0)
			if(NeighbourSet(outim,x,y)){
			  wPixel(x,y,outim,1);
			  changeCount++;
			}
		  }
		}
		for(x=im->dim[0]-1;x>=0;x--)
		{
		  for(y=im->dim[1]-1;y>=0;y--)
		  {
		    if(rPixel(x,y,im))
		      if(rPixel(x,y,outim)==0)
			if(NeighbourSet(outim,x,y)){
			  wPixel(x,y,outim,1);
			  changeCount++;
			}
		  }
		}
		for(x=0;x<im->dim[0];x++)
		{
		  for(y=im->dim[1]-1;y>=0;y--)
		  {
		    if(rPixel(x,y,im))
		      if(rPixel(x,y,outim)==0)
			if(NeighbourSet(outim,x,y)){
			  wPixel(x,y,outim,1);
			  changeCount++;
			}
		  }
		}
		
        }while (changeCount>0);
        memcpy(im->pix, outim->pix, im->dim[0]*im->dim[1]*im->numbytes); /** just a copy **/
        DeleteImage(outim);
}
