/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 04.06.03
\command{       % COMMAND
image\_c *BtdGetDistMap(image\_c *image, int *n, int gval, int gstep);
}{              % DESCRIPTION
Converts a binary 3d image (btd-format) to its distance map (ddd-format): Each voxel in phase 1 is written to a grey value which corresponds to the distance of that voxel to phase 0. The closest distance gets grey value {\\tt gval} which increases ba steps {\\tt gstep} with distance. The phase 0 is not changed. The total number of distance classes is written to {\\tt n}. Note that it is a good idea to chose the parameters such that $ n \\cdot gstep < 255 - gval$. The resulting distance map can be used as input to a watershed segmentation e.g. to separate sintered grains. 
  

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the 3D binary image (btd-format)}
\argu{*n}{Number of detected distance classes}
\argu{gval}{Grey level for the first distance class}
\argu{gstaep}{Grey level step between adjacent distance classes}
\return{Pointer to the ddd-image containing the distance map}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"


image_cc *BtdGetDistMap(image_cc *image, int *n, int gval, int gstep){

  image_cc *dilat,*distance, *plane;
  int x,y,z, count, step, val;
  char buffer[127];

  distance=Btd2Ddd(image);
  
  step=1;
  count=1;
  val=0;
  while(count){
    count=0;
    printf("\n erosion step : %d \n",step);
    dilat=BtdErodeMirCond(image, distance, step, 1);
    for(x=0;x<dilat->dim[0];x++)
     for(y=0;y<dilat->dim[1];y++)
      for(z=0;z<dilat->dim[2];z++)
	if(!rPixel(x,y,z,dilat) && rPixel(x,y,z,distance)==255){
	  wPixel(x,y,z,distance,gval+step*gstep);
	  count++;
	}

    DeleteImage(dilat);
    step++;
  }
  return distance;   
}
