/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 26.1.00
\command{       % COMMAND
double BtdMeancurv(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the mean curvature of a binary structure}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of voxel configurations obtained by BtdQuant()}
\return{mean curvature  in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double BtdMeancurv(image_cc *image, long int *h)
/************************************************************************************ 
mean curvature in 3D is related to the 2D-Euler number on a 2D section plane.
within a 2x2x2 cube 13 different planes can be defined (see lang+99). The results for
the different planes are weighted by the sin of the plame to the vertical axis
 ************************************************************************************/
{
	int i,k,l;
	unsigned long MC,AC,iVol=0;
  	int kr[9][4] = {{1,2,4,8},{1,2,16,32},{1,4,16,64},{1,2,64,128},
			{4,16,8,32},{1,32,4,128},{2,8,16,64},{2,4,32,64},{1,16,8,128}};
	int kt[8][3] = {{1,64,32},{2,16,128},{8,64,32},{4,16,128},
			{2,4,128},{8,1,64},{2,4,16},{8,1,32}};
	double wi[13], a[13], r[13], s, ac, mc, count,atr;
	double r01, r02, r12;
	double *Delta, *weight;
	double c[13]={0.045778, 0.045778, 0.045778, 0.036981, 0.036981, 0.036981, 0.036981, 0.036981, 0.036981, 0.035196, 0.035196, 0.035196, 0.035196};
	double corr_x, corr_y, corr_z;


	Delta=(double *)malloc(3*sizeof(double)); 
	mc=0;
	r[0]=Delta[0]=image->res[0]; 
	r[1]=Delta[1]=image->res[1]; 
	r[2]=Delta[2]=image->res[2];
	r01= sqrt(r[0]*r[0] + r[1]*r[1]);
	r02= sqrt(r[0]*r[0] + r[2]*r[2]);
	r12= sqrt(r[1]*r[1] + r[2]*r[2]);
	s=(r01+r02+r12)/2;	

	a[0]=r[0]*r[1]; a[1]=r[0]*r[2]; a[2]=r[1]*r[2];
	a[3]=a[4]=r[2]*r01;
	a[5]=a[6]=r[1]*r02;
	a[7]=a[8]=r[0]*r12;
	atr=sqrt(s*(s-r01)*(s-r02)*(s-r12));
	a[9]=a[10]=a[11]=a[12]=2*atr;

	weight=(double *)malloc(7*sizeof(double)); 
	for(i=0;i<7;i++) weight[i]=0;
	weights(Delta, weight);
 	wi[0]=weight[0]; wi[1]=weight[1]; wi[2]=weight[2]; wi[3]=weight[3];
	wi[4]=weight[3]; wi[5]=weight[5]; wi[6]=weight[5]; wi[7]=weight[4];
	wi[8]=weight[4]; wi[9]=weight[6]; wi[10]=weight[6]; wi[11]=weight[6];
	wi[12]=weight[6];


	for(l=0;l<256;l++)
	  {
	    iVol+=h[l];
		for(i=0;i<9;i++)
		   for(k=0;k<4;k++)
		     mc+=(double)h[l]*wi[i]/(4*a[i])
			    *((l==(l|kr[i][k]))*(0==(l&kr[i][(k+1)%4]))
			    *(0==(l&kr[i][(k+2)%4]))*(0==(l&kr[i][(k+3)%4]))
			    -(l==(l|kr[i][k]))*(l==(l|kr[i][(k+1)%4]))
			    *(l==(l|kr[i][(k+2)%4]))*(0==(l&kr[i][(k+3)%4])));
		for(i=9;i<13;i++)
		   for(k=0;k<3;k++)
		         mc+=(double)h[l]*wi[i]/(3*a[i])
			    *((l==(l|kt[i-9][k]))*(0==(l&kt[i-9][(k+1)%3]))
			    *(0==(l&kt[i-9][(k+2)%3]))
			    -(l==(l|kt[i-5][k]))*(l==(l|kt[i-5][(k+1)%3]))
			    *(0==(l&kt[i-5][(k+2)%3])));
	  }

	//return (double)4*M_PI*mc/(double)(iVol*image->res[0]*image->res[1]*image->res[2]);
	return (double)4*M_PI*mc/(double)(iVol);
 }
 
