/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 27.11.02
\command{       % COMMAND
long int *BtdQuantMask(image\_c *image, int xm, int ym, int zm, char *mask);
}{              % DESCRIPTION
Calculates the frequency distribution of the 255 different voxel configurations within a 2x2x2 cube for a region identified by {\tt mask}. The format of  {\tt mask} corresponds to that returned by GetSphereElement.
The returned pointer is input for the routines to calculate volume density, surface density, mean curvature and Euler number.   

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*im}{Pointer to the binary 3D-image.}
\argu{int xm, ym, zm}{Coordinates of the center of the region described by {\tt mask}.}
\argu{*mask}{description of the region to be analyzed.}
\return{Pointer to the 255-element array containing frequencies of voxel configurations}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

long int *BtdQuantMask(image_cc *image, int xm, int ym, int zm, char *mask)
{
	int i, x,y,z, X,Y,Z, conf,n, index;
	long int *h;
 	double vol;
	
	h=(long int *)malloc(256*sizeof(long int));
 	for(i=0;i<256;i++) h[i]=0;

	 index=0;
	 for(z=-mask[2];z<=mask[2];z++)
	   for(y=-mask[1];y<=mask[1];y++)
	     for(x=-mask[0];x<=mask[0];x++){
	       if(*(mask+3+index/8) & 1<<index%8){
		    X=xm+x; Y=ym+y; Z=zm+z;
		    if(X>=0 && Y>=0 && Z>=0 && X<image->dim[0]-1 && Y<image->dim[1]-1 && Z<image->dim[2]-1){
		      conf=rPixel(X,Y,Z,image) + (rPixel(X+1,Y,Z,image)<<1)
		        + (rPixel(X,Y+1,Z,image)<<2) + (rPixel(X+1,Y+1,Z,image)<<3); 
		        + (rPixel(X,Y,Z+1,image)<<4) + (rPixel(X+1,Y,Z+1,image)<<5) 
			+ (rPixel(X,Y+1,Z+1,image)<<6) + (rPixel(X+1,Y+1,Z+1,image)<<7);
		      h[conf]++;
		    }		 
		}
	       index++;
	     }
 	return h;
}
