/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 26.1.00
\command{       % COMMAND
double BtdSurfdens(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the surface density of a binary structure}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of voxel configurations obtained by BtdQuant()}
\return{surface density [L$^2$/L$^3$] in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double BtdSurfdens(image_cc *image, long int *h)
{
	int i,l;
	unsigned long sv,le=0;
	double wi[13], r[13], Sv,Lv;	
	int kl[13][2] = {{1,2},{1,4},{1,16},{1,8},{2,4},{1,32},{2,16},{1,64},{4,16},{1,128},{2,64},{4,32},{8,16}};

	r[0]=image->res[0]; r[1]=image->res[1]; r[2]=image->res[2];
	r[3]=r[4]=sqrt(r[0]*r[0] + r[1]*r[1]);
	r[5]=r[6]=sqrt(r[0]*r[0] + r[2]*r[2]);
	r[7]=r[8]=sqrt(r[1]*r[1] + r[2]*r[2]);
	r[9]=r[10]=r[11]=r[12]=sqrt(r[0]*r[0] + r[1]*r[1] + r[2]*r[2]);
  
	wi[0]=wi[1]=wi[3]=wi[4]=M_PI/2;
	wi[2]=0;
	wi[5]=wi[6]=atan(r[0]/r[2]);	
	wi[7]=wi[8]=atan(r[1]/r[2]);	
	wi[9]=wi[10]=wi[11]=wi[12]=atan(r[3]/r[2]);	
		
	for(l=0;l<256;l++) le+= h[l];
	  Sv=Lv=0;
	  for(i=0;i<13;i++)
	    if(wi[i]){
	     sv=0;
	     for(l=0;l<256;l++){	       
	       sv+= h[l] * (l==(l|kl[i][0])) * (0==(l&kl[i][1]));
	       sv+= h[l] * (l==(l|kl[i][1])) * (0==(l&kl[i][0]));
 	     }
	     Sv+= (double)sin(wi[i])*(double)sv;
	     Lv+= (double)sin(wi[i])*(double)le*r[i];
 	   }
	return 2.0 * Sv/Lv;
}
