/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 26.1.00
\command{       % COMMAND
double BtdSurfdens(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the surface density of a binary structure calculated using the formula of Ohser 2000 pp114 and compares it to that one of Vogel ejss 2002}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of voxel configurations obtained by BtdQuant()}
\return{surface density [L$^2$/L$^3$] in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double BtdSurfdens_ohser(image_cc *image, long int *h)
{
	int i,l;
	unsigned long sv,le=0;
	double wi[13], r[13], Sv,Lv, *Delta, *weight, ohservogel;	
	int kl[13][2] = {{1,2},{1,4},{1,16},{1,8},{2,4},{1,32},{2,16},{1,64},{4,16},{1,128},{2,64},{4,32},{8,16}};

	Delta=(double *)malloc(3*sizeof(double)); 
	weight=(double *)malloc(7*sizeof(double)); 
	for(i=0;i<7;i++) weight[i]=0;

	r[0]=Delta[0]=image->res[0]; 
	r[1]=Delta[1]=image->res[1]; 
	r[2]=Delta[2]=image->res[2];
	r[3]=r[4]=sqrt(r[0]*r[0] + r[1]*r[1]);
	r[5]=r[6]=sqrt(r[0]*r[0] + r[2]*r[2]);
	r[7]=r[8]=sqrt(r[1]*r[1] + r[2]*r[2]);
	r[9]=r[10]=r[11]=r[12]=sqrt(r[0]*r[0] + r[1]*r[1] + r[2]*r[2]);

	weights(Delta, weight);
 	wi[0]=weight[0]; wi[1]=weight[1]; wi[2]=weight[2]; wi[3]=weight[3];
	wi[4]=weight[3]; wi[5]=weight[5]; wi[6]=weight[5]; wi[7]=weight[4];
	wi[8]=weight[4]; wi[9]=weight[6]; wi[10]=weight[6]; wi[11]=weight[6];
	wi[12]=weight[6];

	Sv=Lv=0;
	for(l=0;l<256;l++){ 
	  le+= h[l];
	  for(i=0;i<13;i++)
	    Sv += h[l]*wi[i]/r[i] * ((l==(l|kl[i][0]))*(0==(l&kl[i][1])) + (l==(l|kl[i][1]))*(0==(l&kl[i][0])));
	}
	printf("\nSv-Ohser = %lf\n",4.0*Sv/le);
	ohservogel=4.0*Sv/le;

	le=0;
	Sv=Lv=0;
	for(l=0;l<256;l++) le+= h[l];
	for(i=0;i<13;i++)
	    if(wi[i]){
	     sv=0;
	     for(l=0;l<256;l++){	       
	       sv+= h[l] * (l==(l|kl[i][0])) * (0==(l&kl[i][1]));
	       sv+= h[l] * (l==(l|kl[i][1])) * (0==(l&kl[i][0]));
 	     }
	     Sv+= wi[i]*(double)sv;
	     Lv+= wi[i]*(double)le*r[i];
 	   }

	printf("\nSv-Vogel = %lf\n",2.0*Sv/Lv);
	ohservogel/=2.0*Sv/Lv;

	le=0;
	Sv=Lv=0;
	for(l=0;l<256;l++)
	  for(i=0;i<13;i++){
	    Sv+=h[l]*wi[i]* ((l==(l|kl[i][0]))*(0==(l&kl[i][1])) + (l==(l|kl[i][1]))*(0==(l&kl[i][0])));
	    Lv+=h[l]*wi[i]*r[i];
	  }
	printf("\nSv-paper = %lf\n",2.0*Sv/Lv);


	printf("\nohservogel = %lf\n",ohservogel);
	ohservogel=0;
	for(i=0;i<13;i++)
	  ohservogel+=wi[i]*2;
	printf("\nsumwi = %e\n",ohservogel);

	free(Delta);
	free(weight);
	if(!Lv) return 0;
	else return 2.0 * Sv/Lv;
}

 
