/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

%--------------------------------- hj 12.06.02
\command{       % COMMAND
void DddBibin(int LOW,int HIGH,image\_c *im);
}{              % DESCRIPTION
Segments an 3D grey scale image according to 2 thresholds which are regarded to be the limits of a fuzzy region of the grey scale histogram of the image (Conditional Dilation). All pixel of a grey level smaller or equal than {\tt LOW} are written to 0 as well as all pixel having values smaller than {\tt HIGH} and at least one direct neighbour smaller than {\tt LOW}. This algorithm is repeated iteratively until no pixel is to be changed. The other pixel keep their original value. This function overwrites the original image.

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{LOW} {lower threshold.}
\argu{HIGH} {upper threshold.}
\argu{image} {Pointer to the image description structure.}

}

---------------------------------------------------------------------------*/


#include "quantim4.h"

void DddBibin(int LOW,int HIGH,image_cc *im)
{
	int x,y,z,j,dx,dy,dz,s; 
	long n=1;
 
	printf("\nEntering bilevel segementation\n "); 
	
	for(z=0;z<im->dim[2];z++)
	for(y=0;y<im->dim[1];y++)
	for (x=0;x<im->dim[0];x++)
		if(rPixel(x,y,z,im)<=LOW)
			wPixel(x,y,z,im,0);

	while(n){
	printf(".\n"); 
	n=0;
	for(z=1; z<im->dim[2]-1; z++)
	for(y=1; y<im->dim[1]-1; y++)
	for(x=1; x<im->dim[0]-1; x++)
	   if(rPixel(x,y,z,im)<HIGH && rPixel(x,y,z,im)){
	       dx=x; dy=y; dz=z; s=0;
	       for(j=0;j<26;j++)
		  if(!rPixel(dx+N26x[j],dy+N26y[j],dz+N26z[j],im)){
		     wPixel(dx,dy,dz,im,0); n++;s++;break;
		  }
			//if(j>=6 && !s)
			    //wPixel(dx,dy,image,HIGH+1);
	       while(s){
		 s=0;
		 for(j=0;j<26;j++){
		   if(dx+N26x[j]<0||dx+N26x[j]>im->dim[0]-1||dy+N26y[j]<0||dy+N26y[j]>im->dim[1]-1||dz+N26z[j]<0||dz+N26z[j]>im->dim[2]-1){
			  s=0;break;
		   }
		   if(rPixel(dx+N26x[j],dy+N26y[j],dz+N26z[j],im)<HIGH && rPixel(dx+N26x[j],dy+N26y[j],dz+N26z[j],im)){
			  dx=dx+N26x[j];
			  dy=dy+N26y[j];
			  dz=dz+N26z[j];
			  wPixel(dx,dy,dz,im,0);
			  s++;
			  break;
				 }
			     }
			 } /*end while*/
		    }
	}
	printf("\ndone\n"); 
}


 
