/*************************************************************
 *     Addon zu quantim4                                     *
 *                                                           *
 *     U. Weller 17.07.07                                    *
 *                                                           *
 *                                                           *
 *************************************************************/

 
#include "quantim4.h"

//image_cc *newb2GetDistMap(image_cc *im, double gstep);
#define gstep 1
#define sstep 1


image_cc *GetDistMap(image_cc *im)//, double gstep)
{
	image_cc *distmap;

	if(im->ndim==2)  distmap = newb2GetDistMap(im,gstep);
	else             distmap = newb3GetDistMap(im,gstep);

	return distmap;
}

#include <time.h>
#define ProtokolFile 1

image_cc *GetOpenMap(image_cc *distmap, int smax)// double gstep, double sstep, int smax)
{
	int i, x,y,z, sw=1, is3d=0;
	unsigned long j, npix;
	double step, inc;
	image_cc *image, *mask, *bin, *opened, *openedmap;
	FILE *fp;
	char buf[255];
	time_t idum, tinit;

        if(ProtokolFile){	fp=fopen("opening.dat", "w");
	  fprintf(fp,"here we go\n");
	  fclose(fp);
	}

	if(smax<=0) smax=distmap->dim[0];
	npix=distmap->dim[0];
	for(i=1;i< distmap->ndim;i++) npix*= distmap->dim[i];
 
	openedmap=CopyImage(distmap);
	Bin(openedmap, 32768,0,65535);
	//SavePrinciplePlanes(openedmap, "bin");

	i=1;
	inc=1;
	while(sw && i<=smax){
	  if(i>1) sw=0;
	  step=inc*gstep;
	  printf("\nerosion step no %d\n  width: %.2lf",i, step);

	  time(&idum);
	  if(i==1) tinit=idum;
	  if(ProtokolFile){
	    fp=fopen("opening.dat", "a");
	    fprintf(fp,"\nerosion step no %d\n  width: %.2lf   time: %lf",i, step, (double)(idum-tinit)/60.);
	    fclose(fp);
	  }

	  image=CopyImage(distmap);
	  Bin(image, 32768-(int)step-1,0,65535);
	  if(image->ndim==3)	bin=Ddd2Btd(image);
	  else 		bin=CopyImage(image);
	  DeleteImage(image);	
	  //SavePrinciplePlanes(bin, "bin_eroded");
	  image=CopyImage(distmap);
	  BinBand(image, 32768-(int)step, 32768);
	  if(image->ndim==3)	mask=Ddd2Btd(image);
	  else 		mask=CopyImage(image);
	  DeleteImage(image);

	  for(j=0;j<npix;j++)
		if(rPixel(j,openedmap) && !rPixel(j,mask)){
		  wPixel(j,mask,1);
		}

	  opened=ErodeCircCond(bin,mask,inc, 1);// 
	  
	  for(j=0;j<npix;j++)
		if(!rPixel(j,openedmap)){
			sw=1;
			if(rPixel(j,opened))
		  		wPixel(j,openedmap,32768+(int)step);
		}
	  DeleteImage(bin);
	  DeleteImage(opened);
	  
	  inc+=sstep;
	  i++;
	}

	step=inc*gstep;
	for(j=0;j<npix;j++)
		if(!rPixel(j,openedmap))
		  wPixel(j,openedmap,32768+(int)step);

	return openedmap;
}

image_cc *GetDistOpenCloseMap(image_cc *im, int maxdist)// double gstep, int maxdist)
{
	image_cc *distmap;

	if(im->ndim ==2)
		distmap = newb2GetOpenCloseMap(im, gstep,maxdist);
	else
		distmap = newb3GetOpenCloseMap(im, gstep,maxdist);
	return distmap;

}

image_cc *GetDistOpenCloseMap(image_cc *im)//, double gstep)
{
	image_cc *distmap;

	if(im->ndim ==2)
		distmap = newb2GetOpenCloseMap(im, gstep,0);
	else
		distmap = newb3GetOpenCloseMap(im, gstep,0);
	return distmap;

}


image_cc *OpenCirc(image_cc *im, double rad, int mode)
{
	image_cc *copy, *outim;

	copy  = ErodeCirc(im,   rad, mode==0?0:1);
	outim = ErodeCirc(copy, rad, mode==0?1:0);
	DeleteImage(copy);
  return outim;	
}

image_cc *ErodeCirc(image_cc *im, double rad, int mode)
{
	int x,y,z,X,Y,Z,XX,YY,ZZ,Xx,Yy,Zz, i,vol;
	unsigned long j, count, Nb;
	char *se, *voxbuf, buffer[127];
	image_cc *outim, *mirim;

	outim = CopyImage(im);
	
	if(im->ndim ==2){
		se = GetCircElementDouble(rad,im->res[0], im->res[1]);
		//se = GetCircElementDouble_new(rad,im->res[0], im->res[1]);
		mirim=InitImage(im->dim[0]+2*se[0],im->dim[1]+2*se[1],0, "gry");
		mirim->res[0]=im->res[0];mirim->res[1]=im->res[1];	

		for(y=0;y<mirim->dim[1];y++)
	  		for(x=0;x<mirim->dim[0];x++){
	    			XX=abs(x-se[0]); YY=abs(y-se[1]);
	    			Xx=XX/im->dim[0]; Yy=YY/im->dim[1]; 
	    			X=XX-2*(XX-im->dim[0]+1)*Xx; 
	    			Y=YY-2*(YY-im->dim[1]+1)*Yy; 
      	    			wPixel(x,y,mirim,rPixel(X,Y,im));
	  	}

		for(y=0;y<im->dim[1];y++)
	 	for(x=0;x<im->dim[0];x++)	
	    		if(rPixel(x,y,im) == mode*255){
	        		count=0;
				for(Y=-se[1];Y<=se[1];Y++)
		 		for(X=-se[0];X<=se[0];X++){
      		      				if(rPixel(x+X+se[0],y+Y+se[1],mirim)!=mode*255 && *(se+2+count/8) & 1<<count%8){
							if(mode){
			  				wPixel(x,y,outim,0);
			  				X=Y=im->dim[0];
							}
							else{
			  				wPixel(x,y,outim,255);
			  				X=Y=im->dim[0];
							}
		      				}
		      				count++;
		 	}
	    }
	}
	else{ 
		se = GetSphereElementDouble(rad,im->res[0],im->res[1],im->res[2], &vol);
		mirim=InitImage(im->dim[0]+2*se[0],im->dim[1]+2*se[1],im->dim[2]+2*se[2],0, "btd");
		for(i=0;i<3;i++) mirim->res[i]=im->res[i];

		for(z=0;z<mirim->dim[2];z++)
	 	for(y=0;y<mirim->dim[1];y++)
	  	for(x=0;x<mirim->dim[0];x++){
	    		XX=abs(x-se[0]); YY=abs(y-se[1]); ZZ=abs(z-se[2]);
	    		Xx=XX/im->dim[0]; Yy=YY/im->dim[1]; Zz=ZZ/im->dim[2]; 
	    		X=XX-2*(XX-im->dim[0]+1)*Xx; 
	    		Y=YY-2*(YY-im->dim[1]+1)*Yy; 
	    		Z=ZZ-2*(ZZ-im->dim[2]+1)*Zz;     
      	    		wPixel(x,y,z,mirim,rPixel(X,Y,Z,im));
	  	}
		for(z=0;z<im->dim[2];z++)
	  	for(y=0;y<im->dim[1];y++)
	    	for(x=0;x<im->dim[0];x++)
		    if((rPixel(x,y,z,im)+mode+1)%2)
		    { /**if 1 for mode=1, if 0 for mode=0**/
		      count=0;
		      for(Z=-se[2];Z<=se[2];Z++)
		        for(Y=-se[1];Y<=se[1];Y++)
		          for(X=-se[0];X<=se[0];X++)
							{
			          if((rPixel(x+X+se[0],y+Y+se[1],z+Z+se[2],mirim)+mode)%2 && *(se+3+count/8) & 1<<count%8)
								{
			            if(mode)
					wPixel(x,y,z,outim,0);
				        //*(voxbuf+z/8+x*im->numbytes+y*im->dim[0]*im->numbytes) &= ~(1<<z%8);
			            else
					wPixel(x,y,z,outim,1);
				        //*(voxbuf+z/8+x*im->numbytes+y*im->dim[0]*im->numbytes) |= 1<<z%8;
			          }
			          count++;
		          }
	      }		
	}
	return outim;
}  

image_cc *ErodeCircCond(image_cc *im, image_cc *cond, double rad, int mode)
{
	int x,y,z,X,Y,Z,XX,YY,ZZ,Xx,Yy,Zz, i,vol, maxgrey, yval, zval;
	unsigned long j, count, Nb;
	char *se, *voxbuf, buffer[127];
	image_cc *outim, *mirim;

	maxgrey=im->numbytes==2?65535:255;
//printf("\nmaxgrey: %d\n",maxgrey);
	

	outim = CopyImage(im);
	
	if(im->ndim ==2){
		se = GetCircElementDouble(rad,im->res[0], im->res[1]);
		if(im->numbytes==2)
			mirim=InitImage(im->dim[0]+2*se[0],im->dim[1]+2*se[1],0, "gry16");
		else
			mirim=InitImage(im->dim[0]+2*se[0],im->dim[1]+2*se[1],0, "gry");
		mirim->res[0]=im->res[0];mirim->res[1]=im->res[1];	

		for(y=0;y<mirim->dim[1];y++)
	  		for(x=0;x<mirim->dim[0];x++){
	    			XX=abs(x-se[0]); YY=abs(y-se[1]);
	    			Xx=XX/im->dim[0]; Yy=YY/im->dim[1]; 
	    			X=XX-2*(XX-im->dim[0]+1)*Xx; 
	    			Y=YY-2*(YY-im->dim[1]+1)*Yy; 
      	    			wPixel(x,y,mirim,rPixel(X,Y,im));
	  	}

		for(y=0;y<im->dim[1];y++)
	 	for(x=0;x<im->dim[0];x++)	
	    		if(rPixel(x,y,im) == mode*maxgrey && !rPixel(x,y,cond)){
	        		count=0;
				for(Y=-se[1];Y<=se[1];Y++)
		 		for(X=-se[0];X<=se[0];X++){
      		      				if(rPixel(x+X+se[0],y+Y+se[1],mirim)!= mode*maxgrey && *(se+2+count/8) & 1<<count%8){
							if(mode){
			  				wPixel(x,y,outim,0);
			  				X=Y=im->dim[0];
							}
							else{
			  				wPixel(x,y,outim,maxgrey);
			  				X=Y=im->dim[0];
							}
		      				}
		      				count++;
		 	}
	    }
	}
	else{ 
		se = GetSphereElementDouble((rad),im->res[0],im->res[1],im->res[2], &vol);
//#define OLD_STYLE
#ifdef OLD_STYLE
		mirim=InitImage(im->dim[0]+2*se[0],im->dim[1]+2*se[1],im->dim[2]+2*se[2],0, "btd");
		for(i=0;i<3;i++) mirim->res[i]=im->res[i];

		for(z=0;z<mirim->dim[2];z++)
	 	for(y=0;y<mirim->dim[1];y++)
	  	for(x=0;x<mirim->dim[0];x++){
	    		XX=abs(x-se[0]); YY=abs(y-se[1]); ZZ=abs(z-se[2]);
	    		Xx=XX/im->dim[0]; Yy=YY/im->dim[1]; Zz=ZZ/im->dim[2]; 
	    		X=XX-2*(XX-im->dim[0]+1)*Xx; 
	    		Y=YY-2*(YY-im->dim[1]+1)*Yy; 
	    		Z=ZZ-2*(ZZ-im->dim[2]+1)*Zz;     
      	    		wPixel(x,y,z,mirim,rPixel(X,Y,Z,im));
	  	}
		for(z=0;z<im->dim[2];z++)
	  	for(y=0;y<im->dim[1];y++)
	    	for(x=0;x<im->dim[0];x++)
		    if((rPixel(x,y,z,im) == mode) && !rPixel(x,y,z,cond))
		    //if((rPixel(x,y,z,im)+mode+1)%2)
		    { //if 1 for mode=1, if 0 for mode=0
		      count=0;
		      for(Z=-se[2];Z<=se[2];Z++)
		        for(Y=-se[1];Y<=se[1];Y++)
		          for(X=-se[0];X<=se[0];X++)
							{
			          if((rPixel(x+X+se[0],y+Y+se[1],z+Z+se[2],mirim)+mode)%2 && *(se+3+count/8) & 1<<count%8)
								{
			            if(mode)
					wPixel(x,y,z,outim,0);
				        //*(voxbuf+z/8+x*im->numbytes+y*im->dim[0]*im->numbytes) &= ~(1<<z%8);
			            else
					wPixel(x,y,z,outim,1);
				        //*(voxbuf+z/8+x*im->numbytes+y*im->dim[0]*im->numbytes) |= 1<<z%8;
			          }
			          count++;
		          }
#else
		for(z=0;z<im->dim[2];z++)
	  	for(y=0;y<im->dim[1];y++)
	    	for(x=0;x<im->dim[0];x++)
		    if((rPixel(x,y,z,im) == mode) && !rPixel(x,y,z,cond)){
			Xx = x>se[0]?-se[0]:-x;
			XX = x<im->dim[0]-se[0]?se[0]:im->dim[0]-x-1;
			Yy = y>se[1]?-se[1]:-y;
			YY = y<im->dim[1]-se[1]?se[1]:im->dim[1]-y-1;
			Zz = z>se[2]?-se[2]:-z;
			ZZ = z<im->dim[2]-se[2]?se[2]:im->dim[2]-z-1;
			for(Z=Zz;Z<=ZZ;Z++){
				zval= (se[2]+Z)*(2*se[0]+1)*(2*se[1]+1);
				for(Y=Yy;Y<=YY;Y++){
					yval = (se[1]+Y)*(2*se[0]+1)+zval + se[0];
					for(X=Xx;X<=XX;X++){
						if(rPixel(x+X,y+Y,z+Z,im)!=mode && *(se+3+(yval+X)/8) &1<<(yval+X)%8)
							wPixel(x,y,z,outim,1-mode);
					}
				}
			}
				
#endif
	      }		
	}
	return outim;
}  


#define GSTEP 1.

image_cc *ErodeDist(image_cc *im, double dist, int mode)
{
	image_cc *distmap, *outim, *outimbtd;

	if(im->ndim==2)  distmap = newb2GetDistMap(im,GSTEP);
	else             distmap = newb3GetDistMap(im,GSTEP);

	if(!mode)    Bin(distmap,32768-int(dist*GSTEP)-1);
	else         Bin(distmap,32768+int(dist*GSTEP)-1);
	outim=	gry16to8(distmap);
	DeleteImage(distmap);
	if(im->ndim==3){ 
		outimbtd=Ddd2Btd(outim); 
		DeleteImage(outim);
		return outimbtd;
	}
	else   return outim;
}
#undef GSTEP

image_cc *OpenDist(image_cc *im, image_cc *distmap, double rad, int mode)// double gstep, int mode)
{
	image_cc *image, *bin, *mask, *opened, *plane;

	image=CopyImage(distmap);
	if(!mode)  Bin(image, 32768-int((double)gstep*rad)-1);
	else       Bin(image, 32768+int((double)gstep*rad)-1);
	if(im->ndim==3) bin=Ddd2Btd(image);
	else           bin=gry16to8(image);
	DeleteImage(image);	

	//plane = GetPlane(bin, bin->dim[2]/2, 0);
	StoreImage(bin,"plane_opendist");		

	image=CopyImage(distmap);
	if(!mode)  BinBand(image, 32768-int(gstep*rad), 32768);
	else      BinBand(image, 32768, 32768+int(gstep*rad));
	if(im->ndim==3)  mask=Ddd2Btd(image);
	else            mask=gry16to8(image);
	DeleteImage(image);	
	StoreImage(mask,"soil_mask");
//	SavePrinciplePlanes(mask, "conditionmask");

	if(!mode)  opened=ErodeCircCond(bin,mask,rad,1);
	else      opened=ErodeCircCond(bin,mask,rad,0);

	//image  = ErodeDist(im,   rad, mode==0?0:1);
	//opened = ErodeDist(image, rad, mode==0?1:0);
	DeleteImage(bin);
	DeleteImage(mask);
  return opened;	
}

#undef gstep
image_cc *newb2GetDistMap(image_cc *im, double gstep)
{
	int x, y, dist, distsq;
	double fact;
	unsigned int *matrix1, *matrix2;
	int val1,val2;
	image_cc *ret;
	matrix1 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*sizeof(int));
	matrix2 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*sizeof(int));

	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			matrix1[x+y*im->dim[0]] = matrix2[x+y*im->dim[0]] = 2147483647;
	//initialise for maximum distance.
	
	for(y=0;y<im->dim[1];y++){
			for(dist=1;dist < im->dim[0]; dist++){
				distsq=dist*dist;
				for(x=0;x<im->dim[0]-dist;x++){
					if(rPixel(x,y, im)!=rPixel(x+dist,y, im)){
						if(matrix1[x+y*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]]=distsq;
						}
						if(matrix1[x+dist+y*im->dim[0]]>distsq){
							matrix1[x+dist+y*im->dim[0]]=distsq;
							//Look for minimum distance between phases.
						}	
					}
				}
			}
		}
	fact = im->res[1]/im->res[0];
	fact *=fact;
	for(x=0;x<im->dim[0];x++){
			for(dist=0;dist < im->dim[1]; dist++){
				distsq=int(double(dist*dist)*fact);
				for(y=0;y<im->dim[1]-dist;y++){
					if(rPixel(x,y, im)!=rPixel(x,y+dist, im)){
						//look for minimum distance between phases
						if(matrix2[x+y*im->dim[0]]>distsq){
							matrix2[x+y*im->dim[0]]=distsq;
						}
						if(matrix2[x+(dist+y)*im->dim[0]]>distsq){
							matrix2[x+(dist+y)*im->dim[0]]=distsq;
						}
					}else{//minimum in two directions
						if(matrix2[x+y*im->dim[0]]>distsq+matrix1[x+(dist+y)*im->dim[0]]){
							matrix2[x+y*im->dim[0]]=distsq+matrix1[x+(dist+y)*im->dim[0]];
						}
						if(matrix2[x+(dist+y)*im->dim[0]]>distsq+matrix1[x+y*im->dim[0]]){
							matrix2[x+(dist+y)*im->dim[0]]=distsq+matrix1[x+y*im->dim[0]];
						}
					}
				}
			}
		}
	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++){
				matrix2[x+y*im->dim[0]] =(int)floor(gstep*sqrt(matrix2[x+y*im->dim[0]]));
				if(!rPixel(x,y, im)) 
					matrix2[x+y*im->dim[0]] *=-1;
				matrix2[x+y*im->dim[0]] +=32768 ;
			}
	free(matrix1);
	ret  = InitImage(im->dim[0], im->dim[1], 65535, "gry16");	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
				wPixel(x, y, ret, int(matrix2[x+y*im->dim[0]]));

	free(matrix2);
	return(ret);
}

image_cc *newb3GetDistMap(image_cc *im, double gstep)
{
	int x, y, z, dist, distsq;
	unsigned int *matrix1, *matrix2;
	double fact;
	int val1,val2;
	image_cc *ret;
	if(strcmp(im->itype,"btd")!=0){
		printf("Distmap: image type must be btd!\n");
		return 0;
	}
	matrix1 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(int));
	matrix2 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(int));

	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 2147483647;
	//initialise for maximum distance.
	
	for(y=0;y<im->dim[1];y++)
		for(z=0;z<im->dim[2];z++){
			for(dist=1;dist < im->dim[0]; dist++){
				distsq=dist*dist;
				for(x=0;x<im->dim[0]-dist;x++){
					if(rPixel(x,y,z, im)!=rPixel(x+dist,y,z, im)){
						if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
						if(matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
							//Look for minimum distance between phases.
						}	
					}
				}
			}
		}
	fact = im->res[1]/im->res[0];
	fact *=fact;

	for(x=0;x<im->dim[0];x++)
		for(z=0;z<im->dim[2];z++){
			for(dist=0;dist < im->dim[1]; dist++){
				distsq=int((double)(dist*dist)*fact);
				for(y=0;y<im->dim[1]-dist;y++){
					if(rPixel(x,y,z, im)!=rPixel(x,y+dist,z, im)){
						//look for minimum distance between phases
						if(matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
						if(matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
					}else{//minimum in two directions
						if(matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]];
						}
						if(matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]];
						}
					}
				}
			}
		}
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 2147483647;
	fact = im->res[2]/im->res[0];
	fact *=fact;

	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++){
			for(dist=0;dist < im->dim[2]; dist++){
				distsq=int((double)(dist*dist)*fact);
				for(z=0;z<im->dim[2]-dist;z++){
					if(rPixel(x,y,z, im)!=rPixel(x,y,z+dist, im)){
						if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
							
						}
						if(matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]=distsq;
							
						}	
					}else{
						if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]){
							matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]];
						}
						if(matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]>distsq+matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]=distsq+matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]];
								
						}
					}
					
				}
			}
		}
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++){
				matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] =(int)ceil(gstep*sqrt(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]));
				if(rPixel(x,y,z, im)) matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] +=32768;
				else matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] =32768-matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] ;
			}
	free(matrix2);
	ret  = InitImage(im->dim[0], im->dim[1], im->dim[2], 65535, "ddd16");	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				wPixel(x, y, z, ret, int(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]));

	free(matrix1);
	return(ret);
}


/* Currently fastest algorithm for distance map. (Literature?)
Works consecutelively in each direction and searches the minimum distance -> minimum sum of former minimum plus distance. for n^d the complexity is O(d*n). Storage requirement is 3*sizeof(int)*dim[0]*dim[1]*dim[2]. gstep spreads the distance space (substeps). The algorithm works on the squared distance.
*/

image_cc *newb2GetDistMap_old(image_cc *im, double gstep)
{
	int x, y, dist, distsq;
	unsigned int *matrix1, *matrix2;
	int val1,val2;
	image_cc *ret;
	matrix1 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*sizeof(int));
	matrix2 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*sizeof(int));

	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			matrix1[x+y*im->dim[0]] = matrix2[x+y*im->dim[0]] = 2147483647;
	//initialise for maximum distance.
	
	for(y=0;y<im->dim[1];y++){
			for(dist=1;dist < im->dim[0]; dist++){
				distsq=dist*dist;
				for(x=0;x<im->dim[0]-dist;x++){
					if(rPixel(x,y, im)!=rPixel(x+dist,y, im)){
						if(matrix1[x+y*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]]=distsq;
						}
						if(matrix1[x+dist+y*im->dim[0]]>distsq){
							matrix1[x+dist+y*im->dim[0]]=distsq;
							//Look for minimum distance between phases.
						}	
					}
				}
			}
		}
	for(x=0;x<im->dim[0];x++){
			for(dist=0;dist < im->dim[1]; dist++){
				distsq=dist*dist;
				for(y=0;y<im->dim[1]-dist;y++){
					if(rPixel(x,y, im)!=rPixel(x,y+dist, im)){
						//look for minimum distance between phases
						if(matrix2[x+y*im->dim[0]]>distsq){
							matrix2[x+y*im->dim[0]]=distsq;
						}
						if(matrix2[x+(dist+y)*im->dim[0]]>distsq){
							matrix2[x+(dist+y)*im->dim[0]]=distsq;
						}
					}else{//minimum in two directions
						if(matrix2[x+y*im->dim[0]]>distsq+matrix1[x+(dist+y)*im->dim[0]]){
							matrix2[x+y*im->dim[0]]=distsq+matrix1[x+(dist+y)*im->dim[0]];
						}
						if(matrix2[x+(dist+y)*im->dim[0]]>distsq+matrix1[x+y*im->dim[0]]){
							matrix2[x+(dist+y)*im->dim[0]]=distsq+matrix1[x+y*im->dim[0]];
						}
					}
				}
			}
		}
	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++){
				matrix2[x+y*im->dim[0]] =(int)floor(gstep*sqrt(matrix2[x+y*im->dim[0]]));
				if(!rPixel(x,y, im)) 
					matrix2[x+y*im->dim[0]] *=-1;
				matrix2[x+y*im->dim[0]] +=32768 ;
			}
	free(matrix1);
	ret  = InitImage(im->dim[0], im->dim[1], 65535, "gry16");	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
				wPixel(x, y, ret, int(matrix2[x+y*im->dim[0]]));

	free(matrix2);
	return(ret);
}

image_cc *newb3GetDistMap_old(image_cc *im, double gstep)
{
	int x, y, z, dist, distsq;
	unsigned int *matrix1, *matrix2;
	int val1,val2;
	image_cc *ret;
	if(strcmp(im->itype,"btd")!=0){
		printf("Distmap: image type must be btd!\n");
		return 0;
	}
	matrix1 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(int));
	matrix2 = (unsigned int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(int));

	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 2147483647;
	//initialise for maximum distance.
	
	for(y=0;y<im->dim[1];y++)
		for(z=0;z<im->dim[2];z++){
			for(dist=1;dist < im->dim[0]; dist++){
				distsq=dist*dist;
				for(x=0;x<im->dim[0]-dist;x++){
					if(rPixel(x,y,z, im)!=rPixel(x+dist,y,z, im)){
						if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
						if(matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
							//Look for minimum distance between phases.
						}	
					}
				}
			}
		}
	for(x=0;x<im->dim[0];x++)
		for(z=0;z<im->dim[2];z++){
			for(dist=0;dist < im->dim[1]; dist++){
				distsq=dist*dist;
				for(y=0;y<im->dim[1]-dist;y++){
					if(rPixel(x,y,z, im)!=rPixel(x,y+dist,z, im)){
						//look for minimum distance between phases
						if(matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
						if(matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
					}else{//minimum in two directions
						if(matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]];
						}
						if(matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]];
						}
					}
				}
			}
		}
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 2147483647;
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++){
			for(dist=0;dist < im->dim[2]; dist++){
				distsq=dist*dist;
				for(z=0;z<im->dim[2]-dist;z++){
					if(rPixel(x,y,z, im)!=rPixel(x,y,z+dist, im)){
						if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
							
						}
						if(matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]=distsq;
							
						}	
					}else{
						if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]){
							matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]];
						}
						if(matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]>distsq+matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]=distsq+matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]];
								
						}
					}
					
				}
			}
		}
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++){
				matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] =(int)floor(gstep*sqrt(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]));
				if(rPixel(x,y,z, im)) matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] +=32768;
				else matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] =32768-matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] ;
			}
	free(matrix2);
	ret  = InitImage(im->dim[0], im->dim[1], im->dim[2], 65535, "ddd16");	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				wPixel(x, y, z, ret, int(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]));

	free(matrix1);
	return(ret);
}

/* Opening/closing algorithm based on fast distance map. After construction of the distance map, for each (increasing)  distance the reverse distance map is created.
Usage: im: binary image for opening/closing, gstep: number of substeps in distance creation. The algorithm works on the squared distance. The final value is the integer of the square root times gstep. maxdist: maximum squared distance to consider. Return value: the opening/closing map times gstep. 16000 is zero line, values >16000 ly within the strucutre.
*/

image_cc *newb2GetOpenCloseMap(image_cc *im, double gstep, int maxdist)
{
	int x, y, dist, distsq, distsqold, distsqcurrent;
	short int *matrix1, *matrix2, *distmap, *openmap, totalmax=0;
	int val1,val2;
	double calc;
	image_cc *ret;

	matrix1 = (short int*)malloc(im->dim[0]*im->dim[1]*sizeof(short int));
	matrix2 = (short int*)malloc(im->dim[0]*im->dim[1]*sizeof(short int));
	distmap = (short int*)malloc(im->dim[0]*im->dim[1]*sizeof(short int));
	openmap = (short int*)malloc(im->dim[0]*im->dim[1]*sizeof(short int));

	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++){
				matrix1[x+y*im->dim[0]] = distmap[x+y*im->dim[0]] = 32565;
				openmap[x+y*im->dim[0]] = maxdist;
			}
	for(y=0;y<im->dim[1];y++){
			for(dist=1;dist < im->dim[0]; dist++){
				distsq=dist*dist;
				for(x=0;x<im->dim[0]-dist;x++){
					if(rPixel(x,y, im)!=rPixel(x+dist,y,im)){
						if(matrix1[x+y*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]]=distsq;
						}
						if(matrix1[x+dist+y*im->dim[0]]>distsq){
							matrix1[x+dist+y*im->dim[0]]=distsq;
						}	
					}
				}
			}
		}
	for(x=0;x<im->dim[0];x++){
			for(dist=0;dist < im->dim[1]; dist++){
				distsq=dist*dist;
				for(y=0;y<im->dim[1]-dist;y++){
					if(rPixel(x,y, im)!=rPixel(x,y+dist, im)){
						if(distmap[x+y*im->dim[0]]>distsq){
							distmap[x+y*im->dim[0]]=distsq;
						}
						if(distmap[x+(dist+y)*im->dim[0]]>distsq){
							distmap[x+(dist+y)*im->dim[0]]=distsq;
						}
					}else{
						if(distmap[x+y*im->dim[0]]>distsq+matrix1[x+(dist+y)*im->dim[0]]){
							distmap[x+y*im->dim[0]]=distsq+matrix1[x+(dist+y)*im->dim[0]];
						}
						if(distmap[x+(dist+y)*im->dim[0]]>distsq+matrix1[x+y*im->dim[0]]){
							distmap[x+(dist+y)*im->dim[0]]=distsq+matrix1[x+y*im->dim[0]];
						}
					}
				}
			}
		}
	//Distance map in distmap. Now we work backwards 	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++){
				//if(rPixel(x,y,z,im))
				//	distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=0;
				totalmax = totalmax >distmap[x+y*im->dim[0]]?totalmax:distmap[x+y*im->dim[0]];
			}
	printf("Total maximum: %d\n", totalmax);
	if(maxdist)
		totalmax=totalmax>maxdist?maxdist:totalmax;
	calc=0;
	for(distsqcurrent = 0; distsqcurrent <totalmax;){
		distsqold = distsqcurrent;
		//calc = sqrt(distsqcurrent);
		
		while(distsqcurrent == distsqold){
			calc += 1.0/gstep;
			distsqcurrent = (int)floor(calc*calc);
		}
				
		printf("Current distance: %d\n", distsqcurrent);
		for(x=0;x<im->dim[0];x++)
			for(y=0;y<im->dim[1];y++)
					matrix1[x+y*im->dim[0]] = matrix2[x+y*im->dim[0]] = 0;
	
		for(y=0;y<im->dim[1];y++){
				for(dist=0;dist < im->dim[0]; dist++){
					distsq=dist*dist;
					if(distsq>distsqcurrent)break;
					for(x=0;x<im->dim[0]-dist;x++){
						if(rPixel(x,y,im)==rPixel(x+dist,y, im)){
						if(distmap[x+dist+y*im->dim[0]]<=distsqcurrent&&distmap[x+dist+y*im->dim[0]]>distsqold)
							if(matrix1[x+y*im->dim[0]]<distsqcurrent-distsq){
								matrix1[x+y*im->dim[0]]=distsqcurrent-distsq;
							}
						if(distmap[x+y*im->dim[0]]<=distsqcurrent&&distmap[x+y*im->dim[0]]>distsqold)
							if(matrix1[x+dist+y*im->dim[0]]<distsqcurrent-distsq){
								matrix1[x+dist+y*im->dim[0]]=distsqcurrent-distsq;
							}	
						}
					}
					
				}
			}
		for(x=0;x<im->dim[0];x++){
				for(dist=0;dist < im->dim[1]; dist++){
					distsq=dist*dist;
					if(distsq>distsqcurrent)break;
					for(y=0;y<im->dim[1]-dist;y++){
						if(rPixel(x,y, im)==rPixel(x,y+dist, im))
							{
							if(matrix2[x+y*im->dim[0]]<matrix1[x+(dist+y)*im->dim[0]]-distsq){
								matrix2[x+y*im->dim[0]]=matrix1[x+(dist+y)*im->dim[0]]-distsq;
							}
							if(matrix2[x+(dist+y)*im->dim[0]]<matrix1[x+y*im->dim[0]]-distsq){
								matrix2[x+(dist+y)*im->dim[0]]=matrix1[x+y*im->dim[0]]-distsq;
							}
						}
					}
				}
			}
		
		for(x=0;x<im->dim[0];x++)
			for(y=0;y<im->dim[1];y++)
					if(matrix2[x+y*im->dim[0]]) 
						openmap[x+y*im->dim[0]]=distsqcurrent;
		
	}//distsqcurrent loop
		
		
		
		
		
		
		
	free(matrix1);
	free(matrix2);
	free(distmap);
		
		
		
		
	for(y=0;y<im->dim[1];y++)
		for(x=0;x<im->dim[0];x++){
			openmap[x+y*im->dim[0]] =(int)floor(gstep*sqrt(openmap[x+y*im->dim[0]]));
				if(!rPixel(x,y, im)) 
					openmap[x+y*im->dim[0]] *=-1;
				openmap[x+y*im->dim[0]] +=16000;
			}
	ret  = InitImage(im->dim[0], im->dim[1], 65535, "gry16");	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
				wPixel(x, y, ret, openmap[x+y*im->dim[0]]);

	free(openmap);
	return(ret);
}

image_cc *newb3GetOpenCloseMap(image_cc *im, double gstep, int maxdist)
{
	int x, y, z, dist, distsq, distsqold, distsqcurrent;
	short int *matrix1, *matrix2,*distmap, *openmap, totalmax=0;
	int val1,val2;
	double calc;
	image_cc *ret;
		if(strcmp(im->itype,"btd")!=0){
		printf("Distmap: image type must be btd!\n");
		return 0;
	}

	matrix1 = (short int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(short int));
	matrix2 = (short int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(short int));
	distmap = (short int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(short int));
	openmap = (short int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(short int));

	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++){
				matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 32565;
				openmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = maxdist;
			}
	for(y=0;y<im->dim[1];y++)
		for(z=0;z<im->dim[2];z++){
			for(dist=1;dist < im->dim[0]; dist++){
				distsq=dist*dist;
				for(x=0;x<im->dim[0]-dist;x++){
					if(rPixel(x,y,z, im)!=rPixel(x+dist,y,z, im)){
						if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
						if(matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}	
					}
				}
			}
		}
	for(x=0;x<im->dim[0];x++)
		for(z=0;z<im->dim[2];z++){
			for(dist=0;dist < im->dim[1]; dist++){
				distsq=dist*dist;
				for(y=0;y<im->dim[1]-dist;y++){
					if(rPixel(x,y,z, im)!=rPixel(x,y+dist,z, im)){
						if(matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
						if(matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
						}
					}else{
						if(matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]];
						}
						if(matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]];
						}
					}
				}
			}
		}
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 32565;
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++){
			for(dist=0;dist < im->dim[2]; dist++){
				distsq=dist*dist;
				for(z=0;z<im->dim[2]-dist;z++){
					if(rPixel(x,y,z, im)!=rPixel(x,y,z+dist, im)){
						if(distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq){
							distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq;
							
						}
						if(distmap[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]>distsq){
							distmap[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]=distsq;
							
						}	
					}else{
						if(distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsq+matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]){
							distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsq+matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]];
						}
						if(distmap[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]>distsq+matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]){
							distmap[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]=distsq+matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]];
								
						}
					}
					
				}
			}
		}
	//Distance map in distmap. Now we work backwards 	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++){
				//if(rPixel(x,y,z,im))
				//	distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=0;
				totalmax = totalmax >distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]?totalmax:distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]];
			}
	printf("Total maximum: %d\n", totalmax);
	if(maxdist)
		totalmax=totalmax>maxdist?maxdist:totalmax;
	calc=0;
	for(distsqcurrent = 0; distsqcurrent <totalmax;){
		distsqold = distsqcurrent;
		//calc = sqrt(distsqcurrent);
		
		while(distsqcurrent == distsqold){
			calc += 1.0/gstep;
			distsqcurrent = (int)floor(calc*calc);
		}
				
		printf("Current distance: %d\n", distsqcurrent);
		for(x=0;x<im->dim[0];x++)
			for(y=0;y<im->dim[1];y++)
				for(z=0;z<im->dim[2];z++)
					matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 0;
	
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++){
				for(dist=0;dist < im->dim[0]; dist++){
					distsq=dist*dist;
					if(distsq>distsqcurrent)break;
					for(x=0;x<im->dim[0]-dist;x++){
						if(rPixel(x,y,z, im)==rPixel(x+dist,y,z, im)){
						if(distmap[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]<=distsqcurrent&&distmap[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsqold)
							if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]<distsqcurrent-distsq){
								matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsqcurrent-distsq;
							}
						if(distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]<=distsqcurrent&&distmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]>distsqold)
							if(matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]<distsqcurrent-distsq){
								matrix1[x+dist+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsqcurrent-distsq;
							}	
						}
					}
					
				}
			}
		for(x=0;x<im->dim[0];x++)
			for(z=0;z<im->dim[2];z++){
				for(dist=0;dist < im->dim[1]; dist++){
					distsq=dist*dist;
					if(distsq>distsqcurrent)break;
					for(y=0;y<im->dim[1]-dist;y++){
						if(rPixel(x,y,z, im)==rPixel(x,y+dist,z, im))
							{
							if(matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]<matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]-distsq){
								matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=matrix1[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]-distsq;
							}
							if(matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]<matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]-distsq){
								matrix2[x+(dist+y)*im->dim[0]+z*im->dim[1]*im->dim[0]]=matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]-distsq;
							}
						}
					}
				}
			}
		for(x=0;x<im->dim[0];x++)
			for(y=0;y<im->dim[1];y++)
				for(z=0;z<im->dim[2];z++)
					matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] = 0;
		for(x=0;x<im->dim[0];x++)
			for(y=0;y<im->dim[1];y++){
				for(dist=0;dist < im->dim[2]; dist++){
					distsq=dist*dist;
					if(distsq>distsqcurrent)break;
					for(z=0;z<im->dim[2]-dist;z++){
						if(rPixel(x,y,z, im)==rPixel(x,y,z+dist, im))
							if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]<matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]-distsq){
								matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=matrix2[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]-distsq;
							}
							if(matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]<matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]-distsq){
								matrix1[x+y*im->dim[0]+(dist+z)*im->dim[1]*im->dim[0]]=matrix2[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]-distsq;
								
							}
						}
					
					}
			}
		
		for(x=0;x<im->dim[0];x++)
			for(y=0;y<im->dim[1];y++)
				for(z=0;z<im->dim[2];z++)
					if(matrix1[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]) 
						openmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]=distsqcurrent;
		
	}//distsqcurrent loop
		
		
		
		
		
		
		
	free(matrix1);
	free(matrix2);
	free(distmap);
		
		
		
		
	for(z=0;z<im->dim[2];z++)
		for(y=0;y<im->dim[1];y++)
			for(x=0;x<im->dim[0];x++){
				openmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] =(int)floor(gstep*sqrt(openmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]));
				if(!rPixel(x,y,z, im)) 
					openmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] *=-1;
				openmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]] +=16000;
			}
	ret  = InitImage(im->dim[0], im->dim[1], im->dim[2], 65535, "ddd16");	
	for(x=0;x<im->dim[0];x++)
		for(y=0;y<im->dim[1];y++)
			for(z=0;z<im->dim[2];z++)
				wPixel(x, y, z, ret, openmap[x+y*im->dim[0]+z*im->dim[1]*im->dim[0]]);

	free(openmap);
	return(ret);
}
