/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
double *GetAcov(image\_c *im, double *corl, int lag, int mode);
}{              % DESCRIPTION
Returnes the autocovariance function of a 2D grey image}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*im}{Pointer to the image}
\argu{*corl}{address to write the correlation length as result}
\argu{lag}{maximum distance to evaluate (\# pixels)}
\argu{mode}{indicates which directions are to be considered (bit1=x, bit2=y)}
\return{pointer to an array of dimension {\tt lag} where the autocovariance function is stored}
}


150812ss error message for wrong number of dimensions
---------------------------------------------------------------------------*/
#include "quantim4.h"

double *GetAcov(image_cc *im, double *corl, int lag, int mode)
     /* returns autocorrelation function in the range of [0, lag]
	together with the correlation length corl, all in units of # pixel
     */
{
	int x,y,i,mean, xf,yf;
	double *cdf, *acov, *histo;
	double sum;
	unsigned long count;

	if(im->ndim==3)
	{
	 fprintf(stderr,"GetAcov() is for two-dimensional images only. Choose GetDddAcov() for two-dimensional images\n"); 
	 exit(1);
	}
	xf=yf=0;
	if(mode&1) xf=1;
	if(mode&2) yf=1;

	acov = (double *)malloc(lag*sizeof(double));

	count=0;
	  for(x=0;x<im->dim[0];x++)
	    for(y=0;y<im->dim[1];y++) count+=rPixel(x,y, im);
	mean=count/(im->dim[1]*im->dim[0]);
	
	for(i=0;i<lag;i++) acov[i]=0;	
	for(i=0;i<lag;i++){
		count=0;
		    for(x=0;x<im->dim[0]-i*xf;x++)
		    for(y=0;y<im->dim[1]-i*yf;y++){
		      	if(mode & 1 ){
				acov[i]+=(rPixel(x,y, im)-mean)*(rPixel(x+i,y, im)-mean);
				count++;
			}
		      	if(mode & 2){
				acov[i]+=(rPixel(x,y, im)-mean)*(rPixel(x,y+i, im)-mean);
				count++;
			}
		       }
		acov[i]/=count;	
	}
	*corl=0;
	for(i=0;i<lag;i++)
		*corl+=acov[i];
	*corl/=acov[0];

	for(i=1;i<lag;i++)
		acov[i]/=acov[0];
	acov[0]=1;

return acov;
}


