#include "quantim4.h"

double gausint(double x);

image_cc *GetCorDDDImage(double *cdf, int col,int row,int dep,double rx,double ry, double rz,double cx,double cy, double cz, int mode)
/*
mode:
0:	random without any correlation (cx,cy,cz have no meaning here)
1:	Gauss-Correlation model
2: 	Mirrored Gauss-Correlation model
3:	Lorentz-Correlation model
4:	Exponential-Correlation model
5:	von Karman-Correlation model
*/
{
	double ***sfa, randnum,rval;
	int x,y,z,val,i, N;
        image_cc *ddd;
	long idum;
	
	N=col;

	idum=-1;
	if(mode>2)
	    printf("\nSORRY! only gaussian correlation model is implemented (mode<3)\n");
	ddd=InitImage(col,row,dep,255,"ddd");
	ddd->res[0]=rx; ddd->res[1]=ry;ddd->res[2]=rz;
	
	/***** Generation of random field ****/
	sfa=(double ***)malloc(N*sizeof(double **));
	for(x=0;x<N;x++) {
	     sfa[x]=(double **)malloc(N*sizeof(double *));
	     for(y=0;y<N;y++)
	         sfa[x][y]=(double *)malloc(N*sizeof(double));
	}
	if(mode){
	       	if(mode<3)
			grf3(sfa,rx,ry,rz,cx,cy,cz,1,N,0);
		else
			grf3(sfa,rx,ry,rz,cx,cy,cz,1,N,mode-2);
	}
	for(z=0;z<ddd->dim[2];z++)
	for(y=0;y<ddd->dim[1];y++)
	for(x=0;x<ddd->dim[0];x++){
		if(mode==2){
			randnum=1-2*gausint(fabs(sfa[x][y][z]));
//			randnum=erff(fabs(sfa[x][y][z]));
		}
		if(mode==1){
			if(sfa[x][y][z]>=0){
				randnum = gausint(sfa[x][y][z])+0.5; 
			}
			else{	
				randnum=0.5-gausint(fabs(sfa[x][y][z]));
			}
		}
		if(mode==0){
				randnum=ran3(&idum);
		}
		for(i=0;i<256;i++)
			if(randnum<cdf[i]) break;	
//		val =randnum*256;
		val =i;
		wPixel(x,y,z, ddd,val);
	}
	for(x=0;x<N;x++) for(y=0;y<N;y++) free(sfa[x][y]);
	for(x=0;x<N;x++) free(sfa[x]);
	free(sfa);
return ddd;	
}

/*Integral der Standard Gausverteilung (0,1) con 0 bis x f� x>0, Approximation nach Hastings*/

double gausint(double x)
{
	double t,i;
	
	t=1/(1+0.2316419*x);
	i = 1-1/sqrt(2*M_PI)*exp(-(x*x)/2)*(0.31938153*t-0.356563782*pow(t,2)+1.781477937*pow(t,3)-1.82155978*pow(t,4)+1.330274429*pow(t,5));
	return i-0.5;
}

