/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 10.08.01
\command{       % COMMAND
image\_c *GetCorImage(double *cdf, int col,int row,double rx,double ry, double cx,double cy, int mode, double **acov);
}{              % DESCRIPTION
Returnes a random 2D image with defined histogram and/or covariance structure}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*cdf}{cdf of grey levels}
\argu{col, row}{dimensions of reulting image} 
\argu{rx, ry}{size of pixel in x and y}
\argu{cx, cy}{correlation lengths (\# pixel) in x ynd y}
\argu{mode} {0: equal distribution without any correlation (cx,cy,cz and cdf have no meaning here)\\
     1:	equal distribution with  gaussian correlation\\  
     2: predefined distribution (cdf) distribution and gaussian correlation\\   
     3:	Gaussian correlation (cdf have no meaning here)\\
     4:	Lorentz-Correlation model (cdf have no meaning here)\\
     5:	Exponential-Correlation model (cdf have no meaning here)\\
     6:	von Karman-Correlation model (cdf have no meaning here)\\
     7: explicite autocovariance (acov[2][lag])\\
\argu{**acov}{covariance in x and y direction (acov[2][lag]) }
\return{pointer to the created image}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *GetCorImage(double *cdf, int col,int row,double rx,double ry, double cx,double cy, int mode)
/*
mode:

0:	equal distribution without any correlation (cx,cy,cz and cdf have no meaning here)
1:	equal distribution with  gaussian correlation   
2:      predefined distribution (cdf) distribution and gaussian correlation   
3:	Gaussian correlation (cdf have no meaning here)
4:	Lorentz-Correlation model (cdf have no meaning here)
5:	Exponential-Correlation model (cdf have no meaning here)
6:	von Karman-Correlation model (cdf have no meaning here)
7:      explicite autocovariance (acov[2][lag])
*/
{
  double *sfa, randnum,rval,min,max, *iscdf,sum, mean, sig;
	int x,y,z,val,i, N, n, model;
        image_cc *random;
	long idum, count=0;
	
	min=max=0;
	n=col>=row?col:row;
	for(i=1;i<11;i++)
	  if((N=int(pow(2,i)))>=n)
	    break;

	//printf("\nN= %d \n", N);
	//idum=IDUM;
	random=InitImage(col,row,255);
	random->res[0]=rx; random->res[1]=ry;
	
	/***** Generation of random field ****/
	iscdf=(double *)malloc(256*sizeof(double));
	for(i=0;i<256;i++)  iscdf[i]=0;

	sfa=(double *)malloc(N*N*sizeof(double));
	grf2(sfa,N,N,rx,ry,cx,cy,1.,N,mode>2?mode-3:0);
	sum=0;
	for(i=0;i<N*N;i++){
	  sum+=sfa[i];
	  if(sfa[i]<min) min=(sfa[i]);
	  if(sfa[i]>max) max=(sfa[i]);
	}
	mean=sum/(N*N);
	sum=0;
	for(i=0;i<N*N;i++)
	  sum+=(sfa[i]-mean)*(sfa[i]-mean);
	sig=sqrt(sum/(N*N));
	
	//max=3.5*sig;
	//min=-max;
	//printf("\nmin: %lf    max: %lf mean: %lf   sig: %lf \n",min,max,mean,sig);

	/*** calculate cdf of generated values ****/
	for(i=0;i<N*N;i++){
	     val =int((sfa[i]-min)/(max-min) * 255.999);
	     iscdf[val]++;
	     count++;
	}
        for(i=0;i<256;i++) iscdf[i]= (double)iscdf[i]/count;

	sum=iscdf[0];
	for(i=1;i<256;i++){
	     sum+=iscdf[i];
	     iscdf[i]+=iscdf[i-1];
	}
	for(i=0;i<256;i++)
	     iscdf[i]= iscdf[i]/sum;	
	iscdf[0]=0;
	/******************************************/

	for(y=0;y<random->dim[1];y++)
	for(x=0;x<random->dim[0];x++){

		switch(mode){
		case 0: 
			val=int(ran3(&IDUM) * 255.999); break;
		case 1: 	 
			val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
			 for(i=0;i<256;i++)
				if(iscdf[val]<= (double)i/256) break;
        		val = i>255?255:i; break;
		case 2:   
			val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
	     		for(i=0;i<256;i++)
				if(iscdf[val]<cdf[i])   break;
             		 val = i>255?255:i;  break; 
		default:  val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
		}
	   	wPixel(x,y, random,val);
	}
	free(sfa);
return random;	
}

image_cc *GetCorImage(double *cdf, int col,int row,double rx,double ry, double cx,double cy, int mode, double **acov)
/*
mode:

0:	equal distribution without any correlation (cx,cy,cz and cdf have no meaning here)
1:	equal distribution with  gaussian correlation   
2:      predefined distribution (cdf) distribution and gaussian correlation   
3:	Gaussian correlation (cdf have no meaning here)
4:	Lorentz-Correlation model (cdf have no meaning here)
5:	Exponential-Correlation model (cdf have no meaning here)
6:	von Karman-Correlation model (cdf have no meaning here)
7:      explicite autocovariance (acov[2][lag])
*/
{
  double *sfa, randnum,rval,min,max, *iscdf,sum, mean, sig;
	int x,y,z,val,i, N, n, model;
        image_cc *random;
	long idum, count=0;
	
	min=max=0;
	n=col>=row?col:row;
	for(i=1;i<11;i++)
	  if((N=int(pow(2,i)))>=n)
	    break;

	//printf("\nN= %d \n", N);
	//idum=IDUM;
	random=InitImage(col,row,255);
	random->res[0]=rx; random->res[1]=ry;
	
	/***** Generation of random field ****/
	iscdf=(double *)malloc(256*sizeof(double));
	for(i=0;i<256;i++)  iscdf[i]=0;

	sfa=(double *)malloc(N*N*sizeof(double));
	grf2ext(sfa,N,N,rx,ry,cx,cy,1.,N,mode>2?mode-3:0, acov);
	sum=0;
	for(i=0;i<N*N;i++){
	  sum+=sfa[i];
	  if(sfa[i]<min) min=(sfa[i]);
	  if(sfa[i]>max) max=(sfa[i]);
	}
	mean=sum/(N*N);
	sum=0;
	for(i=0;i<N*N;i++)
	  sum+=(sfa[i]-mean)*(sfa[i]-mean);
	sig=sqrt(sum/(N*N));
	
	//max=3.5*sig;
	//min=-max;
	//printf("\nmin: %lf    max: %lf mean: %lf   sig: %lf \n",min,max,mean,sig);

	/*** calculate cdf of generated values ****/
	for(i=0;i<N*N;i++){
	     val =int((sfa[i]-min)/(max-min) * 255);
	     iscdf[val]++;
	     count++;
	}
        for(i=0;i<256;i++) iscdf[i]= (double)iscdf[i]/count;

	sum=iscdf[0];
	for(i=1;i<256;i++){
	     sum+=iscdf[i];
	     iscdf[i]+=iscdf[i-1];
	}
	for(i=0;i<256;i++)
	     iscdf[i]= iscdf[i]/sum;	
	iscdf[0]=0;
	/******************************************/

	for(y=0;y<random->dim[1];y++)
	for(x=0;x<random->dim[0];x++){

		switch(mode){
		case 0: 
			val=int(ran3(&IDUM) * 255.999); break;
		case 1: 	 
			val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
			 for(i=0;i<256;i++)
				if(iscdf[val]< (double)i/256) break;
        		val = i>255?255:i; break;
		case 2:   
			val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
	     		for(i=0;i<256;i++)
				if(iscdf[val]<cdf[i])   break;
             		 val = i>255?255:i;  break; 
		default:  val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
		}
	   	wPixel(x,y, random,val);
	}
	free(sfa);
return random;	
}

