/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
080801hj corrected
150812ss error message for wrong number of dimensions
---------------------------------------------------------------------------*/
#include "quantim4.h"

double *GetDddAcov(image_cc *im, double *corl, int lag, int mode)
{

	int x,y,z,i,mean, xf, yf, zf;
	double *cdf, *acov, *histo;
	double sum;
	unsigned long count;
	
	if(im->ndim==2)
	{
	 fprintf(stderr,"GetDddAcov() is for three-dimensional images only. Choose GetAcov() for two-dimensional images\n"); 
	 exit(1);
	}
	xf=yf=zf=0;
	if(mode&1) xf=1;
	if(mode&2) yf=1;
	if(mode&4) zf=1;

	acov = (double *)malloc(lag*sizeof(double));

	count=0;
	for(z=0;z<im->dim[2];z++)
	  for(x=0;x<im->dim[0];x++)
	    for(y=0;y<im->dim[1];y++) count+=rPixel(x,y,z, im);
	mean=count/(im->dim[1]*im->dim[0]*im->dim[2]);

	for(i=0;i<lag;i++) acov[i]=0;	
	for(i=0;i<lag;i++){
		count=0;
		for(z=0;z<im->dim[2]-i*zf;z++)
	 	   for(x=0;x<im->dim[0]-i*xf;x++)
		      for(y=0;y<im->dim[1]-i*yf;y++){
		      	if(mode & 1<<0){
				acov[i]+=(rPixel(x,y,z, im)-mean)*(rPixel(x+i,y,z, im)-mean);
				count++;
			}
		      	if(mode & 1<<1){
				acov[i]+=(rPixel(x,y,z, im)-mean)*(rPixel(x,y+i,z, im)-mean);
				count++;
			}
		      	if(mode & 1<<2){
				acov[i]+=(rPixel(x,y,z, im)-mean)*(rPixel(x,y,z+i, im)-mean);
				count++;
			}
		       }
		acov[i]/=count;	
	}
	
	
	*corl=0;
	for(i=0;i<lag;i++)
		*corl+=acov[i];
	*corl/=acov[0];
return acov;

}



