/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 02.09.04
\command{       % COMMAND
image\_c *GetRandImage(int col,int row,double rx,double ry, double cx,double cy, int mode);
}{              % DESCRIPTION
Returnes a random 2D image with defined histogram and/or covariance structure}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*cdf}{cdf of grey levels}
\argu{col, row}{dimensions of reulting image} 
\argu{rx, ry}{size of pixel in x and y}
\argu{cx, cy}{correlation lengths (\# pixel) in x ynd y}
\argu{mode} {
     0:	Gaussian correlation \\
     1:	Lorentz-Correlation model\\
     2:	Exponential-Correlation model\\
     3:	von Karman-Correlation model\\
\argu{**acov}{covariance in x and y direction (acov[2][lag]) }
\return{pointer to the created image}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *GetRandImage(int col,int row,double rx,double ry, double cx,double cy, int mode)
/*
mode:

0:	Gaussian correlation 
1:	Lorentz-Correlation model 
2:	Exponential-Correlation model
3:	von Karman-Correlation model

*/
{
	double *sfa, randnum,rval,min,max, *iscdf,sum, **acov;
	int x,y,z,val,i, N, n, model;
        image_cc *random;
	long idum, count=0;
	
	min=max=0;
	n=col>=row?col:row;
	for(i=1;i<11;i++)
	  if((N=int(pow(2,i)))>=n)
	    break;

	idum=-1;
	random=InitImage(col,row,255);
	random->res[0]=rx; random->res[1]=ry;
	
	sfa=(double *)malloc(N*N*sizeof(double));
	grf2ext(sfa,N,N,rx,ry,cx,cy,1.,N,mode, acov);
	for(i=0;i<N*N;i++){
	  if(sfa[i]<min) min=(sfa[i]);
	  if(sfa[i]>max) max=(sfa[i]);
	}

	for(y=0;y<random->dim[1];y++)
	for(x=0;x<random->dim[0];x++){
	  val =int((*(sfa+y*N+x)-min)/(max-min) * 255);
	  wPixel(x,y, random,val);
	}
	free(sfa);
	
return random;	
}

