/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 22.02.02
\command{       % COMMAND
double *GetSemiVar(image\_c *im, int lag, int mode);
}{              % DESCRIPTION
Returnes the semivariogram of a 2D grey image}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*im}{Pointer to the image}
\argu{lag}{maximum distance to evaluate (\# pixels)}
\argu{mode}{indicates which directions are to be considered (bit1=x, bit2=y)}
\return{pointer to an array of dimension {\tt lag} where the semivariogram is stored}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double *GetSemiVar(image_cc *im, int lag, int mode)
     /* returns semivariogram in the range of [0, lag]
     */
{
	int x,y,i, xf,yf;
	double *cdf, *acov, *histo;
	double sum,mean;
	unsigned long count;

	xf=yf=0;
	if(mode&1) xf=1;
	if(mode&2) yf=1;

	acov = (double *)malloc(lag*sizeof(double));

	for(i=0;i<lag;i++) acov[i]=0;	
	for(i=0;i<lag;i++){
		count=0;
		    for(x=0;x<im->dim[0]-i*xf;x++)
		    for(y=0;y<im->dim[1]-i*yf;y++){
		      	if(mode & 1 ){
				acov[i]+=pow((rPixel(x+i,y, im)-rPixel(x,y, im)),2);
				count++;
			}
		      	if(mode & 2){
				acov[i]+=pow((rPixel(x,y+i, im)-rPixel(x,y, im)),2);
				count++;
			}
		       }
		acov[i]/= 2*(count-1);	
	}
return acov;
}

