/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
hj050202: scaling of resolution to avoid rounding errors

\command{char *GetSphereElementDouble(double rad, double rx, double ry, double rz, int *vol)}{
Same as GetSphereElement but with non-integer radius {\tt rad} [voxels].

\medskip
\argu{rad} {radius of the structuring element [voxels]}
\argu{rx, ry, rz} {Resolution in different dimensions [L]}
\argu{vol} {the size of the structuring element [number of voxels] is written to this address}

\smallskip
{\bf return value:} same as GetSphereElement.  
}


---------------------------------------------------------------------------*/
#include "quantim4.h"

char *GetSphereElementDouble(double rad, double rx, double ry, double rz, int *vol)
{
        int vv,x,y,z,  i,N;
	long count=0;
	double Min,r,rr;
	char *s;
	
	Min = rx<=ry?rx:ry; Min= Min<=rz?Min:rz;

	/*** scale resolution towards 1 **/
	rx/=Min; ry/=Min; rz/=Min;

	r=(double)rad;
	//r=(double)rad*Min;
	*vol=0;
	vv=0;

	N=int(3+(rad*2+1)*(rad*2+1)*(rad*2+1)/8+1);
	s = (char *)malloc(N);
	for(i=0;i<N;i++) 
		s[i]=0;
	s[0]=char(rad/rx); s[1]=char(rad/ry); s[2]=char(rad/rz);
	//s[0]=rad * Min/rx; s[1]=rad * Min/ry; s[2]=rad * Min/rz;
	rad*=rad;
	for(z=-s[2];z<=s[2];z++)
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if((double)z*rz*z*rz+y*ry*y*ry+x*rx*x*rx<=rad){
			*(s+3+count/8) |= 1<<count%8;
			vv++;
	  }
	  count++;
	}
	*vol=vv;
/***************** print the structuring element**********************  
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	
		if(i%((2*s[0]+1)*(2*s[1]+1))==0) printf("\n");	

	 	if(*(s+3+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("\n");
**/	  
	return s;
}

