/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

//image_cc *LoadImage(char *buf);

image_cc *LoadImage(char *buf)
{
 	FILE *fp;
	long row; 
	TIFF *tif;
	char fname[255];
	unsigned char *pixbuf;
	image_cc *im;
	int i, alpha=0;
	unsigned long offset;
	
	im = (image_cc *)malloc(sizeof(image_cc));

	while(1){

	  sprintf(fname,"%s.btd",buf);
	  if((fp=fopen(fname,"r"))!=0){
	    sprintf(im->itype,"btd");
	    sprintf(im->name,"%s",fname);
	    fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
		   &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	    im->pix=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->numbytes);
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<im->dim[0]*im->dim[1]*im->numbytes;i++) 
	      im->pix[i]=getc(fp);
	    fclose(fp);
	    break;
	  }
	  sprintf(fname,"%s.ddd",buf);
	  if((fp=fopen(fname,"r"))!=0){
	    sprintf(im->itype,"ddd");
	    sprintf(im->name,"%s",fname);
	    fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
		   &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	    im->pix=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->numbytes);
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<im->dim[0]*im->dim[1]*im->numbytes;i++) 
	      im->pix[i]=getc(fp);
	    fclose(fp);
	    break;
	  }

	  while(1){
	    sprintf(fname,"%s",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.tif",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.tiff",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    printf("\nLoadImage: could not open %s\n",buf);
	    exit(0);
	  }
	  TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &im->dim[1]);
	  TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &im->dim[0]);
	  TIFFGetField(tif, TIFFTAG_SAMPLESPERPIXEL, &im->numbytes);
	  TIFFGetField(tif, TIFFTAG_BITSPERSAMPLE, &im->dim[2]);
	  sprintf(im->name,"%s",buf);
	  if(im->numbytes==3||im->numbytes==4){
	    alpha = im->numbytes-3;
	    im->numbytes=3;
	    sprintf(im->itype,"rgb");
	  }
	  else{
	    alpha = im->numbytes-1;
	    im->numbytes=1;
	    sprintf(im->itype,"gry");
	  }
	  
	  pixbuf =(unsigned char *)malloc(im->dim[1]*im->dim[0]*(im->numbytes+alpha));
	  im->pix =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numbytes);
	  for (row = 0; row < im->dim[1]; row++)
	    TIFFReadScanline(tif, pixbuf+(row*im->dim[0]*(im->numbytes+alpha)), row,0);	  
	  for(i=0;i<im->dim[0]*im->dim[1];i++)
	    *(im->pix+i)=*(pixbuf+i+i/im->numbytes);
	  
	  TIFFClose(tif);
	  break;
	    
	  printf("\nLoadImage: could not open %s\n",buf);
	  exit(0);
	}

	printf("****************************\n");
	printf("Image lllloaded:\n");
	printf("Image name:\t %s\n",im->name);
	printf("Image type:\t %s\n",im->itype);
	if(alpha)
	  printf("Image alpha:\t removed\n",im->itype);
	else
	  printf("Image alpha:\t no\n",im->itype);
	printf("Image hight:\t %d\n", im->dim[1]);
	printf("Image width:\t %d\n", im->dim[0]);
	printf("Image depth:\t %d\n", im->dim[2]);
	printf("Image nbytes:\t %d\n", im->numbytes);
	printf("Image x-res:\t %lf\n", im->res[0]);
	printf("Image y-res:\t %lf\n", im->res[1]);
	printf("Image z-res:\t %lf\n", im->res[2]);
	printf("****************************\n");
	    
 return im;
}


