/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"


void StretchHisto(image_cc *image, int Low, int High)
{
   long idum;
   int i,x,y,z;
   int gv, max;
   double iwidth, dgv;
   unsigned long buf=1;
   idum=-1;
   if(image->numbytes==1)
       max=255;
   else
       max=65535;
   iwidth=(double)max/(High-Low);

   	for(i=0;i<image->ndim;i++)
		buf*=image->dim[i];
	buf*=image->numchannel;

	for(i=0;i<buf*image->numbytes;i+=image->numbytes){
		point.p=image->pix+i;
		if(image->numbytes==1)
		    gv= *(point.p);
		else
		    gv= *(point.q);
		dgv=gv-Low;
		dgv += ran3(&idum) - 0.5;
		dgv*=iwidth;
		if(dgv>max)
			dgv=max;
		if(dgv<0)
			dgv=0;

		if(image->numbytes==1)	*(point.p) =int(dgv);
		else 			*(point.q) =int(dgv);
	}
   return;
}

void StretchHisto(image_cc *image)
{
   long idum;
   int i,x,y,z, High, Low;
   unsigned int gv, max;
   double iwidth, dgv;
   unsigned long buf=1;

   idum=-1;
   GetMinMax(image,&High, &Low);
   if(image->numbytes==1)	max=255;
   else 			max=65535;
   iwidth=(double)max/(High-Low);

   	for(i=0;i<image->ndim;i++)
		buf*=image->dim[i];
	buf*=image->numchannel;

	for(i=0;i<buf*image->numbytes;i+=image->numbytes){
		point.p=image->pix+i;
		if(image->numbytes==1)	gv= *(point.p);
		else 			gv= *(point.q);
		if(gv<Low) dgv=0.;
		else if(gv>High) dgv=(double)max;
		else           dgv=(double)(gv-Low+ran3(&idum))*iwidth-iwidth/2; 
		if(dgv>max)
			dgv=max;
		if(dgv<0)
			dgv=0;
		if(image->numbytes==1)	*(point.p) =int(dgv);
		else 			*(point.q) =int(dgv);
	}
   return;
}
void StretchHisto(image_cc *image, double th)
{
   long idum;
   int i,x,y,z, High, Low;
   unsigned int gv, max;
   double iwidth, dgv, *cdf, cum=0;
   unsigned long buf=1;

   idum=-1;
   th/=100.;	
   cdf=Histo(image);
   for(i=0;i<256;i++){
	cum+=cdf[i];
	if(cum>=th){
		Low=i;
		break;
	}
   }	
   cum=0;
   for(i=255;i>0;i--){
	cum+=cdf[i];
	if(cum>=th){
		High=i;
		break;
	}
   }	
   if(image->numbytes==1)	max=255;
   else {			max=65535; Low*=256; High*=256;}
	printf("\nStretchHisto limits: %d   %d  \n",Low,High);	

   iwidth=(double)max/(High-Low);


   	for(i=0;i<image->ndim;i++)
		buf*=image->dim[i];
	buf*=image->numchannel;

	for(i=0;i<buf*image->numbytes;i+=image->numbytes){
		point.p=image->pix+i;
		if(image->numbytes==1)	gv= *(point.p);
		else 			gv= *(point.q);
		if(gv<Low) dgv=0.;
		else if(gv>High) dgv=(double)max;
		else           dgv=(double)(gv-Low)*max/(High-Low)+ran3(&idum)*iwidth-iwidth/2; 
		if(dgv>max)
			dgv=max;
		if(dgv<0)
			dgv=0;
		if(image->numbytes==1)	*(point.p) =int(dgv);
		else 			*(point.q) =int(dgv);
	}
   return;
}

void GetMinMax(image_cc *im, int *max, int *min)
{
	int i, val;
   	unsigned long buf=1;

   	for(i=0;i<im->ndim;i++)
		buf*=im->dim[i];
	buf*=im->numchannel;

	point.p=im->pix;
	val= im->numbytes==1? *(point.p) : *(point.q);
	*min=*max=val;

	for(i=0;i<buf*im->numbytes;i+=im->numbytes){
		point.p=im->pix+i;
		val= im->numbytes==1? *(point.p) : *(point.q);
		if(val<*min) *min=val;
		else if(val>*max) *max=val;
	}
	return;
}
int GetMaxGrey(image_cc *im)
{
	int i, max, maxgrey, val=0;
   	unsigned long buf=1;

	if(im->numbytes==2) maxgrey=65535;
	else maxgrey=255;
   	for(i=0;i<im->ndim;i++)
		buf*=im->dim[i];
	buf*=im->numchannel;

	point.p=im->pix;
	max=val;

	for(i=0;i<buf*im->numbytes;i+=im->numbytes){
		point.p=im->pix+i;
		val= im->numbytes==1? *(point.p) : *(point.q);
		if(val>max && val!=maxgrey) max=val;
	}
	return max;
}

int GetMinGrey(image_cc *im)
{
	int i, min, maxgrey, val;
   	unsigned long buf=1;

	if(im->numbytes==2) maxgrey=65535;
	else maxgrey=255;
	val=maxgrey;

   	for(i=0;i<im->ndim;i++)
		buf*=im->dim[i];
	buf*=im->numchannel;

	point.p=im->pix;
	min=val;

	for(i=0;i<buf*im->numbytes;i+=im->numbytes){
		point.p=im->pix+i;
		val= im->numbytes==1? *(point.p) : *(point.q);
		if(val<min && val) min=val;
	}
	return min;
}
void StretchHisto_old(image_cc *image, int Low, int High)
{
   long idum;
   int x,y;
   unsigned char gv;
   double iwidth, dgv;

   idum=-1;
   iwidth=(double)255/(High-Low);

   for (x=0;x<image->dim[0];x++)
     for (y=0;y<image->dim[1];y++){
       gv=rPixel(x,y,image);
       if (gv<Low) {
        gv=0;
       } else {
        if (gv>High) {
          gv=255;
        } else {
          dgv=(double)(gv-Low)*255/(High-Low)+ran3(&idum)*iwidth-iwidth/2; 
          if (dgv<0) {
            gv=0;
          } else {
            if (dgv>255) {
              gv=255;
            } else {
              gv=(unsigned char)dgv;
            }
          }
        }
       }
       wPixel(x,y,image,gv);
     }
   return;
}

void StretchHisto_old(image_cc *image)
{
   long idum;
   int x,y, High, Low;
   unsigned char gv;
   double iwidth, dgv;

   GetMinMax(image,&High, &Low);
   idum=-1;
   iwidth=(double)255/(High-Low);

   for (x=0;x<image->dim[0];x++)
     for (y=0;y<image->dim[1];y++){
       gv=rPixel(x,y,image);
       if (gv<Low) {
        gv=0;
       } else {
        if (gv>High) {
          gv=255;
        } else {
           dgv=(double)(gv-Low)*255/(High-Low)+ran3(&idum)*iwidth-iwidth/2; 
          if (dgv<0) {
            gv=0;
          } else {
            if (dgv>255) {
              gv=255;
            } else {
              gv=(unsigned char)dgv;
            }
          }
        }
       }
       wPixel(x,y,image,gv);
     }
   return;
}
