/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 11.06.02
\command{       % COMMAND
double bEuler8(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the  Euler number of a 2D binary structure considering 8-connectivity of phase [1]}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of voxel configurations obtained by bQuant()}
\return{Euler number [1/L$^2$]  in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double bAverageCurvature(image_cc *image, long int *h)
{
	unsigned int i,p;
	long int iChi=0, iVol=0;
	double  avcurve, boundary, dx, dy, dxy;
	int iu[16]=
	{ 0, 1, 0, 0, 0, 0, 0, -1, 0, 1, 0, 0, 0, 0, 0, 0};
	int iw[16]=
	{0, 3, 1, 2, 1, 2, 2, 1, 1, 2, 2, 1, 2, 1, 3, 0};
 

       	for(i=0;i<16;i++){
		iChi+=iu[i]*h[i];
	}
 	avcurve=(double)iChi*2*M_PI;

 	for(i=0;i<16;i++){
	  iChi+=iw[i]*h[i];
	  iVol+=h[i];
	}
	dx=image->res[0];
	dy=image->res[1];
	dxy=sqrt(image->res[0]*image->res[0]+image->res[1]*image->res[1]);
	if(!iVol) return 0;
 	boundary = M_PI/2 * (double)iChi/((double)iVol*(dx+dy+dxy));
	boundary *= image->dim[0]*image->res[0]*image->dim[1]*image->res[1];

	return avcurve/boundary;
}

 
 
