/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 30.05.03
\command{       % COMMAND
unsigned long bErodeMark(image\_c *image, int mark, int step);
}{              % DESCRIPTION
Performs a dilation (0-phase) of a binary image with a circular 
	structuring element of radius {\tt step}. The dilated area is marked 
	with the greylevel {\tt mark}. The number of marked pixel is returned.

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the binary image}
\argu{step}{Radius of structuring element}
\argu{mark}{Greylevel to mark dilated pixel}
\return{Number of marked pixel}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

unsigned long bErodeMark(image_cc *image, int mark, int step)
     /* performs a dilation (0-phase) of a binary image with a circular 
	structuring element of radius 'step'. The dilated area is marked 
	with the greylevel 'mark'. The number of marked pixel is returned.*/ 
{
	int x,y,count,i,j, sum;
	unsigned char Pixel; 
	image_cc imagebuffer, *imbuf;
	
	SetFrame(image,255);
	imbuf=CopyImage(image);

	sum=0;
	for(j=0;j<step;j++){
	   for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++)
		  if((count=rPixel(x,y,image))==255){
			 if(!(j%2)){
			    for(i=0;i<4;i++)
			      if((Pixel=rPixel(x+neigh4x[i],y+neigh4y[i],image))< 255){
				   count=mark;
			      }
			 }
			 else
			    for(i=0;i<8;i++)
			      if((Pixel=rPixel(x+neigh8x[i],y+neigh8y[i],image))< 255){
				    count=mark;
			      }

		  wPixel(x,y, imbuf,count);
		  if(count!=255) sum++;
		  }
	for(y=0;y<image->dim[1];y++)
		for (x=0;x<image->dim[0];x++)
			wPixel(x,y,image,rPixel(x,y,imbuf));
	}
	DeleteImage(imbuf);
	return sum;
}
