/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

%--------------------------------- hj 12.09.03
\command{
image\_c *bErodeMirCirc(image\_c *image,int step, int mode)
}{
as bErodeMir but optimal circles are used as structuring elements for erosion.  The original image is not replaced, the pointer to the resulting image is returned.

\medskip
\argu{image} {Pointer to the image description structure.}
\argu{step} {radius of the hexagonal structuring element }
\argu{mode} {0 = erosion of the dark phase (0), 1 = dilation} 
\return{Pointer to the eroded image}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *bErodeMirCirc(image_cc *im, int step, int mode)
{
	int x,y,X,Y,XX,YY, Xx, Yy,i;
	unsigned long j, count;
	char *se, buffer[127];

	image_cc *outim, *mirim;
	

	outim = CopyImage(im);
	mirim=InitImage(im->dim[0]+2*step,im->dim[1]+2*step,0);
	mirim->res[0]=im->res[0];mirim->res[1]=im->res[1];	

	se = GetCircElement(step,im->res[0], im->res[1]);

	for(y=0;y<mirim->dim[1];y++)
	  for(x=0;x<mirim->dim[0];x++){
	    XX=abs(x-step); YY=abs(y-step);
	    Xx=XX/im->dim[0]; Yy=YY/im->dim[1]; 
	    X=XX-2*(XX-im->dim[0]+1)*Xx; 
	    Y=YY-2*(YY-im->dim[1]+1)*Yy; 
      	    wPixel(x,y,mirim,rPixel(X,Y,im));
	  }

	for(y=0;y<im->dim[1];y++)
	 for(x=0;x<im->dim[0];x++)	
	    if(rPixel(x,y,im) == mode*255){
	        count=0;
		for(Y=-se[1];Y<=se[1];Y++)
		 for(X=-se[0];X<=se[0];X++){
      		      if(rPixel(x+X+se[0],y+Y+se[1],mirim)!=mode*255 && *(se+2+count/8) & 1<<count%8){
			if(mode){
			  wPixel(x,y,outim,0);
			  X=Y=im->dim[0];
			}
			else{
			  wPixel(x,y,outim,255);
			  X=Y=im->dim[0];
			}
		      }
		      count++;
		 }
	    }
	return outim;
}

