/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 12.09.03
\command{       % COMMAND
int bGetDistOpenMap(image\_c *image, image\_c *distance, image\_c *opened,  int gval, int gstep)
}{              % DESCRIPTION
As bGetDistMap(), this function converts a binaryimage to its distance map. Additionally a 'granulometry map' is calculated where  each pixel in phase 1 (255) is written to a grey value which corresponds to the diameter of the maximum circle that can be placed inside phase 1 at that location (corresponding to the 'opening size'). The smallest circle is marked by the grey value {\\tt gval} which increases by steps {\\tt gstep} with the size of the ball.
 

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the binary image}
\argu{*distance}{Must initially be a copy of {\\tt image} and contains the resulting distance map after execution}
\argu{*opened}{Must initially be a copy of {\\tt image} and contains the resulting granulometry map after execution}
\argu{gval}{Grey level for the smallest size class}
\argu{gstep}{Grey level step between subsequent size classes}
\return{Number of detected size classes}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

int bGetDistOpenMap(image_cc *image, image_cc *distance, image_cc *opened, int gval, int gstep)
{
  image_cc *op, *dilat;
  int x,y,z, count, oldcount=0, step,val;
  char buffer[127];
  
  step=1;
  count=1;
  printf("\nGetDistOpenMap - erosion step :\n");

  while(count){
    count=0;
    printf("\r %d ",step);
    dilat=bErodeMirCond(image, distance, step, 1,1);
    for(x=0;x<dilat->dim[0];x++)
     for(y=0;y<dilat->dim[1];y++)
	if(!rPixel(x,y,dilat) && rPixel(x,y,distance)==255){
	  wPixel(x,y,distance,gval+step*gstep);
	  count++;
	}

    DeleteImage(dilat);
    dilat=CopyImage(distance);
    gBin(254,0,255,dilat);
    op=bErodeMirCond(dilat,opened, step, 0,0);
    val=gval+step*gstep;
    for(x=0;x<op->dim[0];x++)
     for(y=0;y<op->dim[1];y++)
	if(!rPixel(x,y,op) && rPixel(x,y,opened)==255){
	  wPixel(x,y,opened,val);
	  count++;
	}

    DeleteImage(dilat);
    DeleteImage(op);
    step++;
    //if(MAXDIL && step>MAXDIL) count=0;
  }
  printf("\n done \n ");

  return step-1;   
}

