/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 11.06.02
\command{       % COMMAND
double bLengthdens(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the  Lengthdensity $B_A$ [cm/cm$^2$] of the boundary of a 2D binary structure}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of voxel configurations obtained by bQuant()}
\return{Lengthdensity [L/L$^2$]  in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double bLengthdens(image_cc *image, long int *h)
{
	unsigned int i,l;
	long int  numpix=0, ii;
	double II=0, LI=0, w[4], r[4];
	int kl[4][2] = {{1,2},{1,4},{1,8},{2,4}};
	
	r[0]=image->res[0];
	r[1]=image->res[1];
	r[2]= r[3]=sqrt(r[0]*r[0] + r[1]*r[1]);

	if(image->res[1]<=0 || image->res[0]<=0){
	  printf("\nbLengthsdens: Image resolution is <=0 \n");
	  return -1;
	}

	w[0]=atan(image->res[0]/image->res[1])/M_PI;
	w[1]=atan(image->res[1]/image->res[0])/M_PI;
	w[2]=w[3]=(1-w[0]-w[1])/2;
	//for(i=0;i<4;i++)
	//printf("\nw[$%d] =  %lf",i,w[i]);

	for(l=0;l<16;l++) numpix += h[l];
	for(i=0;i<4;i++){
	    ii=0;
 	    for(l=0;l<16;l++){
	        ii+= h[l] * (l==(l|kl[i][0])) * (0==(l&kl[i][1]));
		ii+= h[l] * (l==(l|kl[i][1])) * (0==(l&kl[i][0]));
	    }	  
	    II+= (double)w[i]* ii;
	    LI+= (double)w[i]* numpix*r[i];
	    //printf("\nII dir %d :  %lf ",i,II);
	}
	if(!LI) return 0;
	else return M_PI/2 * II/LI;
}


