/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 11.06.02
\command{       % COMMAND
long int *bQuant(image\_c *image);
}{              % DESCRIPTION
Calculates the frequency distribution of 16 different pixel configurations in a 2x2 square. 
The returned pointer is input for the routines to calculate volume density, surface density, length density, curvature and Euler number.   

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*im}{Pointer to the binary 2D-image.}
\return{Pointer to the 16-element array containing frequencies of pixel configurations}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

long int *bQuant(image_cc *image)
{
	int i, x,y, mask;
	long int *h;
	
	h=(long int *)malloc(16*sizeof(long int));
 	for(i=0;i<16;i++) h[i]=0;

        for (x=0;x<image->dim[0]-1;x++){
	     mask=(rPixel(x,0,image)==0) + ((rPixel(x+1,0,image)==0)<<1); 
	     for (y=0;y<image->dim[1]-1;y++){
		  mask+=((rPixel(x,y+1,image)==0)<<2) + ((rPixel(x+1,y+1,image)==0)<<3);
		  h[mask]++;
		  mask>>=2;
	     }
 	}
 	return h;
}

 
 
