/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 27.11.02
\command{       % COMMAND
long int *bQuantMask(image\_c *image, int xm, int ym, char *mask);
}{              % DESCRIPTION
Calculates the frequency distribution of 16 different pixel configurations within a 2x2 square for a region identified by {\tt mask}. The format of  {\tt mask} corresponds to that returned by GetCircElement.
The returned pointer is input for the routines to calculate volume density, surface density, length density, curvature and Euler number.   

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*im}{Pointer to the binary 2D-image.}
\argu{int xm, ym}{Coordinates of the center of the region described by {\tt mask}.}
\argu{*mask}{description of the region to be analyzed.}
\return{Pointer to the 16-element array containing frequencies of pixel configurations}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

long int *bQuantMask(image_cc *image, int xm, int ym, char *mask)
{
	int i, x,y, X,Y, conf,n, index;
	long int *h;
 	double vol;
	
	h=(long int *)malloc(16*sizeof(long int));
 	for(i=0;i<16;i++) h[i]=0;

	 index=0;
	 for(y=-mask[1];y<=mask[1];y++)  
	  for(x=-mask[0];x<=mask[0];x++){
	       if(*(mask+2+index/8) & 1<<index%8){
		    X=xm+x; Y=ym+y;
		    if(X>=0 && Y>=0 && X<image->dim[0]-1 && Y<image->dim[1]-1){
		      conf=(rPixel(X,Y,image)==0) + ((rPixel(X+1,Y,image)==0)<<1)
			+((rPixel(X,Y+1,image)==0)<<2) + ((rPixel(X+1,Y+1,image)==0)<<3);
		      h[conf]++;
		    }		 
		}
	       index++;
	     }
 	return h;
}
