/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 27.11.02
\command{       % COMMAND
long int *bQuantRecMask(image\_c *image, int xdim,int ydim, int xul, int yul);
}{              % DESCRIPTION
Calculates the frequency distribution of 16 different pixel configurations within a 2x2 square for a rectangular region. 
The returned pointer is input for the routines to calculate volume density, surface density, length density, curvature and Euler number.   

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*im}{Pointer to the binary 2D-image.}
\argu{int xdim, ydimm}{Extension of the rectangular region [pixel].}
\argu{int xul, int yul}{Coordinates of the upper left corner.}
\return{Pointer to the 16-element array containing frequencies of pixel configurations}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

long int *bQuantRecMask(image_cc *image, int xdim,int ydim, int xul, int yul)
{
  int x,y, conf;
  long int *h;


	 for(y=yul;y<yul+ydim-1;y++)  
	  for(x=xul;x<<xul+xdim-1;x++){
		      conf=(rPixel(x,y,image)==0) 
			+ ((rPixel(x+1,y,image)==0)<<1)
			+((rPixel(x,y+1,image)==0)<<2) 
			+ ((rPixel(x+1,y+1,image)==0)<<3);
		      h[conf]++;
	  }
}
