/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
void bRemObjects(image_cc *image, int size);
}{              % DESCRIPTION
Removes all objects (grey level=0) smaller than 'size' (number of pixels) }

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the binary image}
\argu{size}{maximum size of objects (#pixels) to be removed}
\return{no return value, the original image is changed}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

int bConCom3(image_cc *image,int xv,int yv, int size);

void RemoveObjects(image_cc *im, int size, int phase)
{
    int numvox=im->dim[0]*im->dim[1]*im->dim[2], changed=0, nr_cl, *size_crit;
    image_cc *clus;
    double *pdf;
    
    if(!phase)
	InvertImage(im);

    clus=Cluster(im,&nr_cl);
    if(nr_cl>65536)nr_cl=65536;
    size_crit=(int*)calloc(nr_cl,sizeof(int));
    pdf=Histo16(clus);
    
    
    for(int i=1;i<nr_cl;i++)
    {
	if(pdf[i]*numvox>size)
	    size_crit[i]=1;
	else
	    changed++;
	
	//printf("%d\t%lf\t%d\n",i,pdf[i]*numvox,size_crit[i]);
    }
    printf("RemoveObjects: %d out of %d\n",changed,nr_cl-1); // background counts as an additional object
    
    for(int i=0;i<numvox;i++)
    {
	if(!size_crit[rPixel(i,clus)])
	  wPixel(i,im,0);
    }
    free(size_crit);
    DeleteImage(clus);
    if(!phase)
	InvertImage(im);
    
}

void RemoveObjects(image_cc *im, image_cc *roi, int size, int phase)
{
    int numvox=im->dim[0]*im->dim[1]*im->dim[2], nr_roi, changed=0, nr_cl, *size_crit;
    image_cc *clus;
    double *pdf;
    
    for(int i=0;i<numvox;i++)
    {
	//mask out region outside ROI
	if(!rPixel(i,roi))
	    wPixel(i,im,0);
	//invert image
	if(!phase)
	{
	   if(rPixel(i,im))
	       wPixel(i,im,0);
	   else
	       wPixel(i,im,1);
	}
    }


    clus=Cluster(im,&nr_cl);
    if(nr_cl>65536)nr_cl=65536;	
    size_crit=(int*)calloc(nr_cl,sizeof(int));
    pdf=Histo16(clus);
    
    
    for(int i=1;i<nr_cl;i++)
    {
	if(pdf[i]*numvox>size)
	    size_crit[i]=1;
	else
	    changed++;
	
	//printf("%d\t%lf\t%d\n",i,pdf[i]*numvox,size_crit[i]);
    }
    printf("RemoveObjects: %d out of %d\n",changed,nr_cl-1); // background counts as an additional object
    
    for(int i=0;i<numvox;i++)
    {
	if(!size_crit[rPixel(i,clus)])
	  wPixel(i,im,0);
    }
    free(size_crit);
    DeleteImage(clus);
    if(!phase)
	InvertImage(im);
    
}

void bRemObjects(image_cc *image, int size)
{
	int x,y,b,i,j,numpix,count=0;	
	char buffer[127];

	printf("\nRemoving obejcts smaller than %d pixels\n ",size);
	for(y=1;y<image->dim[1]-1;y++)
	  for (x=1;x<image->dim[0]-1;x++)
	    if(!rPixel(x,y,image)){
	      count++;
	      printf("\nObjekt number %d detected  ",count);
	      numpix= bConCom3(image, x, y, size);
	      printf("   %d pixels\n ",numpix);
	      if(numpix<size)
		 bConCom(image, x, y, 254);
	      else
		 bConCom(image, x, y, 100);
	}
	gBin(101,0,255,image);
}
 
int bConCom3(image_cc *image,int xv,int yv, int size)
{
	int x,y,b,i,j,count, sum, val=1;
	image_cc *wnd1;
	
	wnd1 = InitImage(image->dim[0],image->dim[1],255);

	wPixel(xv,yv,wnd1,val);
	sum=1;
	
	count=1;
	while(count && sum<=size){
	     count=0;
	     for(y=1;y<wnd1->dim[1]-1;y++)
	      for (x=1;x<wnd1->dim[0]-1;x++){
		     if(rPixel(x,y,wnd1)==val){
			for(j=-1;j<=1;j++)
			for(i=-1;i<=1;i++)
			     if(!rPixel(x+i,y+j,image) && (rPixel(x+i,y+j,wnd1)==255)){
				wPixel(x+i,y+j,wnd1,val);
				sum++;
				count=1;
		     
			     }
		     }
		}
	}
	DeleteImage(wnd1);
	return sum;
}
 
