/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 11.06.02
\command{       % COMMAND
double bSurfdens(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the  Surface density $S_V$ [cm$^2$/cm$^3$] of the boundary of a 3D binary structure, 
as estimated from a 2-dimensional binary section.}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of pixel configurations obtained by bQuant()}
\return{Surface density [L$^2$/L$^3$]  in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

double bSurfdens(image_cc *image, long int *h)
{
	unsigned int i,j,p;
	long int iChi=0, iVol=0;
	double dx, dy, dxy, weight[3], angle, count;
        //  bit positions indicate direction of intercept 1=hor, 2=ver, 3=diag
	int wi[16]=
	{0, 7, 1, 6, 2, 5, 3, 4, 4, 3, 5, 2,  6, 1, 7, 0};
 
	/** weighting according to the shell of the unit sphere 
	    attributed to 3 different directions *************/
	angle=atan(image->res[0]/image->res[1]); 
	weight[0]= 2*M_PI * (1-cos(angle/2))/(4*M_PI);
	weight[1]= (2*M_PI*(1-cos(3*angle/2)) - 2*M_PI*(1-cos(angle/2)) )/(4*M_PI);
	weight[2]= 1-weight[0]-weight[1];

 	for(i=0;i<16;i++){
	  count=0;
	  for(j=0;j<3;j++)
	    if(wi[i]&1<<j)
	      count+=weight[j];
	  iChi+=(long int)(count*h[i]);
	  iVol+=h[i];
	}

	dx=image->res[0]*weight[0];
	dy=image->res[1]*weight[1];
	dxy=sqrt(image->res[0]*image->res[0]+image->res[1]*image->res[1])*weight[2];
	if(!iVol) return 0;
 	else return 2*(double)iChi/((double)iVol*(dx+dy+dxy));
}


 
