/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
/*******
void BinBilevel(image_cc *im, int lower, int upper)
void BinBand(image_cc *im, int lthresh, int uthresh)
void Bin(image_cc *im, int thresh, int lower, int upper)
void Bin(image_c *im, int thresh)
***********/

#include "quantim4.h"

// using namespace std;

#define PRECISION 5

int CalcBilevel(image_cc *im, int *th_high,int *th_low)
{
	int x,y,z,max,min,mittel;
	image_cc *copy;
	long var;
	double count;
	long int k, zz=0;
	int Grau_stufe[256];
	int Glatt_grau[256];

        if(strcmp(im->itype,"rgb")==0 || strcmp(im->itype,"btd")==0){
		printf("\nCalcBilevel: No bilevel thresholding for image type %s possible\n",im->itype);
		exit(0);
	}
	if(im->numbytes==2)
 		copy = bit16to8(im);
	else
		copy=CopyImage(im);

			/*calculate histogramm */
	for(x=0;x<256;x++)
		Grau_stufe[x]=Glatt_grau[x]= 0;
	if(im->ndim==3){
		for (x=0+1;x<copy->dim[0]-1;x+=PRECISION)
		for (y=0+1;y<copy->dim[1]-1;y+=PRECISION) 
		for (z=0+1;z<copy->dim[2]-1;z+=PRECISION) 
				Grau_stufe[rPixel(x,y,z,copy)]++;
	}
	else{
		for (x=0+1;x<copy->dim[0]-1;x+=PRECISION)
			for (y=0+1;y<copy->dim[1]-1;y++) 
				Grau_stufe[rPixel(x,y,copy)]++;
	}
		/*smooth histogramm*/
	for(x=3;x<254;x++) {
		for(y=1;y<3;y++)
			Glatt_grau[x]+=Grau_stufe[x] + Grau_stufe[x-y]+Grau_stufe[x+y];
		Glatt_grau[x]=Glatt_grau[x]/6;
	}

		/*search for 1. maximum*/
	y=max=0;
	count=0;
	x=1;
	while(y<15){
		count+=(double) Glatt_grau[x];
	       if( Glatt_grau[x]>Glatt_grau[max]){
		  if(count > copy->dim[0]*copy->dim[1]/(50*PRECISION)) /*mind 2% */
			max=x;
		   y=0;
	       }
	       else{
		    if(Glatt_grau[x]>0)
			y++;
	       }
	       x++;
	}

		/* search for 1. minimum to find lower threshold */
	y=0;
	min=max;
	x=max+1;
	while(y<15){
	       if( Glatt_grau[x]<Glatt_grau[min]){
			min=x;
			y=0;
	       }
	       else
			y++;
	       x++;
	       if(x==254){
			printf("gBilevel: The histogram is not bimodal!\n");
			return -1;
	       }
	}
	if(im->numbytes==2)
		*th_low=(max+min)/2 *256;
	else
		*th_low=(max+min)/2;

	     /*find 2. maximum and parameters of the gausian function*/
	y=zz=var=0;
	max = min;
	for (x=min+1;x<252;x++)
		if(Glatt_grau[x]>Glatt_grau[max])
			max = x;
	if(max==min){
		printf("CalcBilevel: there is only one maximum in the histogram!\n ");
		return 0;
	}

	     /*calculate modal value symetrical to maximum*/
	zz= (long) max*Glatt_grau[max];
	k=(long)Glatt_grau[max];
	y=1;
	for(x=max+1;x<max+20;x++){  
/*the value of 20 (region to calculate modal value) may be adjusted to different Materials*/
	     if ((2*max-x)>0&&x<=252){
		zz+=(long)Glatt_grau[x]*x;
		k+=(long)Glatt_grau[x];
		zz+=(long)Glatt_grau[2*max-x]*(2*max-x);
		k+=(long)Glatt_grau[2*max-x];
		y+=2;
	     }
	     else
		break;
	}
	mittel=zz/k;

		/*calculate varianz of modal +/- 30 (may be adjusted ..)*/
	zz=0;
	/*y= (mittel+30)>252 ? 252 : mittel+30;
	for(x=y;x>=mittel-30;x--){*/
	for(x=252;x>=mittel-30;x--){
		var +=long (Glatt_grau[x] * pow((x-mittel),2));
		zz+= Glatt_grau[x];
	}
	var = long( sqrt(var/(zz-1)));

		/* find upper threshold*/
	for (x=248; x>*th_low;x--){
		y=int((Glatt_grau[max]/4)* exp(-( pow(x-mittel,2)/(2*pow(var,2)))));
		if(x<max && y<Glatt_grau[min]/4)
			break;
	}
	if(im->numbytes==2)
		*th_high = (x+min)/2 * 256;
	else
		*th_high = (x+min)/2;
return 1;
}


void BinBilevel(image_cc *im, int lower, int upper)
{
	int x,y,z,j,dx,dy,dz,s; 
	long n=1;
	int max=255;

        if(strcmp(im->itype,"rgb")==0 || strcmp(im->itype,"btd")==0){
		printf("\nNo simple thresholding for image type %s possible\n",im->itype);
		exit(0);
	}
	if(im->numbytes==2) max=65535;
 
	Bin(im,lower,0,max+1);

    if(strncmp(im->itype,"ddd",3)==0){
	while(n){
	n=0;
	for(z=1; z<im->dim[2]-1; z++)
	for(y=1; y<im->dim[1]-1; y++)
	   for(x=1; x<im->dim[0]-1; x++)
		   if(rPixel(x,y,z,im)<upper && rPixel(x,y,z,im)){
			dx=x; dy=y; dz=z; s=0;
			for(j=0;j<6;j++)
				if(!rPixel(dx+N6x[j],dy+N6y[j],dz+N6z[j],im)){
				      wPixel(dx,dy,dz,im,0); n++;s++;break;
				}
			//if(j>=6&&!s)
			//	wPixel(dx,dy,im,upper+1);
			while(s){
			    s=0;
			    for(j=0;j<6;j++){
				if(isborder(dx+N6x[j],dy+N6y[j],dz+N6z[j],im));
						s=0;break;
					}

if(rPixel(dx+N6x[j],dy+N6y[j],dz+N6z[j],im)<upper && rPixel(dx+N6x[j],dy+N6y[j],dz+N6z[j],im)){
					dx=dx+N6x[j];
					dy=dy+N6y[j];
					dz=dz+N6z[j];
					wPixel(dx,dy,dz,im,0);
					s++;
					break;
				 }
			     }
			 } /*end while*/
	}
    }
    else{
	while(n){
	n=0;
	for(y=1; y<im->dim[1]-1; y++)
	   for(x=1; x<im->dim[0]-1; x++)
		   if(rPixel(x,y,im)<upper && rPixel(x,y,im)){
			dx=x; dy=y;s=0;
			for(j=0;j<4;j++)
				if(!rPixel(dx+neigh4x[j],dy+neigh4y[j],im)){
				      wPixel(dx,dy,im,0); n++;s++;break;
				}
			if(j>=6&&!s)
				wPixel(dx,dy,im,upper+1);
			while(s){
			    s=0;
			    for(j=0;j<4;j++){
				if(isborder(dx+neigh4x[j],dy+neigh4y[j],im));
						s=0;break;
					}

if(rPixel(dx+neigh4x[j],dy+neigh4y[j],im)<upper && rPixel(dx+neigh4x[j],dy+neigh4y[j],im)){
					dx=dx+neigh4x[j];
					dy=dy+neigh4y[j];
					wPixel(dx,dy,im,0);
					s++;
					break;
				 }
			     }
			 } /*end while*/
		    }
    }
}

void BinBand(image_cc *im, int lthresh, int uthresh)
{
	int x,y,z;
	int max=255;
	unsigned char uc=0;

        if(strcmp(im->itype,"rgb")==0 || strcmp(im->itype,"btd")==0){
		printf("\nNo simple thresholding for image type %s possible\n",im->itype);
		exit(0);
	}
	if(im->numbytes==2) max=65535;

        if(strncmp(im->itype,"ddd",3)==0){
		for(z=0;z<im->dim[2];z++)
		for(y=0;y<im->dim[1];y++)
		for (x=0;x<im->dim[0];x++){
			if(rPixel(x,y,z,im)>=lthresh && rPixel(x,y,z,im)<=uthresh)
		  		wPixel(x,y,z,im,0);
			else
		  		wPixel(x,y,z,im,max);
		}
	}
	else{
		for(y=0; y<im->dim[1]; y++)
	   	for(x=0; x<im->dim[0]; x++){
			if(rPixel(x,y,im)>=lthresh && rPixel(x,y,im)<=uthresh)
				wPixel(x,y,im,0);
			else
				wPixel(x,y,im,max);
	   } 
	}
}

void Bin(image_cc *im, int thresh, int lower, int upper)
{
	int x,y,z,val;
	int max=255;
	unsigned char uc=0;

        if(strcmp(im->itype,"rgb")==0 || strcmp(im->itype,"btd")==0){
		printf("\nNo simple thresholding for image type %s possible\n",im->itype);
		exit(0);
	}
	if(im->numbytes==2) max=65535;

	val= upper>max? -1 : upper;


        if(strncmp(im->itype,"ddd",3)==0){
		for(z=0;z<im->dim[2];z++)
		for(y=0;y<im->dim[1];y++)
		for (x=0;x<im->dim[0];x++){
			if(rPixel(x,y,z,im)<=thresh)
		  		wPixel(x,y,z,im,lower);
			else  if(val!=-1)
		  		wPixel(x,y,z,im,upper);
		}
	}
	else{
		for(y=0; y<im->dim[1]; y++)
	   	for(x=0; x<im->dim[0]; x++){
			if(rPixel(x,y,im)<=thresh)
				wPixel(x,y,im,lower);
			else  if(val!=-1)
				wPixel(x,y,im,upper);
	   } 
	}
}


void Bin(image_cc *im, int thresh)
{
	int x,y,z;
	int max=255;
	unsigned char uc=0;

        if(strcmp(im->itype,"rgb")==0 || strcmp(im->itype,"btd")==0){
		printf("\nNo simple thresholding for image type %s possible\n",im->itype);
		exit(0);
	}
	if(im->numbytes==2) max=65535;

        if(strncmp(im->itype,"ddd",3)==0){
		for(z=0;z<im->dim[2];z++)
		for(y=0;y<im->dim[1];y++)
		for (x=0;x<im->dim[0];x++){
			if(rPixel(x,y,z,im)<=thresh)
		  		wPixel(x,y,z,im,0);
			else
		  		wPixel(x,y,z,im,max);
		}
	}
	else{
		for(y=0; y<im->dim[1]; y++)
	   	for(x=0; x<im->dim[0]; x++){
			if(rPixel(x,y,im)<=thresh)
				wPixel(x,y,im,0);
			else
				wPixel(x,y,im,max);
	   } 
	}
}
