/*************************************************************
 *     Minkowski functionals for quantim4                                     *
 *                                                           *
 *     H.-J. Vogel 03.03.08                                    *
 *                                                           *
 *                                                           *
 *************************************************************/

 
#include "quantim4.h"

image_cc *LogOr(image_cc *wnd1, image_cc *wnd2)
{
	int i,is3d=1;
	image_cc *out;
  	unsigned long j;	

	for(i=0; i<wnd1->ndim;i++)
		if(wnd1->dim[i]!=wnd2->dim[i]){
			printf("\n LogOr: images need to have the same size!\n");
			exit(0);
		}
	out=CopyImage(wnd1);
 	if(wnd1->ndim==3) is3d=wnd1->dim[2];
  	for(j=0;j<wnd1->dim[0]*wnd1->dim[1]*is3d;j++)
		if(rPixel(j,wnd1)+rPixel(j,wnd2))
				wPixel(j,out,255);
return out;
}
image_cc *LogAnd(image_cc *wnd1, image_cc *wnd2)
{
	int i,value, is3d=1;
	image_cc *out;
  	unsigned long j;	

	for(i=0; i<wnd1->ndim;i++)
		if(wnd1->dim[i]!=wnd2->dim[i]){
			printf("\n LogAnd: images need to have the same size!\n");
			exit(0);
		}
	out=CopyImage(wnd1);
 	if(wnd1->ndim==3) is3d=wnd1->dim[2];
  	for(j=0;j<wnd1->dim[0]*wnd1->dim[1]*is3d;j++){
		value = rPixel(j,wnd1)<=rPixel(j,wnd2)?rPixel(j,wnd1):rPixel(j,wnd2);
		wPixel(j,out,value);
	}
return out;
}

image_cc *Intersection(image_cc *wnd1, image_cc *wnd2, int gv1, int gv2)
{
	int i, val1,val2, is3d=1, isbtd=1;
	image_cc *out, *tmp;
  	unsigned long j;	

	for(i=0; i<wnd1->ndim;i++)
		if(wnd1->dim[i]!=wnd2->dim[i]){
			printf("\n Intersection: images need to have the same size!\n");
			exit(0);
		}
	tmp=CopyImage(wnd1);
	if(!strcmp(tmp->itype,"btd")) {out=Btd2Ddd(tmp); isbtd=255;}
	else out=CopyImage(wnd1);
	DeleteImage(tmp);

	//out=InitImage(wnd1->dim[0],wnd1->dim[1],wnd1->dim[2],0,"btd");
 	if(wnd1->ndim==3) is3d=wnd1->dim[2];
  	for(j=0;j<wnd1->dim[0]*wnd1->dim[1]*is3d;j++){
		val1 = rPixel(j,wnd1);
		val2 = rPixel(j,wnd2);
		if(val1 == val2)
			wPixel(j,out,val1*isbtd);
		else if(!val1)
			wPixel(j,out,gv1);
		else if(!val2)
			wPixel(j,out,gv2);
	}
return out;
}
