/*---------------------------------------------------------------------
VERSION 3.1,COPYRIGHT 2005 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

-----------------------------------------------------------------------*/



#include "quantim4.h"
#include "string.h"
#include <vector>
#include <algorithm>

using namespace std;

/*
changes 15.08.12 S. Schlueter: 
diameter of each size class in MinkowskiOpenFunctions() is set to the equivalent diameter of a sphere that has the same volume as the corresponding structure element (3D only)
*/
#define PI 3.14159265358979323846264338327950288419716939937510582097494459230
#define gstep 1
#define pixstep 1

void MinkowskiOpenFunctions(image_cc *image, char *outfile)// double gstep, double pixstep, char *outfile)
{
 	FILE *fp;
	char buffer[127];
	int i, j, min, max, vol;
	double size,vv, sv, mv, epc1, epc2, dia;
	long *h;
  	image_cc *bin, *out;

	max=GetMaxGrey(image);
	min=32768+gstep;//GetMinGrey(image);
	size=gstep*pixstep;
	fp=fopen(outfile, "w");

    if(image->ndim==2){
	fprintf(fp,"sizeclass\t diameter\t av\t lv\t epc4\t epc8 \n");
	printf("\nevaluation of  %d  sizeclasses max: %d min: %lf size: %d\n",(max-min)/(int)size,  max, min, size);
	for(i=min, j=0; i<max; i+=(int)size, j++){
		bin=CopyImage(image);
		BinBand(bin, i, max);
		out=bit16to8(bin);
 	       //sprintf(buffer,"xxx_%d",j);
		//StoreImage(out,buffer);

		h=m2Quant(out);
		vv=m2areadens(out,h);
		sv=m2lengthdens(out,h);
		epc1=m2euler4(out,h);
		epc2=m2euler8(out,h);

		printf("\ncalculating size class %d ",j);
		fprintf(fp,"%lf %lf %e %e %e %e\n", (double)j*pixstep,(double)j*pixstep*image->res[0]*2.+image->res[0], vv,sv,epc1,epc2);

		DeleteImage(out);
		DeleteImage(bin);
		if(!j){
			j+=1/pixstep-1;
			i+=gstep-size;
		}
	}
    }
    else{
	fprintf(fp,"sizeclass\t diameter\t vv\t sv\t mv\t epc6\t epc26 \n");
	printf("\nevaluation of  %d  sizeclasses max: %d min: %d size: %lf\n",(max-min)/(int)size,  max, min, size);
	for(i=min, j=0; i<max; i+=(int)size, j++){
		bin=CopyImage(image);
		BinBand(bin, i, max);
		out=Ddd2Btd(bin);
		InvertImage(out);
 	       //sprintf(buffer,"xxx_%d",j);
		//StoreImage(out,buffer);

		h=m3Quant(out);
		vv=m3voldens(h);
		sv=m3surfdens(out,h);
		mv=m3meancurv(out,h);
		epc1=m3euler6(out,h);
		epc2=m3euler26(out,h);
		GetSphereElementDouble((double)j*pixstep, out->res[0],out->res[1],out->res[2], &vol);
		//dia =j?pow(((double)vol)*6./PI,1./3.):0; //SS080115: ternary operator removed
		dia =pow(((double)vol)*6./PI,1./3.);
		printf("\ncalculating size class %d ",j);
		fprintf(fp,"%e %e %e %e %e %e %e\n", (double)j*pixstep,dia*image->res[0], vv,sv,mv,epc1,epc2);

		DeleteImage(out);
		DeleteImage(bin);
		if(!j){
			j+=1/pixstep-1;
			i+=gstep-size;
		}
	}
    }
	fclose(fp);
}
void MinkowskiOpenFunctions(image_cc *image, image_cc *maskim, char *outfile)// double gstep, double pixstep, char *outfile)
{
 	FILE *fp;
	char buffer[127];
	int i, j, min, max, vol;
	double size, vv, sv, mv, epc1, epc2, dia;
	long *h;
  	image_cc *bin, *out;

	max=GetMaxGrey(image);
	min=32768+gstep;//GetMinGrey(image);
	size=gstep*pixstep;
	fp=fopen(outfile, "w");

    if(image->ndim==2){
	fprintf(fp,"sizeclass\t diameter\t av\t lv\t epc4\t epc8 \n");
	printf("\nevaluation of  %d  sizeclasses max: %d min: %d size: %lf\n",(max-min)/(int)size,  max, min, size);
	for(i=min, j=0; i<max; i+=(int)size, j++){
		bin=CopyImage(image);
		BinBand(bin, i, max);
		out=bit16to8(bin);
 	       //sprintf(buffer,"xxx_%d",j);
		//StoreImage(out,buffer);

		h=m2Quant(out,maskim);
		vv=m2areadens(out,h);
		sv=m2lengthdens(out,h);
		epc1=m2euler4(out,h);
		epc2=m2euler8(out,h);

		printf("\ncalculating size class %d ",j);
		fprintf(fp,"%e %e %e %e %e %e\n", (double)j*pixstep,(double)j*pixstep*image->res[0]*2.+image->res[0], vv,sv,epc1,epc2);

		DeleteImage(out);
		DeleteImage(bin);
		if(!j){
			j+=1/pixstep-1;
			i+=gstep-size;
		}
	}
	
    }
    else{
	fprintf(fp,"sizeclass\t diameter\t vv\t sv\t mv\t epc6\t epc26 \n");
	printf("\nevaluation of  %d  sizeclasses max: %d min: %d size: %lf\n",(max-min)/(int)size,  max, min, size);
	for(i=min, j=0; i<max; i+=(int)size, j++){
		bin=CopyImage(image);
		BinBand(bin, i, max);
		out=Ddd2Btd(bin);
		InvertImage(out);
 	       //sprintf(buffer,"xxx_%d",j);
		//StoreImage(out,buffer);

		h=m3Quant(out,maskim);
		vv=m3voldens(h);
		sv=m3surfdens(out,h);
		mv=m3meancurv(out,h);
		epc1=m3euler6(out,h);
		epc2=m3euler26(out,h);
		GetSphereElementDouble((double)j*pixstep, out->res[0],out->res[1],out->res[2], &vol);
		//dia =j?pow(((double)vol)*6./PI,1./3.):0; //SS080115: ternary operator removed
		dia =pow(((double)vol)*6./PI,1./3.);
		printf("\ncalculating size class %d ",j);
		fprintf(fp,"%e %e %e %e %e %e %e\n", (double)j*pixstep, dia*image->res[0], vv,sv,mv,epc1,epc2);

		DeleteImage(out);
		DeleteImage(bin);
		if(!j){
			j+=1/pixstep-1;
			i+=gstep-size;
		}
	}
    }
	fclose(fp);
}

void MinkowskiFunctions(image_cc *image, char *outfile)// double gstep, double pixstep, char *outfile)
{
 	FILE *fp;
	char buffer[127];
	int i, j, min, max, vol;
	double size, vv, sv, mv, epc1, epc2, dia;
	long *h;
  	image_cc *bin, *out;

	max=GetMaxGrey(image);
	min=GetMinGrey(image);
	size=gstep*pixstep;
	fp=fopen(outfile, "w");

    if(image->ndim==2){
	fprintf(fp,"sizeclass\t diameter\t av\t lv\t epc4\t epc8 \n");
	printf("\nevaluation of  %d  sizeclasses max: %d min: %d size: %lf\n",(max-min)/(int)size,  max, min, size);
	for(i=min, j=0; i<max; i+=(int)size, j++){
		bin=CopyImage(image);
		Bin(bin, i);
		if(image->numbits==16)
			out=bit16to8(bin);
 	       //sprintf(buffer,"xxx_%d",j);
		//StoreImage(out,buffer);

		h=m2Quant(out);
		vv=m2areadens(out,h);
		sv=m2lengthdens(out,h);
		epc1=m2euler4(out,h);
		epc2=m2euler8(out,h);

		printf("\ncalculating size class %d ",j);
		fprintf(fp,"%e %e %e %e %e %e\n", (double)j*pixstep,(double)j*pixstep*image->res[0]*2.+image->res[0], vv,sv,epc1,epc2);

		DeleteImage(out);
		DeleteImage(bin);
	}
    }
    else{
	fprintf(fp,"sizeclass\t diameter\t vv\t sv\t mv\t epc6\t epc26 \n");
	printf("\nevaluation of  %d  sizeclasses max: %d min: %d size: %lf\n",(max-min)/(int)size,  max, min, size);
	for(i=min, j=0; i<max; i+=(int)size, j++){
		bin=CopyImage(image);
		Bin(bin, i);
		out=Ddd2Btd(bin);
 		InvertImage(out);
	       //sprintf(buffer,"xxx_%d",j);
		//StoreImage(out,buffer);

		h=m3Quant(out);
		vv=m3voldens(h);
		sv=m3surfdens(out,h);
		mv=m3meancurv(out,h);
		epc1=m3euler6(out,h);
		epc2=m3euler26(out,h);
		GetSphereElementDouble((double)j*pixstep, out->res[0],out->res[1],out->res[2], &vol);
		dia =pow(((double)vol)*6./PI,1./3.);
		printf("\ncalculating size class %d ",j);
		fprintf(fp,"%e %e %e %e %e %e %e\n", (double)j*pixstep,(double)j*pixstep*image->res[0]*2.+image->res[0], vv,sv,mv,epc1,epc2);

		DeleteImage(out);
		DeleteImage(bin);
	}
    }
	fclose(fp);
}


image_cc *Mask(image_cc *im, int thresh, int size)
{
 	int i, x,y,z, flag=0, minx, min[3], max[3];
        image_cc *outim, *mask;

	outim=CopyImage(im);
	//gErode(outim,size,1);

	for(i=0;i<im->ndim;i++){
		min[i]=im->dim[0];
		max[i]=0;
	}

	if(im->ndim==3){
		mask=InitImage(im->dim[0], im->dim[1], im->dim[2],1,"btd"); 
		//return mask;
		for(z=0;z<outim->dim[2];z++)
		for(y=0;y<outim->dim[1];y++)
		for(x=0;x<outim->dim[0];x++){
			if(rPixel(x,y,z,outim)<thresh)
				wPixel(x,y,z,mask,0);
			else{
				if(x<min[0]) min[0]=x;
				if(y<min[1]) min[1]=y;
				if(z<min[2]) min[2]=z;
				x=outim->dim[0];

			}	
		}
		for(z=0;z<outim->dim[2];z++)
		for(x=0;x<outim->dim[0];x++)
		for(y=0;y<outim->dim[1];y++){
			if(rPixel(x,y,z,outim)<thresh)
				wPixel(x,y,z,mask,0);
			else{
				if(y<min[1]) min[1]=y;
				y=outim->dim[1];
			}	
		}
		for(x=0;x<outim->dim[0];x++)
		for(y=0;y<outim->dim[1];y++)
		for(z=0;z<outim->dim[2];z++){
			if(rPixel(x,y,z,outim)<thresh)
				wPixel(x,y,z,mask,0);
			else{
				if(z<min[2]) min[2]=z;
				z=outim->dim[2];
			}	
		}

		for(z=outim->dim[2]-1;z>=0 ;z--)
		for(y=outim->dim[1]-1;y>=0 ;y--)
		for(x=outim->dim[0]-1;x>=0 ;x--){
			if(rPixel(x,y,z,outim)<thresh)
				wPixel(x,y,z,mask,0);
			else{
				if(x>max[0]) max[0]=x;
				x=-1;
			}
		}
		for(z=outim->dim[2]-1;z>=0 ;z--)
		for(x=outim->dim[0]-1;x>=0 ;x--)
		for(y=outim->dim[1]-1;y>=0 ;y--){
			if(rPixel(x,y,z,outim)<thresh)
				wPixel(x,y,z,mask,0);
			else{
				if(y>max[1]) max[1]=y;
				y=-1;
			}
		}
		for(y=outim->dim[1]-1;y>=0 ;y--)
		for(x=outim->dim[0]-1;x>=0 ;x--)
		for(z=outim->dim[2]-1;z>=0 ;z--){
			if(rPixel(x,y,z,outim)<thresh)
				wPixel(x,y,z,mask,0);
			else{
				if(z>max[2]) max[2]=z;
				z=-1;
			}
		}
		DeleteImage(outim);
		//outim = ImageSegment(im, min[0], min[1], min[2], max[0]-min[0], max[1]-min[1], max[2]-min[2]);
		
		printf("\n%d %d %d     %d %d %d\n",min[0], min[1], min[2], max[0]-min[0], max[1]-min[1], max[2]-min[2]);
	}
	
	else{		

		mask=InitImage(im->dim[0], im->dim[1],255,"gry"); 

	
	}

	// do a Minimum filter on mask

	return mask;
}

image_cc *Diff(image_cc *wnd1,image_cc *wnd2)
{
 	unsigned long i, buf=1;
	unsigned short val1, val2;
	unsigned char cval;
        image_cc *outim;

	for(i=0;i<wnd1->ndim;i++)
		if(wnd1->dim[i]!=wnd2->dim[i]) error(2);
       	outim=CopyImage(wnd1);
	for(i=0;i<wnd1->ndim;i++)
		buf*=wnd1->dim[i];
	if(strcmp(wnd1->itype,"btd")==0){
		buf/=wnd1->dim[2];
		buf*=wnd1->numbytes;		
  	   	for(i=0;i<buf;i++)			 
			*(outim->pix+i) = *(wnd1->pix+i)^ *(wnd2->pix+i);
		InvertImage(outim);
	}
	else{
		buf*=wnd1->numchannel;
		if(wnd1->numbytes==1)  
  	   		for(i=0;i<buf;i++) 
			*(outim->pix+i) = abs(*(wnd1->pix+i)- *(wnd2->pix+i));
		else
		   for(i=0;i<buf*wnd1->numbytes;i+=wnd1->numbytes){
			point.p=wnd1->pix+i; 
			val1= *(point.q);
			point.p=wnd2->pix+i; 
			val2= *(point.q);
			point.p=outim->pix+i;
			//*(point.q) =  val2; 
			*(point.q) =  abs(val1-val2); 
		   }
	}
	return outim;
}
