/*---------------------------------------------------------------------
VERSION 1.0, COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNESS
---------------------------------------------------------------------------*/

#define UNICODE
#include "quantim4.h"
#include "string.h"
#include <locale.h>
#include <unistd.h>
#include <limits>


image_cc *LoadImage(char *buf)
{
  FILE *fp;
  long row; 
  TIFF *tif;
  char fname[255], imtag[255], tfname[255];
  unsigned char *pixbuf;
  image_cc *im;
  int j,floattype=0, alpha=0;
  unsigned long i;
  uint32 length, width;
  uint16 bits, samples, config;
  unsigned long offset;
  double lrange, hrange, fac, min, max;
  int *k;
  size_t block;
  union {
    unsigned char *p;
    float *q;
  } fpoint;
  union {
    unsigned char *p;
    unsigned int *q;
  } ipoint;
  
  
  im = (image_cc *)malloc(sizeof(image_cc));
  setlocale(LC_ALL, "C");
  while(1){
    if(strcmp(".btd", buf+strlen(buf)-4))
    sprintf(fname,"%s.btd",buf);
    else
      sprintf(fname,"%s",buf);
    //printf("Opening %s\n", fname);
    if((fp=fopen(fname,"r"))!=0){
      sprintf(im->itype,"btd");
      sprintf(im->name,"%s",fname);
      im->ndim=3;
      im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
      im->res=(double *)malloc(im->ndim*sizeof(double));
      fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
	     &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	     im->pix=(unsigned char *)malloc((size_t)im->dim[0]*im->dim[1]*im->numbytes);
	     im->numchannel=1;
	     fseek(fp,offset,SEEK_SET);
	     for(i=0;i<im->dim[0]*im->dim[1]*im->numbytes;i++) 
	       im->pix[i]=getc(fp);
	     fclose(fp);
	     break;
    }
    
    if(strcmp(".ddd", buf+strlen(buf)-4))
    sprintf(fname,"%s.ddd",buf);
    else
      sprintf(fname,"%s",buf);
    if((fp=fopen(fname,"r"))!=0){
      sprintf(im->name,"%s",fname);
      im->ndim=3;
      im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
      im->res=(double *)malloc(im->ndim*sizeof(double));
      fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
	     &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	     if(im->numbytes==2) 	sprintf(im->itype,"ddd16");
	     else{ 			sprintf(im->itype,"ddd");
	     im->numbytes=1;
	     }
	     im->numbits=8*im->numbytes;
	      block=(size_t)im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;
	      if(block >= std::numeric_limits<std::size_t>::max())
	      {
		printf("Error in LoadImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
		exit(-1);
	      }    
	      if((im->pix=(unsigned char *)malloc(block))==NULL)
	      {
		printf("Error in LoadImage: Could not allocate %ld Bytes\n",block);
		exit(-1);
	      }
	     im->numchannel=1;
	     fseek(fp,offset,SEEK_SET);
	     i=im->dim[0]*im->dim[1]*im->dim[2];
	     fread(im->pix, i,im->numbytes, fp);
	     /*	    for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i++) 
	     im->pix[i]=getc(fp);*/
	     fclose(fp);
	     break;
    }
    if(strcmp(".df3", buf+strlen(buf)-4))
      sprintf(fname,"%s.df3",buf);
    else
      sprintf(fname,"%s",buf);
    //printf("Opening %s\n", fname);
    if((fp=fopen(fname,"r"))!=0){
      unsigned short dimo[3];
      char tmp,*pt1, *pt2;
      int len, size;
      sprintf(im->name,"%s",fname);
      im->ndim  =3;
      im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
      im->res=(double *)malloc(im->ndim*sizeof(double));
      fseek(fp, 0, SEEK_END);
      size = ftell(fp)-6;
      fseek(fp, 0, SEEK_SET);
      
      
      fread(dimo, 3, 2,fp);
      for(i=0;i<3;i++){
	pt1 =(((char*)dimo)+2*i);
	pt2 = pt1+1;
	tmp = *pt1;
	*pt1 =*pt2;
	*pt2=tmp;
      }
      for(i=0;i<3;i++){
	im->dim[i] = dimo[i];
	im->res[i]=1;
      }
      len = im->dim[0]*im->dim[1]*im->dim[2];
      im->numbytes =size/len;
      if(im->numbytes == 2)
	sprintf(im->itype,"ddd16");
      else
	sprintf(im->itype,"ddd");
      block=(size_t)im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;
      if(block >= std::numeric_limits<std::size_t>::max())
      {
	printf("Error in LoadImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
	exit(-1);
      }    
      if((im->pix=(unsigned char *)malloc(block))==NULL)
      {
	printf("Error in LoadImage: Could not allocate %ld Bytes\n",block);
	exit(-1);
      }    
      im->numchannel=1;
      fread(im->pix, len,im->numbytes, fp);
      if(im->numbytes == 2)
	for(i=0;i<len;i++){
	  pt1 =((char*)im->pix+2*i);
	  pt2 = pt1+1;
	  tmp = *pt1;
	  *pt1 =*pt2;
	  *pt2=tmp;
	}
	fclose(fp);
      break;
      
      
      
    }
    if(strcmp(".vgi", buf+strlen(buf)-4))
    sprintf(fname,"%s.vgi",buf);
    else
      sprintf(fname,"%s",buf);
    
    
    
    if((fp=fopen(fname,"r"))!=0){
      
      
      
      sprintf(im->itype,"ddd16");
      sprintf(im->name,"%s",fname);
      im->ndim=3;
      im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
      im->res=(double *)malloc(im->ndim*sizeof(double));
      int flag=0;
      while(1){
	fscanf(fp,"%s",imtag);
	if(!strcmp("[file1]",imtag)) flag=1;
	if((!strcmp("Size",imtag) || !strcmp("size",imtag)) && flag){
	  fscanf(fp,"%s",imtag);
	  fscanf(fp,"%d %d %d",&im->dim[0],&im->dim[1],&im->dim[2]);
	  fseek(fp,SEEK_SET,0); flag=0;break;
	}
      }
      flag=0;
      while(1){
	fscanf(fp,"%s",imtag);
	if(!strcmp("[geometry]",imtag)) flag=1;
	if(!strcmp("resolution",imtag) && flag){
	  fscanf(fp,"%s",imtag);
	  fscanf(fp,"%lf %lf %lf",&im->res[0],&im->res[1],&im->res[2]);
	  fseek(fp,SEEK_SET,0);flag=0; break;
	}
      }
      while(1){
	fscanf(fp,"%s",imtag);
	if(!strcmp("[file1]",imtag)) flag=1;
	if(!strcmp("datarange",imtag) && flag){
	  fscanf(fp,"%s",imtag);
	  fscanf(fp,"%lf %lf",&lrange, &hrange);
	  fseek(fp,SEEK_SET,0);flag=0; break;
	}
      }
      while(1){
	fscanf(fp,"%s",imtag);
	if(!strcmp("[file1]",imtag)) flag=1;
	if((!strcmp("datatype",imtag) || !strcmp("Datatype",imtag)) && flag){
	  fscanf(fp,"%s",imtag);
	  fscanf(fp,"%s",imtag);
	  if(!strcmp("float",imtag)) floattype=1;
	  fseek(fp,SEEK_SET,0);flag=0; break;
	}
      }
      im->numchannel=1;
      im->numbytes=2;
      im->numbits=16;
      while(1){
	fscanf(fp,"%s",imtag);
	if(!strcmp("[file1]",imtag)) flag=1;
	if(!strcmp("Name",imtag) && flag){
	  fscanf(fp,"%s",imtag);
	  fscanf(fp,"%s",fname);
	  fseek(fp,SEEK_SET,0);flag=0; break;
	}
      }
      fclose(fp);	
      strcpy(tfname, buf);
      pixbuf = (unsigned char*)strrchr(tfname, '/');
      if(pixbuf){//path in filename
	*pixbuf = 0;
	sprintf(imtag, "%s/%s", tfname, fname);
	strcpy(fname, imtag);
    }
    //if(floattype)	sprintf(fname,"%s.vol",buf); 
    //else 		sprintf(fname,"%s.raw",buf);
    printf("\nloading %s\n", fname);
    if((fp=fopen(fname,"r"))==0){
      printf("\nError in Load image no file %s\n",fname);
      exit(0);
    }
    //fpix=(float *)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(float));
    block=(size_t)im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;
    if(block >= std::numeric_limits<std::size_t>::max())
    {
      printf("Error in LoadImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
      exit(-1);
    }    
    if((im->pix=(unsigned char *)malloc(block))==NULL)
    {
      printf("Error in LoadImage: Could not allocate %ld Bytes\n",block);
      exit(-1);
    }    
    fpoint.p=(unsigned char *)malloc(4); 
    if(floattype){
      for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i+=im->numbytes){
	
	fread(fpoint.p,4, 1, fp); 
	point.p=im->pix+i;
	fac= (*(fpoint.q)-lrange)/(hrange-lrange);
	*(point.q)= int(65532 * fac);
      }
    }
    else{
      fread(im->pix, im->dim[0]*im->dim[1]*im->dim[2],im->numbytes, fp);
      
    }
    
    fclose(fp);
    break;
  }
  
  while(1){
    sprintf(fname,"%s",buf);
    if((tif = TIFFOpen(fname, "r"))!=0) break;
    sprintf(fname,"%s.tif",buf);
    if((tif = TIFFOpen(fname, "r"))!=0) break;
    sprintf(fname,"%s.TIF",buf);
    if((tif = TIFFOpen(fname, "r"))!=0) break;
    sprintf(fname,"%s.tiff",buf);
    if((tif = TIFFOpen(fname, "r"))!=0) break;
    sprintf(fname,"%s.TIFF",buf);
    if((tif = TIFFOpen(fname, "r"))!=0) break;
    printf("\nLoadImage: could not open %s\n",buf);
    return(NULL);
  }
  TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &length);
  TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &width);
  TIFFGetField(tif, TIFFTAG_SAMPLESPERPIXEL, &samples);
  TIFFGetField(tif, TIFFTAG_BITSPERSAMPLE, &bits);
  im->numchannel=samples;
  if(samples > 4){ //Multispectral data, treated as 3d Data
    sprintf(im->itype,"msp");
    im->ndim=3;
    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
    im->res=(double *)calloc(im->ndim,sizeof(double));
    im->dim[0]=width;
    im->dim[1]=length;
    im->dim[2]=samples;
    im->numbits=bits;
    im->numchannel=1;
    sprintf(im->name,"%s",buf);
    im->numbytes=im->numbits/8 + (im->numbits%8?1:0);
    im->pix =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numbytes*im->dim[2]);
    TIFFGetField(tif, TIFFTAG_PLANARCONFIG, &config);
    
    pixbuf = (unsigned char *)malloc(TIFFScanlineSize(tif));
    if (config == PLANARCONFIG_CONTIG) {
      for (row = 0; row < length; row++){
	TIFFReadScanline(tif, pixbuf, row);
	for(i=0; i<width; i++){
	  for(j=0;j<samples;j++){
	    memcpy(im->pix+((j*length+row)*width+i)*im->numbytes, pixbuf+(j+i*samples)*im->numbytes, im->numbytes);
	  }
	}
      }
    } else if (config == PLANARCONFIG_SEPARATE) {
      uint16 s, nsamples;
      
      TIFFGetField(tif, TIFFTAG_SAMPLESPERPIXEL, &nsamples);
      for (s = 0; s < nsamples; s++)
	for (row = 0; row < length; row++)
	  TIFFReadScanline(tif, im->pix +(s*length + row)*width, row, s);
    }else {
      printf("Unknown configuration\n");
      return(0);
    }
    
    
    
  }else{
    im->ndim=2;
    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
    im->res=(double *)calloc(im->ndim,sizeof(double));
    im->dim[0]=width;
    im->dim[1]=length;
    im->numbits=bits;
    float reso;
    int ResUnit;
    TIFFGetField(tif, TIFFTAG_RESOLUTIONUNIT, &ResUnit);

    TIFFGetField(tif, TIFFTAG_XRESOLUTION, &reso);
    im->res[0]=ResUnit==RESUNIT_CENTIMETER? 10/reso:25.4/reso;
    TIFFGetField(tif, TIFFTAG_YRESOLUTION, &reso);
    im->res[1]=ResUnit==RESUNIT_CENTIMETER? 10/reso:25.4/reso;
    sprintf(im->name,"%s",buf);
    im->numbytes=im->numbits/8 + (im->numbits%8?1:0);
    //printf("\nnbytes = %d\n",im->numbytes);
    if(im->numchannel==3||im->numchannel==4){
      alpha = im->numchannel-3;
      sprintf(im->itype,"rgb");
    }
    else{
      alpha = im->numchannel-1;
      //im->numbytes=1;
      if(im->numbytes==2 && im->ndim==2)
	sprintf(im->itype,"gry16");
      else if(im->numbytes==2 && im->ndim==3)
	sprintf(im->itype,"ddd16");
      else if(im->numbytes==4 && im->ndim==2)
	sprintf(im->itype,"gry32");
      else
	sprintf(im->itype,"gry");
    }
    
    pixbuf =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numchannel*im->numbytes);
    im->pix =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numbytes*(im->numchannel-alpha));
    for (row = 0; row < im->dim[1]; row++)
      TIFFReadScanline(tif, pixbuf+(row*im->dim[0]*im->numchannel*im->numbytes), row,0);	  
    for(i=0;i<im->dim[0]*im->dim[1]*(im->numchannel-alpha)*im->numbytes;i++)
      *(im->pix+i)=*(pixbuf+i+alpha*i/(im->numchannel-alpha));
    im->numchannel-=alpha;
    
  }
  free(pixbuf);
  TIFFClose(tif);
  
  
  break;
}

for(i=0;i<im->ndim;i++)
  if(!im->res[i]) im->res[i]=1.; 
  
  printf("****************************\n");
printf("Image loaded:\n");
printf("Image name:\t %s\n",im->name);
printf("Image type:\t %s\n",im->itype);
if(alpha)
  printf("Image alpha:\t removed\n");
else
  printf("Image alpha:\t no\n");
printf("Image dimens:\t %d\n", im->ndim);
printf("Image channels:\t %d\n", im->numchannel);
printf("Image alpha:\t %d\n", alpha);
printf("Image height:\t %d\n", im->dim[1]);
printf("Image width:\t %d\n", im->dim[0]);
if(im->ndim>2)
  printf("Image depth:\t %d\n", im->dim[2]);
printf("Image nbytes:\t %d\n", im->numbytes);
printf("Image nbits:\t %d\n", im->numbits);
printf("Image x-res:\t %lf\n", im->res[0]);
printf("Image y-res:\t %lf\n", im->res[1]);
if(im->ndim>2)
  printf("Image z-res:\t %lf\n", im->res[2]);
printf("****************************\n");
//printf("\nlrang: %f    hrange: %f\n",lrange,hrange);
//printf("\nmin: %f    max: %f\n",min,max);

return im;
}


image_cc *LoadImage_old(char *buf)
{
  FILE *fp;
  long row; 
  TIFF *tif;
  char fname[255];
  unsigned char *pixbuf;
  image_cc *im;
  int i, alpha=0; 
  uint32 length, width;
  uint16 bits, samples;
  unsigned long offset;
  int *k;
  
  im = (image_cc *)malloc(sizeof(image_cc));
  
  while(1){
    
    sprintf(fname,"%s.btd",buf);
    if((fp=fopen(fname,"r"))!=0){
      sprintf(im->itype,"btd");
      sprintf(im->name,"%s",fname);
      im->ndim=3;
      im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
      im->res=(double *)malloc(im->ndim*sizeof(double));
      fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
	     &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	     im->pix=(unsigned char *)malloc((size_t)im->dim[0]*im->dim[1]*im->numbytes);
	     im->numchannel=1;
	     fseek(fp,offset,SEEK_SET);
	     for(i=0;i<im->dim[0]*im->dim[1]*im->numbytes;i++) 
	       im->pix[i]=getc(fp);
	     fclose(fp);
	     break;
    }
    sprintf(fname,"%s.ddd",buf);
    if((fp=fopen(fname,"r"))!=0){
      sprintf(im->name,"%s",fname);
      im->ndim=3;
      im->numbytes=1;
      im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
      im->res=(double *)malloc(im->ndim*sizeof(double));
      fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
	     &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	     if(im->numbytes==2) 	sprintf(im->itype,"ddd16");
	     else 			sprintf(im->itype,"ddd");
	     im->pix=(unsigned char *)malloc((size_t)im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes);
	     im->numbytes=1;
	     im->numchannel=1;
	     fseek(fp,offset,SEEK_SET);
	     for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i++) 
	       im->pix[i]=getc(fp);
	     fclose(fp);
	     break;
    }
    
    while(1){
      sprintf(fname,"%s",buf);
      if((tif = TIFFOpen(fname, "r"))!=0) break;
      sprintf(fname,"%s.tif",buf);
      if((tif = TIFFOpen(fname, "r"))!=0) break;
      sprintf(fname,"%s.TIF",buf);
      if((tif = TIFFOpen(fname, "r"))!=0) break;
      sprintf(fname,"%s.tiff",buf);
      if((tif = TIFFOpen(fname, "r"))!=0) break;
      sprintf(fname,"%s.TIFF",buf);
      if((tif = TIFFOpen(fname, "r"))!=0) break;
      printf("\nLoadImage: could not open %s\n",buf);
      exit(0);
    }
    im->ndim=2;
    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
    im->res=(double *)malloc(im->ndim*sizeof(double));
    TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &length);
    TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &width);
    TIFFGetField(tif, TIFFTAG_SAMPLESPERPIXEL, &samples);
    TIFFGetField(tif, TIFFTAG_BITSPERSAMPLE, &bits);
    im->numchannel=samples;
    im->dim[0]=width;
    im->dim[1]=length;
    im->numbits=bits;
    sprintf(im->name,"%s",buf);
    im->numbytes=im->numbits/8 + (im->numbits%8?1:0);
    //printf("\nnbytes = %d\n",im->numbytes);
    if(im->numchannel==3||im->numchannel==4){
      alpha = im->numchannel-3;
      sprintf(im->itype,"rgb");
    }
    else{
      alpha = im->numchannel-1;
      //im->numbytes=1;
      if(im->numbytes==2)
	sprintf(im->itype,"gry16");
      else
	sprintf(im->itype,"gry");
    }
    
    pixbuf =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numchannel*im->numbytes);
    im->pix =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numbytes*(im->numchannel-alpha));
    for (row = 0; row < im->dim[1]; row++)
      TIFFReadScanline(tif, pixbuf+(row*im->dim[0]*im->numchannel*im->numbytes), row,0);	  
    for(i=0;i<im->dim[0]*im->dim[1]*(im->numchannel-alpha)*im->numbytes;i++)
      *(im->pix+i)=*(pixbuf+i+alpha*i/(im->numchannel-alpha));
    im->numchannel-=alpha;
    TIFFClose(tif);
    
    
    break;
    
    printf("\nLoadImage: could not open %s\n",buf);
    exit(0);
  }
  
  printf("****************************\n");
  printf("Image loaded:\n");
  printf("Image name:\t %s\n",im->name);
  printf("Image type:\t %s\n",im->itype);
  if(alpha)
    printf("Image alpha:\t removed\n");
  else
    printf("Image alpha:\t no\n");
  printf("Image dimens:\t %d\n", im->ndim);
  printf("Image channels:\t %d\n", im->numchannel);
  printf("Image alpha:\t %d\n", alpha);
  printf("Image height:\t %d\n", im->dim[1]);
  printf("Image width:\t %d\n", im->dim[0]);
  if(im->ndim>2)
    printf("Image depth:\t %d\n", im->dim[2]);
  printf("Image nbytes:\t %d\n", im->numbytes);
  printf("Image nbits:\t %d\n", im->numbits);
  printf("Image x-res:\t %lf\n", im->res[0]);
  printf("Image y-res:\t %lf\n", im->res[1]);
  if(im->ndim>2)
    printf("Image z-res:\t %lf\n", im->res[2]);
  printf("****************************\n");
  
  return im;
}

void StoreImage(image_cc *im, char *buf)
{
  long row;
  TIFF *tif;
  char fname[127];
  FILE *fp;
  size_t  i; 
  long offset=64;
  
  if(strncmp(im->itype,"gry",3)==0){
    sprintf(fname,"%s.tiff",buf);
    tif = TIFFOpen(fname, "w");
    TIFFSetField(tif, TIFFTAG_IMAGELENGTH, im->dim[1]);
    TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISBLACK);
    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, im->dim[0]);
    TIFFSetField(tif, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, im->numbits);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, im->numchannel);
    for (row = 0; row < im->dim[1]; row++)
      TIFFWriteScanline(tif, im->pix+(row*im->dim[0]*im->numbytes), row,2);
    TIFFClose(tif); 
  }
  else if(strcmp(im->itype,"rgb")==0){
    sprintf(fname,"%s.tiff",buf);
    tif = TIFFOpen(fname, "w");
    TIFFSetField(tif, TIFFTAG_IMAGELENGTH, im->dim[1]);
    TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, 2);
    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, im->dim[0]);
    TIFFSetField(tif, TIFFTAG_COMPRESSION, 1);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 8,8,8);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, im->numchannel);
    TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, 1);
    for (row = 0; row < im->dim[1]; row++)
      TIFFWriteScanline(tif, im->pix+(row*im->dim[0]*im->numchannel), row,2);
    TIFFClose(tif); 
  }
  else if(strncmp(im->itype,"ddd",3)==0||strncmp(im->itype,"msp",3)==0){
    sprintf(fname,"%s.ddd",buf);
    fp=fopen(fname,"w");
    //im->numbytes = im->dim[2];
    fprintf(fp,"%ld %d %d %d %d %lf %lf %lf",
	    offset,im->dim[0],im->dim[1],im->dim[2],im->numbytes,im->res[0],im->res[1],im->res[2]);
	    fseek(fp,offset,SEEK_SET);
	    fwrite(im->pix, (size_t)im->dim[0]*im->dim[1]*im->dim[2],im->numbytes, fp);
	    /*for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i++) 
	    putc(im->pix[i],fp);*/
	    fclose(fp);
  }
  else if(strcmp(im->itype,"btd")==0){
    sprintf(fname,"%s.btd",buf);
    fp=fopen(fname,"w");
    fprintf(fp,"%ld %d %d %d %d %lf %lf %lf",
	    offset,im->dim[0],im->dim[1],im->dim[2],im->numbytes,im->res[0],im->res[1],im->res[2]);
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<(size_t)im->dim[0]*im->dim[1]*im->numbytes;i++) 
	      putc(im->pix[i],fp);
	    fclose(fp);
  }
  else{
    printf("\nStoreImage: Cannot identify file type\n\n");
    exit(0);
  }
  
  printf("****************************\n");
  printf("Image saved:\n");
  printf("Image name:\t %s\n",fname);
  printf("Image type:\t %s\n",im->itype);
  printf("Image channels:\t %d\n", im->numchannel);
  printf("Image height:\t %d\n", im->dim[1]);
  printf("Image width:\t %d\n", im->dim[0]);
  if(im->ndim>2)
    printf("Image depth:\t %d\n", im->dim[2]);
  printf("Image nbytes:\t %d\n", im->numbytes);
  printf("Image nbits:\t %d\n", im->numbits);
  printf("Image x-res:\t %lf\n", im->res[0]);
  printf("Image y-res:\t %lf\n", im->res[1]);
  if(im->ndim>2)
    printf("Image z-res:\t %lf\n", im->res[2]);
  printf("****************************\n");
  
}

void StoreImage(image_cc *im)
{
  long row;
  TIFF *tif;
  char fname[127];
  FILE *fp;
  size_t i; 
  long offset=64;
  
  if(strncmp(im->itype,"gry",3)==0){
    sprintf(fname,"%s.tiff",im->name);
    tif = TIFFOpen(fname, "w");
    TIFFSetField(tif, TIFFTAG_IMAGELENGTH, im->dim[1]);
    TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISBLACK);
    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, im->dim[0]);
    TIFFSetField(tif, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, im->numbits);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, im->numchannel);
    for (row = 0; row < im->dim[1]; row++)
      TIFFWriteScanline(tif, im->pix+(row*im->dim[0]*im->numbytes), row,2);
    TIFFClose(tif); 
  }
  else if(strcmp(im->itype,"rgb")==0){
    sprintf(fname,"%s.tiff",im->name);
    tif = TIFFOpen(fname, "w");
    TIFFSetField(tif, TIFFTAG_IMAGELENGTH, im->dim[1]);
    TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, 2);
    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, im->dim[0]);
    TIFFSetField(tif, TIFFTAG_COMPRESSION, 1);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 8,8,8);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, im->numchannel);
    TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, 1);
    for (row = 0; row < im->dim[1]; row++)
      TIFFWriteScanline(tif, im->pix+(row*im->dim[0]*im->numchannel), row,2);
    TIFFClose(tif); 
  }
  else if(strncmp(im->itype,"ddd",3)==0||strncmp(im->itype,"msp",3)==0){
    sprintf(fname,"%s.ddd",im->name);
    fp=fopen(fname,"w");
    //im->numbytes = im->dim[2];
    fprintf(fp,"%ld %d %d %d %d %lf %lf %lf",
	    offset,im->dim[0],im->dim[1],im->dim[2],im->numbytes,im->res[0],im->res[1],im->res[2]);
	    fseek(fp,offset,SEEK_SET);
	    fwrite(im->pix, (size_t)im->dim[0]*im->dim[1]*im->dim[2],im->numbytes, fp);
	    /*for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i++) 
	    putc(im->pix[i],fp);*/
	    fclose(fp);
  }
  else if(strcmp(im->itype,"btd")==0){
    sprintf(fname,"%s.btd",im->name);
    fp=fopen(fname,"w");
    fprintf(fp,"%ld %d %d %d %d %lf %lf %lf",
	    offset,im->dim[0],im->dim[1],im->dim[2],im->numbytes,im->res[0],im->res[1],im->res[2]);
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<(size_t)im->dim[0]*im->dim[1]*im->numbytes;i++) 
	      putc(im->pix[i],fp);
	    fclose(fp);
  }
  else{
    printf("\nStoreImage: Cannot identify file type\n\n");
    exit(0);
  }
  
  printf("****************************\n");
  printf("Image saved:\n");
  printf("Image name:\t %s\n",fname);
  printf("Image type:\t %s\n",im->itype);
  printf("Image channels:\t %d\n", im->numchannel);
  printf("Image height:\t %d\n", im->dim[1]);
  printf("Image width:\t %d\n", im->dim[0]);
  if(im->ndim>2)
    printf("Image depth:\t %d\n", im->dim[2]);
  printf("Image nbytes:\t %d\n", im->numbytes);
  printf("Image nbits:\t %d\n", im->numbits);
  printf("Image x-res:\t %lf\n", im->res[0]);
  printf("Image y-res:\t %lf\n", im->res[1]);
  if(im->ndim>2)
    printf("Image z-res:\t %lf\n", im->res[2]);
  printf("****************************\n");
  
}

image_cc *CopyImage(image_cc *image)
{
  size_t j,buf=1; 
  int *k;
  image_cc *copy;
  
  //k=(int *)malloc(5*sizeof(int));
  copy = (image_cc *)malloc(sizeof(image_cc));
  copy->ndim=image->ndim;
  
  copy->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
  copy->res=(double *)malloc(image->ndim*sizeof(double));	
  
  sprintf(copy->itype,"%s",image->itype);
  copy->numbits= image->numbits;
  for(j=0;j<image->ndim;j++){
    copy->dim[j]= image->dim[j];
    copy->res[j] = image->res[j];
    buf*=(size_t)image->dim[j];
  }
  if(strcmp(image->itype,"btd")==0) buf/=image->dim[2];
  buf*=(size_t)(image->numbytes*image->numchannel);
  copy->numchannel=image->numchannel; 
  copy->numbytes=image->numbytes;
  if(buf >= std::numeric_limits<std::size_t>::max())
  {
    printf("Error in CopyImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",buf, std::numeric_limits<std::size_t>::max());
    exit(-1);
  }    
  if((copy->pix=(unsigned char *)malloc(buf))==NULL)
  {
    printf("Error in CopyImage: Could not allocate %ld Bytes\n",buf);
    exit(-1);
  }  
  for(j=0;j<buf;j++) 
    *(copy->pix+j) = *(image->pix+j);
  return copy;
}

image_cc *InitImage(int x, int y, int val)
{
  unsigned long j;
  image_cc *image;
  
  image = (image_cc *)malloc(sizeof(image_cc));
  image->ndim=2;
  image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
  image->res=(double *)malloc(image->ndim*sizeof(double));	
  sprintf(image->itype,"gry");
  image->numbits= 8;
  image->dim[0] = x;
  image->dim[1] = y;
  image->numbytes = 1;
  image->numchannel = 1;
  image->res[0] = 1.;
  image->res[1] = 1.;
  image->pix=(unsigned char *)malloc(image->numbytes*x*y);
  for(j=0;j<image->numbytes*x*y;j++) 
    *(image->pix+j) = (unsigned char)val;
  return image;
}

image_cc *InitImage(int x, int y, int z, int val)
{
  size_t j, block;
  image_cc *image;
  
  image = (image_cc *)malloc(sizeof(image_cc));
  image->ndim=3;
  image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
  image->res=(double *)malloc(image->ndim*sizeof(double));	
  sprintf(image->itype,"ddd");
  image->dim[2] = z;
  image->dim[0] = x;
  image->dim[1] = y;
  image->numchannel = 1;
  image->res[0] = 1.;
  image->res[1] = 1.;
  image->res[2] = 1.; 
  image->numbytes =1;
  image->numbits = image->numbytes*8;
  block=(size_t)z*x*y*image->numbytes;
  if(block >= std::numeric_limits<std::size_t>::max())
  {
    printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
    exit(-1);
  }    
  if((image->pix=(unsigned char *)malloc(block))==NULL)
  {
    printf("Error in InitImage: Could not allocate %ld Bytes\n",block);
    exit(-1);
  }
  for(j=0;j<block;j++) 
    *(image->pix+j) = (unsigned char)val;
  return image;
}

image_cc *InitImage(int x, int y, int val, char *type)
{
  unsigned long j;
  int i;
  image_cc *image;
  
  image = (image_cc *)malloc(sizeof(image_cc));
  image->ndim=2;
  image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
  image->res=(double *)malloc(image->ndim*sizeof(double));
  if(strncmp(type,"gry",3)==0){
    image->numchannel = 1;
    if(strcmp(type,"gry16")==0){
      sprintf(image->itype,"gry16");
      image->numbytes = 2;
      image->numbits= 16;
    }// U. Weller inserted gry32 2.08.07
    else if(strcmp(type,"gry32")==0){
      sprintf(image->itype,"gry32");
      image->numbytes = 4;
      image->numbits= 32;
    }
    else{
      sprintf(image->itype,"gry");
      image->numbits= 8;
      image->numbytes = 1;
    }
    }
    else if(strcmp(type,"doub")==0){
      sprintf(image->itype,"doub");
      image->numbytes = sizeof(double);
      //image->numbytes = 8;
      image->numbits= image->numbytes*8;
      image->numchannel = 1;
    }
    else if(strcmp(type,"rgb")==0){
      sprintf(image->itype,"rgb");
      image->numbits= 8;
      image->numbytes = 1;
      image->numchannel = 3;
    }
    image->dim[0] = x;
    image->dim[1] = y;
    image->res[0] = 1.;
    image->res[1] = 1.;
    image->pix=(unsigned char *)malloc(image->numchannel*image->numbytes*x*y);
    for(j=0;j<image->numchannel*image->numbytes*x*y;j+=image->numbytes){ 
      point.p=image->pix+j;
      if(image->numbytes==1) 	*(point.p)=(unsigned char)val;
      else if(image->numbytes==2) 	*(point.q)=(unsigned short)val;
      else if(image->numbytes==sizeof(double)) *(point.d)=(double)val;
      else *(point.r)=val;
      //printf(" %d ", val);
    }
    
    
    //printf("\n");
    
    //*(image->pix+image->numbytes*(x+y*image->dim[0])) = (val&(255<<(i*8)))>>(i*8);
    //*(image->pix+image->numbytes*(x+y*image->dim[0])) = (unsigned char)*((&val)+i);
    //*(image->pix+j) = val;
    return image;
  }
  
image_cc *InitImage(int x, int y, int z, int val, char *type)
{
    //unsigned long j; // Steffen Jan2016: unsigned long (2^32) can only handle 1625^3 voxels, might be too small in some cases 
    size_t j, block;
    image_cc *image;
    int zz;
    
    image = (image_cc *)malloc(sizeof(image_cc));
    image->ndim=3;
    image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
    image->res=(double *)malloc(image->ndim*sizeof(double));
    image->dim[0] = x;
    image->dim[1] = y;
    image->dim[2] = z;
    image->res[0] = 1.;
    image->res[1] = 1.;
    image->res[2] = 1.; 
    image->numchannel = 1;
    
    if(strncmp(type,"ddd",3)==0){ // U. Weller inserted ddd32 2.08.07
      
      if(strcmp(type,"ddd16")==0){
	sprintf(image->itype,"ddd16");
	image->numbytes=2;
	image->numbits= image->numbytes*8;
	block=(size_t)z*x*y*image->numbytes;
	if(block >= std::numeric_limits<std::size_t>::max())
	{
	  printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
	  exit(-1);
	}    
	if((image->pix=(unsigned char *)malloc(block))==NULL)
	{
	  printf("Error in InitImage: Could not allocate %ld Bytes\n",block);
	  exit(-1);
	}
	for(j=0; j<block; j+=image->numbytes){ 
	  //for(j=0; j<z*x*y*image->numbytes; j++){ 
	  //*(image->pix+j) = 0;
	  point.p=image->pix+j;
	  *(point.q) = val;
	  //*(point.q) = 0;
	}
      }else if(strcmp(type,"ddd32")==0){
	sprintf(image->itype,"ddd32");
	image->numbytes=4;
	image->numbits= image->numbytes*8;
	block=(size_t)z*x*y*image->numbytes;
	if(block >= std::numeric_limits<std::size_t>::max())
	{
	  printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
	  exit(-1);
	}    
	if((image->pix=(unsigned char *)malloc(block))==NULL)
	{
	  printf("Error in InitImage: Could not allocate %ld Bytes\n",block);
	  exit(-1);
	}
	for(j=0; j<block; j+=image->numbytes){ 
	  //for(j=0; j<z*x*y*image->numbytes; j++){ 
	  //*(image->pix+j) = 0;
	  point.p=image->pix+j;
	  *(point.r) = val;
	  //*(point.q) = 0;
	}
      }
      else{  sprintf(image->itype,"ddd");
	image->numbytes=1;
	image->numbits= image->numbytes*8;
	block=(size_t)z*x*y*image->numbytes;
	if(block >= std::numeric_limits<std::size_t>::max())
	{
	  printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
	  exit(-1);
	}    
	if((image->pix=(unsigned char *)malloc(block))==NULL)
	{
	  printf("Error in InitImage: Could not allocate %ld Bytes\n",block);
	  exit(-1);
	}
	for(j=0;j<block;j++)
	  *(image->pix+j) = val;
      
      }
  }
  else if(strcmp(type,"doub3")==0){
    sprintf(image->itype,"doub3");
    //image->numbytes = sizeof(double);
    image->numbytes = 8;
    image->numbits= image->numbytes*8;
    block=(size_t)z*x*y*image->numbytes;
    if(block >= std::numeric_limits<std::size_t>::max())
    {
      printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
      exit(-1);
    }    
    if((image->pix=(unsigned char *)malloc(block))==NULL)
    {
      printf("Error in InitImage: Could not allocate %ld Bytes\n",block);
      exit(-1);
    }
    for(j=0; j<block; j+=image->numbytes){
      point.p=image->pix+j;
      *(point.d) = val;
    }
  }
  else if(strcmp(type,"btd")==0){
    sprintf(image->itype,"btd");
    image->numbytes = z%8? z/8+1 : z/8;
    image->numbits = 1;
    block=(size_t)x*y*image->numbytes;
    if(block >= std::numeric_limits<std::size_t>::max())
    {
      printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
      exit(-1);
    }    
    if((image->pix=(unsigned char *)malloc(block))==NULL)
    {
      printf("Error in InitImage: Could not allocate %ld Bytes\n",block);
      exit(-1);
    }
    //for(j=0;j<x*y*image->numbytes;j++) 
    //	*(image->pix+j) = val?255:0;
    block=(size_t)x*y*z;
    for(j=0;j<block;j++) 
      wPixel(j,image,val);
  }
  return image;
}

/*U. Weller, 30.03.10 
    copy the structure, but not the contents of an existing image
*************************/
image_cc *InitImage(image_cc *image)
{
  size_t j,buf=1;

  int *k;
  image_cc *copy;
  
  //k=(int *)malloc(5*sizeof(int));
  copy = (image_cc *)malloc(sizeof(image_cc));
  copy->ndim=image->ndim;
  
  copy->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
  copy->res=(double *)malloc(image->ndim*sizeof(double));	
  
  sprintf(copy->itype,"%s",image->itype);
  copy->numbits= image->numbits;
  for(j=0;j<image->ndim;j++){
    copy->dim[j]= image->dim[j];
    copy->res[j] = image->res[j];
    buf*=(size_t)image->dim[j];
  }
  if(strcmp(image->itype,"btd")==0) buf/=image->dim[2];
  buf*=(size_t)(image->numbytes*image->numchannel);
  copy->numchannel=image->numchannel; 
  copy->numbytes=image->numbytes;
  if(buf >= std::numeric_limits<std::size_t>::max())
  {
    printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",buf, std::numeric_limits<std::size_t>::max());
    exit(-1);
  }    
  if((image->pix=(unsigned char *)malloc(buf))==NULL)
  {
    printf("Error in InitImage: Could not allocate %ld Bytes\n",buf);
    exit(-1);
  }  
  //for(j=0;j<buf;j++) 
  //  *(copy->pix+j) = *(image->pix+j);
  return copy;
}
image_cc *InitImage(image_cc *image, int val)
{
  size_t j,buf=1;
  int *k;
  image_cc *copy;
  
  //k=(int *)malloc(5*sizeof(int));
  copy = (image_cc *)malloc(sizeof(image_cc));
  copy->ndim=image->ndim;
  
  copy->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
  copy->res=(double *)malloc(image->ndim*sizeof(double));	
  
  sprintf(copy->itype,"%s",image->itype);
  copy->numbits= image->numbits;
  for(j=0;j<image->ndim;j++){
    copy->dim[j]= image->dim[j];
    copy->res[j] = image->res[j];
    buf*=(size_t)image->dim[j];
  }
  if(strcmp(image->itype,"btd")==0) buf/=image->dim[2];
  buf*=(size_t)(image->numbytes*image->numchannel);
  copy->numchannel=image->numchannel; 
  copy->numbytes=image->numbytes;
  copy->pix=(unsigned char *)malloc(buf);
  if(buf >= std::numeric_limits<std::size_t>::max())
  {
    printf("Error in InitImage: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",buf, std::numeric_limits<std::size_t>::max());
    exit(-1);
  }    
  if((image->pix=(unsigned char *)malloc(buf))==NULL)
  {
    printf("Error in InitImage: Could not allocate %ld Bytes\n",buf);
    exit(-1);
  }
  if(copy->numbytes == 1)
    for(j=0;j<buf;j++) 
       *(copy->pix+j) = val;
  else
    for(j=0;j<buf;j+=2) 
       *((unsigned short*)(copy->pix+j)) = val;
  return copy;
}

image_cc *InitImage_old(int x, int y, int z, int val, char *type)
{
  unsigned long j;
  image_cc *image;
  int zz;
  
  image = (image_cc *)malloc(sizeof(image_cc));
  image->ndim=3;
  image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
  image->res=(double *)malloc(image->ndim*sizeof(double));
  if(strcmp(type,"ddd")==0){
    sprintf(image->itype,"ddd");
    zz=image->dim[2]= z;
    image->numbytes=1;
    image->numchannel = 1;
  }
  if(strcmp(type,"ddd16")==0){
    sprintf(image->itype,"ddd16");
    zz=image->dim[2]= z;
    image->numbytes=2;
    image->numchannel = 1;
  }
  else if(strcmp(type,"btd")==0){
    sprintf(image->itype,"btd");
    zz=image->numbytes = z%8? z/8+1 : z/8;
    image->dim[2]= z;
    image->numchannel = 1;
    
  }
  image->dim[0] = x;
  image->dim[1] = y;
  image->res[0] = 1.;
  image->res[1] = 1.;
  image->res[2] = 1.; 
  image->pix=(unsigned char *)malloc(zz*x*y*image->numbytes);
  for(j=0;j<zz*x*y*image->numbytes;j+=image->numbytes) 
    *(image->pix+j) = val?255:0;
  return image;
}

void DeleteImage(image_cc *im)
{
    if(im != 0){
        if(im->pix != 0)    free(im->pix);
	if(im->res != 0)    free(im->res);
        if(im->dim != 0)    free(im->dim);
        free(im);
    }
    im = 0;
    
}

image_cc *bit16to8(image_cc *im)
{
  unsigned long i,buf=1;
  unsigned char val;
  image_cc *outim;
  
  outim=CopyImage(im);
  free(outim->pix);
  outim->numbytes=1;
  outim->numbits=8;
  
  if(strcmp(im->itype,"gry16")==0)
    sprintf(outim->itype,"gry");
  else if(strcmp(im->itype,"ddd16")==0)
    sprintf(outim->itype,"ddd");
  else{
    printf("\n image %s is not of 16 bit type\n",im->name);
    exit(0);
  }
  for(i=0;i<im->ndim;i++)
    buf*=im->dim[i];
  buf*=im->numchannel;
  outim->pix=(unsigned char *)malloc(buf);
  for(i=0;i<buf;i++){
    point.p=im->pix+i*im->numbytes;
    *(outim->pix+i)= *(point.q)/256; 
  }
  return outim;
}

image_cc *gry16to8(image_cc *im)
{
  unsigned long i,buf=1;
  unsigned char val;
  image_cc *outim;
  
  outim=CopyImage(im);
  free(outim->pix);
  outim->numbytes=1;
  outim->numbits=8;
  
  if(strcmp(im->itype,"gry16")==0)
    sprintf(outim->itype,"gry");
  else if(strcmp(im->itype,"ddd16")==0)
    sprintf(outim->itype,"ddd");
  else{
    printf("\n image %s is not of 16 bit type\n",im->name);
    exit(0);
  }
  for(i=0;i<im->ndim;i++)
    buf*=im->dim[i];
  buf*=im->numchannel;
  outim->pix=(unsigned char *)malloc(buf);
  for(i=0;i<buf;i++){
    point.p=im->pix+i*im->numbytes;
    *(outim->pix+i)= *(point.q)/256; 
  }
  return outim;
}
image_cc *ddd16to8(image_cc *im)
{
  unsigned long i,buf=1;
  unsigned char val;
  image_cc *outim;
  
  outim=CopyImage(im);
  free(outim->pix);
  outim->numbytes=1;
  outim->numbits=8;
  
  for(i=0;i<im->ndim;i++)
    buf*=im->dim[i];
  buf*=im->numchannel;
  outim->pix=(unsigned char *)malloc(buf);
  for(i=0;i<buf;i++){
    point.p=im->pix+i*im->numbytes;
    *(outim->pix+i)= *(point.q)/256; 
  }
  return outim;
}

image_cc *Ddd2Btd(image_cc *im)
{
  int x,y,z;
  image_cc *outim;
  
  //outim = InitBtdImage(im->dim[0],im->dim[1],im->dim[2],im->res[0],im->res[1],im->res[2]);
  outim = InitImage(im->dim[0],im->dim[1],im->dim[2],0,"btd");
  outim->res[0]=im->res[0];
  outim->res[1]=im->res[1];
  outim->res[2]=im->res[2];
  
  for(z=0;z<im->dim[2];z++)
    for(y=0;y<im->dim[1];y++)
      for (x=0;x<im->dim[0];x++){
	if(rPixel(x,y,z,im))
	  wPixel(x,y,z,outim,1);
	else
	  wPixel(x,y,z,outim,0);
      }
      return outim;
}

image_cc *InitRandImage(int col,int row,double rx,double ry, double cx,double cy, int mode, double *cdf)
/*
mode:

0:	equal distribution without any correlation (cx,cy,cz and cdf have no meaning here)
1:	equal distribution with  gaussian correlation   
2:      predefined distribution (cdf) distribution and gaussian correlation   
3:	Gaussian correlation (cdf have no meaning here)
4:	Lorentz-Correlation model (cdf have no meaning here)
5:	Exponential-Correlation model (cdf have no meaning here)
6:	von Karman-Correlation model (cdf have no meaning here)
*/
{
  double *sfa, randnum,rval,min,max, *iscdf,sum, mean, sig;
  int x,y,z,val,i, N, n, model;
  image_cc *random;
  long idum, count=0;
  
  min=max=0;
  n=col>=row?col:row;
  for(i=1;i<11;i++)
    if((N=int(pow(2,i)))>=n)
      break;
    
    //printf("\nN= %d \n", N);
  //idum=IDUM;
  random=InitImage(col,row,255);
  random->res[0]=rx; random->res[1]=ry;
  
  /***** Generation of random field ****/
  iscdf=(double *)malloc(256*sizeof(double));
  for(i=0;i<256;i++)  iscdf[i]=0;
  
  sfa=(double *)malloc(N*N*sizeof(double));
  grf2(sfa,N,N,rx,ry,cx,cy,1.,N,mode>2?mode-3:0);
  sum=0;
  for(i=0;i<N*N;i++){
    sum+=sfa[i];
    if(sfa[i]<min) min=(sfa[i]);
    if(sfa[i]>max) max=(sfa[i]);
  }
  mean=sum/(N*N);
  sum=0;
  for(i=0;i<N*N;i++)
    sum+=(sfa[i]-mean)*(sfa[i]-mean);
  sig=sqrt(sum/(N*N));
  
  //max=3.5*sig;
  //min=-max;
  //printf("\nmin: %lf    max: %lf mean: %lf   sig: %lf \n",min,max,mean,sig);
  
  /*** calculate cdf of generated values ****/
  for(i=0;i<N*N;i++){
    val =int((sfa[i]-min)/(max-min) * 255.999);
    iscdf[val]++;
    count++;
  }
  for(i=0;i<256;i++) iscdf[i]= (double)iscdf[i]/count;
  
  sum=iscdf[0];
  for(i=1;i<256;i++){
    sum+=iscdf[i];
    iscdf[i]+=iscdf[i-1];
  }
  for(i=0;i<256;i++)
    iscdf[i]= iscdf[i]/sum;	
  iscdf[0]=0;
  /******************************************/
  
  for(y=0;y<random->dim[1];y++)
    for(x=0;x<random->dim[0];x++){
      
      switch(mode){
	case 0: 
	  val=int(ran3(&IDUM) * 255.999); break;
	case 1: 	 
	  val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
	  for(i=0;i<256;i++)
	    if(iscdf[val]<= (double)i/256) break;
	    val = i>255?255:i; break;
	case 2:   
	  val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
	  for(i=0;i<256;i++)
	    if(iscdf[val]<cdf[i])   break;
	    val = i>255?255:i;  break; 
	default:  val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
      }
      wPixel(x,y, random,val);
    }
    free(sfa);
    return random;	
}
image_cc *InitRandImage(int col,int row,int dep,double rx,double ry, double rz,double cx,double cy, double cz, int mode, double *cdf)
{
  double ***sfa, randnum,rval,min,max, *iscdf,sum;
  int x,y,z,val,i,n, N;
  image_cc *ddd;
  long idum, count=0;
  
  min=max=0;
  n=col>=row?col:row;
  if(n<dep) n=dep;
  for(i=1;i<11;i++)
    if((N=int(pow(2,i)))>=n)
      break;
    
    idum=-1;
  ddd=InitImage(col,row,dep,255,"ddd");
  ddd->res[0]=rx; ddd->res[1]=ry;ddd->res[2]=rz;
  
  /***** Gneration of random field ****/
  iscdf=(double *)malloc(256*sizeof(double));
  for(i=0;i<256;i++)
    iscdf[i]=0;
  
  sfa=(double ***)malloc(N*sizeof(double **));
  for(x=0;x<N;x++) {
    sfa[x]=(double **)malloc(N*sizeof(double *));
    for(y=0;y<N;y++)
      sfa[x][y]=(double *)malloc(N*sizeof(double));
  }
  if(mode){
    if(mode<4)	grf3(sfa,rx,ry,rz,cx,cy,cz,1,N,0);
    else    	grf3(sfa,rx,ry,rz,cx,cy,cz,1,N,mode-3);
    for(z=0;z<N;z++)
      for(y=0;y<N;y++)
	for(x=0;x<N;x++){
	  if(sfa[x][y][z]<min) min=(sfa[x][y][z]);
	  if(sfa[x][y][z]>max) max=(sfa[x][y][z]);
	}
	//printf("\nmin: %lf    max: %lf \n",min,max);
      
      /*** calculate cdf of generated values ****/
      for(z=0;z<N;z++)
	for(y=0;y<N;y++)
	  for(x=0;x<N;x++){
	    val =int((sfa[x][y][z]-min)/(max-min) * 255);
	    iscdf[val]++;
	    count++;
	  }
	  for(i=0;i<256;i++)
	    iscdf[i]= (double) iscdf[i]/count;
	  
	  sum=iscdf[0];
	for(i=1;i<256;i++){
	  sum+=iscdf[i];
	  iscdf[i]+=iscdf[i-1];
	}
	for(i=0;i<256;i++)
	  iscdf[i]= iscdf[i]/sum;	
	iscdf[0]=0;
  }
  
  for(z=0;z<ddd->dim[2];z++)
    for(y=0;y<ddd->dim[1];y++)
      for(x=0;x<ddd->dim[0];x++){
	switch(mode){
	  case 0: 
	    val=int(ran3(&idum) * 255.999); break;
	  case 1:
	    val =int((sfa[x][y][z]-min)/(max-min) * 255.999);
	    for(i=0;i<256;i++)
	      if(iscdf[val]< (double)i/256) break;
	      val = i>255?255:i; break; 
	  case 2:   
	    val =int((sfa[x][y][z]-min)/(max-min) * 255);
	    for(i=0;i<256;i++)
	      if(iscdf[val]<cdf[i]) break;
	      val = i>255?255:i; break;  
	  default: val =int((sfa[x][y][z]-min)/(max-min) * 255); 
	}
	wPixel(x,y,z, ddd,val);
      }
      for(x=0;x<N;x++) for(y=0;y<N;y++) free(sfa[x][y]);
      for(x=0;x<N;x++) free(sfa[x]);
      free(sfa);
      return ddd;	
}
void SavePrinciplePlanes(image_cc *im, char *name)
{
  image_cc *plane;
  char buffer[127];
  
  plane = GetPlane(im, im->dim[2]/2, 0);
  sprintf(buffer,"%s_plane_xy",name);
  StoreImage(plane,buffer);		
  DeleteImage(plane);
  plane = GetPlane(im, im->dim[0]/2, 1);
  sprintf(buffer,"%s_plane_yz",name);
  StoreImage(plane,buffer);		
  DeleteImage(plane);
  plane = GetPlane(im, im->dim[1]/2, 2);
  sprintf(buffer,"%s_plane_xz",name);
  StoreImage(plane,buffer);		
  DeleteImage(plane);
  
}

void StoreRaw(image_cc *im)
{
    FILE *fp;
    char buffer[256];
    size_t size, checksum, npix;
    image_cc *gray;
    
    if(im->ndim==2)
	fprintf(stderr,"StoreRaw() is for 3D images only");
    else
    {

	    
	sprintf(buffer, "%s.raw", im->name);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Cannot open %s.\n",buffer);
	    exit(1);
	}
	npix=im->dim[0]*im->dim[1]*im->dim[2];
	size=npix*im->numbytes*im->numchannel;
	
	if(strncmp(im->itype,"btd",3)==0)
	{
	    sprintf(buffer,"ddd");
	    gray=InitImage(im->dim[0],im->dim[1],im->dim[2],0,buffer);
	    for(int i=0;i<npix;i++)
		if(rPixel(i,im)) wPixel(i,gray,1);
	    if((checksum=fwrite(gray->pix, 1, npix, fp))!=npix)
	    {
		fprintf(stderr, "Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);	
	}
	else
	{
	    if((checksum=fwrite(im->pix, 1, size, fp))!=size)
	    {
		fprintf(stderr, "Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);
	}
	
	sprintf(buffer, "%s.txt", im->name);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Cannot open %s.\n",buffer);
	    exit(1);
	}    

	fprintf(fp,"name:\t %s\n",im->name);
	fprintf(fp,"dimens:\t %d\n", im->ndim);
	if(strncmp(im->itype,"btd",3)==0)
	{
	    fprintf(fp,"type:\t %s\n",gray->itype);
	    fprintf(fp,"nbytes:\t %d\n", gray->numbytes);	    
	}
	else
	{
	    fprintf(fp,"type:\t %s\n",im->itype);
	    fprintf(fp,"nbytes:\t %d\n", im->numbytes);
	}
	fprintf(fp,"channels:\t %d\n", im->numchannel);
	fprintf(fp,"width [x]:\t %d\n", im->dim[0]);
	fprintf(fp,"height [y]:\t %d\n", im->dim[1]);
	fprintf(fp,"depth [z]:\t %d\n", im->dim[2]);
	fprintf(fp,"nvoxels:\t %ld\n", long(npix));
	fprintf(fp,"res [x]:\t %lf\n", im->res[0]);
	fprintf(fp,"res [y]:\t %lf\n", im->res[1]);
	fprintf(fp,"res [z]:\t %lf\n", im->res[2]);
	fprintf(fp,"header [byte]:\t 0\n");
	fprintf(fp,"file size [byte]:\t %ld\n", long(size));
	fprintf(fp,"Index order:\t x fastest\n");
	fprintf(fp,"Endian:\t little (Intel)\n");
	fclose(fp);
    }

    
}

void StoreRaw(image_cc *im, char *buf)
{
    FILE *fp;
    char buffer[256];
    size_t size, checksum, npix;
    image_cc *gray;
    
    if(im->ndim==2)
	fprintf(stderr,"StoreRaw() is for 3D images only");
    else
    {

	    
	sprintf(buffer, "%s.raw", buf);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Cannot open %s.\n",buffer);
	    exit(1);
	}
	npix=im->dim[0]*im->dim[1]*im->dim[2];
	size=npix*im->numbytes*im->numchannel;
	
	if(strncmp(im->itype,"btd",3)==0)
	{
	    sprintf(buffer,"ddd");
	    gray=InitImage(im->dim[0],im->dim[1],im->dim[2],0,buffer);
	    for(int i=0;i<npix;i++)
		if(rPixel(i,im)) wPixel(i,gray,1);
	    if((checksum=fwrite(gray->pix, 1, npix, fp))!=npix)
	    {
		fprintf(stderr, "Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);	
	}
	else
	{
	    if((checksum=fwrite(im->pix, 1, size, fp))!=size)
	    {
		fprintf(stderr, "Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);
	}
	
	sprintf(buffer, "%s.txt", im->name);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Cannot open %s.\n",buffer);
	    exit(1);
	}    

	fprintf(fp,"name:\t %s\n",im->name);
	fprintf(fp,"dimens:\t %d\n", im->ndim);
	if(strncmp(im->itype,"btd",3)==0)
	{
	    fprintf(fp,"type:\t %s\n",gray->itype);
	    fprintf(fp,"nbytes:\t %d\n", gray->numbytes);	    
	}
	else
	{
	    fprintf(fp,"type:\t %s\n",im->itype);
	    fprintf(fp,"nbytes:\t %d\n", im->numbytes);
	}
	fprintf(fp,"channels:\t %d\n", im->numchannel);
	fprintf(fp,"width [x]:\t %d\n", im->dim[0]);
	fprintf(fp,"height [y]:\t %d\n", im->dim[1]);
	fprintf(fp,"depth [z]:\t %d\n", im->dim[2]);
	fprintf(fp,"nvoxels:\t %ld\n", long(npix));
	fprintf(fp,"res [x]:\t %lf\n", im->res[0]);
	fprintf(fp,"res [y]:\t %lf\n", im->res[1]);
	fprintf(fp,"res [z]:\t %lf\n", im->res[2]);
	fprintf(fp,"header [byte]:\t 0\n");
	fprintf(fp,"file size [byte]:\t %ld\n", long(size));
	fprintf(fp,"Index order:\t x fastest\n");
	fprintf(fp,"Endian:\t little (Intel)\n");
	fclose(fp);
    }

    
}

image_cc *LoadRaw(char *buf, int cols, int rows, int layers, int offset, int nbyte)
{

 	FILE *fp;
	char fname[255];
	size_t imsize, block;
	image_cc *im;
	im = (image_cc *)malloc(sizeof(image_cc));
	sprintf(fname,"%s",buf);
	if((fp=fopen(fname,"r"))!=0){
	    // obtain file size:
	    fseek (fp , 0 , SEEK_END);
	    int lSize = ftell (fp);
	    rewind (fp);
		im->ndim= 3;
		im->dim = (unsigned int *)malloc(3*sizeof(int));
		im->res = (double *)malloc(3*sizeof(double));
		im->numchannel=1;
		im->numbytes=nbyte;
		
		if(nbyte==2)
		{
		  im->numbits=16;
		  sprintf(im->itype,"ddd16");
		}
		else
		{
		  im->numbits=8;
		  sprintf(im->itype,"ddd");
		}
		sprintf(im->name,"%s",fname);
		im->dim[0]=cols;
		im->dim[1]=rows;
		im->dim[2]=layers;
		im->res[0]=im->res[1]=im->res[2]=1;
		imsize = (size_t)rows*cols*layers;
		fseek(fp,offset,SEEK_SET);
		block=(size_t)imsize*im->numbytes;
		if(block >= std::numeric_limits<std::size_t>::max())
		{
		  printf("Error in LoadRaw: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
		  exit(-1);
		}    
		if((im->pix=(unsigned char *)malloc(block))==NULL)
		{
		  printf("Error in LoadRaw: Could not allocate %ld Bytes\n",block);
		  exit(-1);
		}
		fread(im->pix, im->numbytes, imsize, fp);

		return im;

	}
	fprintf(stderr,"Error occured while opening %s. Raw Image is not loaded.", fname);
	free(im);
	return 0;

}
/***********************************************************
StoreMetaImage() and LoadMetaImage for easier file I/O with ITK and ImageJ (Import > MetaImage)  
***********************************************************/

image_cc *LoadMetaImage(char *buf)
{
  FILE *fp;
  long row; 
  TIFF *tif;
  char fname[511], imtag[511], tfname[511];
  unsigned char *charbuf;
  image_cc *im;
  int i,j,floattype=0, alpha=0, idum; 
  uint32 length, width;
  uint16 bits, samples, config;
  unsigned long offset;
  double lrange, hrange, fac, min, max;
  int *k;
  size_t block;

  union {
    unsigned char *p;
    float *q;
  } fpoint;
  
  im = (image_cc *)malloc(sizeof(image_cc));
  setlocale(LC_ALL, "C");

    if(strcmp(".mhd", buf+strlen(buf)-4))
    sprintf(fname,"%s.mhd",buf);
    else
      sprintf(fname,"%s",buf);
   
    if((fp=fopen(fname,"r"))!=0)
    {
      sprintf(im->name,"%s",fname);
      im->ndim=3;      
      im->dim=(unsigned int *)calloc(im->ndim,sizeof(unsigned int));
      im->res=(double *)calloc(im->ndim,sizeof(double));
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);
	if(!strcmp("ObjectType",imtag))
	{
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  idum=fscanf(fp,"%s",imtag);
	  if(!strcmp("Image",imtag))
	  {
	    fseek(fp,SEEK_SET,0);
	    break;
	  }
	  else
	  {
	      fprintf(stderr,"Error in LoadMetaImage(): ObjectType has to be Image\n");exit(-1);
	  }
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): ObjectType is not known. Make sure that it's Image\n"); 
	    fseek(fp,SEEK_SET,0);
	    break;
	}
      }
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);  
	if(!strcmp("NDims",imtag))
	{
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  idum=fscanf(fp,"%s",imtag);
	  if(!strcmp("3",imtag))
	  {
	    fseek(fp,SEEK_SET,0);
	    break;
	  }
	  else
	  {
	      fprintf(stderr,"Error in LoadMetaImage(): NDims has to be 3\n");
	      exit(-1);
	  }
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): NDims is not known. Make sure that it's 3\n"); 
	    fseek(fp,SEEK_SET,0);
	    break;
	}
      }
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);  
	if(!strcmp("BinaryData",imtag))
	{
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  idum=fscanf(fp,"%s",imtag);
	  if(!strcmp("True",imtag))
	  {
	    fseek(fp,SEEK_SET,0);
	    break;
	  }
	  else
	  {
	      fprintf(stderr,"Error in LoadMetaImage(): BinaryData has to be True\n");
	      exit(-1);
	  }
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): BinaryData is not known. Make sure that it's True\n"); 
	    fseek(fp,SEEK_SET,0);
	    break;
	}
      }
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);  
	if(!strcmp("ElementByteOrderMSB",imtag))
	{
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  idum=fscanf(fp,"%s",imtag);
	  if(!strcmp("False",imtag))
	  {
	    fseek(fp,SEEK_SET,0);
	    break;
	  }
	  else
	  {
	      fprintf(stderr,"Error in LoadMetaImage(): ElementByteOrderMSB has to be False (i.e. little Endian, Intel Byte order, least significant bit). Run a byte swapper beforehand\n");
	      exit(-1);
	  }
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): ElementByteOrderMSB is not known. Make sure that it's little Endian (i.e. Intel Byte order, least significant bit)\n"); 
	    fseek(fp,SEEK_SET,0);
	    break;
	}
      }
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);
	if(!strcmp("DimSize",imtag)){
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  if(idum=fscanf(fp,"%d %d %d",&im->dim[0],&im->dim[1],&im->dim[2])!=3)
	  {
	    fprintf(stderr,"Warning in LoadMetaImage(): DimSize requires three integers. Add it to *.mhd file in the following form DimSize = xxx yyy zzz\n"); 
	    exit(-1);
	  }
	  fseek(fp,SEEK_SET,0);break;
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): DimSize is missing. Add it to *.mhd file in the following form DimSize = xxx yyy zzz\n"); 
	    exit(-1);
	}	
      }  
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);
	if(!strcmp("ElementSize",imtag)){
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  if(idum=fscanf(fp,"%lf %lf %lf",&im->res[0],&im->res[1],&im->res[2])!=3)
	  {
	    fprintf(stderr,"Warning in LoadMetaImage(): ElementSize requires three double floats. Add it to *.mhd file in the following form ElementSize = xxx yyy zzz\n"); 
	    exit(-1);
	  }
	  fseek(fp,SEEK_SET,0);break;
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): ElementSize is missing and assumed to be 1.0 in all three dimensions\n"); 
	    fseek(fp,SEEK_SET,0);break;
	    break;
	}	
      } 
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);
	if(!strcmp("ElementType",imtag)){
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  idum=fscanf(fp,"%s",imtag); 
	  if(!strcmp("MET_UCHAR",imtag))
	  {
	      sprintf(im->itype,"ddd");
	      im->numchannel=1;
	      im->numbytes=1;
	      im->numbits=8;
	      fseek(fp,SEEK_SET,0);break;
	  }
	  else if(!strcmp("MET_USHORT",imtag))
	  {
	      sprintf(im->itype,"ddd16");
	      im->numchannel=1;
	      im->numbytes=2;
	      im->numbits=16;
	      fseek(fp,SEEK_SET,0);break;
	  }
	  else
	  {
	    fprintf(stderr,"Warning in LoadMetaImage(): Only MET_USHORT and MET_UCHAR allowed as ElementType. Run a type conversion beforehand.\n"); 
	    exit(-1);	      
	  }
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): ElementType is missing. Add it to *.mhd file in the following form ElementType = MET_USHORT or MET_UCHAR\n"); 
	    exit(-1);
	}	
      }       
      while(1)
      {
	idum=fscanf(fp,"%s",imtag);  
	if(!strcmp("ElementDataFile",imtag))
	{
	  idum=fscanf(fp,"%s",imtag); // to catch '='
	  idum=fscanf(fp,"%s",fname);
	  fseek(fp,SEEK_SET,0);break;
	}
	else if(feof(fp))
	{
	    fprintf(stderr,"Warning in LoadMetaImage(): ElementDataFile is not known. Add it to *.mhd file in the following form ElementDataFile = <filename>. Also make sure that has no header\n."); 
	    exit(-1);
	}
      }

      fclose(fp);
          
      strcpy(tfname, buf);
      charbuf = (unsigned char*)strrchr(tfname, '/');
      if(charbuf){//path in filename
	*charbuf = 0;
	sprintf(imtag, "%s/%s", tfname, fname);
	strcpy(fname, imtag);
      }
      if((fp=fopen(fname,"r"))==0)
      {
	fprintf(stderr,"\nError in LoadMetaImage(): no file %s\n",fname);
	exit(EXIT_FAILURE);
      }
      else
      {
	block=(size_t)im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;
	if(block >= std::numeric_limits<std::size_t>::max())
	{
	  printf("Error in LoadRaw: File size (%ld Bytes) exceeds maximum of malloc (%ld Bytes)\n",block, std::numeric_limits<std::size_t>::max());
	  exit(-1);
	}    
	if((im->pix=(unsigned char *)malloc(block))==NULL)
	{
	  printf("Error in LoadRaw: Could not allocate %ld Bytes\n",block);
	  exit(-1);
	}	
	idum=fread(im->pix, (size_t)im->dim[0]*im->dim[1]*im->dim[2],im->numbytes, fp);
	fclose(fp);
      }

  }
  else
  {
      fprintf(stderr,"Error in LoadMetaImage(): Cannot find file %s\n", fname); 
      exit(-1);
  }
  
for(i=0;i<im->ndim;i++)
  if(!im->res[i]) im->res[i]=1.; 
  
printf("****************************\n");
printf("Image loaded:\n");
printf("Image name:\t %s\n",im->name);
printf("Image type:\t %s\n",im->itype);
if(alpha)
  printf("Image alpha:\t removed\n");
else
  printf("Image alpha:\t no\n");
printf("Image dimens:\t %d\n", im->ndim);
printf("Image channels:\t %d\n", im->numchannel);
printf("Image alpha:\t %d\n", alpha);
printf("Image height:\t %d\n", im->dim[1]);
printf("Image width:\t %d\n", im->dim[0]);
if(im->ndim>2)
  printf("Image depth:\t %d\n", im->dim[2]);
printf("Image nbytes:\t %d\n", im->numbytes);
printf("Image nbits:\t %d\n", im->numbits);
printf("Image x-res:\t %lf\n", im->res[0]);
printf("Image y-res:\t %lf\n", im->res[1]);
if(im->ndim>2)
  printf("Image z-res:\t %lf\n", im->res[2]);
printf("****************************\n");

return im;
}


void StoreMetaImage(image_cc *im)
{
    FILE *fp;
    char buffer[256],tfname[256];
    unsigned char *charbuf;
    size_t size, checksum, npix;
    image_cc *gray;
    
    if(im->ndim==2)
	fprintf(stderr,"StoreMetaImage() is for 3D images only");
    else
    {

	    
	sprintf(buffer, "%s.raw", im->name);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Error in StoreMetaImage(): Cannot open %s.\n",buffer);
	    exit(1);
	}
	npix=(size_t)im->dim[0]*im->dim[1]*im->dim[2];
	size=(size_t)npix*im->numbytes*im->numchannel;
	
	if(strncmp(im->itype,"btd",3)==0)
	{
	    sprintf(buffer,"ddd");
	    gray=InitImage(im->dim[0],im->dim[1],im->dim[2],0,buffer);
	    for(size_t i=0;i<npix;i++)
		if(rPixel(i,im)) wPixel(i,gray,1);
	    if((checksum=fwrite(gray->pix, 1, npix, fp))!=npix)
	    {
		fprintf(stderr, "Error in StoreMetaImage(): Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);	
	}
	else
	{
	    if((checksum=fwrite(im->pix, 1, size, fp))!=size)
	    {
		fprintf(stderr, "Error in StoreMetaImage(): Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);
	}
	
	sprintf(buffer, "%s.mhd", im->name);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Error in StoreMetaImage(): Cannot open %s.\n",buffer);
	    exit(1);
	}    

	fprintf(fp,"ObjectType = Image\nNDims = 3\nBinaryData = True\n");
	fprintf(fp,"DimSize = %d %d %d\n", im->dim[0],im->dim[1],im->dim[2]);
	fprintf(fp,"ElementSize = %lf %lf %lf\n", im->res[0],im->res[1],im->res[2]);
	if(strncmp(im->itype,"btd",3)==0)
	{
	    fprintf(fp,"ElementType = MET_UCHAR\n");
	}
	else
	{
	    if(im->numbytes==2)
		fprintf(fp,"ElementType = MET_USHORT\n");
	    else
		fprintf(fp,"ElementType = MET_UCHAR\n");
	}
	fprintf(fp,"ElementByteOrderMSB = False\n");
	
	//file name in meta data musn't have a path because it's always stored in the same folder as the mhd file
	strcpy(tfname, im->name);
	charbuf = (unsigned char*)strrchr(tfname, '/');
	if(charbuf){//path in filename
	  fprintf(fp,"ElementDataFile = %s.raw\n", charbuf+1);
	}
	else
	  fprintf(fp,"ElementDataFile = %s.raw\n", im->name);
    }
}


void StoreMetaImage(image_cc *im, char *buf)
{
    FILE *fp;
    char buffer[256],tfname[256];
    unsigned char *charbuf;
    size_t size, checksum, npix;
    image_cc *gray;
    
    if(im->ndim==2)
	fprintf(stderr,"StoreMetaImage() is for 3D images only");
    else
    {

	    
	sprintf(buffer, "%s.raw", buf);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Error in StoreMetaImage(): Cannot open %s.\n",buffer);
	    exit(1);
	}
	npix=(size_t)im->dim[0]*im->dim[1]*im->dim[2];
	size=(size_t)npix*im->numbytes*im->numchannel;
	
	if(strncmp(im->itype,"btd",3)==0)
	{
	    sprintf(buffer,"ddd");
	    gray=InitImage(im->dim[0],im->dim[1],im->dim[2],0,buffer);
	    for(size_t i=0;i<npix;i++)
		if(rPixel(i,im)) wPixel(i,gray,1);
	    if((checksum=fwrite(gray->pix, 1, npix, fp))!=npix)
	    {
		fprintf(stderr, "Error in StoreMetaImage(): Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);	
	}
	else
	{
	    if((checksum=fwrite(im->pix, 1, size, fp))!=size)
	    {
		fprintf(stderr, "Error in StoreMetaImage(): Cannot write %s [%ld bytes required].\n",buffer, long(size));
		exit(1);
	    }
	    fclose(fp);
	}
	
	sprintf(buffer, "%s.mhd", buf);
	if ( (fp = fopen(buffer, "w")) == NULL)
	{
	    fprintf(stderr, "Error in StoreMetaImage(): Cannot open %s.\n",buffer);
	    exit(1);
	}    

	fprintf(fp,"ObjectType = Image\nNDims = 3\nBinaryData = True\n");
	fprintf(fp,"DimSize = %d %d %d\n", im->dim[0],im->dim[1],im->dim[2]);
	fprintf(fp,"ElementSize = %lf %lf %lf\n", im->res[0],im->res[1],im->res[2]);
	if(strncmp(im->itype,"btd",3)==0)
	{
	    fprintf(fp,"ElementType = MET_UCHAR\n");
	}
	else
	{
	    if(im->numbytes==2)
		fprintf(fp,"ElementType = MET_USHORT\n");
	    else
		fprintf(fp,"ElementType = MET_UCHAR\n");
	}
	fprintf(fp,"ElementByteOrderMSB = False\n");
	
	//file name in meta data musn't have a path because it's always stored in the same folder as the mhd file
	strcpy(tfname, buf);
	charbuf = (unsigned char*)strrchr(tfname, '/');
	if(charbuf){//path in filename
	  fprintf(fp,"ElementDataFile = %s.raw\n", charbuf+1);
	}
	else
	  fprintf(fp,"ElementDataFile = %s.raw\n", buf);
    }
}