/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"
#include "string.h"

image_cc *LoadImage(char *buf)
{
 	FILE *fp;
	long row; 
	TIFF *tif;
	char fname[255], imtag[255];
	unsigned char *pixbuf;
	image_cc *im;
	int i,j,floattype=0, alpha=0; 
	uint32 length, width;
	uint16 bits, samples;
	unsigned long offset;
	double lrange, hrange, fac, min, max;
	int *k;
	union {
		unsigned char *p;
		float *q;
	} fpoint;
	union {
		unsigned char *p;
		unsigned int *q;
	} ipoint;
	

	im = (image_cc *)malloc(sizeof(image_cc));

	while(1){

	  sprintf(fname,"%s.btd",buf);
	  if((fp=fopen(fname,"r"))!=0){
	    sprintf(im->itype,"btd");
	    sprintf(im->name,"%s",fname);
	    im->ndim=3;
	    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
	    im->res=(double *)malloc(im->ndim*sizeof(double));
	    fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
		   &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	    im->pix=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->numbytes);
	    im->numchannel=1;
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<im->dim[0]*im->dim[1]*im->numbytes;i++) 
	      im->pix[i]=getc(fp);
	    fclose(fp);
	    break;
	  }

	  sprintf(fname,"%s.ddd",buf);
	  if((fp=fopen(fname,"r"))!=0){
	    sprintf(im->name,"%s",fname);
	    im->ndim=3;
	    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
	    im->res=(double *)malloc(im->ndim*sizeof(double));
	    fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
		   &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	    if(im->numbytes==2) 	sprintf(im->itype,"ddd16");
	    else{ 			sprintf(im->itype,"ddd");
	    				im->numbytes=1;
		}
	    im->pix=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes);
	    im->numchannel=1;
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i++) 
	      im->pix[i]=getc(fp);
	    fclose(fp);
	    break;
	  }
	  sprintf(fname,"%s.vgi",buf);
	  if((fp=fopen(fname,"r"))!=0){
	    sprintf(im->itype,"ddd16");
	    sprintf(im->name,"%s",fname);
	    im->ndim=3;
	    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
	    im->res=(double *)malloc(im->ndim*sizeof(double));
	    int flag=0;
	    while(1){
		fscanf(fp,"%s",imtag);
		if(!strcmp("[file1]",imtag)) flag=1;
		if((!strcmp("Size",imtag) || !strcmp("size",imtag)) && flag){
			fscanf(fp,"%s",imtag);
			fscanf(fp,"%d %d %d",&im->dim[0],&im->dim[1],&im->dim[2]);
			fseek(fp,SEEK_SET,0); flag=0;break;
		}
	    }
	    flag=0;
	    while(1){
		fscanf(fp,"%s",imtag);
		if(!strcmp("[geometry]",imtag)) flag=1;
		if(!strcmp("resolution",imtag) && flag){
			fscanf(fp,"%s",imtag);
			fscanf(fp,"%lf %lf %lf",&im->res[0],&im->res[1],&im->res[2]);
			fseek(fp,SEEK_SET,0);flag=0; break;
		}
            }
	    while(1){
		fscanf(fp,"%s",imtag);
		if(!strcmp("[file1]",imtag)) flag=1;
		if(!strcmp("datarange",imtag) && flag){
			fscanf(fp,"%s",imtag);
			fscanf(fp,"%lf %lf",&lrange, &hrange);
			fseek(fp,SEEK_SET,0);flag=0; break;
		}
	    }
	    while(1){
		fscanf(fp,"%s",imtag);
		if(!strcmp("[file1]",imtag)) flag=1;
		if((!strcmp("datatype",imtag) || !strcmp("Datatype",imtag)) && flag){
			fscanf(fp,"%s",imtag);
			fscanf(fp,"%s",imtag);
			if(!strcmp("float",imtag)) floattype=1;
			fseek(fp,SEEK_SET,0);flag=0; break;
		}
	    }
	    fclose(fp);	
	    im->numchannel=1;
	    im->numbytes=2;
	    im->numbits=16;
		if(floattype)	sprintf(fname,"%s.vol",buf); 
		else 		sprintf(fname,"%s.raw",buf);
		printf("\nloading %s\n", fname);
	  	if((fp=fopen(fname,"r"))==0){
			printf("\nError in Load image no file %s\n",fname);
			exit(0);
		}
	    //fpix=(float *)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(float));
	    im->pix=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes);
	    fpoint.p=(unsigned char *)malloc(4); 
	    for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i+=im->numbytes){
		if(floattype){
			for(j=0;j<4;j++)
				*(fpoint.p+j) =getc(fp); 
			point.p=im->pix+i;
			fac= (*(fpoint.q)-lrange)/(hrange-lrange);
			*(point.q)= int(65532 * fac);
		}
		else{
			point.p=im->pix+i;
			for(j=0;j<2;j++)
				*(point.p+j) =getc(fp); 
		
		}
	    }
	    fclose(fp);
	    break;
	  }

	  while(1){
	    sprintf(fname,"%s",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.tif",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.TIF",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.tiff",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.TIFF",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    printf("\nLoadImage: could not open %s\n",buf);
	    exit(0);
	  }
	  im->ndim=2;
	  im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
	  im->res=(double *)calloc(im->ndim,sizeof(double));
	  TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &length);
	  TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &width);
	  TIFFGetField(tif, TIFFTAG_SAMPLESPERPIXEL, &samples);
	  TIFFGetField(tif, TIFFTAG_BITSPERSAMPLE, &bits);
	  im->numchannel=samples;
	  im->dim[0]=width;
	  im->dim[1]=length;
	  im->numbits=bits;
	  sprintf(im->name,"%s",buf);
	  im->numbytes=im->numbits/8 + (im->numbits%8?1:0);
	  //printf("\nnbytes = %d\n",im->numbytes);
	  if(im->numchannel==3||im->numchannel==4){
	    alpha = im->numchannel-3;
	    sprintf(im->itype,"rgb");
	  }
	  else{
	    alpha = im->numchannel-1;
	    //im->numbytes=1;
	    if(im->numbytes==2 && im->ndim==2)
		sprintf(im->itype,"gry16");
	    else if(im->numbytes==2 && im->ndim==3)
		sprintf(im->itype,"ddd16");
	    else
	    	sprintf(im->itype,"gry");
	  }
	  
	  pixbuf =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numchannel*im->numbytes);
	  im->pix =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numbytes*(im->numchannel-alpha));
	  for (row = 0; row < im->dim[1]; row++)
	    TIFFReadScanline(tif, pixbuf+(row*im->dim[0]*im->numchannel*im->numbytes), row,0);	  
	  for(i=0;i<im->dim[0]*im->dim[1]*(im->numchannel-alpha)*im->numbytes;i++)
	    *(im->pix+i)=*(pixbuf+i+alpha*i/(im->numchannel-alpha));
	  im->numchannel-=alpha;
	  TIFFClose(tif);


	  break;
	}

	for(i=0;i<im->ndim;i++)
		if(!im->res[i]) im->res[i]=1.; 

	printf("****************************\n");
	printf("Image loaded:\n");
	printf("Image name:\t %s\n",im->name);
	printf("Image type:\t %s\n",im->itype);
	if(alpha)
	  printf("Image alpha:\t removed\n");
	else
	  printf("Image alpha:\t no\n");
	printf("Image dimens:\t %d\n", im->ndim);
	printf("Image channels:\t %d\n", im->numchannel);
	printf("Image alpha:\t %d\n", alpha);
	printf("Image hight:\t %d\n", im->dim[1]);
	printf("Image width:\t %d\n", im->dim[0]);
	if(im->ndim>2)
	   printf("Image depth:\t %d\n", im->dim[2]);
	printf("Image nbytes:\t %d\n", im->numbytes);
	printf("Image nbits:\t %d\n", im->numbits);
	printf("Image x-res:\t %lf\n", im->res[0]);
	printf("Image y-res:\t %lf\n", im->res[1]);
	if(im->ndim>2)
	   printf("Image z-res:\t %lf\n", im->res[2]);
	printf("****************************\n");
	//printf("\nlrang: %f    hrange: %f\n",lrange,hrange);
	//printf("\nmin: %f    max: %f\n",min,max);
	    
 return im;
}

image_cc *LoadImage_old(char *buf)
{
 	FILE *fp;
	long row; 
	TIFF *tif;
	char fname[255];
	unsigned char *pixbuf;
	image_cc *im;
	int i, alpha=0; 
	uint32 length, width;
	uint16 bits, samples;
	unsigned long offset;
int *k;
	
	im = (image_cc *)malloc(sizeof(image_cc));

	while(1){

	  sprintf(fname,"%s.btd",buf);
	  if((fp=fopen(fname,"r"))!=0){
	    sprintf(im->itype,"btd");
	    sprintf(im->name,"%s",fname);
	    im->ndim=3;
	    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
	    im->res=(double *)malloc(im->ndim*sizeof(double));
	    fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
		   &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	    im->pix=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->numbytes);
	    im->numchannel=1;
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<im->dim[0]*im->dim[1]*im->numbytes;i++) 
	      im->pix[i]=getc(fp);
	    fclose(fp);
	    break;
	  }
	  sprintf(fname,"%s.ddd",buf);
	  if((fp=fopen(fname,"r"))!=0){
	    sprintf(im->name,"%s",fname);
	    im->ndim=3;
	    im->numbytes=1;
	    im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
	    im->res=(double *)malloc(im->ndim*sizeof(double));
	    fscanf(fp,"%ld %d %d %d %d %lf %lf %lf",
		   &offset,&im->dim[0],&im->dim[1],&im->dim[2],&im->numbytes,&im->res[0],&im->res[1],&im->res[2]);
	    if(im->numbytes==2) 	sprintf(im->itype,"ddd16");
	    else 			sprintf(im->itype,"ddd");
	    im->pix=(unsigned char *)malloc(im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes);
	    im->numbytes=1;
	    im->numchannel=1;
	    fseek(fp,offset,SEEK_SET);
	    for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i++) 
	      im->pix[i]=getc(fp);
	    fclose(fp);
	    break;
	  }

	  while(1){
	    sprintf(fname,"%s",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.tif",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.TIF",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.tiff",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    sprintf(fname,"%s.TIFF",buf);
	    if((tif = TIFFOpen(fname, "r"))!=0) break;
	    printf("\nLoadImage: could not open %s\n",buf);
	    exit(0);
	  }
	  im->ndim=2;
	  im->dim=(unsigned int *)malloc(im->ndim*sizeof(unsigned int));
	  im->res=(double *)malloc(im->ndim*sizeof(double));
	  TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &length);
	  TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &width);
	  TIFFGetField(tif, TIFFTAG_SAMPLESPERPIXEL, &samples);
	  TIFFGetField(tif, TIFFTAG_BITSPERSAMPLE, &bits);
	  im->numchannel=samples;
	  im->dim[0]=width;
	  im->dim[1]=length;
	  im->numbits=bits;
	  sprintf(im->name,"%s",buf);
	  im->numbytes=im->numbits/8 + (im->numbits%8?1:0);
	  //printf("\nnbytes = %d\n",im->numbytes);
	  if(im->numchannel==3||im->numchannel==4){
	    alpha = im->numchannel-3;
	    sprintf(im->itype,"rgb");
	  }
	  else{
	    alpha = im->numchannel-1;
	    //im->numbytes=1;
	    if(im->numbytes==2)
		sprintf(im->itype,"gry16");
	    else
	    	sprintf(im->itype,"gry");
	  }
	  
	  pixbuf =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numchannel*im->numbytes);
	  im->pix =(unsigned char *)malloc(im->dim[1]*im->dim[0]*im->numbytes*(im->numchannel-alpha));
	  for (row = 0; row < im->dim[1]; row++)
	    TIFFReadScanline(tif, pixbuf+(row*im->dim[0]*im->numchannel*im->numbytes), row,0);	  
	  for(i=0;i<im->dim[0]*im->dim[1]*(im->numchannel-alpha)*im->numbytes;i++)
	    *(im->pix+i)=*(pixbuf+i+alpha*i/(im->numchannel-alpha));
	  im->numchannel-=alpha;
	  TIFFClose(tif);


	  break;
	    
	  printf("\nLoadImage: could not open %s\n",buf);
	  exit(0);
	}

	printf("****************************\n");
	printf("Image loaded:\n");
	printf("Image name:\t %s\n",im->name);
	printf("Image type:\t %s\n",im->itype);
	if(alpha)
	  printf("Image alpha:\t removed\n");
	else
	  printf("Image alpha:\t no\n");
	printf("Image dimens:\t %d\n", im->ndim);
	printf("Image channels:\t %d\n", im->numchannel);
	printf("Image alpha:\t %d\n", alpha);
	printf("Image hight:\t %d\n", im->dim[1]);
	printf("Image width:\t %d\n", im->dim[0]);
	if(im->ndim>2)
	   printf("Image depth:\t %d\n", im->dim[2]);
	printf("Image nbytes:\t %d\n", im->numbytes);
	printf("Image nbits:\t %d\n", im->numbits);
	printf("Image x-res:\t %lf\n", im->res[0]);
	printf("Image y-res:\t %lf\n", im->res[1]);
	if(im->ndim>2)
	   printf("Image z-res:\t %lf\n", im->res[2]);
	printf("****************************\n");
	    
 return im;
}

void StoreImage(image_cc *im, char *buf)
{
  long row;
  TIFF *tif;
  char fname[127];
  FILE *fp;
  unsigned long i;
  long offset=64;
 
  if(strncmp(im->itype,"gry",3)==0){
    sprintf(fname,"%s.tiff",buf);
    tif = TIFFOpen(fname, "w");
    TIFFSetField(tif, TIFFTAG_IMAGELENGTH, im->dim[1]);
    TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISBLACK);
    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, im->dim[0]);
    TIFFSetField(tif, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, im->numbits);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, im->numchannel);
    for (row = 0; row < im->dim[1]; row++)
      TIFFWriteScanline(tif, im->pix+(row*im->dim[0]*im->numbytes), row,2);
    TIFFClose(tif); 
  }
  else if(strcmp(im->itype,"rgb")==0){
    sprintf(fname,"%s.tiff",buf);
    tif = TIFFOpen(fname, "w");
    TIFFSetField(tif, TIFFTAG_IMAGELENGTH, im->dim[1]);
    TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, 2);
    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, im->dim[0]);
    TIFFSetField(tif, TIFFTAG_COMPRESSION, 1);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 8,8,8);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, im->numchannel);
    TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, 1);
    for (row = 0; row < im->dim[1]; row++)
      TIFFWriteScanline(tif, im->pix+(row*im->dim[0]*im->numchannel), row,2);
    TIFFClose(tif); 
  }
  else if(strncmp(im->itype,"ddd",3)==0){
    sprintf(fname,"%s.ddd",buf);
    fp=fopen(fname,"w");
    //im->numbytes = im->dim[2];
    fprintf(fp,"%ld %d %d %d %d %lf %lf %lf",
	    offset,im->dim[0],im->dim[1],im->dim[2],im->numbytes,im->res[0],im->res[1],im->res[2]);
    fseek(fp,offset,SEEK_SET);
    for(i=0;i<im->dim[0]*im->dim[1]*im->dim[2]*im->numbytes;i++) 
      putc(im->pix[i],fp);
    fclose(fp);
  }
  else if(strcmp(im->itype,"btd")==0){
    sprintf(fname,"%s.btd",buf);
    fp=fopen(fname,"w");
    fprintf(fp,"%ld %d %d %d %d %lf %lf %lf",
	    offset,im->dim[0],im->dim[1],im->dim[2],im->numbytes,im->res[0],im->res[1],im->res[2]);
    fseek(fp,offset,SEEK_SET);
    for(i=0;i<im->dim[0]*im->dim[1]*im->numbytes;i++) 
      putc(im->pix[i],fp);
    fclose(fp);
  }
  else{
    printf("\nStoreImage: Cannot identify file type\n\n");
    exit(0);
  }
    
  printf("****************************\n");
  printf("Image saved:\n");
  printf("Image name:\t %s\n",fname);
  printf("Image type:\t %s\n",im->itype);
  printf("Image channels:\t %d\n", im->numchannel);
  printf("Image hight:\t %d\n", im->dim[1]);
  printf("Image width:\t %d\n", im->dim[0]);
  if(im->ndim>2)
    printf("Image depth:\t %d\n", im->dim[2]);
  printf("Image nbytes:\t %d\n", im->numbytes);
  printf("Image nbits:\t %d\n", im->numbits);
  printf("Image x-res:\t %lf\n", im->res[0]);
  printf("Image y-res:\t %lf\n", im->res[1]);
  if(im->ndim>2)
    printf("Image z-res:\t %lf\n", im->res[2]);
  printf("****************************\n");

}

image_cc *CopyImage(image_cc *image)
{
	unsigned long j,buf=1;
	int *k;
	image_cc *copy;
	
	//k=(int *)malloc(5*sizeof(int));
	copy = (image_cc *)malloc(sizeof(image_cc));
	copy->ndim=image->ndim;

	copy->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
	copy->res=(double *)malloc(image->ndim*sizeof(double));	
	
	sprintf(copy->itype,"%s",image->itype);
	copy->numbits= image->numbits;
	for(j=0;j<image->ndim;j++){
		copy->dim[j]= image->dim[j];
		copy->res[j] = image->res[j];
		buf*=image->dim[j];
	}
	if(strcmp(image->itype,"btd")==0) buf/=image->dim[2];
	buf*=(image->numbytes*image->numchannel);
	copy->numchannel=image->numchannel; 
	copy->numbytes=image->numbytes;
	copy->pix=(unsigned char *)malloc(buf);
	for(j=0;j<buf;j++) 
		*(copy->pix+j) = *(image->pix+j);
	return copy;
}

image_cc *InitImage(int x, int y, int val)
{
	unsigned long j;
	image_cc *image;
	
	image = (image_cc *)malloc(sizeof(image_cc));
	image->ndim=2;
	image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
	image->res=(double *)malloc(image->ndim*sizeof(double));	
	sprintf(image->itype,"gry");
	image->numbits= 8;
	image->dim[0] = x;
	image->dim[1] = y;
	image->numbytes = 1;
	image->numchannel = 1;
	image->res[0] = 1.;
	image->res[1] = 1.;
	image->pix=(unsigned char *)malloc(image->numbytes*x*y);
	for(j=0;j<image->numbytes*x*y;j++) 
		*(image->pix+j) = (unsigned char)val;
	return image;
}

image_cc *InitImage(int x, int y, int z, int val)
{
	unsigned long j;
	image_cc *image;
	
	image = (image_cc *)malloc(sizeof(image_cc));
	image->ndim=3;
	image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
	image->res=(double *)malloc(image->ndim*sizeof(double));	
	sprintf(image->itype,"ddd");
	image->dim[2]= z;
	image->dim[0] = x;
	image->dim[1] = y;
	image->numbytes = 1;
	image->numchannel = 1;
	image->res[0] = 1.;
	image->res[1] = 1.;
	image->res[2] = 1.; 
	image->pix=(unsigned char *)malloc(image->numbytes*x*y);
	for(j=0;j<image->numbytes*x*y;j++) 
		*(image->pix+j) = (unsigned char)val;
	return image;
}

image_cc *InitImage(int x, int y, int val, char *type)
{
	unsigned long j;
	int i;
	image_cc *image;
	
	image = (image_cc *)malloc(sizeof(image_cc));
	image->ndim=2;
	image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
	image->res=(double *)malloc(image->ndim*sizeof(double));
	if(strncmp(type,"gry",3)==0){
	  image->numchannel = 1;
	  if(strcmp(type,"gry16")==0){
		  sprintf(image->itype,"gry16");
		  image->numbytes = 2;
		  image->numbits= 16;
	  }// U. Weller inserted gry32 2.08.07
	  else if(strcmp(type,"gry32")==0){
		  sprintf(image->itype,"gry32");
		  image->numbytes = 4;
		  image->numbits= 32;
	  }
	  else{
		  sprintf(image->itype,"gry");
		  image->numbits= 8;
		  image->numbytes = 1;
	  }
	}
	else if(strcmp(type,"doub")==0){
		  sprintf(image->itype,"doub");
		  image->numbytes = sizeof(double);
		  //image->numbytes = 8;
		  image->numbits= image->numbytes*8;
		  image->numchannel = 1;
	}
	else if(strcmp(type,"rgb")==0){
	  sprintf(image->itype,"rgb");
	  image->numbits= 8;
	  image->numbytes = 1;
	  image->numchannel = 3;
	}
	image->dim[0] = x;
	image->dim[1] = y;
	image->res[0] = 1.;
	image->res[1] = 1.;
	image->pix=(unsigned char *)malloc(image->numchannel*image->numbytes*x*y);
	for(j=0;j<image->numchannel*image->numbytes*x*y;j+=image->numbytes){ 
		point.p=image->pix+j;
		if(image->numbytes==1) 	*(point.p)=(unsigned char)val;
		else if(image->numbytes==2) 	*(point.q)=(unsigned short)val;
		else if(image->numbytes==sizeof(double)) *(point.d)=(double)val;
		else *(point.r)=val;
		//printf(" %d ", val);
	}


	//printf("\n");

			//*(image->pix+image->numbytes*(x+y*image->dim[0])) = (val&(255<<(i*8)))>>(i*8);
			//*(image->pix+image->numbytes*(x+y*image->dim[0])) = (unsigned char)*((&val)+i);
			//*(image->pix+j) = val;
	return image;
}
image_cc *InitImage(int x, int y, int z, int val, char *type)
{
	unsigned long j;
	image_cc *image;
	int zz;
	
	image = (image_cc *)malloc(sizeof(image_cc));
	image->ndim=3;
	image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
	image->res=(double *)malloc(image->ndim*sizeof(double));
	image->dim[0] = x;
	image->dim[1] = y;
	image->dim[2] = z;
	image->res[0] = 1.;
	image->res[1] = 1.;
	image->res[2] = 1.; 
	image->numchannel = 1;

	if(strncmp(type,"ddd",3)==0){ // U. Weller inserted ddd32 2.08.07
	
		if(strcmp(type,"ddd16")==0){
		  sprintf(image->itype,"ddd16");
		  image->numbytes=2;
		  image->pix=(unsigned char *)malloc(z*x*y*image->numbytes);
		  for(j=0; j<z*x*y*image->numbytes; j+=image->numbytes){ 
		  //for(j=0; j<z*x*y*image->numbytes; j++){ 
		  	//*(image->pix+j) = 0;
			point.p=image->pix+j;
		   	*(point.q) = val;
		   	//*(point.q) = 0;
		  }
		}else if(strcmp(type,"ddd32")==0){
		  sprintf(image->itype,"ddd32");
		  image->numbytes=4;
		  image->pix=(unsigned char *)malloc(z*x*y*image->numbytes);
		  for(j=0; j<z*x*y*image->numbytes; j+=image->numbytes){ 
			  //for(j=0; j<z*x*y*image->numbytes; j++){ 
		  	//*(image->pix+j) = 0;
			point.p=image->pix+j;
		   	*(point.r) = val;
	   	//*(point.q) = 0;
		  }
		}
		else{  sprintf(image->itype,"ddd");
	  		image->numbytes=1;
	  		image->pix=(unsigned char *)malloc(z*x*y);
	  		for(j=0;j<z*x*y;j++) 
	  			*(image->pix+j) = val;
		}
	}
	else if(strcmp(type,"doub3")==0){
		sprintf(image->itype,"doub3");
		//image->numbytes = sizeof(double);
		image->numbytes = 8;
		image->numbits= image->numbytes*8;
		image->pix=(unsigned char *)malloc(image->numbytes*x*y*z);
		for(j=0; j<z*x*y*image->numbytes; j+=image->numbytes){
			point.p=image->pix+j;
			*(point.d) = val;
		}
	}
	else if(strcmp(type,"btd")==0){
	  sprintf(image->itype,"btd");
	  image->numbytes = z%8? z/8+1 : z/8;
	  image->pix=(unsigned char *)malloc(x*y*image->numbytes);
	  for(j=0;j<x*y*image->numbytes;j++) 
	  	*(image->pix+j) = val?255:0;
	}
	return image;
} 
image_cc *InitImage_old(int x, int y, int z, int val, char *type)
{
	unsigned long j;
	image_cc *image;
	int zz;
	
	image = (image_cc *)malloc(sizeof(image_cc));
	image->ndim=3;
	image->dim=(unsigned int *)malloc(image->ndim*sizeof(unsigned int));
	image->res=(double *)malloc(image->ndim*sizeof(double));
	if(strcmp(type,"ddd")==0){
	  sprintf(image->itype,"ddd");
	  zz=image->dim[2]= z;
	  image->numbytes=1;
          image->numchannel = 1;
	}
	if(strcmp(type,"ddd16")==0){
	  sprintf(image->itype,"ddd16");
	  zz=image->dim[2]= z;
	  image->numbytes=2;
          image->numchannel = 1;
	}
	else if(strcmp(type,"btd")==0){
	  sprintf(image->itype,"btd");
	  zz=image->numbytes = z%8? z/8+1 : z/8;
	  image->dim[2]= z;
          image->numchannel = 1;

	}
	image->dim[0] = x;
	image->dim[1] = y;
	image->res[0] = 1.;
	image->res[1] = 1.;
	image->res[2] = 1.; 
	image->pix=(unsigned char *)malloc(zz*x*y*image->numbytes);
	for(j=0;j<zz*x*y*image->numbytes;j+=image->numbytes) 
	  *(image->pix+j) = val?255:0;
	return image;
}

void DeleteImage(image_cc *im)
{
  if(im->pix != 0)	free(im->pix);
  if(im != 0)     	free(im);
  im = 0;
}

image_cc *bit16to8(image_cc *im)
{
	unsigned long i,buf=1;
	unsigned char val;
	image_cc *outim;

	outim=CopyImage(im);
	free(outim->pix);
	outim->numbytes=1;
	outim->numbits=8;

	if(strcmp(im->itype,"gry16")==0)
		sprintf(outim->itype,"gry");
	else if(strcmp(im->itype,"ddd16")==0)
		sprintf(outim->itype,"ddd");
	else{
		printf("\n image %s is not of 16 bit type\n",im->name);
		exit(0);
	}
	for(i=0;i<im->ndim;i++)
		buf*=im->dim[i];
	buf*=im->numchannel;
	outim->pix=(unsigned char *)malloc(buf);
	for(i=0;i<buf;i++){
		point.p=im->pix+i*im->numbytes;
		*(outim->pix+i)= *(point.q)/256; 
	}
	return outim;
}

image_cc *gry16to8(image_cc *im)
{
	unsigned long i,buf=1;
	unsigned char val;
	image_cc *outim;

	outim=CopyImage(im);
	free(outim->pix);
	outim->numbytes=1;
	outim->numbits=8;

	if(strcmp(im->itype,"gry16")==0)
		sprintf(outim->itype,"gry");
	else if(strcmp(im->itype,"ddd16")==0)
		sprintf(outim->itype,"ddd");
	else{
		printf("\n image %s is not of 16 bit type\n",im->name);
		exit(0);
	}
	for(i=0;i<im->ndim;i++)
		buf*=im->dim[i];
	buf*=im->numchannel;
	outim->pix=(unsigned char *)malloc(buf);
	for(i=0;i<buf;i++){
		point.p=im->pix+i*im->numbytes;
		*(outim->pix+i)= *(point.q)/256; 
	}
	return outim;
}
image_cc *ddd16to8(image_cc *im)
{
	unsigned long i,buf=1;
	unsigned char val;
	image_cc *outim;

	outim=CopyImage(im);
	free(outim->pix);
	outim->numbytes=1;
	outim->numbits=8;

	for(i=0;i<im->ndim;i++)
		buf*=im->dim[i];
	buf*=im->numchannel;
	outim->pix=(unsigned char *)malloc(buf);
	for(i=0;i<buf;i++){
		point.p=im->pix+i*im->numbytes;
		*(outim->pix+i)= *(point.q)/256; 
	}
	return outim;
}

image_cc *Ddd2Btd(image_cc *im)
{
	int x,y,z;
	image_cc *outim;
	
	//outim = InitBtdImage(im->dim[0],im->dim[1],im->dim[2],im->res[0],im->res[1],im->res[2]);
	outim = InitImage(im->dim[0],im->dim[1],im->dim[2],0,"btd");
	outim->res[0]=im->res[0];
	outim->res[1]=im->res[1];
	outim->res[2]=im->res[2];

	for(z=0;z<im->dim[2];z++)
	for(y=0;y<im->dim[1];y++)
	for (x=0;x<im->dim[0];x++){
		if(rPixel(x,y,z,im))
		  wPixel(x,y,z,outim,1);
		else
		  wPixel(x,y,z,outim,0);
	}
	return outim;
}

image_cc *InitRandImage(int col,int row,double rx,double ry, double cx,double cy, int mode, double *cdf)
/*
mode:

0:	equal distribution without any correlation (cx,cy,cz and cdf have no meaning here)
1:	equal distribution with  gaussian correlation   
2:      predefined distribution (cdf) distribution and gaussian correlation   
3:	Gaussian correlation (cdf have no meaning here)
4:	Lorentz-Correlation model (cdf have no meaning here)
5:	Exponential-Correlation model (cdf have no meaning here)
6:	von Karman-Correlation model (cdf have no meaning here)
*/
{
  double *sfa, randnum,rval,min,max, *iscdf,sum, mean, sig;
	int x,y,z,val,i, N, n, model;
        image_cc *random;
	long idum, count=0;
	
	min=max=0;
	n=col>=row?col:row;
	for(i=1;i<11;i++)
	  if((N=int(pow(2,i)))>=n)
	    break;

	//printf("\nN= %d \n", N);
	//idum=IDUM;
	random=InitImage(col,row,255);
	random->res[0]=rx; random->res[1]=ry;
	
	/***** Generation of random field ****/
	iscdf=(double *)malloc(256*sizeof(double));
	for(i=0;i<256;i++)  iscdf[i]=0;

	sfa=(double *)malloc(N*N*sizeof(double));
	grf2(sfa,N,N,rx,ry,cx,cy,1.,N,mode>2?mode-3:0);
	sum=0;
	for(i=0;i<N*N;i++){
	  sum+=sfa[i];
	  if(sfa[i]<min) min=(sfa[i]);
	  if(sfa[i]>max) max=(sfa[i]);
	}
	mean=sum/(N*N);
	sum=0;
	for(i=0;i<N*N;i++)
	  sum+=(sfa[i]-mean)*(sfa[i]-mean);
	sig=sqrt(sum/(N*N));
	
	//max=3.5*sig;
	//min=-max;
	//printf("\nmin: %lf    max: %lf mean: %lf   sig: %lf \n",min,max,mean,sig);

	/*** calculate cdf of generated values ****/
	for(i=0;i<N*N;i++){
	     val =int((sfa[i]-min)/(max-min) * 255.999);
	     iscdf[val]++;
	     count++;
	}
        for(i=0;i<256;i++) iscdf[i]= (double)iscdf[i]/count;

	sum=iscdf[0];
	for(i=1;i<256;i++){
	     sum+=iscdf[i];
	     iscdf[i]+=iscdf[i-1];
	}
	for(i=0;i<256;i++)
	     iscdf[i]= iscdf[i]/sum;	
	iscdf[0]=0;
	/******************************************/

	for(y=0;y<random->dim[1];y++)
	for(x=0;x<random->dim[0];x++){

		switch(mode){
		case 0: 
			val=int(ran3(&IDUM) * 255.999); break;
		case 1: 	 
			val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
			 for(i=0;i<256;i++)
				if(iscdf[val]<= (double)i/256) break;
        		val = i>255?255:i; break;
		case 2:   
			val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
	     		for(i=0;i<256;i++)
				if(iscdf[val]<cdf[i])   break;
             		 val = i>255?255:i;  break; 
		default:  val =int((*(sfa+y*N+x)-min)/(max-min) * 255.999);
		}
	   	wPixel(x,y, random,val);
	}
	free(sfa);
return random;	
}
image_cc *InitRandImage(int col,int row,int dep,double rx,double ry, double rz,double cx,double cy, double cz, int mode, double *cdf)
{
	double ***sfa, randnum,rval,min,max, *iscdf,sum;
	int x,y,z,val,i, N;
        image_cc *ddd;
	long idum, count=0;
	
	N=col;
	min=max=0;
	idum=-1;
	ddd=InitImage(col,row,dep,255,"ddd");
	ddd->res[0]=rx; ddd->res[1]=ry;ddd->res[2]=rz;
	
	/***** Generation of random field ****/
	iscdf=(double *)malloc(256*sizeof(double));
	for(i=0;i<256;i++)
		iscdf[i]=0;

	sfa=(double ***)malloc(N*sizeof(double **));
	for(x=0;x<N;x++) {
	     sfa[x]=(double **)malloc(N*sizeof(double *));
	     for(y=0;y<N;y++)
	         sfa[x][y]=(double *)malloc(N*sizeof(double));
	}
	if(mode){
	   if(mode<4)	grf3(sfa,rx,ry,rz,cx,cy,cz,1,N,0);
	   else    	grf3(sfa,rx,ry,rz,cx,cy,cz,1,N,mode-3);
	   for(z=0;z<ddd->dim[2];z++)
	   for(y=0;y<ddd->dim[1];y++)
	   for(x=0;x<ddd->dim[0];x++){
		 if(sfa[x][y][z]<min) min=(sfa[x][y][z]);
		 if(sfa[x][y][z]>max) max=(sfa[x][y][z]);
	   }
	   printf("\nmin: %lf    max: %lf \n",min,max);

	   /*** calculate cdf of generated values ****/
	   for(z=0;z<ddd->dim[2];z++)
	   for(y=0;y<ddd->dim[1];y++)
	   for(x=0;x<ddd->dim[0];x++){
	     val =int((sfa[x][y][z]-min)/(max-min) * 255);
	     iscdf[val]++;
	     count++;
	   }
	   for(i=0;i<256;i++)
		iscdf[i]= (double) iscdf[i]/count;

	   sum=iscdf[0];
	   for(i=1;i<256;i++){
		sum+=iscdf[i];
		iscdf[i]+=iscdf[i-1];
	   }
	   for(i=0;i<256;i++)
		iscdf[i]= iscdf[i]/sum;	
	   iscdf[0]=0;
	}

	for(z=0;z<ddd->dim[2];z++)
	for(y=0;y<ddd->dim[1];y++)
	for(x=0;x<ddd->dim[0];x++){
	   if(mode==0)             val=int(ran3(&idum) * 255);

	   if(mode==1){
	     val =int((sfa[x][y][z]-min)/(max-min) * 255);
	     for(i=0;i<256;i++)
		if(iscdf[val]< (double)i/256) 
		  break;
             val = i>255?255:i;  
	   }
	   if(mode==2){                          //predefined cdf 
	     val =int((sfa[x][y][z]-min)/(max-min) * 255);
	     for(i=0;i<256;i++)
		if(iscdf[val]<cdf[i]) 
		  break;
             val = i>255?255:i;  
	   }

	   if(mode>2) 
	     val =int((sfa[x][y][z]-min)/(max-min) * 255);

	   wPixel(x,y,z, ddd,val);
	}
	for(x=0;x<N;x++) for(y=0;y<N;y++) free(sfa[x][y]);
	for(x=0;x<N;x++) free(sfa[x]);
	free(sfa);
return ddd;	
}
