/*---------------------------------------------------------------------
VERSION 3.1,COPYRIGHT 2005 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"
#include "string.h"
#include <vector>
#include <algorithm>
#include <math.h>



using namespace std;
/* changes 31.07.08 U.Weller

cleaned up g2MinMax, g3MinMax. More readable, eliminated errors.

In Luul and Ullu: replaced the middle step with double size by two steps single size.
1) Is much faster
2) Is supposed to invert exactly the two other steps, which is not true for double radius.
*/

void Median(image_cc *image, int mode) 
{
  int x,y,z,j,k,mode3,xx,yy,zz,ddd=0, count;
  unsigned char *strucel; 
  image_cc *imbuf; 
  int rgb[3];
  
  if(strcmp(image->itype,"ddd")==0) ddd=1;	
  
  k=mode;
  mode=2*mode+1;
  mode3=ddd?mode:1;
  vector<int>win(mode*mode*mode3);
  
  imbuf = CopyImage(image);
  
  if(strncmp(image->itype,"gry",3)==0){
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	count=0;
	for(j=0;j<mode*mode;j++){
	  xx=x-k+j%mode;
	  yy=y-k+j/mode;
	  if(!isborder(xx,yy,image)){
	    win[j]=rPixel(xx,yy,image);
	    count++;
	  }
	  else
	    win[j]=255;
	}
	//if(x==image->dim[0]/2 && y==image->dim[1]/2){
 //if(!x && !y){
 //  for(j=0;j<mode*mode;j++)
 //    printf("\n%d",win[j]);
 //}
 sort(win.begin(),win.end());
 wPixel(x,y, imbuf,win[count/2]);
 //if(x==image->dim[0]/2 && y==image->dim[1]/2){
 //if(!x && !y){
 //  printf("\nsoted:");
 //  for(j=0;j<mode*mode;j++)
 //    printf("\n%d",win[j]);
 //  printf("\n\n%d\n",win[count/2]);
 //}
 
      }					
  }
  else if(strcmp(image->itype,"rgb")==0){
    vector<unsigned char>red(mode*mode);
    vector<unsigned char>green(mode*mode);
    vector<unsigned char>blue(mode*mode);
    
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	count=0;
	for(j=0;j<mode*mode;j++){
	  xx=x-k+j%mode;
	  yy=y-k+j/mode;
	  if(!isborder(xx,yy,image)){
	    rPixel(xx,yy,image,rgb);
	    red[j]=rgb[0]; green[j]=rgb[1]; blue[j]=rgb[2];
	    count++;
	  }
	  else
	    red[j]=green[j]=blue[j]=255;
	}
	sort(red.begin(),red.end());
	sort(green.begin(),green.end());
	sort(blue.begin(),blue.end());
	rgb[0]=  red[count/2];
	rgb[1]=green[count/2];
	rgb[2]= blue[count/2];
	wPixel(x,y, imbuf,rgb);
      }
  }
  else if(strcmp(image->itype,"ddd")==0){  	
    for(z=0;z<image->dim[2];z++)
      for(y=0;y<image->dim[1];y++)
	for (x=0;x<image->dim[0];x++){
	  count=0;
	  for(j=0;j<mode*mode*mode3;j++){
	    xx=x-k+j%mode;
	    //yy=y-k+j/mode;
	    yy=y-k+(j%(mode*mode))/mode;
	    zz=z-k+j/(mode*mode);
	    if(!isborder(xx,yy,zz,image)){
	      win[j]=rPixel(xx,yy,zz,image);
	      count++;
	    }
	    else
	      win[j]=255;
	  }
	  sort(win.begin(),win.end());
	  wPixel(x,y,z,imbuf,win[count/2]);
	}
  }
  else
    printf("\nMedian: Only valid for grey scale and rgb images\n");
  
  
  for(j=0;j<image->dim[0]*image->dim[1]*image->numchannel*image->numbytes;j++)
    *(image->pix+j)=*(imbuf->pix+j);  
  DeleteImage(imbuf);
}

void Mean(image_cc *image, int mode) 
{
  int x,y,z,i,j,k,xx,yy,zz,cum, count;
  image_cc imagebuffer, *imbuf; 
  int crgb[3],rgb[3],is3d=1;
  
  //rgb=(unsigned char *)malloc(3*sizeof(unsigned char));
  k=mode;
  mode=2*mode+1;
  
  imbuf = CopyImage(image);
  
  if(strncmp(image->itype,"gry",3)==0){  	
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	cum=count=0;
	for(j=0;j<mode*mode;j++){
	  xx=x-k+j%mode;
	  yy=y-k+j/mode;
	  if(!isborder(xx,yy,image)){
	    cum+=rPixel(xx,yy,image);
	    count++;
	  }
	}
	cum/=count;
	wPixel(x,y,imbuf,cum);
      }
  }
  else if(strcmp(image->itype,"rgb")==0){
    printf("\nhere we go\n");
    
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	for(i=0;i<3;i++) crgb[i]=0;
	count=0;
	for(j=0;j<mode*mode;j++){
	  xx=x-k+j%mode;
	  yy=y-k+j/mode;
	  if(!isborder(xx,yy,image)){
	    rPixel(xx,yy,image,rgb);
	    for(i=0;i<3;i++) crgb[i]+=rgb[i];
	    count++;
	  }
	}
	for(i=0;i<3;i++) rgb[i]=crgb[i]/count;
	wPixel(x,y,imbuf,rgb);
      }
  }
  else if(strncmp(image->itype,"ddd", 3)==0){
    is3d=image->dim[2];
    for(z=0;z<image->dim[2];z++)
      for(y=0;y<image->dim[1];y++)
	for (x=0;x<image->dim[0];x++){
	  cum=count=0;
	  for(j=0;j<mode*mode*mode;j++){
	    xx=x-k+j%mode;
	    //yy=y-k+j/mode;
	    yy=y-k+(j%(mode*mode))/mode;
	    zz=z-k+j/(mode*mode);
	    if(!isborder(xx,yy,zz,image)){
	      cum+=rPixel(xx,yy,zz,image);
	      count++;
	    }
	  }
	  cum/=count;
	  wPixel(x,y,z,imbuf,cum);
	}
  }
  else
    printf("\niMean: Only valid for grey scale and rgb images\n");
  
  for(j=0;j<image->dim[0]*image->dim[1]*is3d*image->numchannel*image->numbytes;j++)
    *(image->pix+j)=*(imbuf->pix+j);  
  DeleteImage(imbuf);
  
  //free(image->pix);
  //image->pix=imbuf->pix;
}

image_cc *MeanVar(image_cc *image, int mode) 
//still need to be tested for 3D images
{
  int x,y,z,i,j,k,xx,yy,zz,cum, count;
  image_cc *imbuf, *var, *sig; 
  int crgb[3],rgb[3],is3d=1, pval ;
  double dcum, max, dval;	
  
  if(image->ndim==3){
    sig=InitImage(image->dim[0],image->dim[1],image->dim[2],0,"doub3");	
    var=InitImage(image->dim[0],image->dim[1],image->dim[2],0,"ddd");
  }
  else{
    sig=InitImage(image->dim[0],image->dim[1],0,"doub");
    var=InitImage(image->dim[0],image->dim[1],0,"gry");	
  }	
  k=mode;
  mode=2*mode+1;
  
  imbuf = CopyImage(image);
  
  if(strncmp(image->itype,"gry",3)==0){  	
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	cum=count=0;
	for(j=0;j<mode*mode;j++){
	  xx=x-k+j%mode;
	  yy=y-k+j/mode;
	  if(!isborder(xx,yy,image)){
	    cum+=rPixel(xx,yy,image);
	    count++;
	  }
	}
	cum/=count;
	wPixel(x,y,imbuf,cum);
	
	dcum=0;
	for(j=0;j<mode*mode;j++){
	  xx=x-k+j%mode;
	  yy=y-k+j/mode;
	  if(!isborder(xx,yy,image)){
	    dcum+=(rPixel(xx,yy,image)-cum)*(rPixel(xx,yy,image)-cum);
	  }
	}
	
	dcum/=double(count);
	if(dcum>max) max=dcum;
	wPixel(x,y,sig,dcum);  
      }
      
      for(y=0;y<image->dim[1];y++)
	for (x=0;x<image->dim[0];x++){
	  dval=rPIxel(x,y,sig)/max*255.;
	  wPixel(x,y, var,(unsigned char)dval);
	}
  }
  else if(strncmp(image->itype,"ddd",3)==0){
    is3d=image->dim[2];	
    for(z=0;z<image->dim[2];z++)
      for(y=0;y<image->dim[1];y++)
	for (x=0;x<image->dim[0];x++){
	  cum=count=0;
	  for(j=0;j<mode*mode*mode;j++){
	    xx=x-k+j%mode;
	    yy=y-k+j/mode;
	    zz=z-k+j/(mode*mode);
	    if(!isborder(xx,yy,zz,image)){
	      cum+=rPixel(xx,yy,zz,image);
	      count++;
	    }
	  }
	  cum/=count;
	  wPixel(x,y,z,imbuf,cum);
	  
	  dcum=0;
	  for(j=0;j<mode*mode*mode;j++){
	    xx=x-k+j%mode;
	    yy=y-k+j/mode;
	    zz=z-k+j/(mode*mode);
	    if(!isborder(xx,yy,zz,image)){
	      dcum+=(rPixel(xx,yy,zz,image)-cum)*(rPixel(xx,yy,zz,image)-cum);
	    }
	  }
	  
	  dcum/=double(count);
	  if(dcum>max) max=dcum;
	  wPixel(x,y,z,sig,dcum);  
	}
	for(z=0;z<image->dim[2];z++)
	  for(y=0;y<image->dim[1];y++)
	    for (x=0;x<image->dim[0];x++)
	      wPixel(x,y,z,var,(unsigned char)(rPIxel(x,y,z,sig)/max*255));
	    
  }
  else
    printf("\niMeanVar: Only valid for grey scale images\n");
  
  for(j=0;j<image->dim[0]*image->dim[1]*is3d*image->numchannel*image->numbytes;j++)
    *(image->pix+j)=*(imbuf->pix+j);  
  DeleteImage(imbuf);
  
  return var;
}

void Gauss(image_cc *image, int mode,double sigma)
{        
  double  xx,yy,zz,k,val1,Sm=0, drgb[3];
  double *val;
  image_cc *imbuf; 
  int rgb[3];
  int x,y,z,x1,y1,z1,x2,y2,z2,I,i,s,j;
  
  imbuf = CopyImage(image);
  s=2*mode+1;
  
  if(strcmp(image->itype,"btd")==0){
    printf("\nGauss: Only valid for grey scale and rgb images\n");
    exit(0);
  }
  if(strcmp(image->itype,"ddd")==0 || strcmp(image->itype,"ddd16")==0){
    val=(double *)malloc(s*s*s*sizeof(double));
    k= 1.0/sqrt(2.0 * M_PI * sigma*sigma);
    for(z=-mode;z<=mode;z++){
      zz=z*z;
      for(y=-mode;y<=mode;y++){	      	 
	yy=y*y; 
	for(x=-mode;x<=mode;x++){  	   		    
	  xx=x*x;             
	  *(val+(mode+x)+s*(mode+y)+s*s*(mode+z))= 
	  k * exp(-(xx+yy+zz)/(2.0* sigma*sigma));
	  Sm+=*(val+(mode+x)+s*(mode+y)+s*s*(mode+z));
	}
      }
    }
    for(i=0;i<s*s*s;i++)
      *(val+i)*=1./Sm;
  }
  else{
    image->dim[2]=1;
    val=(double *)malloc(s*s*sizeof(double));
    for(y=-mode;y<=mode;y++){	      	 
      yy=y*y; 
      for(x=-mode;x<=mode;x++){  	   		    
	xx=x*x;             
	k= 1.0/sqrt(2.0 * M_PI * sigma*sigma);
	//val[mode+x][mode+y]= k * exp(-(xx+yy)/(2.0* sigma*sigma));
	*(val+(mode+x)+s*(mode+y))= k * exp(-(xx+yy)/(2.0* sigma*sigma));
	Sm+=*(val+(mode+x)+s*(mode+y));
      }
    }
    for(i=0;i<s*s;i++)
      *(val+i)*=1./Sm;
  }
  
  if(strncmp(image->itype,"gry",3)==0 || strncmp(image->itype,"gry16",3)==0){  	
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	Sm=0;
	for(y1=y-mode;y1<=y+mode;y1++)
	  for(x1=x-mode;x1<=x+mode;x1++){ 
	    val1=*(val+(mode+x1-x)+s*(mode+y1-y));
	    
	    x2=x1; y2=y1;
	    if(y1<0) y2=y1+mode;
	    if(x1<0) x2=x1+mode;
	    if(y1>=signed(image->dim[1])) y2=y1-mode; //Steffen: 26.11.2012
	    if(x1>=signed(image->dim[0])) x2=x1-mode; //Steffen: 26.11.2012
	    
	    I=rPixel(x2,y2,image);
	    
	    Sm+=I*val1;
	  }
	  wPixel(x,y,imbuf,int(Sm));
      }
  }
  else if(strcmp(image->itype,"rgb")==0){
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	for(i=0;i<3;i++)drgb[i]=0;
	
	for(y1=y-mode;y1<=y+mode;y1++)
	  for(x1=x-mode;x1<=x+mode;x1++){ 
	    val1=*(val+(mode+x1-x)+s*(mode+y1-y));
	    
	    x2=x1; y2=y1;
	    if(y1<0) y2=y1+mode;
	    if(x1<0) x2=x1+mode;
	    if(y1>= signed(image->dim[1])) y2=y1-mode; //Steffen: 26.11.2012
	    if(x1>=signed(image->dim[0])) x2=x1-mode; //Steffen: 26.11.2012
	    rPixel(x2,y2,image,rgb);
	    
	    for(i=0;i<3;i++)
	      drgb[i]+=double(rgb[i])*val1;
	  }
	  for(i=0;i<3;i++)
	    rgb[i]=int(drgb[i]);
	  wPixel(x,y,imbuf,rgb);
      }
  }
  else if(strcmp(image->itype,"ddd")==0 || strcmp(image->itype,"ddd16")==0){  	
    for(z=0;z<image->dim[2];z++)
      for(y=0;y<image->dim[1];y++)
	for(x=0;x<image->dim[0];x++){
	  Sm=0;
	  for(z1=z-mode;z1<=z+mode;z1++)
	    for(y1=y-mode;y1<=y+mode;y1++)
	      for(x1=x-mode;x1<=x+mode;x1++){ 
		val1=*(val+(mode+x1-x)+s*(mode+y1-y)+s*s*(mode+z1-z));
		z2=z1; x2=x1; y2=y1;
		if(z1<0) z2=z1+mode;
		if(y1<0) y2=y1+mode;
		if(x1<0) x2=x1+mode;
		if(z1>=signed(image->dim[2])) z2=z1-mode; //Steffen: 26.11.2012
		if(y1>=signed(image->dim[1])) y2=y1-mode; //Steffen: 26.11.2012
		if(x1>=signed(image->dim[0])) x2=x1-mode; //Steffen: 26.11.2012
		
		I=rPixel(x2,y2,z2,image);
		
		Sm+=I*val1;
	      }
	      wPixel(x,y,z,imbuf,int(Sm));
	      
	}
  }
  
  for(j=0;j<image->dim[0]*image->dim[1]*image->dim[2]*image->numchannel*image->numbytes;j++)
    *(image->pix+j)=*(imbuf->pix+j);  
  DeleteImage(imbuf);
  
  //free(image->pix);
  //image->pix=imbuf->pix;
}

void MinMax(image_cc *im, double size, int mode)
{
  if(im->ndim==2)
    g2MinMax(im, size, mode);
  else if(im->ndim==3)
    g3MinMax(im, size, mode);
  else
    printf("Error: %d-D not yet implemented", im->ndim);
}

void Luul(image_cc *im, double size)
{
  MinMax(im, size, 0);
  MinMax(im, size, 1);
  MinMax(im, size, 1);
  MinMax(im, size, 0);
}

void Ullu(image_cc *im, double size)
{
  MinMax(im, size, 1);
  MinMax(im, size, 0);
  MinMax(im, size, 0);
  MinMax(im, size, 1);
}

/* 2d Grey value min (or max) filter. Size gives radius in image units. Mode = 
0 is minimum filter, all other max
*/
#define min(a,b) a>b?b:a
#define max(a,b) a>b?a:b

void g2MinMax(image_cc *im, double size, int mode)
{
  unsigned short *matrix;
  int *steps, i, x, y, xrad, yrad, xstep, ystep,totsize,a,b;
  double rxsq, rysq, sizesq;
  totsize =im->dim[0]*im->dim[1];
  matrix = (unsigned short *)malloc(totsize*sizeof(int));
  sizesq=size*size;
  for(x=0;x<totsize;x++)
    matrix[x]=mode?0:65535;
  xrad= (int)(size/im->res[0]);
  yrad= (int)(size/im->res[1]);
  rxsq=im->res[0]*im->res[0];
  rysq=im->res[1]*im->res[1];
  for(xstep=0;xstep<=xrad;xstep++){
    for(ystep=0;ystep<=yrad;ystep++){
      if(xstep*xstep*rxsq+ystep*ystep*rysq<=sizesq){
	for(x=0;x<im->dim[0]-xstep;x++){
	  for(y=0;y<im->dim[1]-ystep;y++){
	    if(mode){
	      a=matrix[y*im->dim[0]+x];
	      b=rPixel(x+xstep,y+ystep, im);
	      matrix[y*im->dim[0]+x]=max(a,b);
	      a=matrix[y*im->dim[0]+x+xstep];
	      b=rPixel(x,y+ystep, im);
	      matrix[y*im->dim[0]+x+xstep]=max(a,b);
	      a=matrix[(y+ystep)*im->dim[0]+x];
	      b=rPixel(x+xstep,y, im);
	      matrix[(y+ystep)*im->dim[0]+x]=max(a,b);
	      a=matrix[(y+ystep)*im->dim[0]+x+xstep];
	      b=rPixel(x,y, im);
	      matrix[(y+ystep)*im->dim[0]+x+xstep]=max(a,b);
	    }
	    else{
	      a=matrix[y*im->dim[0]+x];
	      b=rPixel(x+xstep,y+ystep, im);
	      matrix[y*im->dim[0]+x]=min(a,b);
	      a=matrix[y*im->dim[0]+x+xstep];
	      b=rPixel(x,y+ystep, im);
	      matrix[y*im->dim[0]+x+xstep]=min(a,b);
	      a=matrix[(y+ystep)*im->dim[0]+x];
	      b=rPixel(x+xstep,y, im);
	      matrix[(y+ystep)*im->dim[0]+x]=min(a,b);
	      a=matrix[(y+ystep)*im->dim[0]+x+xstep];
	      b=rPixel(x,y, im);
	      matrix[(y+ystep)*im->dim[0]+x+xstep]=min(a,b);
	    }
	  }
	}
      }
    }
  }
  for(x=0;x<im->dim[0];x++)
    for(y=0;y<im->dim[1];y++)
      wPixel(x,y, im, matrix[y*im->dim[0]+x]);
    
    
    
    free(matrix);
}



/* 3d Grey value min (or max) filter. Size gives radius in image units. Mode = 
0 is minimum filter, all other max
*/

void g3MinMax(image_cc *im, double size, int mode)
{
  unsigned short *matrix, a, b;
  int *steps, i, x, y, z, xrad, yrad, zrad, xstep, ystep, zstep, totsize,zsize, ysize,xtop;
  double rxsq, rysq, rzsq, sizesq;
  totsize =im->dim[0]*im->dim[1]*im->dim[2];
  matrix = (unsigned short *)malloc(totsize*sizeof(int));
  sizesq=size*size;
  for(x=0;x<totsize;x++)
    matrix[x]=mode?0:65535;
  xrad= (int)(ceil(size/im->res[0]))+1;
  yrad= (int)(ceil(size/im->res[1]))+1;
  zrad= (int)(ceil(size/im->res[2]))+1;
  rxsq=im->res[0]*im->res[0];
  rysq=im->res[1]*im->res[1];
  rzsq=im->res[2]*im->res[2];
  zsize = im->dim[1]*im->dim[0];
  ysize = im->dim[0];
  for(xstep=0;xstep<xrad;xstep++){//eigth bowl structuring element, surrounding cube
    for(ystep=0;ystep<yrad;ystep++){
      for(zstep=0;zstep<zrad;zstep++){
        if(xstep*xstep*rxsq+ystep*ystep*rysq+zstep*zstep*rzsq<=sizesq){// if distance is smaller than radius
	  xtop=im->dim[0]-xstep;
          #pragma omp parallel for shared(xstep,ystep,zstep, im, matrix, xtop, xrad), private(x,y,z,a,b), default(shared)
	  for(x=0;x<xtop;x++){//go through image, don't go over borders
            if((x/xrad)&&1){//avoid overlaps in parallel code
	      for(y=0;y<im->dim[1]-ystep;y++){
		for(z=0;z<im->dim[2]-zstep;z++){
		  if(mode){//for each eigth bowl, look for max(min). Looking back is done from forward voxel to backward (for not going over borders).
		    a=matrix[z*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z+zstep, im);
		    matrix[z*zsize +y*ysize+x]= max(a,b);
		    a=matrix[z*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z+zstep, im);
		    matrix[z*zsize+y*ysize+x+xstep]=max(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x]=max(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x+xstep]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x+xstep]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x+xstep]=max(a,b); 
		  }
		  else{
		    a=matrix[z*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z+zstep, im);
		    matrix[z*zsize +y*ysize+x]= min(a,b);
		    a=matrix[z*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z+zstep, im);
		    matrix[z*zsize+y*ysize+x+xstep]=min(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x]=min(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x+xstep]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x+xstep]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x+xstep]=min(a,b); 
		  }
		}
	      }
            }
	  }
          #pragma omp parallel for shared(xstep,ystep,zstep, im, matrix), private(x,y,z,a,b), default(shared)
	  for(x=0;x<xtop;x++){//go through image, don't go over borders
	    if(!((x/xrad)&&1)){//avoid overlaps in parallel code
	      for(y=0;y<im->dim[1]-ystep;y++){
		for(z=0;z<im->dim[2]-zstep;z++){
		  if(mode){//for each eigth bowl, look for max(min). Looking back is done from forward voxel to backward (for not going over borders).
		    a=matrix[z*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z+zstep, im);
		    matrix[z*zsize +y*ysize+x]= max(a,b);
		    a=matrix[z*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z+zstep, im);
		    matrix[z*zsize+y*ysize+x+xstep]=max(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x]=max(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x+xstep]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x+xstep]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x]=max(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x+xstep]=max(a,b); 
		  }
		  else{
		    a=matrix[z*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z+zstep, im);
		    matrix[z*zsize +y*ysize+x]= min(a,b);
		    a=matrix[z*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z+zstep, im);
		    matrix[z*zsize+y*ysize+x+xstep]=min(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x]=min(a,b); 
		    a=matrix[z*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z+zstep, im);
		    matrix[z*zsize+(y+ystep)*ysize+x+xstep]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x];
		    b=rPixel(x+xstep,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +y*ysize+x+xstep];
		    b=rPixel(x,y+ystep, z, im);
		    matrix[(z+zstep)*zsize+y*ysize+x+xstep]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x];
		    b=rPixel(x+xstep,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x]=min(a,b); 
		    a=matrix[(z+zstep)*zsize +(y+ystep)*ysize+x+xstep];
		    b=rPixel(x,y, z, im);
		    matrix[(z+zstep)*zsize+(y+ystep)*ysize+x+xstep]=min(a,b); 
		  }
		}
	      }
	    }
	  }
	}
      }
    }
}
if(strncmp(im->itype,"ddd",3)==0){
  if(im->numbytes==2){
    unsigned short *ipointer = (unsigned short*)im->pix;
    y=zsize*im->dim[2];
    for(x=0;x<y;x++,ipointer++)
      *ipointer = *(matrix+x);
  }else{
    unsigned char *ipointer = (unsigned char*)im->pix;
    y=zsize*im->dim[2];
    for(x=0;x<y;x++,ipointer++)
      *ipointer = *(matrix+x);
  }
}else{
  for(x=0;x<ysize;x++)
    for(y=0;y<im->dim[1];y++)
      for(z=0;z<im->dim[2];z++)
	wPixel(x,y, z, im, matrix[z*zsize + y*ysize + x]);
}			


free(matrix);
}


int isborder(int x, int y, image_cc *im)
{
  if(x<0 || x>=im->dim[0] || y<0 || y>=im->dim[1])
    return 1;
  else
    return 0;
}
int isborder(int x, int y, int z, image_cc *im)
{
  if(x<0 || x>=im->dim[0] || y<0 || y>=im->dim[1]|| z<0 || z>=im->dim[2])
    return 1;
  else
    return 0;
}


void wMean_f( image_cc *im, double size)
{
  
  double sizesq=size*size;
  size/=im->res[0];
  int count =0;
  double rxsq = im->res[0]*im->res[0];
  double rysq = im->res[1]*im->res[1];
  if(im->ndim ==3){
      double rzsq = im->res[2]*im->res[2];

      double *matrix = (double*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(double));
      if(matrix){
          for(int i = 0; i < im->dim[0]*im->dim[1]*im->dim[2];i++)
              matrix[i] =0;
          int ycur, xcur, zcur,yint;
#pragma omp parallel for shared(im, matrix, rxsq,rysq,rzsq,sizesq,count), private(ycur, xcur, zcur), default(shared)
          for(yint=(int)-ceil(size);yint<=(int)size;yint++){//go through structuring element
              double yy = yint;
              for(double zz=-ceil(size);zz<=size;zz++){
                  for(double xx=-ceil(size);xx<=size;xx++){
                      if((yy*yy*rysq + xx*xx *rxsq+ zz*zz*rzsq)<=sizesq){//it's in the element
#pragma omp atomic
                          count++;
                          for(int z = 0; z<im->dim[2];z++){
                              zcur=z+zz>0?z+zz<im->dim[2]?z+zz:im->dim[2]-(z+zz-im->dim[2]+1):-(z+zz);


                          for(int y= 0;y<im->dim[1];y++){
                              ycur=y+yy>0?y+yy<im->dim[1]?y+yy:im->dim[1]-(y+yy-im->dim[1]+1):-(y+yy);
                              for(int x= 0;x<im->dim[0];x++){
                                  xcur=x+xx>0?x+xx<im->dim[0]?x+xx:im->dim[0]-(x+xx-im->dim[0]+1):-(x+xx);
                                  matrix[(z*im->dim[1]+y)*im->dim[0] + x] += rPIxel(xcur, ycur, zcur, im);
                              }
                          }
                      }
                      }
                  }

              }

          }


          for(int i = 0; i < im->dim[0]*im->dim[1]*im->dim[2];i++)
              wPIxel(i, im, matrix[i]/(double)count);
      }
      free(matrix);
  }else{
      double *matrix = (double*)malloc(im->dim[0]*im->dim[1]*sizeof(double));
      if(matrix){
          for(int i = 0; i < im->dim[0]*im->dim[1];i++)
              matrix[i] =0;
          int ycur, xcur;
          for(double yy=-ceil(size);yy<=size;yy++){//go through structuring element
              for(double xx=-ceil(size);xx<=size;xx++){
                  if((yy*yy*rysq + xx*xx *rxsq)<=sizesq){//it's in the element

                      count++;
                      for(int y= 0;y<im->dim[1];y++){
                          ycur=y+yy>0?y+yy<im->dim[1]?y+yy:im->dim[1]-(y+yy-im->dim[1]+1):-(y+yy);
                          for(int x= 0;x<im->dim[0];x++){
                              xcur=x+xx>0?x+xx<im->dim[0]?x+xx:im->dim[0]-(x+xx-im->dim[0]+1):-(x+xx);
                              matrix[y*im->dim[0] + x] += rPIxel(xcur, ycur, im);
                          }
                      }
                  }

              }

          }


          for(int i = 0; i < im->dim[0]*im->dim[1];i++)
              wPIxel(i, im, matrix[i]/(double)count);
      }
      free(matrix);
  }
}
void wGauss_f( image_cc *im, double size, double sigma)
{
    double weight;
    double sizesq=size*size;
    size/=im->res[0];
    sigma/=im->res[0];
    sigma*=sigma;
    double count =0;
    double rxsq = im->res[0]*im->res[0];
    double rysq = im->res[1]*im->res[1];
    if(im->ndim==3){//3d
        double rzsq = im->res[2]*im->res[2];
        double *matrix = (double*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(double));
        if(matrix){
            for(int i = 0; i < im->dim[0]*im->dim[1]*im->dim[2];i++)
                matrix[i] =0;
            int zcur, ycur, xcur;
            int zz, tsize = ceil(size);
#pragma omp parallel for shared(im, matrix, rxsq,rysq,rzsq,sigma,sizesq), private(weight,xcur,zcur, ycur), default(shared)
            for(zz=-tsize;zz<=tsize;zz++){//go through structuring element
                for(double yy=-ceil(size);yy<=size;yy++){
                    for(double xx=-ceil(size);xx<=size;xx++){
                        weight =(zz*zz*rzsq + yy*yy*rysq + xx*xx *rxsq);
                        if(weight<=sizesq){//it's in the element
                            weight = exp(-weight/sigma);
#pragma omp atomic
                            count+= weight;
                            for(int z= 0;z<im->dim[2];z++){
                                zcur=z+zz>0?z+zz<im->dim[2]?z+zz:im->dim[2]-(z+zz-im->dim[2]+1):-(z+zz);


                                for(int y= 0;y<im->dim[1];y++){
                                    ycur=y+yy>0?y+yy<im->dim[1]?y+yy:im->dim[1]-(y+yy-im->dim[1]+1):-(y+yy);
                                    for(int x= 0;x<im->dim[0];x++){
                                        xcur=x+xx>0?x+xx<im->dim[0]?x+xx:im->dim[0]-(x+xx-im->dim[0]+1):-(x+xx);
                                        matrix[z*im->dim[0]*im->dim[1] + y*im->dim[0] + x] += rPIxel(xcur, ycur, zcur, im)*weight;
                                    }
                                }
                            }
                        }

                    }

                }
            }


            for(int i = 0; i < im->dim[0]*im->dim[1]*im->dim[2];i++)
                wPIxel(i, im, matrix[i]/count);
        }
        free(matrix);
    }else{//2D
        double *matrix = (double*)malloc(im->dim[0]*im->dim[1]*sizeof(double));
        if(matrix){
            for(int i = 0; i < im->dim[0]*im->dim[1];i++)
                matrix[i] =0;
            int ycur, xcur;
            for(double yy=-ceil(size);yy<=size;yy++){//go through structuring element
                for(double xx=-ceil(size);xx<=size;xx++){
                    weight =(yy*yy*rysq + xx*xx *rxsq);
                    if(weight<=sizesq){//it's in the element
                        weight = exp(-weight/sigma);
                        count+= weight;
                        for(int y= 0;y<im->dim[1];y++){
                            ycur=y+yy>0?y+yy<im->dim[1]?y+yy:im->dim[1]-(y+yy-im->dim[1]+1):-(y+yy);
                            for(int x= 0;x<im->dim[0];x++){
                                xcur=x+xx>0?x+xx<im->dim[0]?x+xx:im->dim[0]-(x+xx-im->dim[0]+1):-(x+xx);
                                matrix[y*im->dim[0] + x] += rPIxel(xcur, ycur, im)*weight;
                            }
                        }
                    }

                }

            }


            for(int i = 0; i < im->dim[0]*im->dim[1];i++)
                wPIxel(i, im, matrix[i]/count);
        }
        free(matrix);
    }

}
/***************************************************//**
*  \brief windowed mean
*
* calculates the mean in a spherical window. Borders
* are mirrored in the calculation. (Warning: 2d not yet implemented.
* Images with less than window size dimensions will caus problems.)
*
* The function requires a working copy integer of the image.
* \param *im an image_cc pointer to the image. The image will be overwritten by the mean.
* \param size double, size of the spherical element <b>in image resolution</b>
* (for pixel size multiply with
* im->dim[0])
****************************************************/
void wMean( image_cc *im, double size)
{
    if(im->numbytes>=4){
        wMean_f(im, size);
        return;
    }

    if(im->ndim==3){//3d
        double sizesq=size*size;
        size/=im->res[0];
        int count =0;
        double rxsq = im->res[0]*im->res[0];
        double rysq = im->res[1]*im->res[1];
        double rzsq = im->res[2]*im->res[2];
        int *matrix = (int*)malloc(im->dim[0]*im->dim[1]*im->dim[2]*sizeof(int));
        if(matrix){
            for(int i = 0; i < im->dim[0]*im->dim[1]*im->dim[2];i++)
                matrix[i] =0;
            int zcur, ycur, xcur;
            int zz, tsize = ceil(size);
#pragma omp parallel for shared(im, matrix, rxsq,rysq,rzsq,sizesq), private(xcur,zcur, ycur), default(shared) num_threads(4)
            for(zz=-tsize;zz<=tsize;zz++){//go through structuring element
            //for(double zz=-ceil(size);zz<size;zz++){//go through structuring element
                for(double yy=-ceil(size);yy<size;yy++){
                    for(double xx=-ceil(size);xx<size;xx++){
                        if((zz*zz*rzsq + yy*yy*rysq + xx*xx *rxsq)<=sizesq){//it's in the element
#pragma omp atomic
                            count++;
                            for(int z= 0;z<im->dim[2];z++){
                                zcur=z+zz>0?z+zz<im->dim[2]?z+zz:im->dim[2]-(z+zz-im->dim[2]+1):-(z+zz); //mirrored coordinates
                                for(int y= 0;y<im->dim[1];y++){
                                    ycur=y+yy>0?y+yy<im->dim[1]?y+yy:im->dim[1]-(y+yy-im->dim[1]+1):-(y+yy);
                                    for(int x= 0;x<im->dim[0];x++){
                                        xcur=x+xx>0?x+xx<im->dim[0]?x+xx:im->dim[0]-(x+xx-im->dim[0]+1):-(x+xx);
                                        matrix[(z*im->dim[1] + y)*im->dim[0] + x] += rPixel(xcur, ycur, zcur, im);
                                    }
                                }
                            }
                        }
                    }
                }
            }

            for(int i = 0; i < im->dim[0]*im->dim[1]*im->dim[2];i++)
                wPixel(i, im, matrix[i]/count);
        }
        free(matrix);
    }else{//2d
        double sizesq=size*size;
        size/=im->res[0];
        int count =0;
        double rxsq = im->res[0]*im->res[0];
        double rysq = im->res[1]*im->res[1];
        int *matrix = (int*)malloc(im->dim[0]*im->dim[1]*sizeof(int));
        if(matrix){
            for(int i = 0; i < im->dim[0]*im->dim[1];i++)
                matrix[i] =0;
            int ycur, xcur;
            for(double yy=-ceil(size);yy<size;yy++){//go through structuring element
                for(double xx=-ceil(size);xx<size;xx++){
                    if((yy*yy*rysq + xx*xx *rxsq)<=sizesq){//it's in the element
                        count++;
                        for(int y= 0;y<im->dim[1];y++){
                            ycur=y+yy>0?y+yy<im->dim[1]?y+yy:im->dim[1]-(y+yy-im->dim[1]+1):-(y+yy);
                            for(int x= 0;x<im->dim[0];x++){
                                xcur=x+xx>0?x+xx<im->dim[0]?x+xx:im->dim[0]-(x+xx-im->dim[0]+1):-(x+xx);
                                matrix[y*im->dim[0] + x] += rPixel(xcur, ycur, im);
                            }
                        }
                    }
                }
            }


            for(int i = 0; i < im->dim[0]*im->dim[1];i++)
                wPixel(i, im, matrix[i]/count);
        }
        free(matrix);
    }
}
/*********************************************//**
        * \brief pseudo Median absolute deviation
        *
        *  The mdeian absolute deviation is the median of the
        *  absolute differences towards the median.
        *  For reason of speed the median is replaced by
        *  the luul filter.
        *
        *  \returns pointer to the result image
        *  \param orig pointer to original image
        *  \param pMed pointer to pointer to image containing the luul filtered
        *         image. If NULL, this will be created.
        *  \param size radius of spherical window to use.
        *
        ******************************************/

void pseudoMad(image_cc *orig, image_cc **pMed, double size)
{
    int numelem = 1, i, k;
    if(*pMed == NULL){
        *pMed = CopyImage(orig);
        Luul(*pMed, size);
    }
    for(i = 0; i< orig->ndim; i++)
        numelem*= orig->dim[i];
#pragma omp parallel for private(i) shared(orig,numelem, pMed)
    for(i=0;i<numelem;i++){
        wPixel(i, orig, abs(rPixel(i, orig)-rPixel(i, *pMed)));
    }
    Luul(orig, size);

}
void pseudoMad(image_cc *orig, double size)
{
    image_cc *luul = NULL;
    pseudoMad(orig, &luul, size);
    DeleteImage(luul);
}

//#define MINMODSQ(a,b) __signbit(a)?(__signbit(b)?(a>b?a*a:b*b):0):(__signbit(b)?0:(a<b?a*a:b*b))
#define MINMODSQ(a,b) a<0?(b<0?(a>b?a*a:b*b):0):(b<0?0:(a<b?a*a:b*b))
#define epsilon 0.0001
double tv(double x)
{
    return(2.0);
}
double entro(double x)
{
    return((1.0+log(x)));
}

double tv_entro(double x)
{
    return(x> 2.7181?2:(1+log(x)));
}
/*********************************************//**
        * \brief Rudin, Osher, Fatemi filter
        *
        *  This filter minimizes the total variation while keeping
        *  a maximal fidelity to the original image. The strength
        *  of fidelity is given by $\lambda$.
        *
        *
        *  \returns nothing worthwhile
        *  \param timestep timestep for each filtering. If negative, will be handled dynamically. -0.1 normally
        *         works well.
        *  \param lambda fidelity parameter. 5 is a good start.
        *  \param maxstep maximal number of filtering steps.
        *  \param intervall number of steps after which the image in memory will be updated.
        *  \param function kernel functions for filtering. 0: classical Total variation, 1: Entropy, 2: Enhanced entropy
        *
        ******************************************/

int rof_filter(image_cc *image, double timestep, double lambda, int maxstep, int intervall, int function)
{
    if(image->ndim==2)
    {
      fprintf(stderr,"rof_filter() is for three-dimensional images only.\n"); 
      exit(1);
    }
    int Outfile=0,numvox=1;
    double criteria =-1, mean, stdev, *ut, *vt;
    bool ts_dyn = false;
    if(timestep<0){
        timestep = -timestep;
        ts_dyn = true;
    }
    double *sumgrey;
    double summator, sumsq, sumvar, oldsumvar = 1e20;
    typedef double (*DoubFunctionWithOneParameter) (double a);

    DoubFunctionWithOneParameter funky[] = {
        tv,
        entro,
        tv_entro
    };

    for(int i=0;i<image->ndim;i++)
        numvox *= image->dim[i];
    int maxgrey = image->numbytes==2?65535:256;
    cout<<"Numvox: "<<numvox<<endl;
    sumgrey = (double*)calloc(maxgrey, sizeof(double));

    ut = (double*)calloc(numvox, sizeof(double));
    vt = (double*)calloc(numvox, sizeof(double));
    for(int i = 0; i < numvox;i++){
        int j =rPixel(i, image);
        sumgrey[j]+=1.0;
    }

    double num = numvox;
    for(int i = 0; i < maxgrey;i++){
        if(sumgrey[i] >0){
            sumgrey[i]/=num;
            mean+=sumgrey[i]*i;

        }
    }


    for(int i = 0; i < maxgrey;i++){
        double tmp = (double)i-mean;
        stdev += tmp*tmp*sumgrey[i];
    }
    stdev = sqrt(stdev);
    cout<<"Mean: "<<mean<<", Stddev: "<<stdev<<endl;
    for(int i = 0; i < numvox;i++){
        ut[i]=((double)rPixel(i, image)-mean)/stdev;

    }
    int sizez= image->dim[2];
    int sizey= image->dim[1];
    int sizex= image->dim[0];
    double *dplusnormedz = (double*)calloc(sizex*sizey,sizeof(double));
    double *olddplusnormedz = (double*)calloc(sizex*sizey,sizeof(double));
    double *deltaz = (double*)calloc(sizex*sizey,sizeof(double));
    double *olddeltaz = (double*)calloc(sizex*sizey,sizeof(double));
    double *dplusnormedy = (double*)calloc(sizex,sizeof(double));
    double *olddplusnormedy = (double*)calloc(sizex,sizeof(double));
    double *deltay = (double*)calloc(sizex,sizeof(double));
    double *olddeltay = (double*)calloc(sizex,sizeof(double));
    double dplusnormedx =0;
    double olddplusnormedx=0;
    double deltax=0, olddeltax=0;
    for(int i= 0;i<maxstep;i++){
        summator = sumsq = 0.0;
        for(int z = 0;z<sizez;z++){
            for(int y = 0;y<sizey;y++){
                for(int x = 0;x<sizex;x++){
                    olddeltaz[x+y*sizex] = -deltaz[x+y*sizex];
                    deltaz[x+y*sizex] = z<(sizez-1)?ut[x+y*sizex+(z+1)*sizex*sizey] - ut[x+y*sizex+z*sizex*sizey]:0;

                }
            }
            for(int y = 0;y<sizey;y++){
                for(int x = 0;x<sizex;x++){
                    olddeltay[x] = -deltay[x];
                    deltay[x] = y<(sizey-1)?ut[x+(y+1)*sizex+z*sizex*sizey] - ut[x+y*sizex+z*sizex*sizey]:0;
                }
                for(int x = 0;x<sizex;x++){
                    /**********************************************************
           *  dt = delta-(delta+x/sqrt(delta+x^2+minmodsq(delta+y,delta-y)+minodsq...) +thingie(y) + thingie(z)+ lambda(vt)
           * ut += dt
           * vt -=dt
           ************************************************************/
                    deltax = x<(sizex-1)?ut[x+y*sizex+z*sizex*sizey+1] - ut[x+y*sizex+z*sizex*sizey]:0;
                    double mmsqx = MINMODSQ(deltax, olddeltax);
                    double mmsqy = MINMODSQ(deltay[x], olddeltay[x]);
                    double mmsqz = MINMODSQ(deltaz[x+y*sizex], olddeltaz[x+y*sizex]);
                    double absx = sqrt(deltax*deltax + mmsqy + mmsqz+epsilon);
                    double absy = sqrt(deltay[x]*deltay[x] + mmsqx + mmsqz+epsilon);
                    double absz = sqrt(deltaz[x+y*sizex]*deltaz[x+y*sizex] + mmsqy + mmsqx+epsilon);
                    dplusnormedx = funky[function](absx)*deltax/absx;
                    dplusnormedy[x] = funky[function](absy)*deltay[x]/absy;
                    dplusnormedz[x+y*sizex] = funky[function](absz)*deltaz[x+y*sizex]/absz;

                    double dt =  - dplusnormedx + olddplusnormedx - dplusnormedy[x] + olddplusnormedy[x] - dplusnormedz[x+y*sizex] + olddplusnormedz[x+y*sizex] - lambda * vt[x+y*sizex+z*sizex*sizey];
                    dt*=timestep;
                    summator +=dt;sumsq+=dt*dt;
                    //cout << summator << ", "<< dt <<"; ";
                    vt[x+y*sizex+z*sizex*sizey] += dt;
                    ut[x+y*sizex+z*sizex*sizey] -= dt;

                    olddeltax = -deltax;
                    olddplusnormedx = dplusnormedx;
                    olddplusnormedy[x] = dplusnormedy[x];
                    olddplusnormedz[x+y*sizex] = dplusnormedz[x+y*sizex];

                }
                //cout << endl;
            }
        }
        sumvar = sumsq - summator*summator/numvox;
        cout <<"Correction sum:" <<summator <<", "<<sumvar<<endl;
        if((sumvar>=oldsumvar)&&ts_dyn){
            timestep *=0.5;
            cout<<"Adjusting time step "<<timestep<<endl;
        }
        oldsumvar=sumvar;
        if(!((i+1) % intervall)){
            for(int j = 0; j < numvox;j++){
                wPixel(j, image, ut[j]*stdev+mean);

            }

        }

    }
    for(int j = 0; j < numvox;j++){
        wPixel(j, image,ut[j]*stdev+mean);

    }
    cout <<"Finished"<<endl;
    return(0);

}

void TotVarFilter(image_cc *image, double timestep, double lambda, int maxstep, int interval, int function)
{
  int idum;
  
  idum=rof_filter(image,timestep,lambda,maxstep,interval, function);
}
#define MAX(a,b) ((a>b) ? (a) : (b))
#define MIN(a,b) ((a>b) ? (b) : (a))

void DiffGauss(image_cc *image, int mode,double sigma, double sigma2)
{        
  double  xx,yy,zz,k,k2,value,value2,Sm=0, Sm2=0,drgb[3],fdum;
  double *val, *val2;
  image_cc *imbuf; 
  int rgb[3], maxnum;
  int x,y,z,x1,y1,z1,x2,y2,z2,I,i,s,j;
  
  imbuf = CopyImage(image);
  s=2*mode+1;
  maxnum=image->numbytes==2?65535:255;
  if(sigma<sigma2)
  {
    fdum=sigma2;sigma2=sigma;sigma=fdum;
  }
  
  if(strcmp(image->itype,"btd")==0){
    printf("\nGauss: Only valid for grey scale and rgb images\n");
    exit(0);
  }
  if(strcmp(image->itype,"ddd")==0 || strcmp(image->itype,"ddd16")==0){
    val=(double *)malloc(s*s*s*sizeof(double));
    val2=(double *)malloc(s*s*s*sizeof(double));
    k= 1.0/sqrt(2.0 * M_PI * sigma*sigma);
    k2= 1.0/sqrt(2.0 * M_PI * sigma2*sigma2);
    for(z=-mode;z<=mode;z++){
      zz=z*z;
      for(y=-mode;y<=mode;y++){	      	 
	yy=y*y; 
	for(x=-mode;x<=mode;x++){  	   		    
	  xx=x*x;             
	  *(val+(mode+x)+s*(mode+y)+s*s*(mode+z))= k * exp(-(xx+yy+zz)/(2.0* sigma*sigma));
	  Sm+=*(val+(mode+x)+s*(mode+y)+s*s*(mode+z));
	  *(val2+(mode+x)+s*(mode+y)+s*s*(mode+z))= k2 * exp(-(xx+yy+zz)/(2.0* sigma2*sigma2));
	  Sm2+=*(val2+(mode+x)+s*(mode+y)+s*s*(mode+z));
	}
      }
    }
    for(i=0;i<s*s*s;i++)
    {
      *(val+i)*=1./Sm;
      *(val2+i)*=1./Sm2;
      
    }
  }
  else{
    val=(double *)malloc(s*s*sizeof(double));
    val2=(double *)malloc(s*s*sizeof(double));    
    for(y=-mode;y<=mode;y++){	      	 
      yy=y*y; 
      for(x=-mode;x<=mode;x++){  	   		    
	xx=x*x;             
	k= 1.0/sqrt(2.0 * M_PI * sigma*sigma);
	k2= 1.0/sqrt(2.0 * M_PI * sigma2*sigma2);
	//val[mode+x][mode+y]= k * exp(-(xx+yy)/(2.0* sigma*sigma));
	*(val+(mode+x)+s*(mode+y))= k * exp(-(xx+yy)/(2.0* sigma*sigma));
	Sm+=*(val+(mode+x)+s*(mode+y));
	*(val2+(mode+x)+s*(mode+y))= k2 * exp(-(xx+yy)/(2.0* sigma2*sigma2));
	Sm2+=*(val2+(mode+x)+s*(mode+y));
      }
    }
    for(i=0;i<s*s;i++)
    {
      *(val+i)*=1./Sm;
      *(val2+i)*=1./Sm2;
      
    }
  }
  
  if(strncmp(image->itype,"gry",3)==0 || strcmp(image->itype,"gry16")==0){  	
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	Sm=Sm2=0;
	for(y1=y-mode;y1<=y+mode;y1++)
	  for(x1=x-mode;x1<=x+mode;x1++){ 
	    value=*(val+(mode+x1-x)+s*(mode+y1-y));
	    value2=*(val2+(mode+x1-x)+s*(mode+y1-y));
	    
	    x2=x1; y2=y1;
	    if(y1<0) y2=y1+mode;
	    if(x1<0) x2=x1+mode;
	    if(y1>=image->dim[1]) y2=y1-mode; //Steffen: 26.11.2012
	    if(x1>=image->dim[0]) x2=x1-mode; //Steffen: 26.11.2012
	    
	    I=rPixel(x2,y2,image);
	    
	    Sm+=(2*value2-value)*I;
	  }
	  wPixel(x,y,imbuf,MAX(0,MIN(maxnum,int(Sm))));
      }
  }
  else if(strcmp(image->itype,"rgb")==0){
    for(y=0;y<image->dim[1];y++)
      for (x=0;x<image->dim[0];x++){
	for(i=0;i<3;i++)drgb[i]=0;
	
	for(y1=y-mode;y1<=y+mode;y1++)
	  for(x1=x-mode;x1<=x+mode;x1++){ 
	    value=*(val+(mode+x1-x)+s*(mode+y1-y));
	    value2=*(val2+(mode+x1-x)+s*(mode+y1-y));
	    x2=x1; y2=y1;
	    if(y1<0) y2=y1+mode;
	    if(x1<0) x2=x1+mode;
	    if(y1>= signed(image->dim[1])) y2=y1-mode; //Steffen: 26.11.2012
	    if(x1>=signed(image->dim[0])) x2=x1-mode; //Steffen: 26.11.2012
	    rPixel(x2,y2,image,rgb);
	    
	    for(i=0;i<3;i++)
	      drgb[i]+=double(rgb[i])*(2*value2-value);
	  }
	  for(i=0;i<3;i++)
	    rgb[i]=MAX(0,MIN(maxnum,int(drgb[i])));
	  wPixel(x,y,imbuf,rgb);
      }
  }
  else if(strcmp(image->itype,"ddd")==0 || strcmp(image->itype,"ddd16")==0){  	
    for(z=0;z<image->dim[2];z++)
      for(y=0;y<image->dim[1];y++)
	for(x=0;x<image->dim[0];x++){
	  Sm=0;
	  for(z1=z-mode;z1<=z+mode;z1++)
	    for(y1=y-mode;y1<=y+mode;y1++)
	      for(x1=x-mode;x1<=x+mode;x1++){ 
		value=*(val+(mode+x1-x)+s*(mode+y1-y)+s*s*(mode+z1-z));
		value2=*(val2+(mode+x1-x)+s*(mode+y1-y)+s*s*(mode+z1-z));
		z2=z1; x2=x1; y2=y1;
		if(z1<0) z2=z1+mode;
		if(y1<0) y2=y1+mode;
		if(x1<0) x2=x1+mode;
		if(z1>=signed(image->dim[2])) z2=z1-mode; //Steffen: 26.11.2012
		if(y1>=signed(image->dim[1])) y2=y1-mode; //Steffen: 26.11.2012
		if(x1>=signed(image->dim[0])) x2=x1-mode; //Steffen: 26.11.2012
		
		I=rPixel(x2,y2,z2,image);
		
		Sm+=I*(2*value2-value);
	      }
	      wPixel(x,y,z,imbuf,MAX(0,MIN(maxnum,int(Sm))));
	      
	}
  }
  
  for(j=0;j<image->dim[0]*image->dim[1]*image->dim[2]*image->numchannel*image->numbytes;j++)
    *(image->pix+j)=*(imbuf->pix+j);  
  DeleteImage(imbuf);
  
  //free(image->pix);
  //image->pix=imbuf->pix;
}
void UnsharpMask(image_cc *im, int size,double sigma)
{        
  	image_cc *gauss;
	int x,y,z, val,maxval;
	
	
	if(strcmp(im->itype,"rgb")==0)
	  gauss=RGBtoGray(im);
	else gauss = CopyImage(im);
	

	Gauss(gauss,size,sigma);
	maxval=im->numbytes==2?65535:255;
	if(im->ndim==3)
	{
	  for(z=0;z<im->dim[2];z++)
	    for(y=0;y<im->dim[1];y++)
	      for(x=0;x<im->dim[0];x++)
	      {
		val=2*rPixel(x,y,z,im)-rPixel(x,y,z,gauss);
		wPixel(x,y,z,im,val<0?0:val>maxval?maxval:val); 
	      }
	}
	else
	{
	  for(y=0;y<im->dim[1];y++)
	    for(x=0;x<im->dim[0];x++)
	    {
	      val=2*rPixel(x,y,im)-rPixel(x,y,gauss);
	      wPixel(x,y,im,val<0?0:val>maxval?maxval:val); 
	    }
	}
	
}

void *AnisoDiffFilter(image_cc *in, int maxstep, double threshold, double sigma)
{
    if(strncmp(in->itype,"gry",3)==0 || strncmp(in->itype,"btd",3)==0 || strncmp(in->itype,"rgb",3)==0)
    {
	fprintf(stderr,"Anisotropic Diffusion Filter is for 3D gray images only\n");
	exit(-1);
    }
    
	int x,y,z,r, nb, cnt;
	char buffer[127];
	double *incon, *outcon,*smooth,cntval,nbval,sum, *temp,*ti, D, count, gssn[2]/*{central weight;neighbor weight}*/;
	image_cc *out;
	double dt=0.166666666; /* dt=1/6 in 3D, dt=1/4 in 2D*/

	int size=in->dim[1]*in->dim[0]*in->dim[2];
	incon=(double *)calloc(size,sizeof(double));
	smooth=(double *)calloc(size,sizeof(double));
	outcon=(double *)calloc(size,sizeof(double));

	/*** set up Gaussian weights ***/
	double k= 1.0/sqrt(2.0 * M_PI * sigma*sigma);
	gssn[0]=k;
	gssn[1]=k * exp(-1.0/(4.0* sigma*sigma));
	sum=gssn[0]+6*gssn[1];
	gssn[0]/=sum;
	gssn[1]/=sum;




	/*** write boundary conditions ***/
	for(z=0;z<in->dim[2];z++)
	 for(y=0;y<in->dim[1];y++)
	  for(x=0;x<in->dim[0];x++)
	  {
	      cnt=x+in->dim[0]*(y+z*in->dim[1]);
	      incon[cnt]=smooth[cnt]=outcon[cnt]=(double)rPixel(x,y,z,in);
	  }
	
	/****Iterations ***********/
	for(int iter=0;iter<maxstep;iter++)
	{
	 if(iter){temp=incon; incon=outcon; outcon=temp;}

	 /*smoothing of input concentrations smooth= (G_sigma * I) */
	 for(z=1;z<in->dim[2]-1;z++)	   
	  for(y=1;y<in->dim[1]-1;y++)	   
	   for(x=1;x<in->dim[0]-1;x++)
	   {	      
		sum=count=0;
		cnt=x+in->dim[0]*(y+z*in->dim[1]);
		cntval=gssn[0]*incon[cnt];
		for(r=0;r<6;r++)
		{
		    nb=x+N6x[r]+in->dim[0]*((y+N6y[r])+(z+N6z[r])*in->dim[1]);
		    nbval=gssn[1]*incon[nb];
		    sum+=nbval;

		    
		}
		smooth[cnt]=cntval+sum;
	    }
	 /*nonlinear diffusion with smoothed gradients div(g(|smooth|) nabla I) */   
	 for(z=1;z<in->dim[2]-1;z++)	   
	  for(y=1;y<in->dim[1]-1;y++)	   
	   for(x=1;x<in->dim[0]-1;x++)
	   {	      
		sum=count=0;
		cnt=x+in->dim[0]*(y+z*in->dim[1]);
		cntval=smooth[cnt];
		for(r=0;r<6;r++)
		{
		    nb=x+N6x[r]+in->dim[0]*((y+N6y[r])+(z+N6z[r])*in->dim[1]);
		    nbval=smooth[nb];
		    D=fabs(cntval-nbval)>threshold?0:1;
		    if(D)
		    {
			sum+=incon[nb]; // smooth values are only used for edge detector, take original intensities for diffusion
			count++;
		    }
		}
		outcon[cnt]=incon[cnt]*(1.-count*dt)+dt*sum;
	       
	    }
	  }

	for(int i=0;i<size;i++)
	    wPixel(i,in,int(round(outcon[i])));

}

image_cc *MajorityFilter(image_cc *clas, int nr, int wnd, double maj, double rel)
{
  int xx,yy,zz,h[nr], oldval,newval,maxcount,changed=0;
  int imaj=pow(2*wnd+1,3)*maj;
  int irel=pow(2*wnd+1,3)*rel;
  char buf[128];
  image_cc *majim;
  
  majim=CopyImage(clas);
  
  for(int z=wnd; z<clas->dim[2]-wnd; z++)
    for(int y=wnd; y<clas->dim[1]-wnd; y++)
      for(int x=wnd; x<clas->dim[0]-wnd; x++)
      {
	  oldval=rPixel(x,y,z,clas);
	  for(int i=0;i<nr;i++) h[i]=0;
	  
	  for(zz=-wnd; zz<=wnd; zz++)
	    for(yy=-wnd; yy<=wnd; yy++)
	      for(xx=-wnd; xx<=wnd; xx++)
		h[rPixel(x+xx,y+yy,z+zz,clas)]++;

	  maxcount=0;
	  for(int i=0;i<nr;i++)
	      if(h[i]>maxcount)
	      {
		  newval=i;
		  maxcount=h[i];
	      }
	  if(maxcount>=imaj && (maxcount-h[oldval])>irel)   
	  {
	    wPixel(x,y,z,majim,newval);
	    changed++;
	  }
		    
      }

    printf("majority filter changed: %d voxels. That is %.2lf%% of the image\n",changed, 100*double(changed)/clas->dim[0]/clas->dim[1]/clas->dim[2]);
    return majim;
}

image_cc *MajorityFilter(image_cc *clas, image_cc *roi, int nr, int wnd, double maj, double rel)
{
  int xx,yy,zz,h[nr], oldval,newval,maxcount,changed=0, nr_roi;
  int imaj=pow(2*wnd+1,3)*maj;
  int irel=pow(2*wnd+1,3)*rel;
  char buf[128];
  image_cc *majim;
  double fmaj,frel;
  
  majim=CopyImage(clas);
  
  for(int z=wnd; z<clas->dim[2]-wnd; z++)
    for(int y=wnd; y<clas->dim[1]-wnd; y++)
      for(int x=wnd; x<clas->dim[0]-wnd; x++)
	if(rPixel(x,y,z,roi))
	{
	    oldval=rPixel(x,y,z,clas);
	    for(int i=0;i<nr;i++) h[i]=0;
	    nr_roi=0;
	    for(zz=-wnd; zz<=wnd; zz++)
		for(yy=-wnd; yy<=wnd; yy++)
		    for(xx=-wnd; xx<=wnd; xx++)
			if(rPixel(x+xx,y+yy,z+zz,roi))
			{
			    h[rPixel(x+xx,y+yy,z+zz,clas)]++;
			    nr_roi++;
			}

	    fmaj=nr_roi*maj;
	    frel=nr_roi*rel;
	    maxcount=0;
	    for(int i=0;i<nr;i++)
		if(h[i]>maxcount)
		{
		    newval=i;
		    maxcount=h[i];
		}
	    if(maxcount>=fmaj && (maxcount-h[oldval])>frel)   
	    {
		wPixel(x,y,z,majim,newval);
		changed++;
	    }
			
	}

    printf("majority filter changed: %d voxels. That is %.2lf%% of the region of interest\n",changed, 100*double(changed)/clas->dim[0]/clas->dim[1]/clas->dim[2]);
    return majim;
}
