/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
image_cc *gMean2(image_cc *image, int mode); 
}{              % DESCRIPTION
As gMean but returns an image of the variance at each pixel within the defined window of size ${\tt mode}\times {\tt mode}$}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{image} {Pointer to the image description structure.}
\argu{mode} {side length of the operating window (number of pixel)} 
\return{Pointer to the image of variances}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *gMean2(image_cc *image, int mode) 
{
	int x,y,i,j,k,xx,yy,cum, *mat;
	double **sig, max=0;
	image_cc imagebuffer, *imbuf, *var; 
	
	sig = (double **)malloc(image->dim[0]*sizeof(double *));
	for(x=0;x<image->dim[0];x++)
	  sig[x] = (double *)malloc(image->dim[1]*sizeof(double));
	mat = (int *)malloc(mode*mode*sizeof(int));
	var=InitImage(image->dim[0],image->dim[1],0);
	
	k=(mode-1)/2;
	imbuf = CopyImage(image);

	for(y=0;y<image->dim[1];y++)
	 for (x=0;x<image->dim[0];x++){
	          cum=0; sig[x][y]=0;
		  for(j=0;j<mode*mode;j++){
		      if((xx=abs(x-k+j%mode))>=image->dim[0]) 
			xx=2*image->dim[0]-xx-1;
		      if((yy=abs(y-k+j/mode))>=image->dim[1]) 
			yy=2*image->dim[1]-yy-1;
		      cum+= mat[j]=rPixel(xx,yy,image);
		  }
		  cum/=(mode*mode);
		  wPixel(x,y, imbuf,cum);

		  for(j=0;j<mode*mode;j++)
		    sig[x][y]+=(mat[j]-cum)*(mat[j]-cum);
		  sig[x][y]/=(mode*mode);
		  if(sig[x][y]>max) max=sig[x][y];
	 }

	for(y=0;y<image->dim[1];y++)
	 for (x=0;x<image->dim[0];x++)
		  wPixel(x,y, var,(unsigned char)(sig[x][y]/max*255));
					
	free(image->pix);
	image->pix=imbuf->pix;
	return var;
}
/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

void gMedian(image_cc *image, int mode) 
{
	int x,y,i,j,k,m,*mat,r,xx,yy;
	unsigned char  *rank; 
	image_cc imagebuffer, *imbuf; 
	
	k=(mode-1)/2;
	m=(mode*mode+1)/2;
	mat = (int *)malloc(mode*mode*sizeof(int));
	rank = (unsigned char *)malloc(mode*mode);
	imbuf = CopyImage(image);

	for(y=0;y<image->dim[1];y++)
	 for (x=0;x<image->dim[0];x++){
		  for(j=0;j<mode*mode;j++){
		      if((xx=x-k+j%mode)>=image->dim[0]) 
			xx=image->dim[0]-1;
		      if(xx<0) 
			xx=0;
		      if((yy=y-k+j/mode)>=image->dim[1]) 
			yy=image->dim[1]-1;
		      if(yy<0) 
			yy=0;
		      /*
		      if((xx=abs(x-k+j%mode))>=image->dim[0]) 
			xx=2*image->dim[0]-xx-1;
		      if((yy=abs(y-k+j/mode))>=image->dim[1]) 
			yy=2*image->dim[1]-yy-1;
		      */
		      mat[j]=rPixel(xx,yy,image);
		  }
		  for(j=0;j<mode*mode;j++){
				r=0;
				for(i=0;i<mode*mode;i++)
					if(mat[j]>mat[i])
						r++;
				mat[j]--;
				rank[j]=r;
		  }
		  for(j=0;j<mode*mode;j++)
				if(rank[j]==m){
					wPixel(x,y, imbuf,++mat[j]);
					break;
		  }
	 }					
	free(image->pix);
	image->pix=imbuf->pix;
}

