/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"

#define PRECISION 10

int gBilevel(int *th_high,int *th_low,image_cc *image)
{
	int x,y,max,min,mittel;
	long var;
	double count;
	long int k, z=0;
	int Grau_stufe[256];
	int Glatt_grau[256];

			/*calculate histogramm */
	for(x=0;x<256;x++)
		Grau_stufe[x]=Glatt_grau[x]= 0;
	for (x=0+1;x<image->dim[0]-1;x+=PRECISION)
		for (y=0+1;y<image->dim[1]-1;y++) 
			Grau_stufe[rPixel(x,y,image)]++;

		/*smooth histogramm*/
	for(x=3;x<254;x++) {
		for(y=1;y<3;y++)
			Glatt_grau[x]+=Grau_stufe[x] + Grau_stufe[x-y]+Grau_stufe[x+y];
		Glatt_grau[x]=Glatt_grau[x]/6;
	}

		/*search for 1. maximum*/
	y=max=0;
	count=0;
	x=1;
	while(y<15){
		count+=(double) Glatt_grau[x];
	       if( Glatt_grau[x]>Glatt_grau[max]){
		  if(count > image->dim[0]*image->dim[1]/(50*PRECISION)) /*mind 2% */
			max=x;
		   y=0;
	       }
	       else{
		    if(Glatt_grau[x]>0)
			y++;
	       }
	       x++;
	}

		/* search for 1. minimum to find lower threshold */
	y=0;
	min=max;
	x=max+1;
	while(y<15){
	       if( Glatt_grau[x]<Glatt_grau[min]){
			min=x;
			y=0;
	       }
	       else
			y++;
	       x++;
	       if(x==254){
			printf("gBilevel: The histogram is not bimodal!\n");
			return -1;
	       }
	}
	*th_low=(max+min)/2;

	     /*find 2. maximum and parameters of the gausian function*/
	y=z=var=0;
	max = min;
	for (x=min+1;x<252;x++)
		if(Glatt_grau[x]>Glatt_grau[max])
			max = x;
	if(max==min){
		printf("gBilevel: there is only one maximum in the histogram!\n ");
		exit(0);
	}

	     /*calculate modal value symetrical to maximum*/
	z= (long) max*Glatt_grau[max];
	k=(long)Glatt_grau[max];
	y=1;
	for(x=max+1;x<max+20;x++){  
/*the value of 20 (region to calculate modal value) may be adjusted to different Materials*/
	     if ((2*max-x)>0&&x<=252){
		z+=(long)Glatt_grau[x]*x;
		k+=(long)Glatt_grau[x];
		z+=(long)Glatt_grau[2*max-x]*(2*max-x);
		k+=(long)Glatt_grau[2*max-x];
		y+=2;
	     }
	     else
		break;
	}
	mittel=z/k;

		/*calculate varianz of modal +/- 30 (may be adjusted ..)*/
	z=0;
	/*y= (mittel+30)>252 ? 252 : mittel+30;
	for(x=y;x>=mittel-30;x--){*/
	for(x=252;x>=mittel-30;x--){
		var +=long (Glatt_grau[x] * pow((x-mittel),2));
		z+= Glatt_grau[x];
	}
	var = long( sqrt(var/(z-1)));

		/* find upper threshold*/
	for (x=248; x>*th_low;x--){
		y=int((Glatt_grau[max]/4)* exp(-( pow(x-mittel,2)/(2*pow(var,2)))));
		if(x<max && y<Glatt_grau[min]/4)
			break;
	}
	*th_high = (x+min)/2;
return 1;
}
