/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 13.08.01
\command{       % COMMAND
image\_c *gCircMask(image\_c *im, int xmid, int ymid, int rad, int val)
}{              % DESCRIPTION
Cuts out a curcular image with center xmid/ymid and radius rad.
All pixels outside the circle are set to grey level val. The size of the returned image is reduced to 2*rad+1.}

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*image}{Pointer to the grey image}
\argu{xmid, ymid}{center coordinates of the circle}
\argu{rad}{radius of the circle}
\argu{val}{grey level written to the background }
\return{Pointer to the resulting image}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *gCircMask(image_cc *im, int xmid, int ymid, int rad, int val)
{
        int x,y,z, maxgrey;
	image_cc *outim, *inimage;

   	if(im->numbytes==1)	maxgrey=255;
   	else 			maxgrey=65535;

   if(im->ndim==3){
	inimage=CopyImage(im);
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[1];y++)
	  for(z=0;z<im->dim[2];z++)
	    if(sqrt((x-xmid)*(x-xmid)+(y-ymid)*(y-ymid))>rad)
	      wPixel(x,y,z,inimage,maxgrey);

	outim = InitImage(2*rad+1,2*rad+1,im->dim[2],0,im->itype);
	for(x=0;x<outim->dim[0];x++)
	  for(y=0;y<outim->dim[1];y++)
	  for(z=0;z<outim->dim[2];z++)
	      wPixel(x,y,z,outim,rPixel(xmid-rad+x,ymid-rad+y,z,inimage));
	DeleteImage(inimage);

   }
    else{
	inimage=CopyImage(im);
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[1];y++)
	    if(sqrt((x-xmid)*(x-xmid)+(y-ymid)*(y-ymid))>rad)
	      wPixel(x,y,inimage,maxgrey);

	outim = InitImage(2*rad+1,2*rad+1,0,im->itype);
	for(x=0;x<outim->dim[0];x++)
	  for(y=0;y<outim->dim[1];y++)
	      wPixel(x,y,outim,rPixel(xmid-rad+x,ymid-rad+y,inimage));
	DeleteImage(inimage);
    }
	return(outim);
}
