/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

Schlueter (Jan 2010): 
- new functions are generic (2D/3D and 8bit/16bit) - grey images only (no RGB)
- old functions maintained as image_cc *gLaplace(image_cc *image, int mode) - note: mode know has a different meaning
ARGUMENTS: 
- image: the image to be evaluated
- mode: controls the decision whether only positive Laplacians (mode 1), negative Laplacians (mode 2) or both (mode 3) are stored
- mask: optional - only locations where the binary mask is black are evaluated - rest is written to zero 

---------------------------------------------------------------------------*/
#include "quantim4.h"


image_cc *Laplace(image_cc *image, int mode) 
{
	int x,y,z,i,j,count, min, max, val;
	double dval, span, iwidth;
	int *pixbuf, maxgray;
	image_cc *out; 
	long idum;
	
	
	maxgray = image->numbytes==2?65535:255;
	idum=-1;

	if(image->ndim==3){
		out=InitImage(image->dim[0],image->dim[1],image->dim[2],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*image->dim[2]*sizeof(int));	
		for(i=0;i<image->dim[1]*image->dim[0]*image->dim[2];i++) pixbuf[i]=0;
		int fac[4]={-32766,1715,1213,990};
	
		for(z=1;z<image->dim[2]-1;z++)
		   for(y=1;y<image->dim[1]-1;y++)
			for (x=1;x<image->dim[0]-1;x++){
				count=fac[0]*rPixel(x,y,z,image);
				count+=fac[3]*rPixel(x-1,y-1,z-1,image);
				count+=fac[2]*rPixel(x-1,y-1,z,image);
				count+=fac[3]*rPixel(x-1,y-1,z+1,image);
				count+=fac[2]*rPixel(x-1,y,z-1,image);
				count+=fac[1]*rPixel(x-1,y,z,image);
				count+=fac[2]*rPixel(x-1,y,z+1,image);
				count+=fac[3]*rPixel(x-1,y+1,z-1,image);
				count+=fac[2]*rPixel(x-1,y+1,z,image);
				count+=fac[3]*rPixel(x-1,y+1,z+1,image);
				
				count+=fac[2]*rPixel(x,y-1,z-1,image);
				count+=fac[1]*rPixel(x,y-1,z,image);
				count+=fac[2]*rPixel(x,y-1,z+1,image);
				count+=fac[1]*rPixel(x,y,z-1,image);
				//(x,y,z) steht schon oben
				count+=fac[1]*rPixel(x,y,z+1,image);
				count+=fac[2]*rPixel(x,y+1,z-1,image);
				count+=fac[1]*rPixel(x,y+1,z,image);
				count+=fac[2]*rPixel(x,y+1,z+1,image);
	
				
				count+=fac[3]*rPixel(x+1,y-1,z-1,image);
				count+=fac[2]*rPixel(x+1,y-1,z,image);
				count+=fac[3]*rPixel(x+1,y-1,z+1,image);
				count+=fac[2]*rPixel(x+1,y,z-1,image);
				count+=fac[1]*rPixel(x+1,y,z,image);
				count+=fac[2]*rPixel(x+1,y,z+1,image);
				count+=fac[3]*rPixel(x+1,y+1,z-1,image);
				count+=fac[2]*rPixel(x+1,y+1,z,image);
				count+=fac[3]*rPixel(x+1,y+1,z+1,image);
				
				if(mode & 1 && count>0 || mode & 2 && count<=0)	val=*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])=abs(count);
				else if(mode & 1 && count<=0 || mode & 2 && count>=0) val=*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])=0;
				if(x==1&&y==1&&z==1)min=max=val;
				if(val<min)       min=val; 
				else if(val>max) max=val;
			}
		
		span = max - min;
		iwidth=(double)maxgray/span;
	
		for(z=1;z<image->dim[2]-1;z++)
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++){
					dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
					wPixel(x,y,z,out,int(dval));	
				}
	}
	else{//2D
		out=InitImage(image->dim[0],image->dim[1],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		for(i=0;i<image->dim[1]*image->dim[0];i++) pixbuf[i]=0;
		int fac[3]={-32764,4798,3393};	
		for(y=1;y<image->dim[1]-1;y++)
			for (x=1;x<image->dim[0]-1;x++){
				count=fac[0]*rPixel(x,y,image);
				//x-1
				count+=fac[2]*rPixel(x-1,y-1,image);
				count+=fac[1]*rPixel(x-1,y,image);
				count+=fac[2]*rPixel(x-1,y+1,image);
				//x
				count+=fac[1]*rPixel(x,y-1,image);
				count+=fac[1]*rPixel(x,y+1,image);
				//x+1
				count+=fac[2]*rPixel(x+1,y-1,image);
				count+=fac[1]*rPixel(x+1,y,image);
				count+=fac[2]*rPixel(x+1,y+1,image);
	
				if(mode & 1 && count>0 || mode & 2 && count<=0) val=*(pixbuf+x+y*image->dim[0])=abs(count);
				else if(mode & 1 && count<=0 || mode & 2 && count>0)	val=*(pixbuf+x+y*image->dim[0])=0;
					 
				if(x==1&&y==1)	min=max=val;
				if(val<min)	min=val; 
				else if(val>max) max=val;
			}
		span = max - min;
		iwidth=(double)maxgray/span;
		
		for(y=1;y<image->dim[1]-1;y++)
			for (x=1;x<image->dim[0]-1;x++){
				dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
				wPixel(x,y,out,int(dval));	
		}
		
	}

	SetFrame(out,0);
	free(pixbuf);
	return out;
}


image_cc *Laplace(image_cc *image, int mode, image_cc *mask) 
{
	int x,y,z,i,j,count, min, max, val;
	double dval, span, iwidth;
	int *pixbuf, maxgray;
	image_cc *out; 
	long idum;
	
	maxgray = image->numbytes==2?65535:255;
	idum=-1;

	

	if(image->ndim==3){
		out=InitImage(image->dim[0],image->dim[1],image->dim[2],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*image->dim[2]*sizeof(int));	
		for(i=0;i<image->dim[1]*image->dim[0]*image->dim[2];i++) pixbuf[i]=0;
		int fac[4]={-32766,1715,1213,990};
	
		for(z=1;z<image->dim[2]-1;z++)
		   for(y=1;y<image->dim[1]-1;y++)
			for (x=1;x<image->dim[0]-1;x++)
				if(rPixel(x,y,z,mask)){
					count=fac[0]*rPixel(x,y,z,image);
					count+=fac[3]*rPixel(x-1,y-1,z-1,image);
					count+=fac[2]*rPixel(x-1,y-1,z,image);
					count+=fac[3]*rPixel(x-1,y-1,z+1,image);
					count+=fac[2]*rPixel(x-1,y,z-1,image);
					count+=fac[1]*rPixel(x-1,y,z,image);
					count+=fac[2]*rPixel(x-1,y,z+1,image);
					count+=fac[3]*rPixel(x-1,y+1,z-1,image);
					count+=fac[2]*rPixel(x-1,y+1,z,image);
					count+=fac[3]*rPixel(x-1,y+1,z+1,image);
					
					count+=fac[2]*rPixel(x,y-1,z-1,image);
					count+=fac[1]*rPixel(x,y-1,z,image);
					count+=fac[2]*rPixel(x,y-1,z+1,image);
					count+=fac[1]*rPixel(x,y,z-1,image);
					//(x,y,z) stands first
					count+=fac[1]*rPixel(x,y,z+1,image);
					count+=fac[2]*rPixel(x,y+1,z-1,image);
					count+=fac[1]*rPixel(x,y+1,z,image);
					count+=fac[2]*rPixel(x,y+1,z+1,image);
		
					
					count+=fac[3]*rPixel(x+1,y-1,z-1,image);
					count+=fac[2]*rPixel(x+1,y-1,z,image);
					count+=fac[3]*rPixel(x+1,y-1,z+1,image);
					count+=fac[2]*rPixel(x+1,y,z-1,image);
					count+=fac[1]*rPixel(x+1,y,z,image);
					count+=fac[2]*rPixel(x+1,y,z+1,image);
					count+=fac[3]*rPixel(x+1,y+1,z-1,image);
					count+=fac[2]*rPixel(x+1,y+1,z,image);
					count+=fac[3]*rPixel(x+1,y+1,z+1,image);
					
					if(mode & 1 && count>0 || mode & 2 && count<=0)	val=*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])=abs(count);
					else if(mode & 1 && count<=0 || mode & 2 && count>=0) val=*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])=0;
					if(x==1&&y==1&&z==1) min=max=val;
					if(val<min)       min=val; 
					else if(val>max) max=val;
				}
		span = max - min;
		iwidth=(double)maxgray/span;
	
		for(z=1;z<image->dim[2]-1;z++)
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++)
				    if(rPixel(x,y,z,mask)){
					dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
					wPixel(x,y,z,out,int(dval));	
				}
	}
	else{//2D
		out=InitImage(image->dim[0],image->dim[1],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		for(i=0;i<image->dim[1]*image->dim[0];i++) pixbuf[i]=0;
		int fac[3]={-32764,4798,3393};	
		for(y=1;y<image->dim[1]-1;y++)
			for (x=1;x<image->dim[0]-1;x++)
				if(!rPixel(x,y,mask)){
					count=fac[0]*rPixel(x,y,image);
					//x-1
					count+=fac[2]*rPixel(x-1,y-1,image);
					count+=fac[1]*rPixel(x-1,y,image);
					count+=fac[2]*rPixel(x-1,y+1,image);
					//x
					count+=fac[1]*rPixel(x,y-1,image);
					//(x,y) stands first
					count+=fac[1]*rPixel(x,y+1,image);
					//x+1
					count+=fac[2]*rPixel(x+1,y-1,image);
					count+=fac[1]*rPixel(x+1,y,image);
					count+=fac[2]*rPixel(x+1,y+1,image);
		
					if(mode & 1 && count>0 || mode & 2 && count<=0) val=*(pixbuf+x+y*image->dim[0])=abs(count);
					else if(mode & 1 && count<=0 || mode & 2 && count>0)	val=*(pixbuf+x+y*image->dim[0])=0;
					if(x==1&&y==1)	min=max=val;
					if(val<min)	min=val; 
					else if(val>max) max=val;
				}
		span = max - min;
		iwidth=(double)maxgray/span;
		
		for(y=1;y<image->dim[1]-1;y++)
			for (x=1;x<image->dim[0]-1;x++)
			    if(rPixel(x,y,mask)){
				dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
				wPixel(x,y,out,int(dval));	
		}
		
	}

	SetFrame(out,0);
	free(pixbuf);
	return out;
}


image_cc *gLaplace(image_cc *image, int mode) 
{
	int x,y,i,j,count, min, max, val;
	double dval;
	int *pixbuf, maxgray;
	image_cc *out; 
	
	maxgray = image->numbits==16?65535:255;

	out=CopyImage(image);
	pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			count=-4*rPixel(x,y,image);
			count+=rPixel(x-1,y,image);
			count+=rPixel(x-1,y-1,image);
			count+=rPixel(x+1,y,image);
			count+=rPixel(x+1,y+1,image);
			val=*(pixbuf+x+y*image->dim[0])=abs(count);
			if(x==1&&y==1) min=max=val;
			if(val<min)       min=val; 
			else if(val>max) max=val;
		}
	
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
		    if(mode){
			dval=double(maxgray*(*(pixbuf+x+y*image->dim[0])-min)/(max-min));
			//dval=double(255.*(*(pixbuf+x+y*image->dim[0])-min)/(max-min));
			wPixel(x,y,out,int(dval));
		    }
		    else
			wPixel(x,y,out,*(pixbuf+x+y*image->dim[0]));
		}
	SetFrame(out,0);
	free(pixbuf);
	return out;
}


void gLaplace(image_cc *image) 
{

	int x,y,i,j,count;
	unsigned char *pixbuf; 
	
	pixbuf =(unsigned char *)malloc(image->dim[1]*image->dim[0]);	
		
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			count=-4*rPixel(x,y,image);
			count+=rPixel(x-1,y,image);
			count+=rPixel(x-1,y-1,image);
			count+=rPixel(x+1,y,image);
			count+=rPixel(x+1,y+1,image);
			*(pixbuf+x+y*image->dim[0])=abs(count);
		}
	image->pix=pixbuf;
}

image_cc *gLaplaceRescale(image_cc *image) 
{
	int x,y,i,j,count, min, max, val;
	double dval;
	int *pixbuf;
	image_cc *out; 
	
	out=CopyImage(image);
	pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			count=-4*rPixel(x,y,image);
			count+=rPixel(x-1,y,image);
			count+=rPixel(x-1,y-1,image);
			count+=rPixel(x+1,y,image);
			count+=rPixel(x+1,y+1,image);
			val=*(pixbuf+x+y*image->dim[0])=abs(count);
			if(x==1&&y==1) min=max=val;
			if(val<min)       min=val; 
			else if(val>max) max=val;
		}
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			dval=double(255.*(*(pixbuf+x+y*image->dim[0])-min)/(max-min));
			wPixel(x,y,out,int(dval));	
		}
	SetFrame(out,0);
	free(pixbuf);
	return out;
}