/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

Schlueter (Jan 2010): 
- new functions are generic (2D/3D and 8bit/16bit) - grey images only (no RGB)
- old functions maintained as image_cc *gSobel(image_cc *image, int mode) - note: mode now turned of
ARGUMENTS: 
- image: the image to be evaluated
- mask: optional - only locations where the binary mask is black are evaluated - rest is written to zero 
---------------------------------------------------------------------------*/
#include "quantim4.h"

image_cc *Sobel(image_cc *image){
	int x,y,z,count[3], min, max, val;
	int *pixbuf, maxgray;
	double dval, span,iwidth;
	image_cc *out;
	long idum;
	maxgray = image->numbytes==2?65535:255;
	idum=-1;
	
	if(image->ndim==3){
		out=InitImage(image->dim[0],image->dim[1],image->dim[2],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*image->dim[2]*sizeof(int));	
		int fac[3]={3650,2581,2107};
		for(z=1;z<image->dim[2]-1;z++)
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++){
					count[0]=count[1]=count[2]=0;
				//x-1
					count[0]=-fac[2]*rPixel(x-1,y-1,z-1,image);
					count[0]-=fac[1]*rPixel(x-1,y-1,z,image);
					count[0]-=fac[2]*rPixel(x-1,y-1,z+1,image);
					count[0]-=fac[1]*rPixel(x-1,y,z-1,image);
					count[0]-=fac[0]*rPixel(x-1,y,z,image);
					count[0]-=fac[1]*rPixel(x-1,y,z+1,image);
					count[0]-=fac[2]*rPixel(x-1,y+1,z-1,image);
					count[0]-=fac[1]*rPixel(x-1,y+1,z,image);
					count[0]-=fac[2]*rPixel(x-1,y+1,z+1,image);
						//mittleres yz-Kernel fuer x auf allen 9 Positionen 0
						//x+1
					count[0]+=fac[2]*rPixel(x+1,y-1,z-1,image);
					count[0]+=fac[1]*rPixel(x+1,y-1,z,image);
					count[0]+=fac[2]*rPixel(x+1,y-1,z+1,image);
					count[0]+=fac[1]*rPixel(x+1,y,z-1,image);
					count[0]+=fac[0]*rPixel(x+1,y,z,image);
					count[0]+=fac[1]*rPixel(x+1,y,z+1,image);
					count[0]+=fac[2]*rPixel(x+1,y+1,z-1,image);
					count[0]+=fac[1]*rPixel(x+1,y+1,z,image);
					count[0]+=fac[2]*rPixel(x+1,y+1,z+1,image);
					count[0]=abs(count[0]);
						//y-1
					count[1]=-fac[2]*rPixel(x-1,y-1,z-1,image);
					count[1]-=fac[1]*rPixel(x-1,y-1,z,image);
					count[1]-=fac[2]*rPixel(x-1,y-1,z+1,image);
					count[1]-=fac[1]*rPixel(x,y-1,z-1,image);
					count[1]-=fac[0]*rPixel(x,y-1,z,image);
					count[1]-=fac[1]*rPixel(x,y-1,z+1,image);
					count[1]-=fac[2]*rPixel(x+1,y-1,z-1,image);
					count[1]-=fac[1]*rPixel(x+1,y-1,z,image);
					count[1]-=fac[2]*rPixel(x+1,y-1,z+1,image);
						//mittleres yz-Kernel fuer x auf allen 9 Positionen 0
						//x+1
					count[1]+=fac[2]*rPixel(x-1,y+1,z-1,image);
					count[1]+=fac[1]*rPixel(x-1,y+1,z,image);
					count[1]+=fac[2]*rPixel(x-1,y+1,z+1,image);
					count[1]+=fac[1]*rPixel(x,y+1,z-1,image);
					count[1]+=fac[0]*rPixel(x,y+1,z,image);
					count[1]+=fac[1]*rPixel(x,y+1,z+1,image);
					count[1]+=fac[2]*rPixel(x+1,y+1,z-1,image);
					count[1]+=fac[1]*rPixel(x+1,y+1,z,image);
					count[1]+=fac[2]*rPixel(x+1,y+1,z+1,image);
					count[1]=abs(count[1]);
						
					count[2]=-fac[2]*rPixel(x-1,y-1,z-1,image);
					count[2]-=fac[1]*rPixel(x,y-1,z-1,image);
					count[2]-=fac[2]*rPixel(x+1,y-1,z-1,image);
					count[2]-=fac[1]*rPixel(x-1,y,z-1,image);
					count[2]-=fac[0]*rPixel(x,y,z-1,image);
					count[2]-=fac[1]*rPixel(x+1,y,z-1,image);
					count[2]-=fac[2]*rPixel(x-1,y+1,z-1,image);
					count[2]-=fac[1]*rPixel(x,y+1,z-1,image);
					count[2]-=fac[2]*rPixel(x+1,y+1,z-1,image);
						//mittleres yz-Kernel fuer x auf allen 9 Positionen 0
						//x+1
					count[2]+=fac[2]*rPixel(x-1,y-1,z+1,image);
					count[2]+=fac[1]*rPixel(x,y-1,z+1,image);
					count[2]+=fac[2]*rPixel(x+1,y-1,z+1,image);
					count[2]+=fac[1]*rPixel(x-1,y,z+1,image);
					count[2]+=fac[0]*rPixel(x,y,z+1,image);
					count[2]+=fac[1]*rPixel(x+1,y,z+1,image);
					count[2]+=fac[2]*rPixel(x-1,y+1,z+1,image);
					count[2]+=fac[1]*rPixel(x,y+1,z+1,image);
					count[2]+=fac[2]*rPixel(x+1,y+1,z+1,image);
					count[2]=abs(count[2]);
						
								
					val=*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])=count[0]+count[1]+count[2];
			
					if(x==1&&y==1&&z==1) min=max=val;
					if(val<min)       min=val; 
					else if(val>max) max=val;
	
				}
		span = max - min;
		iwidth=(double)maxgray/span;
		for(z=1;z<image->dim[2]-1;z++)
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++){
					dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
					wPixel(x,y,z,out, int(dval));
				}
	}
	else{//2D
		out=InitImage(image->dim[0],image->dim[1],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		int fac[2]={9597,6786};		
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++){
					count[0]=count[1]=0;
					count[0]-=fac[1]*rPixel(x-1,y-1,image);
					count[0]-=fac[0]*rPixel(x-1,y,image);
					count[0]-=fac[1]*rPixel(x-1,y+1,image);
					count[0]+=fac[1]*rPixel(x+1,y-1,image);
					count[0]+=fac[0]*rPixel(x+1,y,image);
					count[0]+=fac[1]*rPixel(x+1,y+1,image);
					count[0]=abs(count[0]);
					
					count[1]-=fac[1]*rPixel(x-1,y-1,image);
					count[1]-=fac[0]*rPixel(x,y-1,image);
					count[1]-=fac[1]*rPixel(x+1,y-1,image);
					count[1]+=fac[1]*rPixel(x+1,y+1,image);
					count[1]+=fac[0]*rPixel(x,y+1,image);
					count[1]+=fac[1]*rPixel(x-1,y+1,image);			
					count[1]=abs(count[1]);
		
					if(count>0) val=*(pixbuf+x+y*image->dim[0])=count[0]+count[1];
					else val=*(pixbuf+x+y*image->dim[0])=0;
					if(x==1&&y==1) min=max=val;
					if(val<min)       min=val; 
					else if(val>max) max=val;
				}
			span = max - min;
			iwidth=(double)maxgray/span;
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++){
					dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
					wPixel(x,y,out,int(dval));
				}
	}	
	SetFrame(out,0);
	free(pixbuf);
	return out;
}
image_cc *Sobel(image_cc *image, image_cc *mask){
	int x,y,z,count[3], min, max, val;
	int *pixbuf, maxgray;
	double dval, span,iwidth;
	image_cc *out;
	long idum;
	maxgray = image->numbytes==2?65535:255;
	idum=-1;

	if(image->ndim==3){
		out=InitImage(image->dim[0],image->dim[1],image->dim[2],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*image->dim[2]*sizeof(int));	
		int fac[3]={3650,2581,2107};
		for(z=1;z<image->dim[2]-1;z++)
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++)
					if(rPixel(x,y,z,mask)){
						count[0]=count[1]=count[2]=0;
						//x-1
						count[0]=-fac[2]*rPixel(x-1,y-1,z-1,image);
						count[0]-=fac[1]*rPixel(x-1,y-1,z,image);
						count[0]-=fac[2]*rPixel(x-1,y-1,z+1,image);
						count[0]-=fac[1]*rPixel(x-1,y,z-1,image);
						count[0]-=fac[0]*rPixel(x-1,y,z,image);
						count[0]-=fac[1]*rPixel(x-1,y,z+1,image);
						count[0]-=fac[2]*rPixel(x-1,y+1,z-1,image);
						count[0]-=fac[1]*rPixel(x-1,y+1,z,image);
						count[0]-=fac[2]*rPixel(x-1,y+1,z+1,image);
							
						//x+1
						count[0]+=fac[2]*rPixel(x+1,y-1,z-1,image);
						count[0]+=fac[1]*rPixel(x+1,y-1,z,image);
						count[0]+=fac[2]*rPixel(x+1,y-1,z+1,image);
						count[0]+=fac[1]*rPixel(x+1,y,z-1,image);
						count[0]+=fac[0]*rPixel(x+1,y,z,image);
						count[0]+=fac[1]*rPixel(x+1,y,z+1,image);
						count[0]+=fac[2]*rPixel(x+1,y+1,z-1,image);
						count[0]+=fac[1]*rPixel(x+1,y+1,z,image);
						count[0]+=fac[2]*rPixel(x+1,y+1,z+1,image);
						count[0]=abs(count[0]);
						//y-1
						count[1]=-fac[2]*rPixel(x-1,y-1,z-1,image);
						count[1]-=fac[1]*rPixel(x-1,y-1,z,image);
						count[1]-=fac[2]*rPixel(x-1,y-1,z+1,image);
						count[1]-=fac[1]*rPixel(x,y-1,z-1,image);
						count[1]-=fac[0]*rPixel(x,y-1,z,image);
						count[1]-=fac[1]*rPixel(x,y-1,z+1,image);
						count[1]-=fac[2]*rPixel(x+1,y-1,z-1,image);
						count[1]-=fac[1]*rPixel(x+1,y-1,z,image);
						count[1]-=fac[2]*rPixel(x+1,y-1,z+1,image);
							
						//y+1
						count[1]+=fac[2]*rPixel(x-1,y+1,z-1,image);
						count[1]+=fac[1]*rPixel(x-1,y+1,z,image);
						count[1]+=fac[2]*rPixel(x-1,y+1,z+1,image);
						count[1]+=fac[1]*rPixel(x,y+1,z-1,image);
						count[1]+=fac[0]*rPixel(x,y+1,z,image);
						count[1]+=fac[1]*rPixel(x,y+1,z+1,image);
						count[1]+=fac[2]*rPixel(x+1,y+1,z-1,image);
						count[1]+=fac[1]*rPixel(x+1,y+1,z,image);
						count[1]+=fac[2]*rPixel(x+1,y+1,z+1,image);
						count[1]=abs(count[1]);
						//z-1	
						count[2]=-fac[2]*rPixel(x-1,y-1,z-1,image);
						count[2]-=fac[1]*rPixel(x,y-1,z-1,image);
						count[2]-=fac[2]*rPixel(x+1,y-1,z-1,image);
						count[2]-=fac[1]*rPixel(x-1,y,z-1,image);
						count[2]-=fac[0]*rPixel(x,y,z-1,image);
						count[2]-=fac[1]*rPixel(x+1,y,z-1,image);
						count[2]-=fac[2]*rPixel(x-1,y+1,z-1,image);
						count[2]-=fac[1]*rPixel(x,y+1,z-1,image);
						count[2]-=fac[2]*rPixel(x+1,y+1,z-1,image);
						
						//z+1
						count[2]+=fac[2]*rPixel(x-1,y-1,z+1,image);
						count[2]+=fac[1]*rPixel(x,y-1,z+1,image);
						count[2]+=fac[2]*rPixel(x+1,y-1,z+1,image);
						count[2]+=fac[1]*rPixel(x-1,y,z+1,image);
						count[2]+=fac[0]*rPixel(x,y,z+1,image);
						count[2]+=fac[1]*rPixel(x+1,y,z+1,image);
						count[2]+=fac[2]*rPixel(x-1,y+1,z+1,image);
						count[2]+=fac[1]*rPixel(x,y+1,z+1,image);
						count[2]+=fac[2]*rPixel(x+1,y+1,z+1,image);
						count[2]=abs(count[2]);
							
									
						val=*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])=count[0]+count[1]+count[2];
				
						if(x==1&&y==1&&z==1) min=max=val;
						if(val<min)       min=val; 
						else if(val>max) max=val;
		
					}
		span = max - min;
		iwidth=(double)maxgray/span;
		for(z=1;z<image->dim[2]-1;z++)
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++)
				    if(rPixel(x,y,z,mask)){
					dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0]+z*image->dim[0]*image->dim[1])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
					wPixel(x,y,z,out, int(dval));	
				}
	}
	else{//2D
		out=InitImage(image->dim[0],image->dim[1],0,image->itype);
		pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		int fac[2]={9597,6786};		
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++)
					if(rPixel(x,y,mask)){
						count[0]=count[1]=0;
						count[0]-=fac[1]*rPixel(x-1,y-1,image);
						count[0]-=fac[0]*rPixel(x-1,y,image);
						count[0]-=fac[1]*rPixel(x-1,y+1,image);
						count[0]+=fac[1]*rPixel(x+1,y-1,image);
						count[0]+=fac[0]*rPixel(x+1,y,image);
						count[0]+=fac[1]*rPixel(x+1,y+1,image);
						count[0]=abs(count[0]);
						
						count[1]-=fac[1]*rPixel(x-1,y-1,image);
						count[1]-=fac[0]*rPixel(x,y-1,image);
						count[1]-=fac[1]*rPixel(x+1,y-1,image);
						count[1]+=fac[1]*rPixel(x+1,y+1,image);
						count[1]+=fac[0]*rPixel(x,y+1,image);
						count[1]+=fac[1]*rPixel(x-1,y+1,image);			
						count[1]=abs(count[1]);
			
						if(count>0) val=*(pixbuf+x+y*image->dim[0])=count[0]+count[1];
						else val=*(pixbuf+x+y*image->dim[0])=0;
						if(x==1&&y==1) min=max=val;
						if(val<min)       min=val; 
						else if(val>max) max=val;
					}
			span = max - min;
			iwidth=(double)maxgray/span;
			for(y=1;y<image->dim[1]-1;y++)
				for (x=1;x<image->dim[0]-1;x++)
				if(rPixel(x,y,mask)){
				
					dval=((double)maxgray*(double)(*(pixbuf+x+y*image->dim[0])-min)/span)+ran3(&idum)*iwidth-iwidth/2;
					wPixel(x,y,out,int(dval));
				}
	}	
	SetFrame(out,0);
	free(pixbuf);
	return out;
}



image_cc *gSobel(image_cc *image, int mode) 
{
	int x,y,i,j,count[4], min, max, val;
	double dval;
	int *pixbuf, maxgray;; 
	image_cc *out; 
	
	maxgray = image->numbits==16?65535:255;

	out=CopyImage(image);
	pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			count[0]=count[1]=count[2]=count[3]=0;
			count[0]=-2*rPixel(x-1,y,image);
			count[0]-=rPixel(x-1,y+1,image);
			count[0]-=rPixel(x-1,y-1,image);
			count[0]+=2*rPixel(x+1,y,image);
			count[0]+=rPixel(x+1,y+1,image);
			count[0]+=rPixel(x+1,y-1,image);			
			count[0]=abs(count[0]);
			count[1]=-2*rPixel(x,y-1,image);
			count[1]-=rPixel(x-1,y-1,image);
			count[1]-=rPixel(x+1,y-1,image);
			count[1]+=2*rPixel(x,y+1,image);
			count[1]+=rPixel(x+1,y+1,image);
			count[1]+=rPixel(x-1,y+1,image);			
			count[1]=abs(count[1]);	
			count[2]=-2*rPixel(x+1,y-1,image);
			count[2]-=rPixel(x,y-1,image);
			count[2]-=rPixel(x+1,y,image);
			count[2]+=2*rPixel(x-1,y+1,image);
			count[2]+=rPixel(x-1,y,image);
			count[2]+=rPixel(x,y+1,image);			
			count[2]=abs(count[2]);
			count[3]=-2*rPixel(x+1,y+1,image);
			count[3]-=rPixel(x+1,y,image);
			count[3]-=rPixel(x,y+1,image);
			count[3]+=2*rPixel(x-1,y-1,image);
			count[3]+=rPixel(x,y-1,image);
			count[3]+=rPixel(x-1,y,image);			
			count[3]=abs(count[3]);
					
			val=*(pixbuf+x+y*image->dim[0])=(count[0]+count[1]+count[2]+count[3])/4;
//			*(pixbuf+x+y*image->dim[0])=count[0];
			if(x==1&&y==1) min=max=val;
			if(val<min)       min=val; 
			else if(val>max) max=val;

		}
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
		    if(mode){
			dval=double(maxgray*(*(pixbuf+x+y*image->dim[0])-min)/(max-min));
			wPixel(x,y,out,int(dval));	
		   }
		    else
			wPixel(x,y,out,*(pixbuf+x+y*image->dim[0]));
		}
	SetFrame(out,0);
	free(pixbuf);
	return out;
}


void gSobel(image_cc *image) 
{
	int x,y,i,j,count[4];
	unsigned char *pixbuf; 
	
	pixbuf =(unsigned char *)malloc(image->dim[1]*image->dim[0]);	
		
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			count[0]=count[1]=count[2]=count[3]=0;
			count[0]=-2*rPixel(x-1,y,image);
			count[0]-=rPixel(x-1,y+1,image);
			count[0]-=rPixel(x-1,y-1,image);
			count[0]+=2*rPixel(x+1,y,image);
			count[0]+=rPixel(x+1,y+1,image);
			count[0]+=rPixel(x+1,y-1,image);			
			count[0]=abs(count[0]);
			count[1]=-2*rPixel(x,y-1,image);
			count[1]-=rPixel(x-1,y-1,image);
			count[1]-=rPixel(x+1,y-1,image);
			count[1]+=2*rPixel(x,y+1,image);
			count[1]+=rPixel(x+1,y+1,image);
			count[1]+=rPixel(x-1,y+1,image);			
			count[1]=abs(count[1]);	
			count[2]=-2*rPixel(x+1,y-1,image);
			count[2]-=rPixel(x,y-1,image);
			count[2]-=rPixel(x+1,y,image);
			count[2]+=2*rPixel(x-1,y+1,image);
			count[2]+=rPixel(x-1,y,image);
			count[2]+=rPixel(x,y+1,image);			
			count[2]=abs(count[2]);
			count[3]=-2*rPixel(x+1,y+1,image);
			count[3]-=rPixel(x+1,y,image);
			count[3]-=rPixel(x,y+1,image);
			count[3]+=2*rPixel(x-1,y-1,image);
			count[3]+=rPixel(x,y-1,image);
			count[3]+=rPixel(x-1,y,image);			
			count[3]=abs(count[3]);
					
			*(pixbuf+x+y*image->dim[0])=(count[0]+count[1]+count[2]+count[3])/4;
//			*(pixbuf+x+y*image->dim[0])=count[0];
		}
	image->pix=pixbuf;
}
image_cc *gSobelRescale(image_cc *image) 
{
	int x,y,i,j,count[4], min, max, val;
	double dval;
	int *pixbuf; 
	image_cc *out; 
	
	out=CopyImage(image);
	pixbuf =(int *)malloc(image->dim[1]*image->dim[0]*sizeof(int));	
		
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			count[0]=count[1]=count[2]=count[3]=0;
			count[0]=-2*rPixel(x-1,y,image);
			count[0]-=rPixel(x-1,y+1,image);
			count[0]-=rPixel(x-1,y-1,image);
			count[0]+=2*rPixel(x+1,y,image);
			count[0]+=rPixel(x+1,y+1,image);
			count[0]+=rPixel(x+1,y-1,image);			
			count[0]=abs(count[0]);
			count[1]=-2*rPixel(x,y-1,image);
			count[1]-=rPixel(x-1,y-1,image);
			count[1]-=rPixel(x+1,y-1,image);
			count[1]+=2*rPixel(x,y+1,image);
			count[1]+=rPixel(x+1,y+1,image);
			count[1]+=rPixel(x-1,y+1,image);			
			count[1]=abs(count[1]);	
			count[2]=-2*rPixel(x+1,y-1,image);
			count[2]-=rPixel(x,y-1,image);
			count[2]-=rPixel(x+1,y,image);
			count[2]+=2*rPixel(x-1,y+1,image);
			count[2]+=rPixel(x-1,y,image);
			count[2]+=rPixel(x,y+1,image);			
			count[2]=abs(count[2]);
			count[3]=-2*rPixel(x+1,y+1,image);
			count[3]-=rPixel(x+1,y,image);
			count[3]-=rPixel(x,y+1,image);
			count[3]+=2*rPixel(x-1,y-1,image);
			count[3]+=rPixel(x,y-1,image);
			count[3]+=rPixel(x-1,y,image);			
			count[3]=abs(count[3]);
					
			val=*(pixbuf+x+y*image->dim[0])=(count[0]+count[1]+count[2]+count[3])/4;
//			*(pixbuf+x+y*image->dim[0])=count[0];
			if(x==1&&y==1) min=max=val;
			if(val<min)       min=val; 
			else if(val>max) max=val;

		}
	for(y=1;y<image->dim[1]-1;y++)
		for (x=1;x<image->dim[0]-1;x++){
			dval=double(255.*(*(pixbuf+x+y*image->dim[0])-min)/(max-min));
			wPixel(x,y,out,int(dval));	
		}
	SetFrame(out,0);
	free(pixbuf);
	return out;
}

