/*---------------------------------------------------------------------
VERSION 4.0,COPYRIGHT 5. 20088 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"
#include "string.h"

double *Histo(image_cc *im)
{
	int i,x,y,z;
	image_cc *dummy;
	unsigned long buf=1, gval[256],count=0;
	double *gdens;

	if(strcmp(im->itype,"btd")==0){
		printf("\nHisto: without meaning for binary images\n");
		return 0; 
	}
	gdens=(double *)malloc(256*sizeof(double));
	for(i=0;i<256;i++)	gval[i]=0;
	for(i=0;i<im->ndim;i++) buf*=(unsigned long)im->dim[i];
	buf*=(unsigned long)im->numchannel;
	
	if(im->numbytes==2){
	  dummy=gry16to8(im);
	  for(i=0;i<buf;i++){ 
		  gval[*(dummy->pix+i)]++;
		  count++;
	  }
	  DeleteImage(dummy);
	}
	else
	{
	  for(i=0;i<buf;i++){ 
		  gval[*(im->pix+i)]++;
		  count++;
	  }  	  
	}

	for(i=0;i<256;i++){
		gdens[i]= (double) gval[i]/count;
	}
	return gdens;
}
double *Histo(image_cc *im,image_cc *mask)
{
	int i,x,y,z;
	image_cc *dummy;
	unsigned long buf=1, gval[256],count=0;
	double *gdens;

	if(strcmp(im->itype,"btd")==0){
		printf("\nHisto: without meaning for binary images\n");
		return 0; 
	}

	gdens=(double *)malloc(256*sizeof(double));
	for(i=0;i<256;i++)	gval[i]=0;
	for(i=0;i<im->ndim;i++) buf*=(unsigned long)im->dim[i];
	buf*=(unsigned long)im->numchannel;
	
	if(im->numbytes==2){
	  dummy=gry16to8(im);	
	  for(i=0;i<buf;i++){ 
	    if(rPixel(i,mask))
		  gval[*(dummy->pix+i)]++;
	    count++;
	  }
	  DeleteImage(dummy);
	}
	else{
	  for(i=0;i<buf;i++){ 
	    if(rPixel(i,mask))
		  gval[*(im->pix+i)]++;
	    count++;
	  }	 
	}

	for(i=0;i<256;i++){
		gdens[i]= (double) gval[i]/count;
	}
	return gdens;
}
//-----------------------------------ss 18.04.2013
double *Histo16(image_cc *im)
{
  if(im->numbytes!=2)
  {
    fprintf(stderr,"only 16bit images allowed in Histo16()\n");
    exit(-1);
  }
  if(strcmp(im->itype,"btd")==0){
	  printf("\nHisto: without meaning for binary images\n");
	  return 0; 
  }
	int i,x,y,z;
	unsigned long buf=1, gval[65536],count=0;
	double *gdens;

	if(strcmp(im->itype,"btd")==0){
		printf("\nHisto: without meaning for binary images\n");
		return 0; 
	}
	gdens=(double *)malloc(65536*sizeof(double));
	for(i=0;i<65536;i++)	gval[i]=0;
	for(i=0;i<im->ndim;i++) buf*=(unsigned long)im->dim[i];
  	for(i=0;i<buf;i++){ 
		gval[rPixel(i,im)]++;
		count++;
	}
	for(i=0;i<65536;i++){
		gdens[i]= (double) gval[i]/count;
	}
	return gdens;
  
}
//-----------------------------------ss 18.04.2013
double *Histo16(image_cc *im,image_cc *mask)
{
  if(im->numbytes!=2)
  {
    fprintf(stderr,"only 16bit images allowed in Histo16()\n");
    exit(-1);
  }
  if(strcmp(im->itype,"btd")==0){
	  printf("\nHisto: without meaning for binary images\n");
	  return 0; 
  }
	int i,x,y,z;
	unsigned long buf=1, gval[65536],count=0;
	double *gdens;

	gdens=(double *)malloc(65536*sizeof(double));
	for(i=0;i<65536;i++)	gval[i]=0;
	for(i=0;i<im->ndim;i++) buf*=(unsigned long)im->dim[i];
  	for(i=0;i<buf;i++){
		if(rPixel(i,mask))
		  gval[rPixel(i,im)]++;
		count++;
	}
	for(i=0;i<65536;i++){
		gdens[i]= (double) gval[i]/count;
	}
	return gdens;
  
}
double *GreyCdf(image_cc *im)
{
	int i;
	double *cdf, *histo;
	double sum;
	
	cdf = (double *)malloc(256*sizeof(double));
	
	histo = Histo(im);
	sum=histo[0];
	for(i=1;i<256;i++){
		sum+=histo[i];
		histo[i]+=histo[i-1];
	}
	for(i=0;i<256;i++)
		cdf[i]= histo[i]/sum;		
return cdf;
}
double *GreyCdf(image_cc *im, image_cc *mask)
{
	int i;
	double *cdf, *histo;
	double sum;
	
	cdf = (double *)malloc(256*sizeof(double));
	
	histo = Histo(im,mask);
	sum=histo[0];
	for(i=1;i<256;i++){
		sum+=histo[i];
		histo[i]+=histo[i-1];
	}
	for(i=0;i<256;i++)
		cdf[i]= histo[i]/sum;		
return cdf;
}
//-----------------------------------ss 18.04.2013
double *GreyCdf16(image_cc *im)
{
  if(im->numbytes!=2)
  {
    fprintf(stderr,"only 16bit images allowed in GreyCdf16()\n");
    exit(-1);
  }
  
  double *cdf, *histo, sum;

  
  cdf=(double *)calloc(65536,sizeof(double));
  histo=Histo16(im);
  sum=histo[0]; 
  for(int i=0;i<65536;i++)
  {
    sum+=histo[i];
    histo[i]+=histo[i-1];
  }

  for(int i=0;i<65536;i++)
    cdf[i]= histo[i]/sum;
  
  return cdf;

}
//-----------------------------------ss 18.04.2013
double *GreyCdf16(image_cc *im, image_cc *mask)
{
  if(im->numbytes!=2)
  {
    fprintf(stderr,"only 16bit images allowed in GreyCdf16()\n");
    exit(-1);
  }
  
  double *cdf, *histo, sum;

  
  cdf=(double *)calloc(65536,sizeof(double));
  histo=Histo16(im,mask);
  sum=histo[0]; 
  for(int i=0;i<65536;i++)
  {
    sum+=histo[i];
    histo[i]+=histo[i-1];
  }

  for(int i=0;i<65536;i++)
    cdf[i]= histo[i]/sum;
  
  return cdf;

}

void HistoMatch(double *cdf, image_cc *image)
{
  int x,y,i,val,nval,is3d=1,k,max;
  double *oldcdf, *newval, *oldscore, *newscore;
  unsigned long j;	
  long idum;

	if(image->ndim==3) is3d=image->dim[2];
	//max = image->numbytes ==1?256:65536;
	//oldcdf = GreyCdf(image);
	
	if(image->numbytes ==2)
	{
	    max=65536;
	    oldcdf=GreyCdf16(image);
	}
	else
	{
	    max=256;
	    oldcdf=GreyCdf(image);
	}
	newval=(double*)malloc(max*sizeof(double));
	oldscore=(double*)malloc(max*sizeof(double));
	newscore=(double*)malloc(max*sizeof(double));
	
	//score (percentile rank) - the probability that any score in the sample distribution fall below k (contains half of k's one probability by definition)
	oldscore[0]=0.5*oldcdf[0];
	newscore[0]=0.5*cdf[0];
	for(k=1;k<max;k++){
		oldscore[k]=oldcdf[k-1]+0.5*(oldcdf[k]-oldcdf[k-1]);
		newscore[k]=cdf[k-1]+0.5*(cdf[k]-cdf[k-1]);
	}
	
	for(k=0;k<max;k++){
		for(i=0;i<max;i++)
			if(oldscore[k]<newscore[i]) break;
		newval[k]=(i-1)+(oldscore[k]-newscore[i-1])/(newscore[i]-newscore[i-1]);
		if(newval[k]<0) newval[k]=0;
		//printf("k:%d oldcdf:%lf oldscore:%lf newcdf:%lf newscore:%lf newval:%lf\n", k,oldcdf[k], oldscore[k], cdf[k], newscore[k],newval[k]);
		
	}
	
  	for(j=0;j<image->dim[0]*image->dim[1]*is3d;j++){
		val=rPixel(j,image);
		if(val<max-1) nval=newval[val]+(newval[val+1]-newval[val])*ran3(&idum);
		else nval=newval[val];

		wPixel(j,image,int(nval));
	}
	free(newval);
	free(oldcdf);
	free(oldscore);
	free(newscore);
}

void GreyClas(image_cc *image, int Nclas, int *th, int *gval)
{
	int i, maxg, is3d=1;
	unsigned char val;
  	unsigned long j;	  

	maxg=(int)pow(2,image->numbits);
  	if(image->ndim==3) is3d=image->dim[2];
	
  	for(j=0;j<image->dim[0]*image->dim[1]*is3d;j++){
		val=rPixel(j,image);
		for(i=0;i<Nclas;i++)
		    if(val<=th[i]){
			wPixel(j,image,gval[i]);
			break;
		    }
		if(i==Nclas)    
			wPixel(j,image,maxg);    
	}
}


double *Acov(image_cc *im, double *corl, int lag, int mode)
{

	int x,y,z,i,mean, xf, yf, zf;
	double *cdf, *acov, *histo;
	double sum;
	unsigned long j, count;
	
	xf=yf=zf=0;
	if(mode&1) xf=1;
	if(mode&2) yf=1;
	if(mode&4) zf=1;

	acov = (double *)malloc(lag*sizeof(double));


	

	for(i=0;i<lag;i++) acov[i]=0;	

   if(im->ndim==3){
     	count=0;
	for(z=0;z<im->dim[2];z++)
	  for(x=0;x<im->dim[0];x++)
	    for(y=0;y<im->dim[1];y++) count+=rPixel(x,y,z, im);
	mean=count/(im->dim[1]*im->dim[0]*im->dim[2]);
     
	for(i=0;i<lag;i++){
		count=0;
		for(z=0;z<im->dim[2]-i*zf;z++)
	 	   for(x=0;x<im->dim[0]-i*xf;x++)
		      for(y=0;y<im->dim[1]-i*yf;y++){
		      	if(mode & 1<<0){
				acov[i]+=(rPixel(x,y,z, im)-mean)*(rPixel(x+i,y,z, im)-mean);
				count++;
			}
		      	if(mode & 1<<1){
				acov[i]+=(rPixel(x,y,z, im)-mean)*(rPixel(x,y+i,z, im)-mean);
				count++;
			}
		      	if(mode & 1<<2){
				acov[i]+=(rPixel(x,y,z, im)-mean)*(rPixel(x,y,z+i, im)-mean);
				count++;
			}
		       }
		acov[i]/=count;	
	}
    }
    else{
      	count=0;
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[1];y++) count+=rPixel(x,y, im);
	mean=count/(im->dim[1]*im->dim[0]);
	
	for(i=0;i<lag;i++){
		count=0;
		    for(x=0;x<im->dim[0]-i*xf;x++)
		    for(y=0;y<im->dim[1]-i*yf;y++){
		      	if(mode & 1 ){
				acov[i]+=(rPixel(x,y, im)-mean)*(rPixel(x+i,y, im)-mean);
				count++;
			}
		      	if(mode & 2){
				acov[i]+=(rPixel(x,y, im)-mean)*(rPixel(x,y+i, im)-mean);
				count++;
			}
		       }
		acov[i]/=count;	
	}
    }	
	*corl=0;
	for(i=0;i<lag;i++)
		*corl+=acov[i];
	*corl/=acov[0];

	//for(i=1;i<lag;i++)
	//	acov[i]/=acov[0];
	//acov[0]=1;

return acov;

}

double *SemiVar(image_cc *im, int lag, int mode)
     /* returns semivariogram in the range of [0, lag]
     */
{
	int x,y,z,i, xf,yf, zf;
	double *cdf, *acov, *histo;
	double sum,mean;
	unsigned long count;

	xf=yf=zf=0;
	if(mode&1) xf=1;
	if(mode&2) yf=1;
	if(mode&4 && im->ndim==3) zf=1;

	if(zf && lag>im->dim[2]-2) {printf("\nSemiVar: lag too large!!!\n"); exit(0);}
	if(yf && lag>im->dim[1]-2) {printf("\nSemiVar: lag too large!!!\n"); exit(0);}
	if(xf && lag>im->dim[0]-2) {printf("\nSemiVar: lag too large!!!\n"); exit(0);}


	acov = (double *)malloc(lag*sizeof(double));

	for(i=0;i<lag;i++) acov[i]=0;	

   if(im->ndim==3){
	for(i=0;i<lag;i++){
		count=0;
		    for(z=0;z<im->dim[2]-i*zf;z++)
		    for(x=0;x<im->dim[0]-i*xf;x++)
		    for(y=0;y<im->dim[1]-i*yf;y++){
		      	if(mode & 1 ){
				acov[i]+=pow((rPixel(x+i,y,z, im)-rPixel(x,y,z, im)),2);
				count++;
			}
		      	if(mode & 2){
				acov[i]+=pow((rPixel(x,y+i,z, im)-rPixel(x,y,z, im)),2);
				count++;
			}
		      	if(mode & 4){
				acov[i]+=pow((rPixel(x,y,z+i, im)-rPixel(x,y,z, im)),2);
				count++;
			}

		       }
		acov[i]/= 2*(count-1);	
	}
    }
    else{
	for(i=0;i<lag;i++){
		count=0;
		    for(x=0;x<im->dim[0]-i*xf;x++)
		    for(y=0;y<im->dim[1]-i*yf;y++){
		      	if(mode & 1 ){
				acov[i]+=pow((rPixel(x+i,y, im)-rPixel(x,y, im)),2);
				count++;
			}
		      	if(mode & 2){
				acov[i]+=pow((rPixel(x,y+i, im)-rPixel(x,y, im)),2);
				count++;
			}
		       }
		acov[i]/= 2*(count-1);		
	}
    }	
	
return acov;
}

double *GreyConFunc(image_cc *inim, int mode)
{
  int g, is3d;
  double *epc;
  long int *h;
  image_cc *binim;

  is3d=inim->ndim==3?1:0;	

  epc=(double *)malloc(256*sizeof(double));
  epc[255]=0;

  for(g=0;g<255;g++){
    	binim=CopyImage(inim);
    	Bin(binim,g,0,255);
	if(is3d){
		h=m3Quant(binim);
		if(mode==26)
    			epc[g]=m3euler26(binim,h);
		else
    			epc[g]=m3euler6(binim,h);
	}
	else{
		h=m2Quant(binim);
		if(mode==8)
    			epc[g]=m2euler8(binim,h);
		else
    			epc[g]=m2euler4(binim,h);
	}
   	DeleteImage(binim);
  }
  return epc;
}



#define mask -2
#define init -1
#define inqueue -3
#define wshed 0

image_cc *WaterShed(image_cc *image, int conmode)
{

   	image_cc *out;
 	int i,j,k,p, x,y,z, change, val, val2, edge, th, thresh, row, col,dep, d[26],pos;
	char buffer[127];
	int *watshed, *fifoqueue, cur_label=0, flag=0, wcount, rcount, abscount;
	
if(image->ndim==2){
	if(conmode!=4 && conmode!=8){
	  printf("\ngWaterShed: no valid connectivity mode (must be 4 or 8)\n");
	  return NULL;
	}
	printf("\n calculating watershed ...\n");


	row=image->dim[1]; 
	col=image->dim[0];
	fifoqueue = (int *)malloc(col*row*sizeof(int));
	watshed   = (int *)malloc(col*row*sizeof(int));

	d[0] = -col;          /* neighborhood pixels */
	d[1] = 1;
	d[2] = col;
	d[3] = -1;
	d[4] = 1 - col;
	d[5] = 1 + col;
	d[6] = col - 1;
	d[7] = -1 - col; 


	for(i=0;i<col*row;i++)
	  watshed[i]=init;

	wcount=rcount=abscount=0;
	/*** mark local maxima ***/
	for(th=255; th>0; th--){
	  for(y=1;y<row-1;y++)
	    for(x=1;x<col-1;x++)
	      if(rPixel(x,y,image)==th){
		pos=x+y*col;
		watshed[pos]=mask;
		for(j=0;j<conmode;j++)
		  if(watshed[pos+d[j]]>=0){
		    watshed[pos]=inqueue;		
		    *(fifoqueue+wcount%(col*row)) = pos;
		    wcount++; abscount++;
		    break;
		  }

	      }
	  while(abscount){
	    pos = *(fifoqueue+rcount%(col*row));
	    rcount++;
	    abscount--;
	    for(j=0;j<conmode;j++){
		  if((val=watshed[pos+d[j]])>0){
		    if(watshed[pos]==inqueue || (watshed[pos]==wshed && flag==1) )
		      watshed[pos] = val;
		    else if(watshed[pos] >0 && watshed[pos]!=val){  
		      watshed[pos]=wshed;
		      flag=0;
		    }
		  }
	          else if(val==wshed){
		    if(watshed[pos]==inqueue){
		      watshed[pos]=wshed;
		      flag=1;
		    }
		  }
		  else if(val==mask){
		    watshed[pos+d[j]]=inqueue;
		    *(fifoqueue+wcount%(col*row)) = pos+d[j];
		    wcount++;
		    abscount++;
		  }
	    }
	  }
	 
	  for(y=1;y<image->dim[1]-1;y++)
	    for(x=1;x<image->dim[0]-1;x++)
	      if(rPixel(x,y,image)==th){
		pos=x+y*col;
		if(watshed[pos]==mask){
		  cur_label++;
		  *(fifoqueue+wcount%(col*row)) =pos;
		  wcount++; abscount++;
		  watshed[pos]=cur_label;
		  while(abscount){
		    pos = *(fifoqueue+rcount%(col*row));
		    rcount++;
		    abscount--;
		    for(j=0;j<conmode;j++){
		      if(watshed[pos+d[j]]==mask){
			*(fifoqueue+wcount%(col*row))=pos+d[j];
			wcount++; abscount++;			
			watshed[pos+d[j]]=cur_label;
		      }
		    }
		  }		  

		}
	      }
	}/** loop over thresholds **/


	out=CopyImage(image);
	for(y=1;y<row-1;y++)
	  for(x=1;x<col-1;x++)
	      wPixel(x,y,out,*(watshed+x+y*col));
}
else{
	if(conmode!=6 && conmode!=26){
	  printf("\ngWaterShed: no valid connectivity mode (must be 6 or 26)\n");
	  return NULL;
	}
	printf("\n calculating watershed ...\n");


	row=image->dim[1]; 
	col=image->dim[0];
	dep=image->dim[2];
	fifoqueue = (int *)malloc(col*row*dep*sizeof(int));
	watshed   = (int *)malloc(col*row*dep*sizeof(int));

	// pos= z*col*row + y*col +x

	d[0] = -col*row;          /* neighborhood pixels */
	d[1] = 1;
	d[2] = col*row;
	d[3] = -1;
	d[4] =  - col;
	d[5] =  + col;
	d[6] = -col*row - col;
	d[7] = -col*row - col -1; 
	d[8] = -col*row - col +1; 
	d[9] =   -col*row -1;
	d[10] =  -col*row +1;
	d[11] =  -col*row + col;
	d[12] =  -col*row + col -1;
	d[13] =  -col*row + col +1;  
	d[14] =  - col -1;
	d[15] =  - col +1;
	d[16] =  col -1;
	d[17] =  col +1;
	d[18] =  col*row - col;
	d[19] =  col*row - col -1; 
	d[20] =  col*row - col +1; 
	d[21] =  col*row -1;
	d[22] =  col*row +1;
	d[23] =  col*row + col;
	d[24] =  col*row + col -1;
	d[25] =  col*row + col +1;  


	for(i=0;i<col*row*dep;i++)
	  watshed[i]=init;

	wcount=rcount=abscount=0;
	/*** mark local maxima ***/
	for(th=255; th>0; th--){
	  for(z=1;z<dep-1;z++)
	  for(y=1;y<row-1;y++)
	    for(x=1;x<col-1;x++)
	      if(rPixel(x,y,z,image)==th){
		pos=x+y*col+z*col*row;
		watshed[pos]=mask;
		for(j=0;j<conmode;j++)
		  if(watshed[pos+d[j]]>=0){
		    watshed[pos]=inqueue;		
		    *(fifoqueue+wcount%(col*row*dep)) = pos;
		    wcount++; abscount++;
		    break;
		  }

	      }
	  while(abscount){
	    pos = *(fifoqueue+rcount%(col*row*dep));
	    rcount++;
	    abscount--;
	    for(j=0;j<conmode;j++){
		  if((val=watshed[pos+d[j]])>0){
		    if(watshed[pos]==inqueue || (watshed[pos]==wshed && flag==1) )
		      watshed[pos] = val;
		    else if(watshed[pos] >0 && watshed[pos]!=val){  
		      watshed[pos]=wshed;
		      flag=0;
		    }
		  }
	          else if(val==wshed){
		    if(watshed[pos]==inqueue){
		      watshed[pos]=wshed;
		      flag=1;
		    }
		  }
		  else if(val==mask){
		    watshed[pos+d[j]]=inqueue;
		    *(fifoqueue+wcount%(col*row*dep)) = pos+d[j];
		    wcount++;
		    abscount++;
		  }
	    }
	  }
	 
	  for(z=1;z<image->dim[2]-1;z++)
	  for(y=1;y<image->dim[1]-1;y++)
	    for(x=1;x<image->dim[0]-1;x++)
	      if(rPixel(x,y,z,image)==th){
		pos=x+y*col+z*row*col;
		if(watshed[pos]==mask){
		  cur_label++;
		  *(fifoqueue+wcount%(col*row*dep)) =pos;
		  wcount++; abscount++;
		  watshed[pos]=cur_label;
		  while(abscount){
		    pos = *(fifoqueue+rcount%(col*row*dep));
		    rcount++;
		    abscount--;
		    for(j=0;j<conmode;j++){
		      if(watshed[pos+d[j]]==mask){
			*(fifoqueue+wcount%(col*row*dep))=pos+d[j];
			wcount++; abscount++;			
			watshed[pos+d[j]]=cur_label;
		      }
		    }
		  }		  

		}
	      }
	}/** loop over thresholds **/


	out=CopyImage(image);
	for(z=1;z<dep-1;z++)
	for(y=1;y<row-1;y++)
	  for(x=1;x<col-1;x++){
	    // wPixel(x,y,z,out,*(watshed+x+y*col+z*col*row));
	    if(*(watshed+x+y*col+z*col*row)>0)
	      wPixel(x,y,z,out,150);
	    else
	      if(*(watshed+x+y*col+z*col*row)==0)
		wPixel(x,y,z,out,0);
	      else
		wPixel(x,y,z,out,255);
	  }
}
	return out;  
}

#undef mask 
#undef init 
#undef inqueue 
#undef wshed 


double *Histo_old(image_cc *im)
{
	int i,x,y,z, is3d=1;
	unsigned long j,gval[256],count=0;
	double *gdens;
	
	gdens=(double *)malloc(256*sizeof(double));
	if(im->numbytes!=1){
		printf("\nHisto: only for 8bit grey scale images\n"); 
		return gdens;
	} 
	if(im->ndim==3) is3d=im->dim[2];

	for(i=0;i<256;i++)	gval[i]=0;
	for(j=0;j<im->dim[0]*im->dim[1]*is3d;j++){
		gval[rPixel(j,im)]++;
		count++;
	}
	for(i=0;i<256;i++){
		gdens[i]= (double) gval[i]/count;
	}
	return gdens;
}


