#include "quantim4.h"

/****** generates a 3D random field************
size: NxNxN
results are written to sfa[x][y][z] geschrieben.

DX,DY, DZ distance of points in directions x,y, z (always 1) 
VAR: ariance of the underlying distribution (should be 1 !!!!)
LAMX, LAMY, LAMZ:  correlation lengths in directions  x, y, z.
 ********************************************************************/


	void fourn(float *data, unsigned long *nn, int ndim, int isign);
	double I0(double x);
	double K0(double x);

void grf3(double ***sfa,double DX,double DY,double DZ,double LAMX,double LAMY,double LAMZ,double VAR,int N,int TYPE)
{
  
  unsigned long dim[4];
  int i,j,l,n,m,k,p;
  long idum;
  float *buf,s1,s2,*phi,r,r0;

  buf=(float*)malloc((size_t)((2*pow(N+1,3)+1)*sizeof(float))); buf++;
  phi=(float*)malloc((size_t)((pow(N+1,3)+1)*sizeof(float)));

  idum=-1; ran3(&idum);				/* initialize random generator */
  dim[1]=dim[2]=dim[3]=N;
  for (i=0;i<pow(N+1,3);i++) 
  	phi[i]=2*M_PI*ran3(&idum);
  if (TYPE==0) 				/* Gauss */
   for (k=0;k<=N/2;k++)
    for (i=0;i<=N/2;i++) 
      for (j=0;j<=N/2;j++) {
        r=exp(-0.25*M_PI*(pow(i*DX/LAMX,2)+pow(j*DY/LAMY,2)+pow(k*DZ/LAMZ,2)));
	p= k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
      }
  if (TYPE==1)                              /* Lorentz */
   for (k=0;k<=N/2;k++)
    for (i=0;i<=N/2;i++)
      for (j=0;j<=N/2;j++) {
        r=1/(1+pow((M_PI/2),2)*(pow(i*DX/LAMX,2)+pow(j*DY/LAMY,2)+pow(k*DZ/LAMZ,2)));
	p= k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
      }
  if (TYPE==2)                              /* Exponential */
   for (k=0;k<=N/2;k++)
    for (i=0;i<=N/2;i++)
      for (j=0;j<=N/2;j++) {
        r=exp(-sqrt(pow(i*DX/LAMX,2)+pow(j*DY/LAMY,2)+pow(k*DZ/LAMZ,2)));
	p= k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
      }
  if (TYPE==3){                              /* von Karman */
    r0=0.0001*DX*DY*DZ/(LAMX*LAMY*LAMZ);
   for (k=0;k<=N/2;k++)
    for (i=0;i<=N/2;i++)
      for (j=0;j<=N/2;j++) {
        r=sqrt(pow(i*DX/LAMX,2)+pow(j*DY/LAMY,2)+pow(k*DZ/LAMZ,2)); if (r<r0) r=r0;
	r=(2/M_PI)*K0(r);
	p= k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n= j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m= i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
	p= -k+N/2; m=-i+N/2; n=-j+N/2; l=2*(m+(n*N)+(p*N*N))+1; buf[l]=r; buf[l+1]=0;
      }
    }
  fourn(buf,dim,3,1);
  for (i=0;i<N*(N+1)*(N+1);i++) {
    r=pow(pow(buf[2*i+1],2)+pow(buf[2*(i+1)],2),0.25);
    buf[2*i+1]=r*cos(phi[i]); buf[2*(i+1)]=r*sin(phi[i]);
  }
  fourn(buf,dim,3,-1);
					/* correct statistics of realization */
  s1=0; for (k=0;k<N;k++) for (i=0;i<N;i++) for (j=0;j<N;j++) s1+=buf[2*(i+(j*N)+(k*N*N))+1];
  s1/=pow(N,3);
  s2=0; for (k=0;k<N;k++) for (i=0;i<N;i++) for (j=0;j<N;j++) s2+=pow(buf[2*(i+(j*N)+(k*N*N))+1]-s1,2);
  s2=sqrt(pow(N,3)*VAR/s2);
  for (k=0;k<N;k++) for (i=0;i<N;i++) for (j=0;j<N;j++) sfa[i][j][k]=s2*(buf[2*(i+(j*N)+(k*N*N))+1]-s1);

//  free((void*)buf); free((void*)phi);
  free((void*)(buf-1)); free((void*)phi);
}
/*-------------------------------------------------------------------------------------
K0: modified Bessel function K_0(x)
-------------------------------------------------------------------------------------*/
double K0(double x)
{
  double y,ans;

  if (x<=2) {
    y=x*x/4;
    ans=(-log(x/2)*I0(x))+(-0.57721566+y*(0.42278420
            +y*(0.23069756+y*(0.3488590e-1+y*(0.262698e-2
            +y*(0.10750e-3+y*0.74e-5))))));
  } else {
    y=2/x;
    ans=(exp(-x)/sqrt(x))*(1.25331414+y*(-0.7832358e-1
            +y*(0.2189568e-1+y*(-0.1062446e-1+y*(0.587872e-2
            +y*(-0.251540e-2+y*0.53208e-3))))));
  }
  return ans;
}

double I0(double x)
{
  double ax,ans;
  double y;

  if ((ax=fabs(x)) < 3.75) {
    y=x/3.75;
    y*=y;
    ans=1+y*(3.5156229+y*(3.0899424+y*(1.2067492
            +y*(0.2659732+y*(0.360768e-1+y*0.45813e-2)))));
  } else {
    y=3.75/ax;
    ans=(exp(ax)/sqrt(ax))*(0.39894228+y*(0.1328592e-1
            +y*(0.225319e-2+y*(-0.157565e-2+y*(0.916281e-2
            +y*(-0.2057706e-1+y*(0.2635537e-1+y*(-0.1647633e-1
            +y*0.392377e-2))))))));
  }
  return ans;
}

/*-------------------------------------------------------------------------------------
fourn: n-dimensional FFT from Press et al, 1992
-------------------------------------------------------------------------------------*/
void fourn(float *data, unsigned long *nn, int ndim, int isign)
{
  int idim;
  unsigned long i1,i2,i3,i2rev,i3rev,ip1,ip2,ip3,ifp1,ifp2;
  unsigned long ibit,k1,k2,n,nprev,nrem,ntot;
  float tempi,tempr;
  float theta,wi,wpi,wpr,wr,wtemp;

  for (ntot=1,idim=1;idim<=ndim;idim++) ntot *= nn[idim];
  nprev=1;
  for (idim=ndim;idim>=1;idim--) {
    n=nn[idim];
    nrem=ntot/(n*nprev);
    ip1=nprev << 1;
    ip2=ip1*n;
    ip3=ip2*nrem;
    i2rev=1;
    for (i2=1;i2<=ip2;i2+=ip1) {
      if (i2 < i2rev) {
        for (i1=i2;i1<=i2+ip1-2;i1+=2) {
          for (i3=i1;i3<=ip3;i3+=ip2) {
            i3rev=i2rev+i3-i2;
            SWAP(data[i3],data[i3rev]);
            SWAP(data[i3+1],data[i3rev+1]);
          }
        }
      }
      ibit=ip2 >> 1;
      while (ibit >= ip1 && i2rev > ibit) {
        i2rev -= ibit;
        ibit >>= 1;
      }
      i2rev += ibit;
    }
    ifp1=ip1;
    while (ifp1 < ip2) {
      ifp2=ifp1 << 1;
      theta=isign*6.28318530717959/(ifp2/ip1);
      wtemp=sin(0.5*theta);
      wpr = -2.0*wtemp*wtemp;
      wpi=sin(theta);
      wr=1.0;
      wi=0.0;
      for (i3=1;i3<=ifp1;i3+=ip1) {
        for (i1=i3;i1<=i3+ip1-2;i1+=2) {
          for (i2=i1;i2<=ip3;i2+=ifp2) {
            k1=i2;
            k2=k1+ifp1;
            tempr=(float)wr*data[k2]-(float)wi*data[k2+1];
            tempi=(float)wr*data[k2+1]+(float)wi*data[k2];
            data[k2]=data[k1]-tempr;
            data[k2+1]=data[k1+1]-tempi;
            data[k1] += tempr;
            data[k1+1] += tempi;
          }
        }
        wr=(wtemp=wr)*wpr-wi*wpi+wr;
        wi=wi*wpr+wtemp*wpi+wi;
      }
      ifp1=ifp2;
    }
    nprev *= n;
  }
}

