/*---------------------------------------------------------------------
VERSION 3.1,COPYRIGHT 5. 2005 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"
#include "string.h"

char *GetCircElement(int rad, double rx, double ry)
{
        int x,y,  i,N;
	long count=0;
	double rady;
	char *s;

	rady=rad*rx/ry;
	N=2+((int)rad*2+1)*((int)rady*2+1)/8+1;
	s = (char *)malloc(N);
	for(i=0;i<N;i++) s[i]=0;
	s[0]=char(rad); s[1]=char(rady);
	//printf("s[0]=%d\n",s[0]);
	
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if(y*ry*y*ry+x*rx*x*rx <= rad*rad)
			*(s+2+count/8) |= 1<<count%8;
	 	count++;
	}
/***************** print the structuring element**************
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	

	 	if(*(s+2+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("s[0]=%d\n",s[0]);
	 **********/ 	  
	return s;
}

char *GetCircElementDouble(double rad, double rx, double ry)
{
        int x,y,  i,N;
	long count=0;
	double rady;
	char *s;

	rady=rad*rx/ry;

	N=3+((int)rad*2+1)*((int)rady*2+1)/8+1;
	s = (char *)malloc(N);
	for(i=0;i<N;i++) s[i]=0;
	s[0]=char(rad); s[1]=char(rady);
	//printf("s[0]=%d\n",s[0]);
	
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if(y*ry*y*ry+x*rx*x*rx <= rad*rad)
			*(s+2+count/8) |= 1<<count%8;
	 	count++;
	}
/***************** print the structuring element*********************
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	

	 	if(*(s+2+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("s[0]=%d\n",s[0]);
***/ 
	 	  
	return s;
}
char *GetSphereElement(int rad, double rx, double ry, double rz)
{
        int x,y,z,  i,N;
	long count=0;
	double rady, radz;
	char *s;
	
	rady=rad*rx/ry;
	radz=rad*rx/rz;

	N=3+((int)rad*2+1)*((int)rady*2+1)*((int)radz*2+1)/8+1;
	s = (char *)malloc(N);
	for(i=0;i<N;i++) s[i]=0;
	s[0]=char(rad); s[1]=char(rady); s[2]=char(radz);
	rad*=rad;
	ry/=rx;ry*=ry;
	rz/=rx;rz*=rz;
	
	for(z=-s[2];z<=s[2];z++)
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if(z*rz*z+y*ry*y+x*x <= rad)
			*(s+3+count/8) |= 1<<count%8;
	 	count++;
	}
/***************** print the structuring element**************	  
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	
		if(i%((2*s[0]+1)*(2*s[1]+1))==0) printf("\n");	

	 	if(*(s+3+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("\n");
**********/	  
	return s;
}

char *GetSphereElementDouble(double rad, double rx, double ry, double rz, int *vol)
{
        int vv,x,y,z,  i,N;
	long count=0;
	double rady, radz;
	char *s;
	//r=(double)rad*Min;
	*vol=0;
	vv=0;
	

	rady=rad*rx/ry;
	radz=rad*rx/rz;

	N=int(3+((int)rad*2+1)*((int)rady*2+1)*((int)radz*2+1)/8+1);
	//N=int(3+(int)rad*2+1)*((int)rady*2+1)*((int)radz*2+1)/8+1);
	s = (char *)malloc(N);
	for(i=0;i<N;i++) s[i]=0;
	s[0]=char(rad); s[1]=char(rady); s[2]=char(radz);
	rad*=rad;
	ry/=rx;ry*=ry;
	rz/=rx;rz*=rz;
	for(z=-s[2];z<=s[2];z++)
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if(z*rz*z+y*ry*y+x*x <= rad){
			*(s+3+count/8) |= 1<<count%8;
			vv++;
	  }
	  count++;
	}
	*vol=vv;
	
/***************** print the structuring element**********************
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	
		if(i%((2*s[0]+1)*(2*s[1]+1))==0) printf("\n");	

	 	if(*(s+3+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("\n");
**/	  
	return s;
}

char *GetSphereElementDouble_old(double rad, double rx, double ry, double rz, int *vol)
{
        int vv,x,y,z,  i,N;
	long count=0;
	double Min,r,rr;
	char *s;
	
	Min = rx<=ry?rx:ry; Min= Min<=rz?Min:rz;

	/*** scale resolution towards 1 **/
	rx/=Min; ry/=Min; rz/=Min;

	r=(double)rad;
	//r=(double)rad*Min;
	*vol=0;
	vv=0;

	N=int(3+(rad*2+1)*(rad*2+1)*(rad*2+1)/8+1);
	s = (char *)malloc(N);
	for(i=0;i<N;i++) s[i]=0;
	s[0]=char(rad/rx); s[1]=char(rad/ry); s[2]=char(rad/rz);
	//s[0]=rad * Min/rx; s[1]=rad * Min/ry; s[2]=rad * Min/rz;
	
	for(z=-s[2];z<=s[2];z++)
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if(sqrt((double)z*rz*z*rz+y*ry*y*ry+x*rx*x*rx)<=rad*1.01){
			*(s+3+count/8) |= 1<<count%8;
			vv++;
	  }
	  count++;
	}
	*vol=vv;
/***************** print the structuring element**********************  
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	
		if(i%((2*s[0]+1)*(2*s[1]+1))==0) printf("\n");	

	 	if(*(s+3+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("\n");
**/	  
	return s;
}




char *GetSphereElement_old(int rad, double rx, double ry, double rz)
{
        int x,y,z,  i,N;
	long count=0;
	double Min,r,rr;
	char *s;
	
	Min = rx<=ry?rx:ry; Min= Min<=rz?Min:rz;

	/*** scale resolution towards 1 **/
	rx/=Min; ry/=Min; rz/=Min;

	r=(double)rad;
	//r=(double)rad*Min;

	N=3+(rad*2+1)*(rad*2+1)*(rad*2+1)/8+1;
	s = (char *)malloc(N);
	for(i=0;i<N;i++) s[i]=0;
	s[0]=char(rad/rx); s[1]=char(rad/ry); s[2]=char(rad/rz);
	//s[0]=rad * Min/rx; s[1]=rad * Min/ry; s[2]=rad * Min/rz;
	
	for(z=-s[2];z<=s[2];z++)
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if(sqrt((double)z*rz*z*rz+y*ry*y*ry+x*rx*x*rx)<=r*1.01)
			*(s+3+count/8) |= 1<<count%8;
	 	count++;
	}
/***************** print the structuring element**************	  
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	
		if(i%((2*s[0]+1)*(2*s[1]+1))==0) printf("\n");	

	 	if(*(s+3+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("\n");
**********/	  
	return s;
}

char *GetCircElementDouble_old(double rad, double rx, double ry)
{
        int x,y,  i,N;
	long count=0;
	double Min,r,rr;
	char *s;
	
	Min = rx<=ry?rx:ry;


	/*** scale resolution towards 1 **/
	rx/=Min; ry/=Min;

	N=3+((int)rad*2+1)*((int)rad*2+1)/8+1;
	s = (char *)malloc(N);
	for(i=0;i<N;i++) s[i]=0;
	s[0]=char(rad/rx); s[1]=char(rad/ry);
	//printf("s[0]=%d\n",s[0]);
	
	for(y=-s[1];y<=s[1];y++)
	for(x=-s[0];x<=s[0];x++){
	  if(sqrt((double)y*ry*y*ry+x*rx*x*rx)<=rad*1.01)
			*(s+2+count/8) |= 1<<count%8;
	 	count++;
	}
/***************** print the structuring element************************/ 
	for(i=0;i<count;i++){
		if(i%(2*s[0]+1)==0) printf("\n");	

	 	if(*(s+2+i/8)&1<<i%8)
			printf(" 1 ");
		else
			printf(" 0 ");
	}
	printf("s[0]=%d\n",s[0]);
	 	  
	return s;
}
