/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES 
---------------------------------------------------------------------------*/
#include "quantim4.h"

//hj_130214: corrected rPixel and wPixel for rgb images 
//S. Schlueter 17.02.2010 added 2d-capability of sequential rPixel(i,image) and wPixel(i,image,val)


//U. Weller 2.08.07 added 32 bit versions
/****** 2D grey Images ****/ 
/**************************/
void wPixel(unsigned long i, image_cc *im, int value)
{
  int x,y,z;

   if(im->ndim==3){ //if 3d, else 2d
	if(i>(size_t)(im->dim[0])*im->dim[1]*im->dim[2]) return;
	if(strcmp(im->itype,"btd")==0){
	z= i/(im->dim[0]*im->dim[1]);
	y= (i%(im->dim[0]*im->dim[1]))/im->dim[0];
	x= i%im->dim[0];
	if(value)
	*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes) |= 1<<z%8;
	else
	*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes) &= ~(1<<z%8);
	}
	else{
	point.p=(im->pix+im->numbytes*i);
	if(im->numbytes==1) *(point.p)=(unsigned char)value;
	else *(point.q)=(unsigned short)value;
	}
  }
  else{//2d
	if(i>im->dim[0]*im->dim[1]) return;
	point.p=(im->pix+im->numbytes*i);
	if(im->numbytes==1) *(point.p)=(unsigned char)value;
	else *(point.q)=(unsigned short)value;
  }
}
void wPIxel(unsigned long i, image_cc *im, double value)
{
  int x,y,z, size=1;
  for(x=0;x<im->ndim;x++)
    size*=im->dim[x];
  if(i>size) return;
  if(im->numbytes<4){
    wPixel(i, im, (int)value);
  }
  else{
    point.p=(im->pix+im->numbytes*i);
    if(im->numbytes==4) *(point.f)=(float)value;
    else *(point.d)=value;
  }
}

int rPixel(unsigned long i, image_cc *im)
{	
  int x,y,z;
  if(im->ndim==3){ //if 3d, else 2d
	if(i>(size_t)(im->dim[0])*im->dim[1]*im->dim[2]) return 0;
  	if(strcmp(im->itype,"btd")==0){
	z= i/(im->dim[0]*im->dim[1]);
	y= (i%(im->dim[0]*im->dim[1]))/im->dim[0];
	x= i%im->dim[0];
	if(*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes) & 1<<z%8)
	return 1;
	else
	return 0;
	}
	else{
	point.p=(im->pix+im->numbytes*i);
	if(im->numbytes==1) 	return *(point.p);
	else 			return *(point.q);
	}
  }
  else{ //2d
	if(i>im->dim[0]*im->dim[1]) return 0;
	point.p=(im->pix+im->numbytes*i);
	if(im->numbytes==1) 	return *(point.p);
	else 			return *(point.q);
  }
}
void wPixel(int x, int y, image_cc *im, int value)
{
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0) return;
  point.p=(im->pix+im->numbytes*(x+y*im->dim[0]));
  if(im->numbytes==1) *(point.p)=(unsigned char)value;
  else if(im->numbytes==2) *(point.q)=(unsigned short)value;
  else if(im->numbytes==sizeof(double)) *(point.d)=(double)value;
  else *(point.f)=value;
}
void wPixel(int x, int y, image_cc *im, double value)
{
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0) return;
  point.p=(im->pix+im->numbytes*(x+y*im->dim[0]));
  if(im->numbytes==1) *(point.p)=(unsigned char)value;
  else if(im->numbytes==2) *(point.q)=(unsigned short)value;
  else if(im->numbytes==sizeof(double)) *(point.d)=(double)value;
  else *(point.f)=(float)value;
}

int rPixel(int x, int y, image_cc *im)
{	
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0) return 0;
  point.p=(im->pix+im->numbytes*(x+y*im->dim[0]));
  if(im->numbytes==1) 	return *(point.p);
  else 	if(im->numbytes==2) 	return *(point.q);
  else 	return *(point.f);
}
double rPIxel(int x, int y, image_cc *im)
{
  if(im->numbytes<4)
    return(rPixel(x,y,im));
  
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0) return 0;
  point.p=(im->pix+im->numbytes*(x+y*im->dim[0]));
  if(im->numbytes==4)
    return *(point.f);
  else
    return *(point.d);
}
double rPIxel(int i, image_cc *im)
{
  if(im->numbytes<4)
    return(rPixel(i,im));
  
  point.p=(im->pix+im->numbytes*i);
  if(im->numbytes==4)
    return *(point.f);
  else
    return *(point.d);
}


/****** RGB Images ********/ 
/**************************/
void wPixel(int x, int y, image_cc *im, int vr, int vg, int vb) //corrected 130214
{	
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0) return;
  *(im->pix+im->numchannel*im->numbytes*(x+y*im->dim[0])+0) = vr; 
  *(im->pix+im->numchannel*(im->numbytes*(x+y*im->dim[0]))+1) = vg; 
  *(im->pix+im->numchannel*(im->numbytes*(x+y*im->dim[0]))+2) = vb; 
}
int rPixel(int x, int y, image_cc *im, int *vr, int *vg, int *vb) //corrected 130214
{	
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0) return 0;
  *vr=*(im->pix+im->numchannel*im->numbytes*(x+y*im->dim[0]));
  *vg=*(im->pix+im->numchannel*(im->numbytes*(x+y*im->dim[0]))+1);
  *vb=*(im->pix+im->numchannel*(im->numbytes*(x+y*im->dim[0]))+2);
  
  return (*vr+*vg+*vb)/3;
}
void wPixel(int x, int y, image_cc *im, int *value) //corrected 130214
{	
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0) return;
  for(int i=0;i<3;i++)
    *(im->pix+im->numchannel*(im->numbytes*(x+y*im->dim[0]))+i) = *(value+i); 
}
int rPixel(int x, int y, image_cc *im, int *value)
{	
  if(x>=im->dim[0]||y>=im->dim[1]||x<0||y<0){
    value[0]=value[1]=value[2]=0; 
    return 0;
  }
  if(im->numbytes == 1){
    value[0]=*(im->pix+im->numchannel*(x+y*im->dim[0]));
    value[1]=*(im->pix+im->numchannel*((x+y*im->dim[0]))+1);
    value[2]=*(im->pix+im->numchannel*((x+y*im->dim[0]))+2);
  }else{
    value[0]=*((unsigned short*)im->pix+im->numchannel*(x+y*im->dim[0]));
    value[1]=*((unsigned short*)im->pix+im->numchannel*(x+y*im->dim[0])+1);
    value[2]=*((unsigned short*)im->pix+im->numchannel*(x+y*im->dim[0])+2);
  }

  return (value[0]+value[1]+value[2])/3;
}

/****** 3D grey Images ****/ 
/**************************/
void wPixel(int x, int y, int z, image_cc *im, int value)
{
  if(x>=im->dim[0]||y>=im->dim[1]||z>=im->dim[2]||x<0||y<0||z<0) return;
  
  if(strcmp(im->itype,"btd")!=0){
    //point.p=(im->pix+x + im->numchannel*im->numbytes*(im->dim[0]*y + z*im->dim[0]*im->dim[1]));
    point.p=(im->pix + im->numchannel*im->numbytes*(x + im->dim[0]*y + (size_t)(z)*im->dim[0]*im->dim[1]));
    if(im->numbytes==1) 	*(point.p)=(unsigned char)value;
    else if(im->numbytes==2) *(point.q)=(unsigned short)value;
    else if(im->numbytes==sizeof(double)) *(point.d)=(double)value;
    else *(point.f)=value;
    //*(im->pix+x + im->numchannel*im->numbytes*(im->dim[0]*y + z*im->dim[0]*im->dim[1])) = value; 
  }
  else{
    if(value)
      (*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes)) |= 1<<z%8;
    else
      (*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes)) &= ~(1<<z%8);
  }
}
void wPixel(int x, int y, int z, image_cc *im, double value)
{
  if(x>=im->dim[0]||y>=im->dim[1]||z>=im->dim[2]||x<0||y<0||z<0) return;
  point.p=(im->pix + im->numchannel*im->numbytes*(x + im->dim[0]*y + (size_t)(z)*im->dim[0]*im->dim[1]));
  if(im->numbytes==1) 	*(point.p)=(unsigned char)value;
  else if(im->numbytes==2) *(point.q)=(unsigned short)value;
  else if(im->numbytes==sizeof(double)) *(point.d)=(double)value;
  else *(point.f)=(float)value;
}


int rPixel(int x, int y, int z, image_cc *im)
{
  if(x>=im->dim[0]||y>=im->dim[1]||z>=im->dim[2]||x<0||y<0||z<0) return 0;
  if(strcmp(im->itype,"btd")!=0){
    point.p=(im->pix+ im->numchannel*im->numbytes*(x + im->dim[0]*y + (size_t)(z)*im->dim[0]*im->dim[1]));
    if(im->numbytes==1) 	return *(point.p);
    else if(im->numbytes==2) return *(point.q);
    else return *(point.f);
    //return(*(im->pix+ im->numbytes*(x + im->dim[0]*y + z*im->dim[0]*im->dim[1])));
  }
  else{
    if(*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes) & 1<<z%8)
      return 1;
    else    return 0;
  }
}

double rPIxel(int x, int y, int z, image_cc *im)
{
  if(x>=im->dim[0]||y>=im->dim[1]||z>=im->dim[2]||x<0||y<0||z<0) return 0;
  
  point.p=(im->pix+ im->numchannel*im->numbytes*(x + im->dim[0]*y + z*im->dim[0]*im->dim[1]));
  if(im->numbytes==1) 	return *(point.p);
  else if(im->numbytes==2) return *(point.q);
  else if(im->numbytes==sizeof(double)) return *(point.d);
  else return *(point.f);
}

/*****************************************************/
/*** old functions, just for upward compatibiloity ***/
/*****************************************************/
//int WBtdVoxel(image_cc *im, int x, int y, int z,char val)
//void wPixel(int x, int y,int z, image_cc *im, int value)
//void wPixel(int x, int y, image_cc *image, unsigned char value)
//unsigned char rPixel(int x, int y, int z, image_cc *im)
//int RBtdVoxel(image_cc *im, int x, int y, int z)
//unsigned char rPixel(int x, int y, image_cc *image)


int WBtdVoxel(image_cc *im, int x, int y, int z,char val)
{
  if(val)
    (*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes)) |= 1<<z%8;
  else
    (*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes)) &= ~(1<<z%8);
}

int RBtdVoxel(image_cc *im, int x, int y, int z)
{
  if(*(im->pix + z/8 + x*im->numbytes + y*im->dim[0]*im->numbytes) & 1<<z%8)
    return 1;
  else    return 0;
}
