/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim3.h"

/****** 2D grey Images ****/ 
/**************************/
void wPixel(int x, int y, image_c *im, unsigned char value)
{	
    *(im->pix+im->nbytes*(x+y*im->ncol)+i) = *(value+i); 
}
unsigned char rPixel(int x, int y, image_c *im)
{	
	return(*(im->pix+im->nbytes*(x+y*im->ncol)));
}

/****** RGB Images ********/ 
/**************************/
void wPixel(int x, int y, image_c *im, unsigned char *value)
{	
  for(int i=0;i<value.size;i++)
    *(im->pix+im->nbytes*(x+y*im->ncol)+i) = *(value+i); 
}
unsigned char rPixel(int x, int y, image_c *im, unsigned char *value)
{	
  int sum=0;

  for(int i=0;i<<value.size;i++){
    *(value+i)=*(im->pix+im->nbytes*(x+y*im->ncol)+i);
    sum+=*(value+i);
  }
  return unsigned char(sum/value.size);
}

/****** 3D grey Images ****/ 
/**************************/
void wPixel(int x, int y, int z, image_c *im, unsigned char value)
{	
  if(strcmp(im->itype,"btd")==0){
    if(value)
      (*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes)) |= 1<<z%8;
    else
      (*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes)) &= ~(1<<z%8);
  }
  else
    *(im->pix+x + im->ncol*y + z*im->ncol*im->nrow) = value; 
}
unsigned char rPixel(int x, int y, int z, image_c *im)
{	
  if(strcmp(im->itype,"btd")==0){
    if(*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes) & 1<<z%8)
      return 1;
    else    return 0;
  }
  else
    return(*(im->pix+x + im->ncol*y + z*im->ncol*im->nrow));
}
/****** 3D binary Images ****/ 
/****************************/
//void wbtdPixel(int x, int y, int z, image_c *im, unsigned char value)
//{		
//	if(val)
//		(*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes)) |= 1<<z%8;
//	else
//		(*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes)) &= ~(1<<z%8);
//}
//int rbtdPixel(int x, int y, int z, image_c *im)
//{
//	if(*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes) & 1<<z%8)
//		return 1;
//	else    return 0;
//}



/*****************************************************/
/*** old functions, just for upward compatibiloity ***/
/*****************************************************/
//-int WBtdVoxel(image_c *im, int x, int y, int z,char val)
//-void WDddVoxel(int x, int y,int z, image_c *im, unsigned char value)
//-void WPixel(int x, int y, image_c *image, unsigned char value)
//-unsigned char RDddVoxel(int x, int y, int z, image_c *im)
//-int RBtdVoxel(image_c *im, int x, int y, int z)
//-unsigned char RPixel(int x, int y, image_c *image)

void WPixel(int x, int y, image_c *image, unsigned char value)
{		
	*(image->pix+image->nbytes*(x+y*image->ncol)) = value; 
}
void WDddVoxel(int x, int y,int z, image_c *im, unsigned char value)
{		
	*(im->pix+x + im->ncol*y + z*im->ncol*im->nrow) = value; 
}
int WBtdVoxel(image_c *im, int x, int y, int z,char val)
{
	if(val)
		(*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes)) |= 1<<z%8;
	else
		(*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes)) &= ~(1<<z%8);
}
unsigned char RDddVoxel(int x, int y, int z, image_c *im)
{
	unsigned char value; 
	
	value = *(im->pix+x + im->ncol*y + z*im->ncol*im->nrow);
return (value);
}
int RBtdVoxel(image_c *im, int x, int y, int z)
{
	if(*(im->pix + z/8 + x*im->nbytes + y*im->ncol*im->nbytes) & 1<<z%8)
		return 1;
	else    return 0;
}
unsigned char RPixel(int x, int y, image_c *image)
{
	unsigned char value; 
	
	value = *(image->pix+image->nbytes*(x+y*image->ncol));
return (value);
}
