/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES

%--------------------------------- hj 14.04.04
\command{       % COMMAND
void ps3Dview(char *fname, image\_c *image, double min, double max);
}{              % DESCRIPTION
Draws a 3D colored view of a ddd-image and write an eps-file. 

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*fname}{name of the resulting eps-file}
\argu{*image}{Pointer to the ddd-image.}
\argu{min, max}{miniumum and maximum greylevel inbetween which the color is scaled.}
}
---------------------------------------------------------------------------*/

#include "quantim4.h"
#include "PSgraf3.h"


#define NCTR 65
#define MAXHUE 0.7

void ps3Dview(char *fname, image_cc *image, double min, double max)
{
	int i,j, x,y,z;
	double ctr[NCTR], c0[NCTR+1], c1[NCTR+1],  c2[NCTR+1];
	struct dvec X0, X1, X2,illum;
	double ***f;
	int  dx, dy, dz;


	dx=image->dim[0];
	dy=image->dim[1];
	dz=image->dim[2];
	f=(double ***)malloc(image->dim[0]*sizeof(double **));
	for(i=0;i<image->dim[0];i++){
	  f[i]=(double **)malloc(image->dim[1]*sizeof(double *));
	  for(j=0;j<image->dim[1];j++)
	    f[i][j]=(double *)malloc(image->dim[2]*sizeof(double));
	}

	for(x=0;x<image->dim[0];x++)
	for(y=0;y<image->dim[1];y++)
	  for(z=0;z<image->dim[2];z++){
	    f[x][y][z]=double(rPixel(x,y,z,image));
	    if(f[x][y][z]<min)f[x][y][z]=min;
	    else if(f[x][y][z]>max)f[x][y][z]=max;
	  }

	
	X0.dim = X1.dim = X2.dim = illum.dim = 3;

	gPaper(fname);

	sXWorldCoord(0,dx,0,(double)PSWIDTH);
	sYWorldCoord(0,dy,0,(double)PSWIDTH*dy/dx);
	sZWorldCoord(0,dz,0,(double)PSWIDTH*dz/dx);

	
	
	X0.x=0;  X0.y=0; X0.z=0;
	X1.y=-1;
	X1.z=-1;
        X1.x=-1; 
	X2.x=1;  X2.y=0; X2.z=-1;
	sView(X1,X2);

	sColorSpace("HSB");

	for(i=0;i<NCTR;i++){
	  ctr[i]=min+i+1 * (max-min)/(NCTR+1);
	  c0[i]=MAXHUE*i/(NCTR-1); 
	  c1[i]=1;
	  c2[i]=1;
	}
	c0[NCTR]=MAXHUE; c1[NCTR]=1; c2[NCTR]=0.8;
	sContours(ctr,NCTR,c0,c1,c2);

	illum.dim=3; illum.x=-0.3; illum.y=-1;illum.z=-0.6;
	sCBlock(0,1,dx,0,dx-1,
		0,1,dy,0,dy-1,
		0,1,dz,0,dz-1,1,illum);
	dCBlock(f,1,0);
	sCBlock(0,1,dx,(int)(0.2*dx),dx-1,
		0,1,dy,(int)(0.5*dy),dy-1,
		0,1,dz,(int)(0.3*dz),dz-1,0,illum);
	dCBlock(f,1,0);
	sCBlock(0,1,dx,(int)(0.5*dx),dx-1,
		0,1,dy,0,(int)(0.5*dy),
		0,1,dz,(int)(0.5*dz),dz-1,0,illum);
	dCBlock(f,1,0);

	endPS();
}
#undef NCTR
#undef MAXHUE



