/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"
#include "PSgraf3.h"


	void set_line(int i);

void psMultiPlot(char *fname, int *ndat, int nplot, double **xdat, double **ydat, int mode)
{
	int i, p;
	double sx, sy, maxx, maxy, minx, miny;
	char xtitle[127], ytitle[127];
	
	sprintf(xtitle,"x values");
	sprintf(ytitle,"y values");

	gPaper(fname);

	/***** scaling *************************/
	maxx=minx=xdat[0][0];
	maxy=miny=ydat[0][0];
	for(p=0;p<nplot;p++)
	for(i=0;i<ndat[p];i++){
		if(xdat[p][i]>maxx) maxx=xdat[p][i];
		if(xdat[p][i]<minx) minx=xdat[p][i];
		if(ydat[p][i]>maxy) maxy=ydat[p][i];
		if(ydat[p][i]<miny) miny=ydat[p][i];
	}

	sXWorldCoord(minx*1.05,maxx*1.05,0.,PSWIDTH+YTIT);
	sYWorldCoord(miny*1.05,maxy*1.05,0.,PSHIGHT+XTIT);

	/***** axis *************************/
	dYAxis(minx*1.05, miny*1.05, maxy*1.05,1);
	dXAxis(minx*1.05, miny*1.05, maxx*1.05,1);
	sText(FONT, 12,'C','T');
	sTextRotation(90);
	movea('W',minx*1.05,(maxy+miny)/2);
	mover('P', YTIT,0);
	dText(ytitle);
	sText(FONT, 12,'C','B');
	sTextRotation(0);
	movea('W',maxx*1.05/2,miny*1.05);
	mover('P',0, XTIT);
	dText(xtitle);
		
	/***** plot data *************************/
	for(p=0;p<nplot;p++){
		if(mode==0){
 	   	   for(i=0;i<ndat[p];i++)
	   		dSymbol('W',xdat[p][i],ydat[p][i],1,p);
		}
		else{
			set_line(p);
			dPolygon('W',xdat[p],ydat[p],ndat[p]);
			set_line(0);
		}
	}	
	endPS();
}

void set_line(int i)
{  
  sThickness(0.1);  
  switch(i){
  	case 0:    sDash("[] 0"); break;
  	case 1:    sDash("[1.5] 0"); break;
  	case 2:    sDash("[2 0.5] 0"); break;
  	case 3:    sDash("[4 1] 0"); break;
  	case 4:    sThickness(0.3); sDash("[] 0"); break;
  	case 5:    sThickness(0.3); sDash("[1.5] 0"); break;
  	case 6:    sThickness(0.1); sDash("[0.5] 0"); break;
  	case 7:    sThickness(0.3); sDash("[4 1] 0"); break;
  	case 8:    sThickness(0.5); sDash("[] 0"); break;
	default:   sDash("[] 0"); break;	
  }
}   
/**************************************************/
