/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES


%--------------------------------- hj 26.1.00
\command{       % COMMAND
double BtdEuler6(image\_c *image, long int *h);
}{              % DESCRIPTION
Returnes the volumetric Euler number of a 3D binary structure considering 6-connectivity of phase [1]

\medskip        %ARGUMENTS AND RETURN VALUE
\argu{*h}{Pointer to the array of voxel configurations obtained by BtdQuant()}
\return{Euler number [1/L$^3$]  in units of image->res[0]}
}

---------------------------------------------------------------------------*/
#include "quantim4.h"



unsigned char Red(image_cc *in,int x,int y)
{
 return *(in->pix+in->numchannel*(x+y*in->dim[0]));
}

unsigned char Green(image_cc *in,int  x,int y)
{
 return *(in->pix+in->numchannel*(x+y*in->dim[0])+1);
}
unsigned char Blue(image_cc *in,int  x,int y)
{
 return *(in->pix+in->numchannel*(x+y*in->dim[0])+2);
}

void WRed(image_cc *in,int   x,int  y, unsigned char val)
{
  *(in->pix+in->numchannel*(x+y*in->dim[0]))=val;
}

void WGreen(image_cc *in,int   x,int  y, unsigned char val)
{
  *(in->pix+in->numchannel*(x+y*in->dim[0])+1)=val;
}

void WBlue(image_cc *in,int   x,int  y, unsigned char val)
{
  *(in->pix+in->numchannel*(x+y*in->dim[0])+2)=val;
}

void WRGBPixel(image_cc *in, int  x,int  y,unsigned char rval,unsigned char gval,unsigned char bval)
{
  *(in->pix+in->numchannel*(x+y*in->dim[0]))=rval;
  *(in->pix+in->numchannel*(x+y*in->dim[0])+1)=gval;
  *(in->pix+in->numchannel*(x+y*in->dim[0])+2)=bval;
}
void GetRGBImageNew(image_cc *image, char *buf)
{
	long row;
	TIFF *tif;

	if((tif = TIFFOpen(buf, "r"))==0)
		printf("\ncould not open %s\n",buf);
	sprintf(image->name,"%s",buf);
	TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &image->dim[1]);
	TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &image->dim[0]);
	TIFFGetField(tif, TIFFTAG_SAMPLESPERPIXEL, &image->numchannel);
	TIFFGetField(tif, TIFFTAG_BITSPERSAMPLE, &image->dim[2]);
	TIFFGetField(tif, TIFFTAG_ROWSPERSTRIP, &RPS);

//	if(!image->numbytes)
		image->numchannel=3;
	printf("Image name: %s\n",image->name);
	printf("Bytes per pixel: %d\n", image->numchannel);
	printf("Image hight: %d\n", image->dim[1]);
	printf("Image width: %d\n", image->dim[0]);
	printf("Rows per Strip: %d\n", RPS);

	image->pix =(unsigned char *)malloc(image->dim[1]*image->dim[0]*image->numchannel);

	for (row = 0; row < image->dim[1]; row++)
TIFFReadScanline(tif, image->pix+(row*image->dim[0]*image->numchannel), row,0);

TIFFClose(tif);
}

void SaveRGBImageNew(image_cc *image, char *buf)
{
	long row;
	TIFF *tif;

	tif = TIFFOpen(buf, "w");
	TIFFSetField(tif, TIFFTAG_IMAGELENGTH, image->dim[1]);
	TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, 2);
	TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, image->dim[0]);
	TIFFSetField(tif, TIFFTAG_COMPRESSION, 1);
	TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
	TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 8,8,8);
	TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, image->numchannel);

	TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, RPS);
	//TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, 3);

	for (row = 0; row < image->dim[1]; row++)
	  //TIFFWriteScanline(tif, image->pix+(row*image->dim[0]*image->numbytes), row,2);
TIFFWriteScanline(tif, image->pix+(row*image->dim[0]*image->numchannel), row,0);

TIFFClose(tif); 
}




image_cc *ScaleRGBImage(image_cc *im, double sc) 
{

	int x,y,n,m,xx,yy;
	unsigned long count;
	image_cc *red;
	
	red=InitImage(int(im->dim[0]*sc), int(im->dim[1]*sc),0,"rgb");
	
	for(y=0;y<red->dim[1];y++)
		for (x=0;x<red->dim[0];x++){
			wPixel(x,y,red,Red(im,int(x/sc),int(y/sc)),Green(im,int(x/sc),int(y/sc)),Blue(im,int(x/sc),int(y/sc)));
		}
	return red;
}

