/*---------------------------------------------------------------------
VERSION 1.0,COPYRIGHT 5. 1998 H.J. VOGEL
quantim IS LICENSED FREE OF CHARGE. THEREFORE THIS FILE,AND ALL THE ACCOMPANYING FILES WHICH IN THEIR ENTIRETY CONSTITUTE quantim, ARE PROVIDED "AS IS",WITHOUT WARRANTY OF ANY KIND,WHETHER EXPRESSED OR IMPLIED. YOU ARE RESPONSIBLE FOR
ASCERTAINING THE FITNES
---------------------------------------------------------------------------*/
#include "quantim4.h"
#include "string.h"

image_cc *ImageSegment(image_cc *image, int ulx, int uly, int dx, int dy)
{
  int i,x,y;
  image_cc *cut;

  cut=InitImage(dx,dy, 0, image->itype);
	
/******/
  dx*=image->numchannel*image->numbytes;
  dy*=image->numchannel*image->numbytes;
  ulx*=image->numchannel*image->numbytes;
  uly*=image->numchannel*image->numbytes;

  for(i=0;i<cut->dim[0]*cut->dim[1]*cut->numchannel*cut->numbytes;i++) 
    *(cut->pix+i)=*(image->pix+((i%dx+ulx) + (i/dx+uly)*image->dim[0]*image->numchannel*image->numbytes));
	
  return cut;
}

image_cc *ImageSegment(image_cc *image, int ulx, int uly, int ulz, int dx, int dy, int dz)
{
  int x,y,z;
  image_cc *cut;

  cut=InitImage(dx,dy,dz, 0, image->itype);
  cut->res[0]=image->res[0];
  cut->res[1]=image->res[1];
  cut->res[2]=image->res[2];

  for(z=0;z<dz;z++)
    for(y=0;y<dy;y++)
      for(x=0;x<dx;x++){
	if(strncmp(image->itype,"ddd",3)==0)
	  //*(cut->pix+x + cut->dim[0]*y + z*cut->dim[0]*cut->dim[1]) = rPixel(x+ulx,y+uly,z+ulz,image);  	
	  wPixel(x,y,z,cut,rPixel(x+ulx,y+uly,z+ulz,image));  	
	else{
	  if(rPixel(x+ulx,y+uly,z+ulz,image))
	    *(cut->pix + z/8 + x*cut->numbytes + y*cut->dim[0]*cut->numbytes) |= 1<<z%8;
	}
      }
  return cut;
}

image_cc *GetPlane(image_cc *im,int plane, int mode)
{
  int x,y,z, btd=0;
  image_cc *outim;
	
  if(strcmp(im->itype,"btd")==0) btd=1;

  switch(mode){
  case 2: 
    if(im->numbytes==2)
    	outim=InitImage(im->dim[0],im->dim[2], 255, "gry16");
    else	
    	outim=InitImage(im->dim[0],im->dim[2], 255);
    outim->res[0] = im->res[0];
    outim->res[1] = im->res[2];
    for(x=0;x<im->dim[0];x++)
      for(y=0;y<im->dim[2];y++){
	if(strncmp(im->itype,"ddd",3)==0)
	//if(im->numbytes==im->dim[2])
	  wPixel(x,y,outim,rPixel(x,plane,y,im));
	else
	  wPixel(x,y,outim,rPixel(x,plane,y,im)*255);
      }
    break;
  case 1:
    if(im->numbytes==2)
    	outim=InitImage(im->dim[1],im->dim[2], 255, "gry16");
    else	
    	outim=InitImage(im->dim[1],im->dim[2], 255);
    outim->res[0] = im->res[1];
    outim->res[1] = im->res[2];
    for(x=0;x<im->dim[1];x++)
      for(y=0;y<im->dim[2];y++){
	if(strncmp(im->itype,"ddd",3)==0)
	//if(im->numbytes==im->dim[2])
	  wPixel(x,y,outim,rPixel(plane,x,y,im));
	else
	  wPixel(x,y,outim,rPixel(plane,x,y,im)*255);
      }
    break;
  case 0:
    if(im->numbytes==2)
    	outim=InitImage(im->dim[0],im->dim[1], 255, "gry16");
    else	
    	outim=InitImage(im->dim[0],im->dim[1], 255);
    outim->res[0] = im->res[0];
    outim->res[1] = im->res[1];
    for(x=0;x<im->dim[0];x++)
      for(y=0;y<im->dim[1];y++){
	if(strncmp(im->itype,"ddd",3)==0)
	//if(im->numbytes==im->dim[2])
	  wPixel(x,y,outim,rPixel(x,y,plane,im));
	else
	  wPixel(x,y,outim,rPixel(x,y,plane,im)*255);
      }
    break;
  default:
    printf("\nGetPlane: No valid mode of section plane\n");
    return 0;
    break;
  }	
  return outim;
}

void InvertImage(image_cc *im)
{
  int x,y,z,i, maxg;
  int rgb[3];

  //maxg=(int)pow(2,im->numbits)-1;	
  maxg=im->numbytes==2?65535:255;	

  if(strncmp(im->itype,"gry",3)==0){  	
    for(x=0; x<im->dim[0];x++)
      for(y=0; y<im->dim[1];y++)
	wPixel(x,y,im,maxg-rPixel(x,y,im));
  }
  else if(strcmp(im->itype,"rgb")==0){
    for(x=0; x<im->dim[0];x++)
      for(y=0; y<im->dim[1];y++){
	rPixel(x,y,im,rgb);
	for(i=0;i<3;i++)
	  rgb[i]=255-rgb[i];
	wPixel(x,y,im,rgb);
      }
  }
  else if(strncmp(im->itype,"ddd",3)==0){
     for(z=0; z<im->dim[2];z++)
       for(x=0; x<im->dim[0];x++)
	 for(y=0; y<im->dim[1];y++)
	   wPixel(x,y,z,im,maxg-rPixel(x,y,z,im));

  }
  else if(strcmp(im->itype,"btd")==0 ){
     for(z=0; z<im->dim[2];z++)
       for(x=0; x<im->dim[0];x++)
	 for(y=0; y<im->dim[1];y++)
	   wPixel(x,y,z,im,1-rPixel(x,y,z,im));
  }
  else
    printf("\nInvertImage: No valid image type\n");
}

void FlipImage(image_cc *im, int mode)
/********
mode =0 -> horizontal flip
mode =1 -> vertical
********/
{
  image_cc *outim;
  int x,y;
  int rgb[3];


  outim=InitImage(im->dim[0],im->dim[1],0,im->itype);

  if(strncmp(im->itype,"gry",3)==0){  
      for(x=0;x<im->dim[0];x++)
	for(y=0;y<im->dim[1];y++)
	  switch(mode){
	  case 0:
	    wPixel(outim->dim[0]-x-1,y,outim,rPixel(x,y,im));
	    break;
	  case 1:
	    wPixel(x,outim->dim[1]-y-1,outim,rPixel(x,y,im));
	    break;
	  default:
	    printf("\nFlipImage: no valid mode\n");
	    break;
	  }    
  }
  else if(strcmp(im->itype,"rgb")==0){
    for(x=0; x<im->dim[0];x++)
      for(y=0; y<im->dim[1];y++){
	rPixel(x,y,im,rgb);
	switch(mode){
	case 0:
	  wPixel(outim->dim[0]-x-1,y,outim,rgb);
	  break;
	case 1:
	  wPixel(x,outim->dim[1]-y-1,outim,rgb);
	  break;
	default:
	  printf("\nFlipImage: no valid mode\n");
	    break;
	}    
      }
  }
  else
    printf("\nFlipImage: only valid for 2D images\n");

  for(x=0;x<im->dim[0]*im->dim[1]*im->numchannel*im->numbytes;x++)
    *(im->pix+x)=*(outim->pix+x);
  DeleteImage(outim);
  
}

void RotateImage(image_cc *im, int mode)
/********
mode =-1 -> 90 degree counter clock wise
mode = 1 ->  90 degree clock wise
mode = 0 ->  180 drgree
********/
{
  image_cc *outim;
  int x,y;
  int rgb[3];

  if(mode!=0)
    outim=InitImage(im->dim[1],im->dim[0],0,im->itype);
  else
    outim=InitImage(im->dim[0],im->dim[1],0,im->itype);

  if(strncmp(im->itype,"gry",3)==0){  
      for(x=0;x<im->dim[0];x++)
	for(y=0;y<im->dim[1];y++)
	  switch(mode){
	  case -1:
	    wPixel(y,outim->dim[1]-x-1,outim,rPixel(x,y,im));
	    break;
	  case 1:
	    wPixel(outim->dim[0]-y-1,x,outim,rPixel(x,y,im));
	    break;
	  case 0:
	    wPixel(outim->dim[0]-x-1,outim->dim[1]-y-1,outim,rPixel(x,y,im));
	    break;
	  default:
	    printf("\nFlipImage: no valid mode\n");
	    break;
	  }    
  }
  else if(strcmp(im->itype,"rgb")==0){
    for(x=0; x<im->dim[0];x++)
      for(y=0; y<im->dim[1];y++){
	rPixel(x,y,im,rgb);
	switch(mode){
	  case -1:
	    wPixel(y,outim->dim[1]-x-1,outim,rgb);
	    break;
	  case 1:
	    wPixel(outim->dim[0]-y-1,x,outim,rgb);
	    break;
	  case 0:
	    wPixel(outim->dim[0]-x-1,outim->dim[1]-y-1,outim,rgb);
	    break;
	default:
	  printf("\nFlipImage: no valid mode\n");
	    break;
	}    
      }
  }
  else
    printf("\nFlipImage: only valid for 2D images\n");

  for(x=0;x<im->dim[0]*im->dim[1]*im->numchannel*im->numbytes;x++)
    *(im->pix+x)=*(outim->pix+x);
  im->dim[0]=outim->dim[0];
  im->dim[1]=outim->dim[1];
  DeleteImage(outim);
  
}

image_cc *TurnImage(image_cc *im,double grad)
{
 	int x,y,xx,yy, xm, ym;
 	double X,Y;
	unsigned long i; 	       
        image_cc *outim;
	int rgb[3];
        
        outim=InitImage(im->dim[0],im->dim[1],0,im->itype);
	xm=im->dim[0]/2;
	ym=im->dim[1]/2;
		
	printf("\n%s \n",im->itype);
	
        for(x=0;x<im->dim[0];x++)
	   for(y=0;y<im->dim[1];y++){
		X=(double)(x-xm)*cos(grad*M_PI/180)+(y-ym)*sin(grad*M_PI/180);
		Y=(double)-(x-xm)*sin(grad*M_PI/180)+(y-ym)*cos(grad*M_PI/180);
	   	X+=xm;
		Y+=ym;
		xx=int(X+0.5); yy=int(Y+0.5);
		if(strcmp(im->itype,"rgb")==0){
		  rPixel(x,y,im,rgb);
		  if(xx>1 && xx<im->dim[0]-1 && yy>1 && yy<im->dim[1]-1){
		    wPixel(xx,yy,outim,rgb);
		    for(i=0;i<4;i++)
		      wPixel(xx+neigh4x[i],yy+neigh4y[i],outim,rgb);
		  }
		}
		else if(strncmp(im->itype,"gry",3)==0){
		  if(xx>1 && xx<im->dim[0]-1 && yy>1 && yy<im->dim[1]-1){
		    wPixel(xx,yy,outim,rPixel(x,y,im));
		    for(i=0;i<4;i++)
		      wPixel(xx+neigh4x[i],yy+neigh4y[i],outim,rPixel(x,y,im));
		  }
		}
		else
		  printf("\nTurnImage: only valid for 2D images\n");
	}
	return outim;
}

/*** to do

- ScaleImage(image_cc *image, double scale) 
    ->replace  DddResRed, ChangeResolution + include rgb bin and btd

***/

image_cc *ChangeResolution( image_cc *in, int newx, int newy ){

  image_cc *out = InitImage( newx, newy, 0 );
  double newincx = 1.0/out->dim[0];
  double newincy = 1.0/out->dim[1];
  double oldincx = 1.0/in->dim[0];
  double oldincy = 1.0/in->dim[1];
  double dnewx1, dnewy1, dnewx2, dnewy2, doldx1, doldy1, doldx2, doldy2;
  double x1,y1,x2,y2;
  int ioldx1, ioldy1, ioldx2, ioldy2;
  double w,w1,w2,w3,w4, val, mean, wtot;
  int x,y,i,j;

  out->res[0]=in->res[0]*(double)in->dim[0]/newx;
  out->res[1]=in->res[1]*(double)in->dim[1]/newy;
 
  mean = 0.0;
  for( y=0; y<in->dim[1]; y++ )
    for( x=0; x<in->dim[0]; x++ )
      mean += rPixel(x,y,in);
  mean /= in->dim[1]*in->dim[0];
  printf( "orig Mean: %f\n", mean );

  for( y=0; y<out->dim[1]; y++ ){
    dnewy1 = y * newincy;
    dnewy2 = (y+1) * newincy;
    doldy1 = dnewy1/oldincy;
    ioldy1 = (int)(doldy1-0.0001);
    doldy2 = dnewy2/oldincy;
    ioldy2 = (int)(doldy2-0.0001);

    for( x=0; x<out->dim[0]; x++ ){
      dnewx1 = x * newincx;
      dnewx2 = (x+1) * newincx;
      doldx1 = dnewx1/oldincx;
      ioldx1 = (int)(doldx1);
      doldx2 = dnewx2/oldincx;
      ioldx2 = (int)(doldx2);

      val = 0;
      wtot=0;	

      if( (ioldx1 == ioldx2) && (ioldy1 == ioldy2 ) )
        val = rPixel( ioldx1, ioldy1, in );

      if( (ioldx1 != ioldx2) && (ioldy1 == ioldy2 ) ){
        w1 = ( (ioldx1+1)*oldincx - dnewx1 ) / newincx;
        w2 = ( dnewx2 - ioldx2*oldincx ) / newincx;

        w1 = ( doldx1 != 0 )     ? w1 : 0.0; 
        w2 = ( doldx2 < in->dim[0] ) ? w2 : 0.0; 

        x2 = (ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;

        val = w1 * rPixel(ioldx1,ioldy1,in) + w2 * rPixel(int(x2),ioldy1,in);
        
        for( i=(doldx1==0)?0:1; i<(ioldx2 - ioldx1); i++ )
          val += (oldincx*oldincy)/(newincx*newincy) * rPixel(ioldx1+i,ioldy1,in);
      }

      if( (ioldx1 == ioldx2) && (ioldy1 != ioldy2 ) ){
        w1 = ( (ioldy1+1)*oldincy - dnewy1 ) / newincy;
        w2 = ( dnewy2 - ioldy2*oldincy ) / newincy;

        w1 = ( doldy1 != 0 )     ? w1 : 0.0; 
        w2 = ( doldy2 < in->dim[1] ) ? w2 : 0.0; 

        y2 = (ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;

        val = w1 * rPixel(ioldx1,ioldy1,in) + w2 * rPixel(ioldx1,int(y2),in);
        
        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          val += (oldincx*oldincy)/(newincx*newincy) * rPixel(ioldx1,ioldy1+i,in);
      }
      
      if( (ioldx1 != ioldx2) && (ioldy1 != ioldy2 ) ){

        w1 = (((ioldx1+1)*oldincx-dnewx1)*((ioldy1+1)*oldincy-dnewy1)) / (newincx * newincy);
        w2 = (((ioldx1+1)*oldincx-dnewx1)*(dnewy2-ioldy2*oldincy)) / (newincx * newincy); 
        w3 = ((dnewx2-ioldx2*oldincx)*((ioldy1+1)*oldincy-dnewy1)) / (newincx * newincy);
        w4 = ((dnewx2-ioldx2*oldincx)*(dnewy2-ioldy2*oldincy)) / (newincx * newincy);

        w1 = ( doldx1 != 0 && doldy1 != 0 )             ? w1 : 0.0;
        w2 = ( doldx1 != 0 && doldy2 < in->dim[1] )       ? w2 : 0.0;
        w3 = ( doldx2 < in->dim[0] && doldy1 != 0 )       ? w3 : 0.0;
        w4 = ( doldx2 < in->dim[0] && doldy2 < in->dim[1] ) ? w4 : 0.0;

        x2 = ( ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;
        y2 = ( ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;

        val = w1 * rPixel(ioldx1,ioldy1,in) +
              w2 * rPixel(ioldx1,int(y2),in)+
              w3 * rPixel(int(x2),ioldy1,in)+
              w4 * rPixel(int(x2),int(y2),in);

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          for( j=(doldx1 == 0)?0:1; j<(ioldx2 - ioldx1); j++ )
            val += (oldincx*oldincy)/(newincx*newincy) * rPixel(ioldx1+j,ioldy1+i,in);

        for( i=(doldx1 == 0)?0:1; i<(ioldx2 - ioldx1); i++ ){
          w = ( oldincx * ((ioldy1+1)*oldincy-dnewy1) ) / (newincx * newincy);
          w = ( doldy1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,ioldy1,in);

          w = ( oldincx * (dnewy2-ioldy2*oldincy) ) / (newincx * newincy);
          w = ( doldy2 < in->dim[1] ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,int(y2),in);
        }

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ ){
          w = ( ((ioldx1+1)*oldincx-dnewx1) * oldincy ) / (newincx * newincy);
          w = ( doldx1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1+i,in);


          w = ( (dnewx2-ioldx2*oldincx) * oldincy ) / (newincx * newincy);
          w = ( doldx2 < in->dim[0] ) ? w : 0.0;
          val += w * rPixel(int(x2),ioldy1+i,in);
        }
      }
      wPixel( x, y, out, (unsigned char)val);
    }
  }

  mean = 0.0;
  for( y=0; y<out->dim[1]; y++ )
    for( x=0; x<out->dim[0]; x++ )
      mean += rPixel(x,y,out);
  mean /= out->dim[1]*out->dim[0];
  printf( "rescaled Mean: %f\n", mean );


  return(out);
}

image_cc *ChangeResolution( image_cc *in, int newx, int newy, int newz ){

  image_cc *out = InitImage(newx, newy, newz, 0, in->itype);
  double newincx = 1.0/out->dim[0];
  double newincy = 1.0/out->dim[1];
  double newincz = 1.0/out->dim[2];
  double oldincx = 1.0/in->dim[0];
  double oldincy = 1.0/in->dim[1];
  double oldincz = 1.0/in->dim[2];
  double dnewx1, dnewy1, dnewz1,  dnewx2, dnewy2, dnewz2, doldx1, doldy1, doldz1, doldx2, doldy2, doldz2;
  double x1,y1,z1,x2,y2,z2;
  int ioldx1, ioldy1, ioldz1, ioldx2, ioldy2, ioldz2;
  double w,w1,w2,w3,w4,w5,w6,w7,w8, val, mean, wtot, norm;
  int x,y,z,i,j,k;

  out->res[0]=in->res[0]*(double)in->dim[0]/newx;
  out->res[1]=in->res[1]*(double)in->dim[1]/newy;
  out->res[2]=in->res[2]*(double)in->dim[2]/newz;
 
  mean = 0.0;
  for( z=0; z<in->dim[2]; z++ )
  for( y=0; y<in->dim[1]; y++ )
    for( x=0; x<in->dim[0]; x++ )
      mean += rPixel(x,y,z,in);
  mean /= in->dim[2]*in->dim[1]*in->dim[0];
  printf( "orig Mean: %f\n", mean );

  for( z=0; z<out->dim[2]; z++ ){
    dnewz1 = z * newincz;
    dnewz2 = (z+1) * newincz;
    doldz1 = dnewz1/oldincz;
    ioldz1 = (int)(doldz1-0.0001);
    doldz2 = dnewz2/oldincz;
    ioldz2 = (int)(doldz2-0.0001);

  for( y=0; y<out->dim[1]; y++ ){
    dnewy1 = y * newincy;
    dnewy2 = (y+1) * newincy;
    doldy1 = dnewy1/oldincy;
    ioldy1 = (int)(doldy1-0.0001);
    doldy2 = dnewy2/oldincy;
    ioldy2 = (int)(doldy2-0.0001);

    for( x=0; x<out->dim[0]; x++ ){
      dnewx1 = x * newincx;
      dnewx2 = (x+1) * newincx;
      doldx1 = dnewx1/oldincx;
      ioldx1 = (int)(doldx1);
      doldx2 = dnewx2/oldincx;
      ioldx2 = (int)(doldx2);

      val = 0;
      wtot=0;	

      if( (ioldx1 == ioldx2) && (ioldy1 == ioldy2 ) && (ioldz1 == ioldz2 ) )
       val = rPixel( ioldx1, ioldy1, ioldz1, in );

      if( (ioldx1 != ioldx2) && (ioldy1 == ioldy2 ) && (ioldz1 == ioldz2 ) ){
        w1 = ( (ioldx1+1)*oldincx - dnewx1 ) / newincx;
        w2 = ( dnewx2 - ioldx2*oldincx ) / newincx;

        w1 = ( doldx1 != 0 )     ? w1 : 0.0; 
        w2 = ( doldx2 < in->dim[0] ) ? w2 : 0.0; 

        x2 = (ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;

        val = w1 * rPixel(ioldx1,ioldy1,ioldz1,in) + w2 * rPixel(int(x2),ioldy1,ioldz1,in);
        
        for( i=(doldx1==0)?0:1; i<(ioldx2 - ioldx1); i++ )
          val += (oldincx*oldincy*oldincz)/(newincx*newincy*newincz) * rPixel(ioldx1+i,ioldy1,ioldz1,in);
      }

      if( (ioldx1 == ioldx2) && (ioldy1 != ioldy2 )  && (ioldz1 == ioldz2 ) ){
        w1 = ( (ioldy1+1)*oldincy - dnewy1 ) / newincy;
        w2 = ( dnewy2 - ioldy2*oldincy ) / newincy;

        w1 = ( doldy1 != 0 )     ? w1 : 0.0; 
        w2 = ( doldy2 < in->dim[1] ) ? w2 : 0.0; 

        y2 = (ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;

        val = w1 * rPixel(ioldx1,ioldy1,ioldz1,in) + w2 * rPixel(ioldx1,int(y2),ioldz1,in);
        
        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          val += (oldincx*oldincy*oldincz)/(newincx*newincy*newincz) * rPixel(ioldx1,ioldy1+i,ioldz1,in);
      }

      if( (ioldx1 == ioldx2) && (ioldy1 == ioldy2 )  && (ioldz1 != ioldz2 ) ){
        w1 = ( (ioldz1+1)*oldincz - dnewz1 ) / newincz;
        w2 = ( dnewz2 - ioldz2*oldincz ) / newincz;

        w1 = ( doldz1 != 0 )     ? w1 : 0.0; 
        w2 = ( doldz2 < in->dim[2] ) ? w2 : 0.0; 

        z2 = (ioldz2 < in->dim[2] ) ? ioldz2 : ioldz2-1;

        val = w1 * rPixel(ioldx1,ioldy1,ioldz1,in) + w2 * rPixel(ioldx1,ioldy1,int(z2),in);
        
        for( i=(doldz1==0)?0:1; i<(ioldz2 - ioldz1); i++ )
          val += (oldincx*oldincy*oldincz)/(newincx*newincy*newincz) * rPixel(ioldx1,ioldy1,ioldz1+i,in);

      }

      
      if( (ioldx1 != ioldx2) && (ioldy1 != ioldy2)  && (ioldz1 == ioldz2 ) ){
	norm = newincx * newincy;
        w1 = (((ioldx1+1)*oldincx-dnewx1)*((ioldy1+1)*oldincy-dnewy1)) / norm;
        w2 = (((ioldx1+1)*oldincx-dnewx1)*(dnewy2-ioldy2*oldincy)) / norm; 
        w3 = ((dnewx2-ioldx2*oldincx)*((ioldy1+1)*oldincy-dnewy1)) / norm;
        w4 = ((dnewx2-ioldx2*oldincx)*(dnewy2-ioldy2*oldincy)) / norm;

        w1 = ( doldx1 != 0 && doldy1 != 0 )             ? w1 : 0.0;
        w2 = ( doldx1 != 0 && doldy2 < in->dim[1] )       ? w2 : 0.0;
        w3 = ( doldx2 < in->dim[0] && doldy1 != 0 )       ? w3 : 0.0;
        w4 = ( doldx2 < in->dim[0] && doldy2 < in->dim[1] ) ? w4 : 0.0;

        x2 = ( ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;
        y2 = ( ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;

        val = w1 * rPixel(ioldx1,ioldy1,ioldz1,in) +
              w2 * rPixel(ioldx1,int(y2),ioldz1,in)+
              w3 * rPixel(int(x2),ioldy1,ioldz1,in)+
              w4 * rPixel(int(x2),int(y2),ioldz1,in);

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          for( j=(doldx1 == 0)?0:1; j<(ioldx2 - ioldx1); j++ )
            val += (oldincx*oldincy*oldincz)/(newincx*newincy*oldincz) * rPixel(ioldx1+j,ioldy1+i,ioldz1,in);

        for( i=(doldx1 == 0)?0:1; i<(ioldx2 - ioldx1); i++ ){
          w = ( oldincx * ((ioldy1+1)*oldincy-dnewy1) ) / norm;
          w = ( doldy1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,ioldy1,ioldz1,in);

          w = ( oldincx * (dnewy2-ioldy2*oldincy) ) / norm;
          w = ( doldy2 < in->dim[1] ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,int(y2),ioldz1,in);
        }

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ ){
          w = ( ((ioldx1+1)*oldincx-dnewx1) * oldincy ) / norm;
          w = ( doldx1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1+i,ioldz1,in);


          w = ( (dnewx2-ioldx2*oldincx) * oldincy ) / norm;
          w = ( doldx2 < in->dim[0] ) ? w : 0.0;
          val += w * rPixel(int(x2),ioldy1+i,ioldz1,in);
        }
      }


      if( (ioldx1 == ioldx2) && (ioldy1 != ioldy2)  && (ioldz1 != ioldz2 ) ){
	norm = newincz * newincy;
        w1 = (((ioldz1+1)*oldincz-dnewz1)*((ioldy1+1)*oldincy-dnewy1)) / norm;
        w2 = (((ioldz1+1)*oldincz-dnewz1)*(dnewy2-ioldy2*oldincy)) / norm; 
        w3 = ((dnewz2-ioldz2*oldincz)*((ioldy1+1)*oldincy-dnewy1)) / norm;
        w4 = ((dnewz2-ioldz2*oldincz)*(dnewy2-ioldy2*oldincy)) / norm;

        w1 = ( doldz1 != 0 && doldy1 != 0 )             ? w1 : 0.0;
        w2 = ( doldz1 != 0 && doldy2 < in->dim[1] )       ? w2 : 0.0;
        w3 = ( doldz2 < in->dim[2] && doldy1 != 0 )       ? w3 : 0.0;
        w4 = ( doldz2 < in->dim[2] && doldy2 < in->dim[1] ) ? w4 : 0.0;

        z2 = ( ioldz2 < in->dim[2] ) ? ioldz2 : ioldz2-1;
        y2 = ( ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;

        val = w1 * rPixel(ioldz1,ioldy1,ioldz1,in) +
              w2 * rPixel(ioldz1,int(y2),ioldz1,in)+
              w3 * rPixel(int(z2),ioldy1,ioldz1,in)+
              w4 * rPixel(int(z2),int(y2),ioldz1,in);

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          for( j=(doldz1 == 0)?0:1; j<(ioldz2 - ioldz1); j++ )
            val += (oldincx*oldincy*oldincz)/(newincx*newincy*oldincz) * rPixel(ioldx1,ioldy1+i,ioldz1+j,in);

        for( i=(doldz1 == 0)?0:1; i<(ioldz2 - ioldz1); i++ ){
          w = ( oldincz * ((ioldy1+1)*oldincy-dnewy1) ) / norm;
          w = ( doldy1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1,ioldz1+i,in);

          w = ( oldincz * (dnewy2-ioldy2*oldincy) ) / norm;
          w = ( doldy2 < in->dim[1] ) ? w : 0.0;
          val += w * rPixel(ioldx1,int(y2),ioldz1+i,in);
        }

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ ){
          w = ( ((ioldz1+1)*oldincz-dnewz1) * oldincy ) / norm;
          w = ( doldz1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1+i,ioldz1,in);


          w = ( (dnewz2-ioldz2*oldincz) * oldincy ) / norm;
          w = ( doldz2 < in->dim[2] ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1+i,int(z2),in);
        }
      }

      if( (ioldx1 != ioldx2) && (ioldy1 == ioldy2)  && (ioldz1 != ioldz2 ) ){
	norm = newincz * newincx;
        w1 = (((ioldx1+1)*oldincx-dnewx1)*((ioldz1+1)*oldincz-dnewz1)) / norm;
        w2 = (((ioldx1+1)*oldincx-dnewx1)*(dnewz2-ioldz2*oldincz)) / norm; 
        w3 = ((dnewx2-ioldx2*oldincx)*((ioldz1+1)*oldincz-dnewz1)) / norm;
        w4 = ((dnewx2-ioldx2*oldincx)*(dnewz2-ioldz2*oldincz)) / norm;

        w1 = ( doldx1 != 0 && doldz1 != 0 )             ? w1 : 0.0;
        w2 = ( doldx1 != 0 && doldz2 < in->dim[2] )       ? w2 : 0.0;
        w3 = ( doldx2 < in->dim[0] && doldz1 != 0 )       ? w3 : 0.0;
        w4 = ( doldx2 < in->dim[0] && doldz2 < in->dim[2] ) ? w4 : 0.0;

        x2 = ( ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;
        y2 = ( ioldz2 < in->dim[2] ) ? ioldz2 : ioldz2-1;

        val = w1 * rPixel(ioldx1,ioldy1,ioldz1,in) +
              w2 * rPixel(ioldx1,ioldy1,int(z2),in)+
              w3 * rPixel(int(x2),ioldy1,ioldz1,in)+
              w4 * rPixel(int(x2),ioldy1,int(z2),in);

        for( i=(doldz1==0)?0:1; i<(ioldz2 - ioldz1); i++ )
          for( j=(doldx1 == 0)?0:1; j<(ioldx2 - ioldx1); j++ )
            val += (oldincx*oldincy*oldincz)/(newincx*newincy*oldincz) * rPixel(ioldx1+j,ioldy1,ioldz1+i,in);

        for( i=(doldx1 == 0)?0:1; i<(ioldx2 - ioldx1); i++ ){
          w = ( oldincx *((ioldz1+1)*oldincz-dnewz1) ) / norm;
          w = ( doldz1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,ioldy1,ioldz1,in);

          w = ( oldincx *(dnewz2-ioldz2*oldincz) ) / norm;
          w = ( doldz2 < in->dim[2] ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,ioldy1,int(z2),in);
        }

        for( i=(doldz1==0)?0:1; i<(ioldz2 - ioldz1); i++ ){
          w = ( ((ioldx1+1)*oldincx-dnewx1) * oldincz ) / norm;
          w = ( doldx1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1,ioldz1+i,in);


          w = ( (dnewx2-ioldx2*oldincx) * oldincz ) / norm;
          w = ( doldx2 < in->dim[0] ) ? w : 0.0;
          val += w * rPixel(int(x2),ioldy1,ioldz1+i,in);
        }
      }

      if( (ioldx1 != ioldx2) && (ioldy1 != ioldy2)  && (ioldz1 != ioldz2 ) ){
	norm = (newincx * newincy * newincz);
        w1 = (((ioldx1+1)*oldincx-dnewx1)*((ioldy1+1)*oldincy-dnewy1)*((ioldz1+1)*oldincz-dnewz1)) / norm;
        w2 = (((ioldx1+1)*oldincx-dnewx1)*(dnewy2-ioldy2*oldincy)*((ioldz1+1)*oldincz-dnewz1)) / norm; 
        w3 = ((dnewx2-ioldx2*oldincx)*((ioldy1+1)*oldincy-dnewy1)*((ioldz1+1)*oldincz-dnewz1)) / norm;
        w4 = ((dnewx2-ioldx2*oldincx)*(dnewy2-ioldy2*oldincy)*((ioldz1+1)*oldincz-dnewz1)) / norm;
       w5 = (((ioldx1+1)*oldincx-dnewx1)*((ioldy1+1)*oldincy-dnewy1)*(dnewz2-ioldz2*oldincz)) / norm;
        w6 = (((ioldx1+1)*oldincx-dnewx1)*(dnewy2-ioldy2*oldincy)*(dnewz2-ioldz2*oldincz)) / norm; 
        w7 = ((dnewx2-ioldx2*oldincx)*((ioldy1+1)*oldincy-dnewy1)*(dnewz2-ioldz2*oldincz)) / norm;
        w8 = ((dnewx2-ioldx2*oldincx)*(dnewy2-ioldy2*oldincy)*(dnewz2-ioldz2*oldincz)) / norm;

        w1 = ( doldx1 != 0 && doldy1 != 0  && doldz1 != 0 )             ? w1 : 0.0;
        w2 = ( doldx1 != 0 && doldy2 < in->dim[1] && doldz1 != 0  )       ? w2 : 0.0;
        w3 = ( doldx2 < in->dim[0] && doldy1 != 0 && doldz1 != 0  )       ? w3 : 0.0;
        w4 = ( doldx2 < in->dim[0] && doldy2 < in->dim[1] && doldz1 != 0  ) ? w4 : 0.0;
        w5 = ( doldx1 != 0 && doldy1 != 0  && doldz2 < in->dim[2] )             ? w5 : 0.0;
        w6 = ( doldx1 != 0 && doldy2 < in->dim[1] && doldz2 < in->dim[2] )       ? w6 : 0.0;
        w7 = ( doldx2 < in->dim[0] && doldy1 != 0 && doldz2 < in->dim[2])       ? w7 : 0.0;
        w8 = ( doldx2 < in->dim[0] && doldy2 < in->dim[1] && doldz2 < in->dim[2]  )? w8 : 0.0;

        x2 = ( ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;
        y2 = ( ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;
        z2 = ( ioldz2 < in->dim[2] ) ? ioldz2 : ioldz2-1;

        val = w1 * rPixel(ioldx1,ioldy1,ioldz1,in) +
              w2 * rPixel(ioldx1,int(y2),ioldz1,in)+
              w3 * rPixel(int(x2),ioldy1,ioldz1,in)+
              w4 * rPixel(int(x2),int(y2),ioldz1,in)+
              w5 * rPixel(ioldx1,ioldy1,int(z2),in)+
              w6 * rPixel(ioldx1,int(y2),int(z2),in)+
              w7 * rPixel(int(x2),ioldy1,int(z2),in)+
              w8 * rPixel(int(x2),int(y2),int(z2),in);
// soweit OKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
       for( k=(doldz1==0)?0:1; k<(ioldz2 - ioldz1); k++ )
        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          for( j=(doldx1 == 0)?0:1; j<(ioldx2 - ioldx1); j++ )
            val += (oldincx*oldincy*oldincz)/(newincx*newincy*oldincz) * rPixel(ioldx1+j,ioldy1+i,ioldz1+k,in);

       for( k=(doldz1==0)?0:1; k<(ioldz2 - ioldz1); k++ )
        for( i=(doldx1 == 0)?0:1; i<(ioldx2 - ioldx1); i++ ){
          w = ( oldincx *oldincz * ((ioldy1+1)*oldincy-dnewy1) ) / norm;
          w = ( doldy1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,ioldy1,ioldz1+k,in);

          w = ( oldincx * oldincz * (dnewy2-ioldy2*oldincy) ) / norm;
          w = ( doldy2 < in->dim[1] ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,int(y2),ioldz1+k,in);
        }

       for( k=(doldz1==0)?0:1; k<(ioldz2 - ioldz1); k++ )
        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ ){
          w = ( ((ioldx1+1)*oldincx-dnewx1) * oldincy * oldincz ) / norm;
          w = ( doldx1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1+i,ioldz1+k,in);


          w = ( (dnewx2-ioldx2*oldincx) * oldincy* oldincz  ) / norm;
          w = ( doldx2 < in->dim[0] ) ? w : 0.0;
          val += w * rPixel(int(x2),ioldy1+i,ioldz1+k,in);
        }
      

	for( k=(doldx1==0)?0:1; k<(ioldx2 - ioldx1); k++ )
        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ ){
          w = ( ((ioldz1+1)*oldincz-dnewz1) * oldincx * oldincy ) / norm;
          w = ( doldz1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1+k,ioldy1+i,ioldz1,in);


          w = ( (dnewz2-ioldz2*oldincz) * oldincx* oldincy  ) / norm;
          w = ( doldz2 < in->dim[2] ) ? w : 0.0;
          val += w * rPixel(ioldx1+k,ioldy1+i,int(z2),in);
        }
      }

      wPixel( x, y, z, out, (unsigned char)val);
    }
  }
  }

  mean = 0.0;
  for( y=0; y<out->dim[1]; y++ )
    for( x=0; x<out->dim[0]; x++ )
      mean += rPixel(x,y,out);
  mean /= out->dim[1]*out->dim[0];
  printf( "rescaled Mean: %f\n", mean );


  return(out);
}
