/*****************************************************/
/*** old functions, just for upward compatibiloity ***/
/*****************************************************/
//void CutImage(image_cc *image, int ulx, int uly, int drx, int dry)
//image_cc *GetImageSeg(image_cc *image, int ulx, int uly, int dx, int dy)
//void SaveImageSeg(image_cc *image, char *buf, int ulx, int uly, int drx, int dry)
//void SaveRGBImageSeg(image_cc *image, char *buf, int ulx, int uly, int drx, int dry)
//image_cc *GetDddSegment(image_cc *im, int ulx, int uly, int ulz, int nx, int ny, int nz)
//image_cc *GetBtdSegment(image_cc *im, int xul,int yul,int zul, int nx, int ny, int nz)
//image_cc *GetDddXZPlane(image_cc *im,int plane)
//image_cc *GetBtdXZPlane(image_cc *im,int plane)
//image_cc *GetBtdYZPlane(image_cc *im,int plane)
//image_cc *GetDddYZPlane(image_cc *im,int plane)
//image_cc *GetBtdXYPlane(image_cc *im,int plane)
//image_cc *GetDddXYPlane(image_cc *im,int plane)
//void gInvert(image_cc *image)
//void BtdInvert(image_cc *image)
//image_cc *FlipRGBImage(image_cc *im)
//image_cc *TurnRGBImage(image_cc *im,double grad)

image_cc *TurnRGBImage(image_cc *im,double grad)
{
 	int x,y,xx,yy, xmiddle, ymiddle;
 	double X,Y;
	unsigned long i; 	       
        image_cc *outim;
        
        outim=InitRGBImage(im->dim[0],im->dim[1]);
	xmiddle=im->dim[0]/2;
	ymiddle=im->dim[1]/2;
	
        for(x=0;x<im->dim[0];x++)
	   for(y=0;y<im->dim[1];y++){
		X=(double)(x-xmiddle)*cos(grad*M_PI/180)+(y-ymiddle)*sin(grad*M_PI/180);
		Y=(double)-(x-xmiddle)*sin(grad*M_PI/180)+(y-ymiddle)*cos(grad*M_PI/180);
	   	X+=xmiddle;
		Y+=ymiddle;
		xx=int(X+0.5); yy=int(Y+0.5);
		if(xx>1 && xx<im->dim[0]-1 && yy>1 && yy<im->dim[1]-1){
			WRGBPixel(outim,xx,yy,Red(im,x,y),Green(im,x,y),Blue(im,x,y));
			for(i=0;i<4;i++)
				WRGBPixel(outim,xx+neigh4x[i],yy+neigh4y[i],Red(im,x,y),Green(im,x,y),Blue(im,x,y));		
		}
	}
	return outim;
}

image_cc *FlipRGBImage(image_cc *im)
{
  image_cc *outim;
  int x,y;

  outim=InitRGBImage(im->dim[1],im->dim[0]);
  
  for(x=0;x<im->dim[0];x++)
     for(y=0;y<im->dim[1];y++)
       	WRGBPixel(outim,y,outim->dim[1]-x-1,Red(im,x,y),Green(im,x,y),Blue(im,x,y));

  return outim;
}

void BtdInvert(image_cc *image)
{
  	int x,y,z;
  	unsigned char val;    
  	
  	for(x=0; x<image->dim[0];x++)
       	  for(y=0; y<image->dim[1];y++)
       	  for(z=0; z<image->dim[2];z++)
	 	WBtdVoxel(image,x,y,z,rPixel(x,y,z,image)?0:1);
}

void gInvert(image_cc *image)
{
  	int x,y;
  	unsigned char val;    
  	
  	for(x=0; x<image->dim[0];x++)
       	  for(y=0; y<image->dim[1];y++)
	 	wPixel(x,y,image,255-rPixel(x,y,image));
}

image_cc *GetDddXYPlane(image_cc *im,int plane)
{
 	int x,y;
 	unsigned long i; 	       
        long offset;
        image_cc *outim;
        
        outim=InitImage(im->dim[0],im->dim[1], 255);
	outim->res[0] = im->res[0];
	outim->res[1] = im->res[1];
	outim->res[2] =0; 
        
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[1];y++)
		wPixel(x,y,outim,rPixel(x,y,plane,im));
	return outim;
}

image_cc *GetBtdXYPlane(image_cc *im,int plane)
{
 	FILE *fp;
 	int x,y;
 	unsigned long i; 	       
        long offset;
        image_cc *outim;
        
        outim=InitImage(im->dim[1],im->dim[2], 255);
	outim->res[0] = im->res[0];
	outim->res[1] = im->res[1];
	outim->res[2] =0; 
        
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[1];y++){
		if(*(im->pix + plane/8 + x*im->numbytes + y*im->dim[0]*im->numbytes) & 1<<plane%8)
			wPixel(x,y,outim,255);
		else    
			wPixel(x,y,outim,0);
	   }
	return outim;
}

image_cc *GetDddYZPlane(image_cc *im,int plane)
{
 	int x,y,z;
 	unsigned long i; 	       
        long offset;
        image_cc *outim;
        
        outim=InitImage(im->dim[1],im->dim[2], 255);
	outim->res[0] = im->res[1];
	outim->res[1] = im->res[2];
	outim->res[2] =0; 
	
        for(z=0;z<im->dim[2];z++)
	   for(y=0;y<im->dim[1];y++)
		wPixel(y,z,outim,rPixel(plane,y,z,im));
	return outim;
}

image_cc *GetBtdYZPlane(image_cc *im,int plane)
{
 	FILE *fp;
 	int x,y;
 	unsigned long i; 	       
        long offset;
        image_cc *outim;
        
        outim=InitImage(im->dim[1],im->dim[2], 255);
	outim->res[0] = im->res[1];
	outim->res[1] = im->res[2];
	outim->res[2] = 0; 
        
	for(x=0;x<im->dim[1];x++)
	  for(y=0;y<im->dim[2];y++){
		if(*(im->pix + y/8 + plane*im->numbytes + x*im->dim[0]*im->numbytes) & 1<<y%8)
			wPixel(x,y,outim,255);
		else    
			wPixel(x,y,outim,0);
	   }
	return outim;
}

image_cc *GetBtdXZPlane(image_cc *im,int plane)
{
 	FILE *fp;
 	int x,y;
 	unsigned long i; 	       
        long offset;
        image_cc *outim;
        
	outim=InitImage(im->dim[0],im->dim[2], 255);
	outim->res[0] = im->res[0];
	outim->res[1] = im->res[2];
	outim->res[2] = 0;
        
	for(x=0;x<im->dim[0];x++)
	  for(y=0;y<im->dim[2];y++){
		if(*(im->pix + y/8 + x*im->numbytes + plane*im->dim[0]*im->numbytes) & 1<<y%8)
			wPixel(x,y,outim,255);
		else    
			wPixel(x,y,outim,0);
	   }
	return outim;
}

image_cc *GetDddXZPlane(image_cc *im,int plane)
{
 	int x,y,z;
 	unsigned long i; 	       
        long offset;
        image_cc *outim;
        
        outim=InitImage(im->dim[0],im->dim[2], 255);
	outim->res[0] = im->res[0];
	outim->res[1] = im->res[2];
	outim->res[2] = 0;
	
        for(z=0;z<im->dim[2];z++)
	   for(x=0;x<im->dim[0];x++)
		wPixel(x,z,outim,rPixel(x,plane,z,im));
	return outim;
}

image_cc *GetBtdSegment(image_cc *im, int xul,int yul,int zul, int nx, int ny, int nz)
{
	int x,y,z;
	image_cc *outim;
	
	outim = InitBtdImage(nx,ny,nz, im->res[0],im->res[1],im->res[2]);
	for(z=0;z<nz;z++)
	 for(x=0;x<nx;x++)
	  for(y=0;y<ny;y++){
		if(rPixel(x+xul,y+yul,z+zul,im))
			*(outim->pix + z/8 + x*outim->numbytes + y*outim->dim[0]*outim->numbytes) |= 1<<z%8;
	   }
	return outim;
}

image_cc *GetDddSegment(image_cc *im, int ulx, int uly, int ulz, int nx, int ny, int nz)
{
	int x,y,z;
	image_cc *outim;
	
	outim = InitDDDImage(nx,ny,nz,0);
	for(z=0;z<nz;z++)
	 for(x=0;x<nx;x++)
	  for(y=0;y<ny;y++)
		*(outim->pix+x + outim->dim[0]*y + z*outim->dim[0]*outim->dim[1]) = rPixel(x+ulx,y+uly,z+ulz,im);

	outim->res[0]=im->res[0];
	outim->res[1]=im->res[1];
	outim->res[2]=im->res[2];

	return outim;
}


void SaveRGBImageSeg(image_cc *image, char *buf, int ulx, int uly, int drx, int dry)
{
	long row;
	TIFF *tif;

	tif = TIFFOpen(buf, "w");
	TIFFSetField(tif, TIFFTAG_IMAGELENGTH, dry-uly+1);
	TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, 2);
	TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, drx-ulx+1);
	TIFFSetField(tif, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
	TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
	TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 8,8,8);
	TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, image->numbytes);
	TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, RPS);

	for (row = 0; row <= dry-uly; row++)
TIFFWriteScanline(tif, image->pix+((uly+row)*image->dim[0]*image->numbytes)+ulx*image->numbytes, row,0);

TIFFClose(tif); 
}

void SaveImageSeg(image_cc *image, char *buf, int ulx, int uly, int drx, int dry)
{
	long row;
	TIFF *tif;

	tif = TIFFOpen(buf, "w");
	TIFFSetField(tif, TIFFTAG_IMAGELENGTH, dry-uly+1);
	TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISBLACK);
	TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, drx-ulx+1);
	TIFFSetField(tif, TIFFTAG_COMPRESSION, COMPRESSION_NONE);
	TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
	TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, image->dim[2]);
	TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, image->numbytes);
	for (row = 0; row <= dry-uly; row++)
TIFFWriteScanline(tif, image->pix+((uly+row)*image->dim[0]*image->numbytes)+ulx, row,2);

TIFFClose(tif); 
}

image_cc *GetImageSeg(image_cc *image, int ulx, int uly, int dx, int dy)
{
	int x,y;
	image_cc *seg;

	seg = InitImage(dx,dy,0);
	seg->res[1]=image->res[1];
        seg->res[0]=image->res[0];
        seg->res[2]=image->res[2];

	for(y=0;y<seg->dim[1];y++)
	  for(x=0;x<seg->dim[0];x++)
	    wPixel(x,y,seg,rPixel(x+ulx,y+uly,image));

	return seg;
}

void CutImage(image_cc *image, int ulx, int uly, int drx, int dry)
{
  int x,y;
  image_cc *cut;

  cut=InitImage(drx-ulx+1,dry-uly+1,0);
  for(y=0;y<cut->dim[1];y++)
    for(x=0;x<cut->dim[0];x++)
      wPixel(x,y,cut,rPixel(x+ulx,y+uly,image));

  free(image->pix);
  image->pix=cut->pix;
  image->dim[0]=cut->dim[0];
  image->dim[1]=cut->dim[1];
}

image_cc *ChangeRes( image_cc *in, int newx, int newy );
image_cc *ChangeResRGB( image_cc *in, int newx, int newy );

image_cc *ChangeResolution( image_cc *in, int newx, int newy ){

  if(strcmp(in->itype,"gry")==0)
    return ChangeRes(in, newx, newy);
  else if(strcmp(in->itype,"rgb")==0)
    return ChangeResRGB(in, newx, newy);
  else{
    printf("\nNo change in resolution possible for this type of image!!!\n"); 
    return in;
  }
}

image_cc *ChangeRes( image_cc *in, int newx, int newy ){

  image_cc *out = InitImage( newx, newy, 0 );
  double newincx = 1.0/out->dim[0];
  double newincy = 1.0/out->dim[1];
  double oldincx = 1.0/in->dim[0];
  double oldincy = 1.0/in->dim[1];
  double dnewx1, dnewy1, dnewx2, dnewy2, doldx1, doldy1, doldx2, doldy2;
  double x1,y1,x2,y2;
  int ioldx1, ioldy1, ioldx2, ioldy2;
  double w,w1,w2,w3,w4, val, mean;
  int x,y,i,j;

  out->res[0]=in->res[0]*(double)in->dim[0]/newx;
  out->res[1]=in->res[1]*(double)in->dim[1]/newy;
 
  mean = 0.0;
  for( y=0; y<in->dim[1]; y++ )
    for( x=0; x<in->dim[0]; x++ )
      mean += rPixel(x,y,in);
  mean /= in->dim[1]*in->dim[0];
  printf( "orig Mean: %f\n", mean );

  for( y=0; y<out->dim[1]; y++ ){
    dnewy1 = y * newincy;
    dnewy2 = (y+1) * newincy;
    doldy1 = dnewy1/oldincy;
    ioldy1 = (int)(doldy1-0.0001);
    doldy2 = dnewy2/oldincy;
    ioldy2 = (int)(doldy2-0.0001);

    for( x=0; x<out->dim[0]; x++ ){
      dnewx1 = x * newincx;
      dnewx2 = (x+1) * newincx;
      doldx1 = dnewx1/oldincx;
      ioldx1 = (int)(doldx1);
      doldx2 = dnewx2/oldincx;
      ioldx2 = (int)(doldx2);

      val = 0;

      if( (ioldx1 == ioldx2) && (ioldy1 == ioldy2 ) )
        val = rPixel( ioldx1, ioldy1, in );

      if( (ioldx1 != ioldx2) && (ioldy1 == ioldy2 ) ){
        w1 = ( (ioldx1+1)*oldincx - dnewx1 ) / newincx;
        w2 = ( dnewx2 - ioldx2*oldincx ) / newincx;

        w1 = ( doldx1 != 0 )     ? w1 : 0.0; 
        w2 = ( doldx2 < in->dim[0] ) ? w2 : 0.0; 

        x2 = (ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;

        val = w1 * rPixel(ioldx1,ioldy1,in) + w2 * rPixel(int(x2),ioldy1,in);
        
        for( i=(doldx1==0)?0:1; i<(ioldx2 - ioldx1); i++ )
          val += (oldincx*oldincy)/(newincx*newincy) * rPixel(ioldx1+i,ioldy1,in);
      }

      if( (ioldx1 == ioldx2) && (ioldy1 != ioldy2 ) ){
        w1 = ( (ioldy1+1)*oldincy - dnewy1 ) / newincy;
        w2 = ( dnewy2 - ioldy2*oldincy ) / newincy;

        w1 = ( doldy1 != 0 )     ? w1 : 0.0; 
        w2 = ( doldy2 < in->dim[1] ) ? w2 : 0.0; 

        y2 = (ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;

        val = w1 * rPixel(ioldx1,ioldy1,in) + w2 * rPixel(ioldx1,int(y2),in);
        
        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          val += (oldincx*oldincy)/(newincx*newincy) * rPixel(ioldx1,ioldy1+i,in);
      }
      
      if( (ioldx1 != ioldx2) && (ioldy1 != ioldy2 ) ){

        w1 = (((ioldx1+1)*oldincx-dnewx1)*((ioldy1+1)*oldincy-dnewy1)) / (newincx * newincy);
        w2 = (((ioldx1+1)*oldincx-dnewx1)*(dnewy2-ioldy2*oldincy)) / (newincx * newincy); 
        w3 = ((dnewx2-ioldx2*oldincx)*((ioldy1+1)*oldincy-dnewy1)) / (newincx * newincy);
        w4 = ((dnewx2-ioldx2*oldincx)*(dnewy2-ioldy2*oldincy)) / (newincx * newincy);

        w1 = ( doldx1 != 0 && doldy1 != 0 )             ? w1 : 0.0;
        w2 = ( doldx1 != 0 && doldy2 < in->dim[1] )       ? w2 : 0.0;
        w3 = ( doldx2 < in->dim[0] && doldy1 != 0 )       ? w3 : 0.0;
        w4 = ( doldx2 < in->dim[0] && doldy2 < in->dim[1] ) ? w4 : 0.0;

        x2 = ( ioldx2 < in->dim[0] ) ? ioldx2 : ioldx2-1;
        y2 = ( ioldy2 < in->dim[1] ) ? ioldy2 : ioldy2-1;

        val = w1 * rPixel(ioldx1,ioldy1,in) +
              w2 * rPixel(ioldx1,int(y2),in)+
              w3 * rPixel(int(x2),ioldy1,in)+
              w4 * rPixel(int(x2),int(y2),in);

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ )
          for( j=(doldx1 == 0)?0:1; j<(ioldx2 - ioldx1); j++ )
            val += (oldincx*oldincy)/(newincx*newincy) * rPixel(ioldx1+j,ioldy1+i,in);

        for( i=(doldx1 == 0)?0:1; i<(ioldx2 - ioldx1); i++ ){
          w = ( oldincx * ((ioldy1+1)*oldincy-dnewy1) ) / (newincx * newincy);
          w = ( doldy1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,ioldy1,in);

          w = ( oldincx * (dnewy2-ioldy2*oldincy) ) / (newincx * newincy);
          w = ( doldy2 < in->dim[1] ) ? w : 0.0;
          val += w * rPixel(ioldx1+i,int(y2),in);
        }

        for( i=(doldy1==0)?0:1; i<(ioldy2 - ioldy1); i++ ){
          w = ( ((ioldx1+1)*oldincx-dnewx1) * oldincy ) / (newincx * newincy);
          w = ( doldx1 != 0 ) ? w : 0.0;
          val += w * rPixel(ioldx1,ioldy1+i,in);


          w = ( (dnewx2-ioldx2*oldincx) * oldincy ) / (newincx * newincy);
          w = ( doldx2 < in->dim[0] ) ? w : 0.0;
          val += w * rPixel(int(x2),ioldy1+i,in);
        }
      }
      wPixel( x, y, out, (unsigned char)val);
    }
  }

  mean = 0.0;
  for( y=0; y<out->dim[1]; y++ )
    for( x=0; x<out->dim[0]; x++ )
      mean += rPixel(x,y,out);
  mean /= out->dim[1]*out->dim[0];
  printf( "rescaled Mean: %f\n", mean );


  return(out);
}

image_cc *ChangeResRGB( image_cc *in, int newx, int newy )
{
  int x,y;
  image_cc *red, *green, *blue,*red2, *green2, *blue2, *out;

  red=InitImage(in->dim[0],in->dim[1],0,"gry");
  red->res[0]=in->res[0];
  red->res[1]=in->res[1];
  green=CopyImage(red);
  blue=CopyImage(red);

  for(x=0;x<in->dim[0];x++)
    for(y=0;y<in->dim[1];y++){
      wPixel(x,y,red,Red(in,x,y));
      wPixel(x,y,green,Green(in,x,y));
      wPixel(x,y,blue,Blue(in,x,y));
    }

 StoreImage(red,"rescaled1-red");
 StoreImage(green,"rescaled1-green");
 StoreImage(blue,"rescaled1-blue");

  red2=ChangeRes(red,newx,newy );
  green2=ChangeRes(green,newx,newy );
  blue2=ChangeRes(blue,newx,newy );

 StoreImage(red2,"rescaled-red");
 StoreImage(green2,"rescaled-green");
 StoreImage(blue2,"rescaled-blue");

  out=InitImage(newx,newy,0,"rgb");
  out->res[0]=in->res[0]*(double)in->dim[0]/newx;
  out->res[1]=in->res[1]*(double)in->dim[1]/newy;
 
  for(x=0;x<out->dim[0];x++)
    for(y=0;y<out->dim[1];y++){
       WRGBPixel(out, x,y,rPixel(x,y,red2),rPixel(x,y,green2),rPixel(x,y,blue2));
    }
  return out;
}

